/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/path","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/network","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/errors","vs/base/common/types","vs/base/common/async","vs/platform/log/common/log","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/strings","vs/base/node/pfs","vs/base/common/objects","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/uuid","vs/base/common/process","os","vs/platform/environment/common/environment","fs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/map","vs/base/common/extpath","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/extensionManagement/common/extensionManagement","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/base/common/codicons","vs/base/common/json","child_process","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/performance","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/uriIdentity/common/uriIdentity","vs/server/node/remoteUriTransformer","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/marshalling","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/base/common/semver/semver","vs/base/parts/ipc/node/ipc.net","vs/base/common/mime","vs/base/common/glob","vs/base/common/labels","vs/base/common/uriIpc","vs/editor/common/core/range","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/environment/node/shellEnv","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","crypto","url","vs/server/node/remoteLanguagePacks","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/processes","vs/base/common/htmlContent","vs/base/common/normalization","vs/base/common/severity","vs/base/common/console","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/position","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/credentials/common/credentials","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/localizations/node/localizations","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTypes","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/hash","vs/base/common/filters","vs/base/common/iconLabels","vs/base/node/decoder","vs/base/node/languagePacks","path","vs/base/node/macAddress","util","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/editor/common/model","vs/editor/common/languageFeatureRegistry","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/server/node/remoteAgentEnvironmentImpl","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/node/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/editor/common/editor","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/environment/node/argvHelper","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/markers/common/markers","vs/platform/notification/common/notification","vs/platform/credentials/node/credentialsMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/workspaces/common/workspaces","vs/server/node/remoteExtensionManagement","vs/server/node/remoteTelemetryChannel","vs/server/node/remoteTelemetryService","vs/server/node/remoteFileSystemProviderServer","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/testing/common/testId","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionPoints","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/extensions/common/remoteConsoleUtil","vs/workbench/services/extensions/node/extensionPoints","vs/server/node/remoteAgentEnvironmentImpl","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","string_decoder","minimist","assert","graceful-fs","yauzl","yazl","http","vs/server/node/server.main"],we=function(J){for(var e=[],_=0,t=J.length;_<t;_++)e[_]=ve[J[_]];return e};define(ve[117],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class _{static get(){const w=new Map,P=new Map,D=new Map,k=new Map;function y(v,c){v.has(c.detail)||v.set(c.detail,-c.timestamp)}function E(v,c){let d=v.get(c.detail);!d||d>=0||v.set(c.detail,d+c.timestamp)}const T=J.getStats().slice(0).sort((v,c)=>v.timestamp-c.timestamp);for(const v of T)switch(v.type){case 10:y(w,v);break;case 11:case 12:E(w,v);break;case 21:y(P,v);break;case 22:E(P,v);break;case 33:y(D,v);break;case 34:E(D,v);break;case 31:y(k,v);break;case 32:E(k,v);break}let R=0;D.forEach(v=>R+=v);function h(v){let c=[];return v.forEach((d,g)=>c.push([g,d])),c}return{amdLoad:h(w),amdInvoke:h(P),nodeRequire:h(D),nodeEval:h(k),nodeRequireTotal:R}}static toMarkdownTable(w,P){let D="",k=[];return w.forEach((y,E)=>{k[E]=y.length}),P.forEach(y=>{y.forEach((E,T)=>{typeof E=="undefined"&&(E=y[T]="-");const R=E.toString().length;k[T]=Math.max(R,k[T])})}),w.forEach((y,E)=>{D+=`| ${y+" ".repeat(k[E]-y.toString().length)} `}),D+=`|
`,w.forEach((y,E)=>{D+=`| ${"-".repeat(k[E])} `}),D+=`|
`,P.forEach(y=>{y.forEach((E,T)=>{typeof E!="undefined"&&(D+=`| ${E+" ".repeat(k[T]-E.toString().length)} `)}),D+=`|
`}),D}}e.LoaderStats=_}),define(ve[118],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function _(t,w){if(!t)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=_}),define(ve[37],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function _(D){return D?D.replace(/\$\((.*?)\)/g,(k,y)=>` ${y} `).trim():""}e.getCodiconAriaLabel=_;class t{constructor(k,y,E){this.id=k,this.definition=y,this.description=E,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function w(D,k){const y=["codicon","codicon-"+D];return k&&y.push("codicon-modifier-"+k),y}e.getClassNamesArray=w;var P;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function y(R){if(R instanceof t)return["codicon","codicon-"+R.id];const h=k.exec(R.id);if(!h)return y(t.error);let[,v,c]=h;const d=["codicon","codicon-"+v];return c&&d.push("codicon-modifier-"+c.substr(1)),d}D.asClassNameArray=y;function E(R){return y(R).join(" ")}D.asClassName=E;function T(R){return"."+y(R).join(".")}D.asCSSSelector=T})(P=e.CSSIcon||(e.CSSIcon={}))}),define(ve[74],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function _(D){return(k,y,E)=>{let T=null,R=null;if(typeof E.value=="function"?(T="value",R=E.value):typeof E.get=="function"&&(T="get",R=E.get),!R)throw new Error("not supported");E[T]=D(R,y)}}e.createDecorator=_;function t(D,k,y){let E=null,T=null;if(typeof y.value=="function"?(E="value",T=y.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(E="get",T=y.get),!T)throw new Error("not supported");const R=`$memoize$${k}`;y[E]=function(...h){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,h)}),this[R]}}e.memoize=t;function w(D,k,y){return _((E,T)=>{const R=`$debounce$${T}`,h=`$debounce$result$${T}`;return function(...v){this[h]||(this[h]=y?y():void 0),clearTimeout(this[R]),k&&(this[h]=k(this[h],...v),v=[this[h]]),this[R]=setTimeout(()=>{E.apply(this,v),this[h]=y?y():void 0},D)}})}e.debounce=w;function P(D,k,y){return _((E,T)=>{const R=`$throttle$timer$${T}`,h=`$throttle$result$${T}`,v=`$throttle$lastRun$${T}`,c=`$throttle$pending$${T}`;return function(...d){if(this[h]||(this[h]=y?y():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),k&&(this[h]=k(this[h],...d)),this[c])return;const g=this[v]+D;g<=Date.now()?(this[v]=Date.now(),E.apply(this,[this[h]]),this[h]=y?y():void 0):(this[c]=!0,this[R]=setTimeout(()=>{this[c]=!1,this[v]=Date.now(),E.apply(this,[this[h]]),this[h]=y?y():void 0},g-Date.now()))}})}e.throttle=P}),define(ve[11],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(a=>{a(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=_,e.errorHandler=new _;function t(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=t;function w(u){y(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=w;function P(u){y(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=P;function D(u){if(u instanceof Error){let{name:s,message:a}=u;const i=u.stacktrace||u.stack;return{$isError:!0,name:s,message:a,stack:i}}return u}e.transformErrorForSerialization=D;const k="Canceled";function y(u){return u instanceof E?!0:u instanceof Error&&u.name===k&&u.message===k}e.isCancellationError=y;class E extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=E;function T(){const u=new Error(k);return u.name=u.message,u}e.canceled=T;function R(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=R;function h(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=h;function v(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function c(u){const s=new Error(`${u} has been disposed`);return s.name="DISPOSED",s}e.disposed=c;function d(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=d;class g extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=g;class b extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=b;class l extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=l;function C(u){const s=u;return s instanceof Error&&Array.isArray(s.actions)}e.isErrorWithActions=C;function p(u,s=Object.create(null)){const a=new Error(u);return s.actions&&(a.actions=s.actions),a}e.createErrorWithActions=p}),define(ve[17],we([0,1,11]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(Z,H=0){return Z[Z.length-(1+H)]}e.tail=t;function w(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=w;function P(Z,H,j=(V,ne)=>V===ne){if(Z===H)return!0;if(!Z||!H||Z.length!==H.length)return!1;for(let V=0,ne=Z.length;V<ne;V++)if(!j(Z[V],H[V]))return!1;return!0}e.equals=P;function D(Z,H,j){let V=0,ne=Z.length-1;for(;V<=ne;){const me=(V+ne)/2|0,De=j(Z[me],H);if(De<0)V=me+1;else if(De>0)ne=me-1;else return me}return-(V+1)}e.binarySearch=D;function k(Z,H){let j=0,V=Z.length;if(V===0)return 0;for(;j<V;){const ne=Math.floor((j+V)/2);H(Z[ne])?V=ne:j=ne+1}return j}e.findFirstInSorted=k;function y(Z,H,j){if(Z=Z|0,Z>=H.length)throw new TypeError("invalid index");let V=H[Math.floor(H.length*Math.random())],ne=[],me=[],De=[];for(let ae of H){const fe=j(ae,V);fe<0?ne.push(ae):fe>0?me.push(ae):De.push(ae)}return Z<ne.length?y(Z,ne,j):Z<ne.length+De.length?De[0]:y(Z-(ne.length+De.length),me,j)}e.quickSelect=y;function E(Z,H){const j=[];let V;for(const ne of Z.slice(0).sort(H))!V||H(V[0],ne)!==0?(V=[ne],j.push(V)):V.push(ne);return j}e.groupBy=E;function T(Z,H,j){const V=[];function ne(ae,fe,pe){if(fe===0&&pe.length===0)return;const Q=V[V.length-1];Q&&Q.start+Q.deleteCount===ae?(Q.deleteCount+=fe,Q.toInsert.push(...pe)):V.push({start:ae,deleteCount:fe,toInsert:pe})}let me=0,De=0;for(;;){if(me===Z.length){ne(me,0,H.slice(De));break}if(De===H.length){ne(me,Z.length-me,[]);break}const ae=Z[me],fe=H[De],pe=j(ae,fe);pe===0?(me+=1,De+=1):pe<0?(ne(me,1,[]),me+=1):pe>0&&(ne(me,0,[fe]),De+=1)}return V}e.sortedDiff=T;function R(Z,H,j){const V=T(Z,H,j),ne=[],me=[];for(const De of V)ne.push(...Z.slice(De.start,De.start+De.deleteCount)),me.push(...De.toInsert);return{removed:ne,added:me}}e.delta=R;function h(Z,H,j){if(j===0)return[];const V=Z.slice(0,j).sort(H);return c(Z,H,V,j,Z.length),V}e.top=h;function v(Z,H,j,V,ne){return j===0?Promise.resolve([]):new Promise((me,De)=>{(async()=>{const ae=Z.length,fe=Z.slice(0,j).sort(H);for(let pe=j,Q=Math.min(j+V,ae);pe<ae;pe=Q,Q=Math.min(Q+V,ae)){if(pe>j&&await new Promise(z=>setTimeout(z)),ne&&ne.isCancellationRequested)throw(0,_.canceled)();c(Z,H,fe,pe,Q)}return fe})().then(me,De)})}e.topAsync=v;function c(Z,H,j,V,ne){for(const me=j.length;V<ne;V++){const De=Z[V];if(H(De,j[me-1])<0){j.pop();const ae=k(j,fe=>H(De,fe)<0);j.splice(ae,0,De)}}}function d(Z){return Z.filter(H=>!!H)}e.coalesce=d;function g(Z){let H=0;for(let j=0;j<Z.length;j++)Z[j]&&(Z[H]=Z[j],H+=1);Z.length=H}e.coalesceInPlace=g;function b(Z,H,j){Z.splice(j,0,Z.splice(H,1)[0])}e.move=b;function l(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=l;function C(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=C;function p(Z,H=j=>j){const j=new Set;return Z.filter(V=>{const ne=H(V);return j.has(ne)?!1:(j.add(ne),!0)})}e.distinct=p;function u(Z){const H=new Set;return j=>{const V=Z(j);return H.has(V)?!1:(H.add(V),!0)}}e.uniqueFilter=u;function s(Z,H){const j=a(Z,H);if(j!==-1)return Z[j]}e.findLast=s;function a(Z,H){for(let j=Z.length-1;j>=0;j--){const V=Z[j];if(H(V))return j}return-1}e.lastIndex=a;function i(Z,H){return Z.length>0?Z[0]:H}e.firstOrDefault=i;function n(Z,H,j=(V,ne)=>V===ne){let V=0;for(let ne=0,me=Math.min(Z.length,H.length);ne<me&&j(Z[ne],H[ne]);ne++)V++;return V}e.commonPrefixLength=n;function r(Z){return[].concat(...Z)}e.flatten=r;function o(Z,H){let j=typeof H=="number"?Z:0;typeof H=="number"?j=Z:(j=0,H=Z);const V=[];if(j<=H)for(let ne=j;ne<H;ne++)V.push(ne);else for(let ne=j;ne>H;ne--)V.push(ne);return V}e.range=o;function f(Z,H,j){return Z.reduce((V,ne)=>(V[H(ne)]=j?j(ne):ne,V),Object.create(null))}e.index=f;function S(Z,H){return Z.push(H),()=>A(Z,H)}e.insert=S;function A(Z,H){const j=Z.indexOf(H);if(j>-1)return Z.splice(j,1),H}e.remove=A;function I(Z,H,j){const V=Z.slice(0,H),ne=Z.slice(H);return V.concat(j,ne)}e.arrayInsert=I;function F(Z,H){let j;if(typeof H=="number"){let V=H;j=()=>{const ne=Math.sin(V++)*179426549;return ne-Math.floor(ne)}}else j=Math.random;for(let V=Z.length-1;V>0;V-=1){const ne=Math.floor(j()*(V+1)),me=Z[V];Z[V]=Z[ne],Z[ne]=me}}e.shuffle=F;function U(Z,H){const j=Z.indexOf(H);j>-1&&(Z.splice(j,1),Z.unshift(H))}e.pushToStart=U;function W(Z,H){const j=Z.indexOf(H);j>-1&&(Z.splice(j,1),Z.push(H))}e.pushToEnd=W;function m(Z,H){return Array.isArray(Z)?Z.map(H):H(Z)}e.mapArrayOrNot=m;function L(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=L;function M(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=M;function Y(Z,H){for(const j of Z){const V=H(j);if(V!==void 0)return V}}e.mapFind=Y;function $(Z,H,j){const V=ie(Z,H),ne=Z.length,me=j.length;Z.length=ne+me;for(let De=ne-1;De>=V;De--)Z[De+me]=Z[De];for(let De=0;De<me;De++)Z[De+V]=j[De]}e.insertInto=$;function G(Z,H,j,V){const ne=ie(Z,H),me=Z.splice(ne,j);return $(Z,ne,V),me}e.splice=G;function ie(Z,H){return H<0?Math.max(H+Z.length,0):Math.min(H,Z.length)}function B(Z,H){return(j,V)=>H(Z(j),Z(V))}e.compareBy=B;const q=(Z,H)=>Z-H;e.numberComparator=q;function ee(Z,H){if(Z.length===0)return;let j=Z[0];for(let V=1;V<Z.length;V++){const ne=Z[V];H(ne,j)>0&&(j=ne)}return j}e.findMaxBy=ee;function oe(Z,H){if(Z.length===0)return;let j=Z[0];for(let V=1;V<Z.length;V++){const ne=Z[V];H(ne,j)>=0&&(j=ne)}return j}e.findLastMaxBy=oe;function re(Z,H){return ee(Z,(j,V)=>-H(j,V))}e.findMinBy=re;class de{constructor(H){this.items=H,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(H){let j=this.firstIdx;for(;j<this.items.length&&H(this.items[j]);)j++;const V=j===this.firstIdx?null:this.items.slice(this.firstIdx,j);return this.firstIdx=j,V}takeFromEndWhile(H){let j=this.lastIdx;for(;j>=0&&H(this.items[j]);)j--;const V=j===this.lastIdx?null:this.items.slice(j+1,this.lastIdx+1);return this.lastIdx=j,V}peek(){return this.items[this.firstIdx]}dequeue(){const H=this.items[this.firstIdx];return this.firstIdx++,H}takeCount(H){const j=this.items.slice(this.firstIdx,this.firstIdx+H);return this.firstIdx+=H,j}}e.ArrayQueue=de}),define(ve[75],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(t){const w=this;let P=!1,D;return function(){return P||(P=!0,D=t.apply(w,arguments)),D}}e.once=_}),define(ve[51],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(t){function w(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}t.is=w;const P=Object.freeze([]);function D(){return P}t.empty=D;function*k(u){yield u}t.single=k;function y(u){return u||P}t.from=y;function E(u){return!u||u[Symbol.iterator]().next().done===!0}t.isEmpty=E;function T(u){return u[Symbol.iterator]().next().value}t.first=T;function R(u,s){for(const a of u)if(s(a))return!0;return!1}t.some=R;function h(u,s){for(const a of u)if(s(a))return a}t.find=h;function*v(u,s){for(const a of u)s(a)&&(yield a)}t.filter=v;function*c(u,s){let a=0;for(const i of u)yield s(i,a++)}t.map=c;function*d(...u){for(const s of u)for(const a of s)yield a}t.concat=d;function*g(u){for(const s of u)for(const a of s)yield a}t.concatNested=g;function b(u,s,a){let i=a;for(const n of u)i=s(i,n);return i}t.reduce=b;function*l(u,s,a=u.length){for(s<0&&(s+=u.length),a<0?a+=u.length:a>u.length&&(a=u.length);s<a;s++)yield u[s]}t.slice=l;function C(u,s=Number.POSITIVE_INFINITY){const a=[];if(s===0)return[a,u];const i=u[Symbol.iterator]();for(let n=0;n<s;n++){const r=i.next();if(r.done)return[a,t.empty()];a.push(r.value)}return[a,{[Symbol.iterator](){return i}}]}t.consume=C;function p(u,s,a=(i,n)=>i===n){const i=u[Symbol.iterator](),n=s[Symbol.iterator]();for(;;){const r=i.next(),o=n.next();if(r.done!==o.done)return!1;if(r.done)return!0;if(!a(r.value,o.value))return!1}}t.equals=p})(_=e.Iterable||(e.Iterable={}))}),define(ve[38],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(_=e.ScanError||(e.ScanError={}));var t;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(s){s.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function D(s,a=!1){let i=0,n=s.length,r="",o=0,f=16,S=0;function A(M){let Y=0,$=0;for(;Y<M;){const G=s.charCodeAt(i);if(G>=48&&G<=57)$=$*16+G-48;else if(G>=65&&G<=70)$=$*16+G-65+10;else if(G>=97&&G<=102)$=$*16+G-97+10;else break;i++,Y++}return Y<M&&($=-1),$}function I(M){i=M,r="",o=0,f=16,S=0}function F(){const M=i;if(s.charCodeAt(i)===48)i++;else for(i++;i<s.length&&E(s.charCodeAt(i));)i++;if(i<s.length&&s.charCodeAt(i)===46)if(i++,i<s.length&&E(s.charCodeAt(i)))for(i++;i<s.length&&E(s.charCodeAt(i));)i++;else return S=3,s.substring(M,i);let Y=i;if(i<s.length&&(s.charCodeAt(i)===69||s.charCodeAt(i)===101))if(i++,(i<s.length&&s.charCodeAt(i)===43||s.charCodeAt(i)===45)&&i++,i<s.length&&E(s.charCodeAt(i))){for(i++;i<s.length&&E(s.charCodeAt(i));)i++;Y=i}else S=3;return s.substring(M,Y)}function U(){let M="",Y=i;for(;;){if(i>=n){M+=s.substring(Y,i),S=2;break}const $=s.charCodeAt(i);if($===34){M+=s.substring(Y,i),i++;break}if($===92){if(M+=s.substring(Y,i),i++,i>=n){S=2;break}switch(s.charCodeAt(i++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const ie=A(4);ie>=0?M+=String.fromCharCode(ie):S=4;break}default:S=5}Y=i;continue}if($>=0&&$<=31)if(y($)){M+=s.substring(Y,i),S=2;break}else S=6;i++}return M}function W(){if(r="",S=0,o=i,i>=n)return o=n,f=17;let M=s.charCodeAt(i);if(k(M)){do i++,r+=String.fromCharCode(M),M=s.charCodeAt(i);while(k(M));return f=15}if(y(M))return i++,r+=String.fromCharCode(M),M===13&&s.charCodeAt(i)===10&&(i++,r+=`
`),f=14;switch(M){case 123:return i++,f=1;case 125:return i++,f=2;case 91:return i++,f=3;case 93:return i++,f=4;case 58:return i++,f=6;case 44:return i++,f=5;case 34:return i++,r=U(),f=10;case 47:{const Y=i-1;if(s.charCodeAt(i+1)===47){for(i+=2;i<n&&!y(s.charCodeAt(i));)i++;return r=s.substring(Y,i),f=12}if(s.charCodeAt(i+1)===42){i+=2;const $=n-1;let G=!1;for(;i<$;){if(s.charCodeAt(i)===42&&s.charCodeAt(i+1)===47){i+=2,G=!0;break}i++}return G||(i++,S=1),r=s.substring(Y,i),f=13}return r+=String.fromCharCode(M),i++,f=16}case 45:if(r+=String.fromCharCode(M),i++,i===n||!E(s.charCodeAt(i)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=F(),f=11;default:for(;i<n&&m(M);)i++,M=s.charCodeAt(i);if(o!==i){switch(r=s.substring(o,i),r){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return r+=String.fromCharCode(M),i++,f=16}}function m(M){if(k(M)||y(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let M;do M=W();while(M>=12&&M<=15);return M}return{setPosition:I,getPosition:()=>i,scan:a?L:W,getToken:()=>f,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>S}}e.createScanner=D;function k(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function y(s){return s===10||s===13||s===8232||s===8233}function E(s){return s>=48&&s<=57}var T;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(T||(T={}));function R(s,a){const i=[],n=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function S(A,I,F,U){o.value=A,o.offset=I,o.length=F,o.type=U,o.colonOffset=void 0,r=o}try{C(s,{onObjectBegin:(A,I)=>{if(a<=A)throw n;r=void 0,f=a>A,i.push("")},onObjectProperty:(A,I,F)=>{if(a<I||(S(A,I,F,"property"),i[i.length-1]=A,a<=I+F))throw n},onObjectEnd:(A,I)=>{if(a<=A)throw n;r=void 0,i.pop()},onArrayBegin:(A,I)=>{if(a<=A)throw n;r=void 0,i.push(0)},onArrayEnd:(A,I)=>{if(a<=A)throw n;r=void 0,i.pop()},onLiteralValue:(A,I,F)=>{if(a<I||(S(A,I,F,u(A)),a<=I+F))throw n},onSeparator:(A,I,F)=>{if(a<=I)throw n;if(A===":"&&r&&r.type==="property")r.colonOffset=I,f=!1,r=void 0;else if(A===","){const U=i[i.length-1];typeof U=="number"?i[i.length-1]=U+1:(f=!0,i[i.length-1]=""),r=void 0}}})}catch(A){if(A!==n)throw A}return{path:i,previousNode:r,isAtPropertyKey:f,matches:A=>{let I=0;for(let F=0;I<A.length&&F<i.length;F++)if(A[I]===i[F]||A[I]==="*")I++;else if(A[I]!=="**")return!1;return I===A.length}}}e.getLocation=R;function h(s,a=[],i=P.DEFAULT){let n=null,r=[];const o=[];function f(A){Array.isArray(r)?r.push(A):n!==null&&(r[n]=A)}return C(s,{onObjectBegin:()=>{const A={};f(A),o.push(r),r=A,n=null},onObjectProperty:A=>{n=A},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const A=[];f(A),o.push(r),r=A,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:f,onError:(A,I,F)=>{a.push({error:A,offset:I,length:F})}},i),r[0]}e.parse=h;function v(s,a=[],i=P.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(A){n.type==="property"&&(n.length=A-n.offset,n=n.parent)}function o(A){return n.children.push(A),A}C(s,{onObjectBegin:A=>{n=o({type:"object",offset:A,length:-1,parent:n,children:[]})},onObjectProperty:(A,I,F)=>{n=o({type:"property",offset:I,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:A,offset:I,length:F,parent:n})},onObjectEnd:(A,I)=>{n.length=A+I-n.offset,n=n.parent,r(A+I)},onArrayBegin:(A,I)=>{n=o({type:"array",offset:A,length:-1,parent:n,children:[]})},onArrayEnd:(A,I)=>{n.length=A+I-n.offset,n=n.parent,r(A+I)},onLiteralValue:(A,I,F)=>{o({type:u(A),offset:I,length:F,parent:n,value:A}),r(I+F)},onSeparator:(A,I,F)=>{n.type==="property"&&(A===":"?n.colonOffset=I:A===","&&r(I))},onError:(A,I,F)=>{a.push({error:A,offset:I,length:F})}},i);const S=n.children[0];return S&&delete S.parent,S}e.parseTree=v;function c(s,a){if(!s)return;let i=s;for(let n of a)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===n){i=o.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=c;function d(s){if(!s.parent||!s.parent.children)return[];const a=d(s.parent);if(s.parent.type==="property"){const i=s.parent.children[0].value;a.push(i)}else if(s.parent.type==="array"){const i=s.parent.children.indexOf(s);i!==-1&&a.push(i)}return a}e.getNodePath=d;function g(s){switch(s.type){case"array":return s.children.map(g);case"object":{const a=Object.create(null);for(let i of s.children){const n=i.children[1];n&&(a[i.children[0].value]=g(n))}return a}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=g;function b(s,a,i=!1){return a>=s.offset&&a<s.offset+s.length||i&&a===s.offset+s.length}e.contains=b;function l(s,a,i=!1){if(b(s,a,i)){const n=s.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=a;r++){const o=l(n[r],a,i);if(o)return o}return s}}e.findNodeAtOffset=l;function C(s,a,i=P.DEFAULT){const n=D(s,!1);function r(de){return de?()=>de(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(de){return de?Z=>de(Z,n.getTokenOffset(),n.getTokenLength()):()=>!0}const f=r(a.onObjectBegin),S=o(a.onObjectProperty),A=r(a.onObjectEnd),I=r(a.onArrayBegin),F=r(a.onArrayEnd),U=o(a.onLiteralValue),W=o(a.onSeparator),m=r(a.onComment),L=o(a.onError),M=i&&i.disallowComments,Y=i&&i.allowTrailingComma;function $(){for(;;){const de=n.scan();switch(n.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:M||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(de){case 12:case 13:M?G(10):m();break;case 16:G(1);break;case 15:case 14:break;default:return de}}}function G(de,Z=[],H=[]){if(L(de),Z.length+H.length>0){let j=n.getToken();for(;j!==17;){if(Z.indexOf(j)!==-1){$();break}else if(H.indexOf(j)!==-1)break;j=$()}}}function ie(de){const Z=n.getTokenValue();return de?U(Z):S(Z),$(),!0}function B(){switch(n.getToken()){case 11:{let de=0;try{de=JSON.parse(n.getTokenValue()),typeof de!="number"&&(G(2),de=0)}catch{G(2)}U(de);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return $(),!0}function q(){return n.getToken()!==10?(G(3,[],[2,5]),!1):(ie(!1),n.getToken()===6?(W(":"),$(),re()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function ee(){f(),$();let de=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(de||G(4,[],[]),W(","),$(),n.getToken()===2&&Y)break}else de&&G(6,[],[]);q()||G(4,[],[2,5]),de=!0}return A(),n.getToken()!==2?G(7,[2],[]):$(),!0}function oe(){I(),$();let de=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(de||G(4,[],[]),W(","),$(),n.getToken()===4&&Y)break}else de&&G(6,[],[]);re()||G(4,[],[4,5]),de=!0}return F(),n.getToken()!==4?G(8,[4],[]):$(),!0}function re(){switch(n.getToken()){case 3:return oe();case 1:return ee();case 10:return ie(!0);default:return B()}}return $(),n.getToken()===17?i.allowEmptyContent?!0:(G(4,[],[]),!1):re()?(n.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=C;function p(s,a){let i=D(s),n=[],r,o=0,f;do switch(f=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:o!==f&&n.push(s.substring(o,f)),a!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,a)),o=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=p;function u(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(ve[119],we([0,1,38]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(E,T,R){let h,v,c,d,g;if(T){for(d=T.offset,g=d+T.length,c=d;c>0&&!y(E,c-1);)c--;let f=g;for(;f<E.length&&!y(E,f);)f++;v=E.substring(c,f),h=D(v,R)}else v=E,h=0,c=0,d=0,g=E.length;const b=k(R,E);let l=!1,C=0,p;R.insertSpaces?p=P(" ",R.tabSize||4):p="	";const u=(0,_.createScanner)(v,!1);let s=!1;function a(){return b+P(p,h+C)}function i(){let f=u.scan();for(l=!1;f===15||f===14;)l=l||f===14,f=u.scan();return s=f===16||u.getTokenError()!==0,f}const n=[];function r(f,S,A){!s&&S<g&&A>d&&E.substring(S,A)!==f&&n.push({offset:S,length:A-S,content:f})}let o=i();if(o!==17){const f=u.getTokenOffset()+c,S=P(p,h);r(S,c,f)}for(;o!==17;){let f=u.getTokenOffset()+u.getTokenLength()+c,S=i(),A="";for(;!l&&(S===12||S===13);){const F=u.getTokenOffset()+c;r(" ",f,F),f=u.getTokenOffset()+u.getTokenLength()+c,A=S===12?a():"",S=i()}if(S===2)o!==1&&(C--,A=a());else if(S===4)o!==3&&(C--,A=a());else{switch(o){case 3:case 1:C++,A=a();break;case 5:case 12:A=a();break;case 13:l?A=a():A=" ";break;case 6:A=" ";break;case 10:if(S===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?A=" ":S!==5&&S!==17&&(s=!0);break;case 16:s=!0;break}l&&(S===12||S===13)&&(A=a())}const I=u.getTokenOffset()+c;r(A,f,I),o=S}return n}e.format=t;function w(E,T){const R=JSON.stringify(E,void 0,T.insertSpaces?T.tabSize||4:"	");return T.eol!==void 0?R.replace(/\r\n|\r|\n/g,T.eol):R}e.toFormattedString=w;function P(E,T){let R="";for(let h=0;h<T;h++)R+=E;return R}function D(E,T){let R=0,h=0;const v=T.tabSize||4;for(;R<E.length;){const c=E.charAt(R);if(c===" ")h++;else if(c==="	")h+=v;else break;R++}return Math.floor(h/v)}function k(E,T){for(let R=0;R<T.length;R++){const h=T.charAt(R);if(h==="\r")return R+1<T.length&&T.charAt(R+1)===`
`?`\r
`:"\r";if(h===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=k;function y(E,T){return`\r
`.indexOf(E.charAt(T))!==-1}e.isEOL=y}),define(ve[120],we([0,1,38,119]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function w(E,T,R){return P(E,T,void 0,R)}e.removeProperty=w;function P(E,T,R,h,v){const c=T.slice(),d=[],g=(0,_.parseTree)(E,d);let b,l;for(;c.length>0&&(l=c.pop(),b=(0,_.findNodeAtLocation)(g,c),b===void 0&&R!==void 0);)typeof l=="string"?R={[l]:R}:R=[R];if(b)if(b.type==="object"&&typeof l=="string"&&Array.isArray(b.children)){const C=(0,_.findNodeAtLocation)(b,[l]);if(C!==void 0)if(R===void 0){if(!C.parent)throw new Error("Malformed AST");const p=b.children.indexOf(C.parent);let u,s=C.parent.offset+C.parent.length;if(p>0){const a=b.children[p-1];u=a.offset+a.length}else u=b.offset+1,b.children.length>1&&(s=b.children[1].offset);return D(E,{offset:u,length:s-u,content:""},h)}else return D(E,{offset:C.offset,length:C.length,content:JSON.stringify(R)},h);else{if(R===void 0)return[];const p=`${JSON.stringify(l)}: ${JSON.stringify(R)}`,u=v?v(b.children.map(a=>a.children[0].value)):b.children.length;let s;if(u>0){const a=b.children[u-1];s={offset:a.offset+a.length,length:0,content:","+p}}else b.children.length===0?s={offset:b.offset+1,length:0,content:p}:s={offset:b.offset+1,length:0,content:p+","};return D(E,s,h)}}else if(b.type==="array"&&typeof l=="number"&&Array.isArray(b.children))if(R!==void 0){const C=`${JSON.stringify(R)}`;let p;if(b.children.length===0||l===0)p={offset:b.offset+1,length:0,content:b.children.length===0?C:C+","};else{const u=l===-1||l>b.children.length?b.children.length:l,s=b.children[u-1];p={offset:s.offset+s.length,length:0,content:","+C}}return D(E,p,h)}else{const C=l,p=b.children[C];let u;if(b.children.length===1)u={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===C){const s=b.children[C-1],a=s.offset+s.length,i=b.offset+b.length;u={offset:a,length:i-2-a,content:""}}else u={offset:p.offset,length:b.children[C+1].offset-p.offset,content:""};return D(E,u,h)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${b.type}`);else{if(R===void 0)throw new Error("Can not delete in empty document");return D(E,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(R)},h)}}e.setProperty=P;function D(E,T,R){let h=k(E,T),v=T.offset,c=T.offset+T.content.length;if(T.length===0||T.content.length===0){for(;v>0&&!(0,t.isEOL)(h,v-1);)v--;for(;c<h.length&&!(0,t.isEOL)(h,c);)c++}const d=(0,t.format)(h,{offset:v,length:c-v},R);for(let b=d.length-1;b>=0;b--){const l=d[b];h=k(h,l),v=Math.min(v,l.offset),c=Math.max(c,l.offset+l.length),c+=l.content.length-l.length}const g=E.length-(h.length-c)-v;return[{offset:v,length:g,content:h.substring(v,c)}]}e.withFormatting=D;function k(E,T){return E.substring(0,T.offset)+T.content+E.substring(T.offset+T.length)}e.applyEdit=k;function y(E,T){let R=T.slice(0).sort((v,c)=>{const d=v.offset-c.offset;return d===0?v.length-c.length:d}),h=E.length;for(let v=R.length-1;v>=0;v--){let c=R[v];if(c.offset+c.length<=h)E=k(E,c);else throw new Error("Overlapping edit");h=c.offset}return E}e.applyEdits=y}),define(ve[121],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(w){this.executor=w,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(w){this._error=w}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(w){return new _(()=>w(this.getValue()))}}e.Lazy=_}),define(ve[2],we([0,1,75,51]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const w=!1;let P=null;function D(n){P=n}if(e.setDisposableTracker=D,w){const n="__is_disposable_tracked__";D(new class{trackDisposable(r){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[n]||console.log(o)},3e3)}setParent(r,o){if(r&&r!==l.None)try{r[n]=!0}catch{}}markAsDisposed(r){if(r&&r!==l.None)try{r[n]=!0}catch{}}markAsSingleton(r){}})}function k(n){return P?.trackDisposable(n),n}function y(n){P?.markAsDisposed(n)}function E(n,r){P?.setParent(n,r)}function T(n,r){if(!!P)for(const o of n)P.setParent(o,r)}function R(n){return P?.markAsSingleton(n),n}e.markAsSingleton=R;class h extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=h;function v(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=v;function c(n){if(t.Iterable.is(n)){let r=[];for(const o of n)if(o)try{o.dispose()}catch(f){r.push(f)}if(r.length===1)throw r[0];if(r.length>1)throw new h(r);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=c;function d(...n){const r=g(()=>c(n));return T(n,r),r}e.combinedDisposable=d;function g(n){const r=k({dispose:(0,_.once)(()=>{y(r),n()})});return r}e.toDisposable=g;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{c(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return E(r,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class l{constructor(){this._store=new b,k(this),E(this._store,this)}dispose(){y(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=l,l.None=Object.freeze({dispose(){}});class C{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&E(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&E(r,null),r}}e.MutableDisposable=C;class p{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=p;class u{constructor(){this.references=new Map}acquire(r,...o){let f=this.references.get(r);f||(f={counter:0,object:this.createReferencedObject(r,...o)},this.references.set(r,f));const{object:S}=f,A=(0,_.once)(()=>{--f.counter==0&&(this.destroyReferencedObject(r,f.object),this.references.delete(r))});return f.counter++,{object:S,dispose:A}}}e.ReferenceCollection=u;class s{constructor(r){this.referenceCollection=r}async acquire(r,...o){const f=this.referenceCollection.acquire(r,...o);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(S){throw f.dispose(),S}}}e.AsyncReferenceCollection=s;class a{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=a;function i(n){const r=new b;try{n(r)}finally{r.dispose()}}e.disposeOnReturn=i}),define(ve[122],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{constructor(P){this.element=P,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class t{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){let P=this._first;for(;P!==_.Undefined;){const D=P.next;P.prev=_.Undefined,P.next=_.Undefined,P=D}this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,D){const k=new _(P);if(this._first===_.Undefined)this._first=k,this._last=k;else if(D){const E=this._last;this._last=k,k.prev=E,E.next=k}else{const E=this._first;this._first=k,k.next=E,E.prev=k}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(k))}}shift(){if(this._first!==_.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==_.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==_.Undefined&&P.next!==_.Undefined){const D=P.prev;D.next=P.next,P.next.prev=D}else P.prev===_.Undefined&&P.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):P.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):P.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==_.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(ve[123],we([1]),e):(J=typeof globalThis!="undefined"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(ae,fe){for(var pe=0;pe<fe.length;pe++){var Q=fe[pe];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(ae,Q.key,Q)}}function _(ae,fe,pe){return fe&&e(ae.prototype,fe),pe&&e(ae,pe),Object.defineProperty(ae,"prototype",{writable:!1}),ae}function t(ae,fe){if(!!ae){if(typeof ae=="string")return w(ae,fe);var pe=Object.prototype.toString.call(ae).slice(8,-1);if(pe==="Object"&&ae.constructor&&(pe=ae.constructor.name),pe==="Map"||pe==="Set")return Array.from(ae);if(pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(pe))return w(ae,fe)}}function w(ae,fe){(fe==null||fe>ae.length)&&(fe=ae.length);for(var pe=0,Q=new Array(fe);pe<fe;pe++)Q[pe]=ae[pe];return Q}function P(ae,fe){var pe=typeof Symbol!="undefined"&&ae[Symbol.iterator]||ae["@@iterator"];if(pe)return(pe=pe.call(ae)).next.bind(pe);if(Array.isArray(ae)||(pe=t(ae))||fe&&ae&&typeof ae.length=="number"){pe&&(ae=pe);var Q=0;return function(){return Q>=ae.length?{done:!0}:{done:!1,value:ae[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=D();function k(ae){J.defaults=ae}var y=/[&<>"']/,E=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,h={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(fe){return h[fe]};function c(ae,fe){if(fe){if(y.test(ae))return ae.replace(E,v)}else if(T.test(ae))return ae.replace(R,v);return ae}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(ae){return ae.replace(d,function(fe,pe){return pe=pe.toLowerCase(),pe==="colon"?":":pe.charAt(0)==="#"?pe.charAt(1)==="x"?String.fromCharCode(parseInt(pe.substring(2),16)):String.fromCharCode(+pe.substring(1)):""})}var b=/(^|[^\[])\^/g;function l(ae,fe){ae=ae.source||ae,fe=fe||"";var pe={replace:function(z,x){return x=x.source||x,x=x.replace(b,"$1"),ae=ae.replace(z,x),pe},getRegex:function(){return new RegExp(ae,fe)}};return pe}var C=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(ae,fe,pe){if(ae){var Q;try{Q=decodeURIComponent(g(pe)).replace(C,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}fe&&!p.test(pe)&&(pe=r(fe,pe));try{pe=encodeURI(pe).replace(/%25/g,"%")}catch{return null}return pe}var s={},a=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(ae,fe){s[" "+ae]||(a.test(ae)?s[" "+ae]=ae+"/":s[" "+ae]=A(ae,"/",!0)),ae=s[" "+ae];var pe=ae.indexOf(":")===-1;return fe.substring(0,2)==="//"?pe?fe:ae.replace(i,"$1")+fe:fe.charAt(0)==="/"?pe?fe:ae.replace(n,"$1")+fe:ae+fe}var o={exec:function(){}};function f(ae){for(var fe=1,pe,Q;fe<arguments.length;fe++){pe=arguments[fe];for(Q in pe)Object.prototype.hasOwnProperty.call(pe,Q)&&(ae[Q]=pe[Q])}return ae}function S(ae,fe){var pe=ae.replace(/\|/g,function(x,X,ue){for(var ye=!1,Pe=X;--Pe>=0&&ue[Pe]==="\\";)ye=!ye;return ye?"|":" |"}),Q=pe.split(/ \|/),z=0;if(Q[0].trim()||Q.shift(),Q[Q.length-1].trim()||Q.pop(),Q.length>fe)Q.splice(fe);else for(;Q.length<fe;)Q.push("");for(;z<Q.length;z++)Q[z]=Q[z].trim().replace(/\\\|/g,"|");return Q}function A(ae,fe,pe){var Q=ae.length;if(Q===0)return"";for(var z=0;z<Q;){var x=ae.charAt(Q-z-1);if(x===fe&&!pe)z++;else if(x!==fe&&pe)z++;else break}return ae.substr(0,Q-z)}function I(ae,fe){if(ae.indexOf(fe[1])===-1)return-1;for(var pe=ae.length,Q=0,z=0;z<pe;z++)if(ae[z]==="\\")z++;else if(ae[z]===fe[0])Q++;else if(ae[z]===fe[1]&&(Q--,Q<0))return z;return-1}function F(ae){ae&&ae.sanitize&&!ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function U(ae,fe){if(fe<1)return"";for(var pe="";fe>1;)fe&1&&(pe+=ae),fe>>=1,ae+=ae;return pe+ae}function W(ae,fe,pe,Q){var z=fe.href,x=fe.title?c(fe.title):null,X=ae[1].replace(/\\([\[\]])/g,"$1");if(ae[0].charAt(0)!=="!"){Q.state.inLink=!0;var ue={type:"link",raw:pe,href:z,title:x,text:X,tokens:Q.inlineTokens(X,[])};return Q.state.inLink=!1,ue}else return{type:"image",raw:pe,href:z,title:x,text:c(X)}}function m(ae,fe){var pe=ae.match(/^(\s+)(?:```)/);if(pe===null)return fe;var Q=pe[1];return fe.split(`
`).map(function(z){var x=z.match(/^\s+/);if(x===null)return z;var X=x[0];return X.length>=Q.length?z.slice(Q.length):z}).join(`
`)}var L=function(){function ae(pe){this.options=pe||J.defaults}var fe=ae.prototype;return fe.space=function(Q){var z=this.rules.block.newline.exec(Q);if(z&&z[0].length>0)return{type:"space",raw:z[0]}},fe.code=function(Q){var z=this.rules.block.code.exec(Q);if(z){var x=z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:z[0],codeBlockStyle:"indented",text:this.options.pedantic?x:A(x,`
`)}}},fe.fences=function(Q){var z=this.rules.block.fences.exec(Q);if(z){var x=z[0],X=m(x,z[3]||"");return{type:"code",raw:x,lang:z[2]?z[2].trim():z[2],text:X}}},fe.heading=function(Q){var z=this.rules.block.heading.exec(Q);if(z){var x=z[2].trim();if(/#$/.test(x)){var X=A(x,"#");(this.options.pedantic||!X||/ $/.test(X))&&(x=X.trim())}var ue={type:"heading",raw:z[0],depth:z[1].length,text:x,tokens:[]};return this.lexer.inline(ue.text,ue.tokens),ue}},fe.hr=function(Q){var z=this.rules.block.hr.exec(Q);if(z)return{type:"hr",raw:z[0]}},fe.blockquote=function(Q){var z=this.rules.block.blockquote.exec(Q);if(z){var x=z[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:z[0],tokens:this.lexer.blockTokens(x,[]),text:x}}},fe.list=function(Q){var z=this.rules.block.list.exec(Q);if(z){var x,X,ue,ye,Pe,Ae,Fe,Ue,le,ge,he,Re,Me=z[1].trim(),qe=Me.length>1,Be={type:"list",raw:"",ordered:qe,start:qe?+Me.slice(0,-1):"",loose:!1,items:[]};Me=qe?"\\d{1,9}\\"+Me.slice(-1):"\\"+Me,this.options.pedantic&&(Me=qe?Me:"[*+-]");for(var je=new RegExp("^( {0,3}"+Me+")((?: [^\\n]*)?(?:\\n|$))");Q&&(Re=!1,!(!(z=je.exec(Q))||this.rules.block.hr.test(Q)));){if(x=z[0],Q=Q.substring(x.length),Ue=z[2].split(`
`,1)[0],le=Q.split(`
`,1)[0],this.options.pedantic?(ye=2,he=Ue.trimLeft()):(ye=z[2].search(/[^ ]/),ye=ye>4?1:ye,he=Ue.slice(ye),ye+=z[1].length),Ae=!1,!Ue&&/^ *$/.test(le)&&(x+=le+`
`,Q=Q.substring(le.length+1),Re=!0),!Re)for(var He=new RegExp("^ {0,"+Math.min(3,ye-1)+"}(?:[*+-]|\\d{1,9}[.)])");Q&&(ge=Q.split(`
`,1)[0],Ue=ge,this.options.pedantic&&(Ue=Ue.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!He.test(Ue));){if(Ue.search(/[^ ]/)>=ye||!Ue.trim())he+=`
`+Ue.slice(ye);else if(!Ae)he+=`
`+Ue;else break;!Ae&&!Ue.trim()&&(Ae=!0),x+=ge+`
`,Q=Q.substring(ge.length+1)}Be.loose||(Fe?Be.loose=!0:/\n *\n *$/.test(x)&&(Fe=!0)),this.options.gfm&&(X=/^\[[ xX]\] /.exec(he),X&&(ue=X[0]!=="[ ] ",he=he.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:x,task:!!X,checked:ue,loose:!1,text:he}),Be.raw+=x}Be.items[Be.items.length-1].raw=x.trimRight(),Be.items[Be.items.length-1].text=he.trimRight(),Be.raw=Be.raw.trimRight();var se=Be.items.length;for(Pe=0;Pe<se;Pe++){this.lexer.state.top=!1,Be.items[Pe].tokens=this.lexer.blockTokens(Be.items[Pe].text,[]);var Se=Be.items[Pe].tokens.filter(function(Le){return Le.type==="space"}),ke=Se.every(function(Le){for(var Oe=Le.raw.split(""),Ye=0,$e=P(Oe),Ve;!(Ve=$e()).done;){var Xe=Ve.value;if(Xe===`
`&&(Ye+=1),Ye>1)return!0}return!1});!Be.loose&&Se.length&&ke&&(Be.loose=!0,Be.items[Pe].loose=!0)}return Be}},fe.html=function(Q){var z=this.rules.block.html.exec(Q);if(z){var x={type:"html",raw:z[0],pre:!this.options.sanitizer&&(z[1]==="pre"||z[1]==="script"||z[1]==="style"),text:z[0]};return this.options.sanitize&&(x.type="paragraph",x.text=this.options.sanitizer?this.options.sanitizer(z[0]):c(z[0]),x.tokens=[],this.lexer.inline(x.text,x.tokens)),x}},fe.def=function(Q){var z=this.rules.block.def.exec(Q);if(z){z[3]&&(z[3]=z[3].substring(1,z[3].length-1));var x=z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:x,raw:z[0],href:z[2],title:z[3]}}},fe.table=function(Q){var z=this.rules.block.table.exec(Q);if(z){var x={type:"table",header:S(z[1]).map(function(Fe){return{text:Fe}}),align:z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:z[3]?z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(x.header.length===x.align.length){x.raw=z[0];var X=x.align.length,ue,ye,Pe,Ae;for(ue=0;ue<X;ue++)/^ *-+: *$/.test(x.align[ue])?x.align[ue]="right":/^ *:-+: *$/.test(x.align[ue])?x.align[ue]="center":/^ *:-+ *$/.test(x.align[ue])?x.align[ue]="left":x.align[ue]=null;for(X=x.rows.length,ue=0;ue<X;ue++)x.rows[ue]=S(x.rows[ue],x.header.length).map(function(Fe){return{text:Fe}});for(X=x.header.length,ye=0;ye<X;ye++)x.header[ye].tokens=[],this.lexer.inlineTokens(x.header[ye].text,x.header[ye].tokens);for(X=x.rows.length,ye=0;ye<X;ye++)for(Ae=x.rows[ye],Pe=0;Pe<Ae.length;Pe++)Ae[Pe].tokens=[],this.lexer.inlineTokens(Ae[Pe].text,Ae[Pe].tokens);return x}}},fe.lheading=function(Q){var z=this.rules.block.lheading.exec(Q);if(z){var x={type:"heading",raw:z[0],depth:z[2].charAt(0)==="="?1:2,text:z[1],tokens:[]};return this.lexer.inline(x.text,x.tokens),x}},fe.paragraph=function(Q){var z=this.rules.block.paragraph.exec(Q);if(z){var x={type:"paragraph",raw:z[0],text:z[1].charAt(z[1].length-1)===`
`?z[1].slice(0,-1):z[1],tokens:[]};return this.lexer.inline(x.text,x.tokens),x}},fe.text=function(Q){var z=this.rules.block.text.exec(Q);if(z){var x={type:"text",raw:z[0],text:z[0],tokens:[]};return this.lexer.inline(x.text,x.tokens),x}},fe.escape=function(Q){var z=this.rules.inline.escape.exec(Q);if(z)return{type:"escape",raw:z[0],text:c(z[1])}},fe.tag=function(Q){var z=this.rules.inline.tag.exec(Q);if(z)return!this.lexer.state.inLink&&/^<a /i.test(z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(z[0]):c(z[0]):z[0]}},fe.link=function(Q){var z=this.rules.inline.link.exec(Q);if(z){var x=z[2].trim();if(!this.options.pedantic&&/^</.test(x)){if(!/>$/.test(x))return;var X=A(x.slice(0,-1),"\\");if((x.length-X.length)%2==0)return}else{var ue=I(z[2],"()");if(ue>-1){var ye=z[0].indexOf("!")===0?5:4,Pe=ye+z[1].length+ue;z[2]=z[2].substring(0,ue),z[0]=z[0].substring(0,Pe).trim(),z[3]=""}}var Ae=z[2],Fe="";if(this.options.pedantic){var Ue=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);Ue&&(Ae=Ue[1],Fe=Ue[3])}else Fe=z[3]?z[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(x)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),W(z,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Fe&&Fe.replace(this.rules.inline._escapes,"$1")},z[0],this.lexer)}},fe.reflink=function(Q,z){var x;if((x=this.rules.inline.reflink.exec(Q))||(x=this.rules.inline.nolink.exec(Q))){var X=(x[2]||x[1]).replace(/\s+/g," ");if(X=z[X.toLowerCase()],!X||!X.href){var ue=x[0].charAt(0);return{type:"text",raw:ue,text:ue}}return W(x,X,x[0],this.lexer)}},fe.emStrong=function(Q,z,x){x===void 0&&(x="");var X=this.rules.inline.emStrong.lDelim.exec(Q);if(!!X&&!(X[3]&&x.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ue=X[1]||X[2]||"";if(!ue||ue&&(x===""||this.rules.inline.punctuation.exec(x))){var ye=X[0].length-1,Pe,Ae,Fe=ye,Ue=0,le=X[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(le.lastIndex=0,z=z.slice(-1*Q.length+ye);(X=le.exec(z))!=null;)if(Pe=X[1]||X[2]||X[3]||X[4]||X[5]||X[6],!!Pe){if(Ae=Pe.length,X[3]||X[4]){Fe+=Ae;continue}else if((X[5]||X[6])&&ye%3&&!((ye+Ae)%3)){Ue+=Ae;continue}if(Fe-=Ae,!(Fe>0)){if(Ae=Math.min(Ae,Ae+Fe+Ue),Math.min(ye,Ae)%2){var ge=Q.slice(1,ye+X.index+Ae);return{type:"em",raw:Q.slice(0,ye+X.index+Ae+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var he=Q.slice(2,ye+X.index+Ae-1);return{type:"strong",raw:Q.slice(0,ye+X.index+Ae+1),text:he,tokens:this.lexer.inlineTokens(he,[])}}}}}},fe.codespan=function(Q){var z=this.rules.inline.code.exec(Q);if(z){var x=z[2].replace(/\n/g," "),X=/[^ ]/.test(x),ue=/^ /.test(x)&&/ $/.test(x);return X&&ue&&(x=x.substring(1,x.length-1)),x=c(x,!0),{type:"codespan",raw:z[0],text:x}}},fe.br=function(Q){var z=this.rules.inline.br.exec(Q);if(z)return{type:"br",raw:z[0]}},fe.del=function(Q){var z=this.rules.inline.del.exec(Q);if(z)return{type:"del",raw:z[0],text:z[2],tokens:this.lexer.inlineTokens(z[2],[])}},fe.autolink=function(Q,z){var x=this.rules.inline.autolink.exec(Q);if(x){var X,ue;return x[2]==="@"?(X=c(this.options.mangle?z(x[1]):x[1]),ue="mailto:"+X):(X=c(x[1]),ue=X),{type:"link",raw:x[0],text:X,href:ue,tokens:[{type:"text",raw:X,text:X}]}}},fe.url=function(Q,z){var x;if(x=this.rules.inline.url.exec(Q)){var X,ue;if(x[2]==="@")X=c(this.options.mangle?z(x[0]):x[0]),ue="mailto:"+X;else{var ye;do ye=x[0],x[0]=this.rules.inline._backpedal.exec(x[0])[0];while(ye!==x[0]);X=c(x[0]),x[1]==="www."?ue="http://"+X:ue=X}return{type:"link",raw:x[0],text:X,href:ue,tokens:[{type:"text",raw:X,text:X}]}}},fe.inlineText=function(Q,z){var x=this.rules.inline.text.exec(Q);if(x){var X;return this.lexer.state.inRawBlock?X=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):c(x[0]):x[0]:X=c(this.options.smartypants?z(x[0]):x[0]),{type:"text",raw:x[0],text:X}}},ae}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:o,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=l(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=l(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=l(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=l(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=l(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=l(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=f({},M),M.gfm=f({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=l(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=l(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=f({},M.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:o,paragraph:l(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Y={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:o,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:o,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Y._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Y.punctuation=l(Y.punctuation).replace(/punctuation/g,Y._punctuation).getRegex(),Y.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Y.escapedEmSt=/\\\*|\\_/g,Y._comment=l(M._comment).replace("(?:-->|$)","-->").getRegex(),Y.emStrong.lDelim=l(Y.emStrong.lDelim).replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimAst=l(Y.emStrong.rDelimAst,"g").replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimUnd=l(Y.emStrong.rDelimUnd,"g").replace(/punct/g,Y._punctuation).getRegex(),Y._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Y._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Y._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Y.autolink=l(Y.autolink).replace("scheme",Y._scheme).replace("email",Y._email).getRegex(),Y._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Y.tag=l(Y.tag).replace("comment",Y._comment).replace("attribute",Y._attribute).getRegex(),Y._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Y._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Y._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Y.link=l(Y.link).replace("label",Y._label).replace("href",Y._href).replace("title",Y._title).getRegex(),Y.reflink=l(Y.reflink).replace("label",Y._label).replace("ref",M._label).getRegex(),Y.nolink=l(Y.nolink).replace("ref",M._label).getRegex(),Y.reflinkSearch=l(Y.reflinkSearch,"g").replace("reflink",Y.reflink).replace("nolink",Y.nolink).getRegex(),Y.normal=f({},Y),Y.pedantic=f({},Y.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",Y._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Y._label).getRegex()}),Y.gfm=f({},Y.normal,{escape:l(Y.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Y.gfm.url=l(Y.gfm.url,"i").replace("email",Y.gfm._extended_email).getRegex(),Y.breaks=f({},Y.gfm,{br:l(Y.br).replace("{2,}","*").getRegex(),text:l(Y.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function $(ae){return ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(ae){var fe="",pe,Q,z=ae.length;for(pe=0;pe<z;pe++)Q=ae.charCodeAt(pe),Math.random()>.5&&(Q="x"+Q.toString(16)),fe+="&#"+Q+";";return fe}var ie=function(){function ae(pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=pe||J.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:M.normal,inline:Y.normal};this.options.pedantic?(Q.block=M.pedantic,Q.inline=Y.pedantic):this.options.gfm&&(Q.block=M.gfm,this.options.breaks?Q.inline=Y.breaks:Q.inline=Y.gfm),this.tokenizer.rules=Q}ae.lex=function(Q,z){var x=new ae(z);return x.lex(Q)},ae.lexInline=function(Q,z){var x=new ae(z);return x.inlineTokens(Q)};var fe=ae.prototype;return fe.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Q,this.tokens);for(var z;z=this.inlineQueue.shift();)this.inlineTokens(z.src,z.tokens);return this.tokens},fe.blockTokens=function(Q,z){var x=this;z===void 0&&(z=[]),this.options.pedantic&&(Q=Q.replace(/^ +$/gm,""));for(var X,ue,ye,Pe;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Fe){return(X=Fe.call({lexer:x},Q,z))?(Q=Q.substring(X.raw.length),z.push(X),!0):!1}))){if(X=this.tokenizer.space(Q)){Q=Q.substring(X.raw.length),X.raw.length===1&&z.length>0?z[z.length-1].raw+=`
`:z.push(X);continue}if(X=this.tokenizer.code(Q)){Q=Q.substring(X.raw.length),ue=z[z.length-1],ue&&(ue.type==="paragraph"||ue.type==="text")?(ue.raw+=`
`+X.raw,ue.text+=`
`+X.text,this.inlineQueue[this.inlineQueue.length-1].src=ue.text):z.push(X);continue}if(X=this.tokenizer.fences(Q)){Q=Q.substring(X.raw.length),z.push(X);continue}if(X=this.tokenizer.heading(Q)){Q=Q.substring(X.raw.length),z.push(X);continue}if(X=this.tokenizer.hr(Q)){Q=Q.substring(X.raw.length),z.push(X);continue}if(X=this.tokenizer.blockquote(Q)){Q=Q.substring(X.raw.length),z.push(X);continue}if(X=this.tokenizer.list(Q)){Q=Q.substring(X.raw.length),z.push(X);continue}if(X=this.tokenizer.html(Q)){Q=Q.substring(X.raw.length),z.push(X);continue}if(X=this.tokenizer.def(Q)){Q=Q.substring(X.raw.length),ue=z[z.length-1],ue&&(ue.type==="paragraph"||ue.type==="text")?(ue.raw+=`
`+X.raw,ue.text+=`
`+X.raw,this.inlineQueue[this.inlineQueue.length-1].src=ue.text):this.tokens.links[X.tag]||(this.tokens.links[X.tag]={href:X.href,title:X.title});continue}if(X=this.tokenizer.table(Q)){Q=Q.substring(X.raw.length),z.push(X);continue}if(X=this.tokenizer.lheading(Q)){Q=Q.substring(X.raw.length),z.push(X);continue}if(ye=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var Fe=1/0,Ue=Q.slice(1),le=void 0;x.options.extensions.startBlock.forEach(function(ge){le=ge.call({lexer:this},Ue),typeof le=="number"&&le>=0&&(Fe=Math.min(Fe,le))}),Fe<1/0&&Fe>=0&&(ye=Q.substring(0,Fe+1))}(),this.state.top&&(X=this.tokenizer.paragraph(ye))){ue=z[z.length-1],Pe&&ue.type==="paragraph"?(ue.raw+=`
`+X.raw,ue.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ue.text):z.push(X),Pe=ye.length!==Q.length,Q=Q.substring(X.raw.length);continue}if(X=this.tokenizer.text(Q)){Q=Q.substring(X.raw.length),ue=z[z.length-1],ue&&ue.type==="text"?(ue.raw+=`
`+X.raw,ue.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ue.text):z.push(X);continue}if(Q){var Ae="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,z},fe.inline=function(Q,z){this.inlineQueue.push({src:Q,tokens:z})},fe.inlineTokens=function(Q,z){var x=this;z===void 0&&(z=[]);var X,ue,ye,Pe=Q,Ae,Fe,Ue;if(this.tokens.links){var le=Object.keys(this.tokens.links);if(le.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)le.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Ae.index)+"["+U("a",Ae[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Ae.index)+"["+U("a",Ae[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Ae.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(Fe||(Ue=""),Fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(he){return(X=he.call({lexer:x},Q,z))?(Q=Q.substring(X.raw.length),z.push(X),!0):!1}))){if(X=this.tokenizer.escape(Q)){Q=Q.substring(X.raw.length),z.push(X);continue}if(X=this.tokenizer.tag(Q)){Q=Q.substring(X.raw.length),ue=z[z.length-1],ue&&X.type==="text"&&ue.type==="text"?(ue.raw+=X.raw,ue.text+=X.text):z.push(X);continue}if(X=this.tokenizer.link(Q)){Q=Q.substring(X.raw.length),z.push(X);continue}if(X=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(X.raw.length),ue=z[z.length-1],ue&&X.type==="text"&&ue.type==="text"?(ue.raw+=X.raw,ue.text+=X.text):z.push(X);continue}if(X=this.tokenizer.emStrong(Q,Pe,Ue)){Q=Q.substring(X.raw.length),z.push(X);continue}if(X=this.tokenizer.codespan(Q)){Q=Q.substring(X.raw.length),z.push(X);continue}if(X=this.tokenizer.br(Q)){Q=Q.substring(X.raw.length),z.push(X);continue}if(X=this.tokenizer.del(Q)){Q=Q.substring(X.raw.length),z.push(X);continue}if(X=this.tokenizer.autolink(Q,G)){Q=Q.substring(X.raw.length),z.push(X);continue}if(!this.state.inLink&&(X=this.tokenizer.url(Q,G))){Q=Q.substring(X.raw.length),z.push(X);continue}if(ye=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var he=1/0,Re=Q.slice(1),Me=void 0;x.options.extensions.startInline.forEach(function(qe){Me=qe.call({lexer:this},Re),typeof Me=="number"&&Me>=0&&(he=Math.min(he,Me))}),he<1/0&&he>=0&&(ye=Q.substring(0,he+1))}(),X=this.tokenizer.inlineText(ye,$)){Q=Q.substring(X.raw.length),X.raw.slice(-1)!=="_"&&(Ue=X.raw.slice(-1)),Fe=!0,ue=z[z.length-1],ue&&ue.type==="text"?(ue.raw+=X.raw,ue.text+=X.text):z.push(X);continue}if(Q){var ge="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return z},_(ae,null,[{key:"rules",get:function(){return{block:M,inline:Y}}}]),ae}(),B=function(){function ae(pe){this.options=pe||J.defaults}var fe=ae.prototype;return fe.code=function(Q,z,x){var X=(z||"").match(/\S*/)[0];if(this.options.highlight){var ue=this.options.highlight(Q,X);ue!=null&&ue!==Q&&(x=!0,Q=ue)}return Q=Q.replace(/\n$/,"")+`
`,X?'<pre><code class="'+this.options.langPrefix+c(X,!0)+'">'+(x?Q:c(Q,!0))+`</code></pre>
`:"<pre><code>"+(x?Q:c(Q,!0))+`</code></pre>
`},fe.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},fe.html=function(Q){return Q},fe.heading=function(Q,z,x,X){return this.options.headerIds?"<h"+z+' id="'+this.options.headerPrefix+X.slug(x)+'">'+Q+"</h"+z+`>
`:"<h"+z+">"+Q+"</h"+z+`>
`},fe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},fe.list=function(Q,z,x){var X=z?"ol":"ul",ue=z&&x!==1?' start="'+x+'"':"";return"<"+X+ue+`>
`+Q+"</"+X+`>
`},fe.listitem=function(Q){return"<li>"+Q+`</li>
`},fe.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},fe.paragraph=function(Q){return"<p>"+Q+`</p>
`},fe.table=function(Q,z){return z&&(z="<tbody>"+z+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+z+`</table>
`},fe.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},fe.tablecell=function(Q,z){var x=z.header?"th":"td",X=z.align?"<"+x+' align="'+z.align+'">':"<"+x+">";return X+Q+"</"+x+`>
`},fe.strong=function(Q){return"<strong>"+Q+"</strong>"},fe.em=function(Q){return"<em>"+Q+"</em>"},fe.codespan=function(Q){return"<code>"+Q+"</code>"},fe.br=function(){return this.options.xhtml?"<br/>":"<br>"},fe.del=function(Q){return"<del>"+Q+"</del>"},fe.link=function(Q,z,x){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return x;var X='<a href="'+c(Q)+'"';return z&&(X+=' title="'+z+'"'),X+=">"+x+"</a>",X},fe.image=function(Q,z,x){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return x;var X='<img src="'+Q+'" alt="'+x+'"';return z&&(X+=' title="'+z+'"'),X+=this.options.xhtml?"/>":">",X},fe.text=function(Q){return Q},ae}(),q=function(){function ae(){}var fe=ae.prototype;return fe.strong=function(Q){return Q},fe.em=function(Q){return Q},fe.codespan=function(Q){return Q},fe.del=function(Q){return Q},fe.html=function(Q){return Q},fe.text=function(Q){return Q},fe.link=function(Q,z,x){return""+x},fe.image=function(Q,z,x){return""+x},fe.br=function(){return""},ae}(),ee=function(){function ae(){this.seen={}}var fe=ae.prototype;return fe.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},fe.getNextSafeSlug=function(Q,z){var x=Q,X=0;if(this.seen.hasOwnProperty(x)){X=this.seen[Q];do X++,x=Q+"-"+X;while(this.seen.hasOwnProperty(x))}return z||(this.seen[Q]=X,this.seen[x]=0),x},fe.slug=function(Q,z){z===void 0&&(z={});var x=this.serialize(Q);return this.getNextSafeSlug(x,z.dryrun)},ae}(),oe=function(){function ae(pe){this.options=pe||J.defaults,this.options.renderer=this.options.renderer||new B,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new ee}ae.parse=function(Q,z){var x=new ae(z);return x.parse(Q)},ae.parseInline=function(Q,z){var x=new ae(z);return x.parseInline(Q)};var fe=ae.prototype;return fe.parse=function(Q,z){z===void 0&&(z=!0);var x="",X,ue,ye,Pe,Ae,Fe,Ue,le,ge,he,Re,Me,qe,Be,je,He,se,Se,ke,Le=Q.length;for(X=0;X<Le;X++){if(he=Q[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]&&(ke=this.options.extensions.renderers[he.type].call({parser:this},he),ke!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(he.type))){x+=ke||"";continue}switch(he.type){case"space":continue;case"hr":{x+=this.renderer.hr();continue}case"heading":{x+=this.renderer.heading(this.parseInline(he.tokens),he.depth,g(this.parseInline(he.tokens,this.textRenderer)),this.slugger);continue}case"code":{x+=this.renderer.code(he.text,he.lang,he.escaped);continue}case"table":{for(le="",Ue="",Pe=he.header.length,ue=0;ue<Pe;ue++)Ue+=this.renderer.tablecell(this.parseInline(he.header[ue].tokens),{header:!0,align:he.align[ue]});for(le+=this.renderer.tablerow(Ue),ge="",Pe=he.rows.length,ue=0;ue<Pe;ue++){for(Fe=he.rows[ue],Ue="",Ae=Fe.length,ye=0;ye<Ae;ye++)Ue+=this.renderer.tablecell(this.parseInline(Fe[ye].tokens),{header:!1,align:he.align[ye]});ge+=this.renderer.tablerow(Ue)}x+=this.renderer.table(le,ge);continue}case"blockquote":{ge=this.parse(he.tokens),x+=this.renderer.blockquote(ge);continue}case"list":{for(Re=he.ordered,Me=he.start,qe=he.loose,Pe=he.items.length,ge="",ue=0;ue<Pe;ue++)je=he.items[ue],He=je.checked,se=je.task,Be="",je.task&&(Se=this.renderer.checkbox(He),qe?je.tokens.length>0&&je.tokens[0].type==="paragraph"?(je.tokens[0].text=Se+" "+je.tokens[0].text,je.tokens[0].tokens&&je.tokens[0].tokens.length>0&&je.tokens[0].tokens[0].type==="text"&&(je.tokens[0].tokens[0].text=Se+" "+je.tokens[0].tokens[0].text)):je.tokens.unshift({type:"text",text:Se}):Be+=Se),Be+=this.parse(je.tokens,qe),ge+=this.renderer.listitem(Be,se,He);x+=this.renderer.list(ge,Re,Me);continue}case"html":{x+=this.renderer.html(he.text);continue}case"paragraph":{x+=this.renderer.paragraph(this.parseInline(he.tokens));continue}case"text":{for(ge=he.tokens?this.parseInline(he.tokens):he.text;X+1<Le&&Q[X+1].type==="text";)he=Q[++X],ge+=`
`+(he.tokens?this.parseInline(he.tokens):he.text);x+=z?this.renderer.paragraph(ge):ge;continue}default:{var Oe='Token with "'+he.type+'" type was not found.';if(this.options.silent){console.error(Oe);return}else throw new Error(Oe)}}}return x},fe.parseInline=function(Q,z){z=z||this.renderer;var x="",X,ue,ye,Pe=Q.length;for(X=0;X<Pe;X++){if(ue=Q[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(ye=this.options.extensions.renderers[ue.type].call({parser:this},ue),ye!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ue.type))){x+=ye||"";continue}switch(ue.type){case"escape":{x+=z.text(ue.text);break}case"html":{x+=z.html(ue.text);break}case"link":{x+=z.link(ue.href,ue.title,this.parseInline(ue.tokens,z));break}case"image":{x+=z.image(ue.href,ue.title,ue.text);break}case"strong":{x+=z.strong(this.parseInline(ue.tokens,z));break}case"em":{x+=z.em(this.parseInline(ue.tokens,z));break}case"codespan":{x+=z.codespan(ue.text);break}case"br":{x+=z.br();break}case"del":{x+=z.del(this.parseInline(ue.tokens,z));break}case"text":{x+=z.text(ue.text);break}default:{var Ae='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return x},ae}();function re(ae,fe,pe){if(typeof ae=="undefined"||ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");if(typeof fe=="function"&&(pe=fe,fe=null),fe=f({},re.defaults,fe||{}),F(fe),pe){var Q=fe.highlight,z;try{z=ie.lex(ae,fe)}catch(ye){return pe(ye)}var x=function(Pe){var Ae;if(!Pe)try{fe.walkTokens&&re.walkTokens(z,fe.walkTokens),Ae=oe.parse(z,fe)}catch(Fe){Pe=Fe}return fe.highlight=Q,Pe?pe(Pe):pe(null,Ae)};if(!Q||Q.length<3||(delete fe.highlight,!z.length))return x();var X=0;re.walkTokens(z,function(ye){ye.type==="code"&&(X++,setTimeout(function(){Q(ye.text,ye.lang,function(Pe,Ae){if(Pe)return x(Pe);Ae!=null&&Ae!==ye.text&&(ye.text=Ae,ye.escaped=!0),X--,X===0&&x()})},0))}),X===0&&x();return}try{var ue=ie.lex(ae,fe);return fe.walkTokens&&re.walkTokens(ue,fe.walkTokens),oe.parse(ue,fe)}catch(ye){if(ye.message+=`
Please report this to https://github.com/markedjs/marked.`,fe.silent)return"<p>An error occurred:</p><pre>"+c(ye.message+"",!0)+"</pre>";throw ye}}re.options=re.setOptions=function(ae){return f(re.defaults,ae),k(re.defaults),re},re.getDefaults=D,re.defaults=J.defaults,re.use=function(){for(var ae=arguments.length,fe=new Array(ae),pe=0;pe<ae;pe++)fe[pe]=arguments[pe];var Q=f.apply(void 0,[{}].concat(fe)),z=re.defaults.extensions||{renderers:{},childTokens:{}},x;fe.forEach(function(X){if(X.extensions&&(x=!0,X.extensions.forEach(function(ye){if(!ye.name)throw new Error("extension name required");if(ye.renderer){var Pe=z.renderers?z.renderers[ye.name]:null;Pe?z.renderers[ye.name]=function(){for(var Ae=arguments.length,Fe=new Array(Ae),Ue=0;Ue<Ae;Ue++)Fe[Ue]=arguments[Ue];var le=ye.renderer.apply(this,Fe);return le===!1&&(le=Pe.apply(this,Fe)),le}:z.renderers[ye.name]=ye.renderer}if(ye.tokenizer){if(!ye.level||ye.level!=="block"&&ye.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");z[ye.level]?z[ye.level].unshift(ye.tokenizer):z[ye.level]=[ye.tokenizer],ye.start&&(ye.level==="block"?z.startBlock?z.startBlock.push(ye.start):z.startBlock=[ye.start]:ye.level==="inline"&&(z.startInline?z.startInline.push(ye.start):z.startInline=[ye.start]))}ye.childTokens&&(z.childTokens[ye.name]=ye.childTokens)})),X.renderer&&function(){var ye=re.defaults.renderer||new B,Pe=function(Ue){var le=ye[Ue];ye[Ue]=function(){for(var ge=arguments.length,he=new Array(ge),Re=0;Re<ge;Re++)he[Re]=arguments[Re];var Me=X.renderer[Ue].apply(ye,he);return Me===!1&&(Me=le.apply(ye,he)),Me}};for(var Ae in X.renderer)Pe(Ae);Q.renderer=ye}(),X.tokenizer&&function(){var ye=re.defaults.tokenizer||new L,Pe=function(Ue){var le=ye[Ue];ye[Ue]=function(){for(var ge=arguments.length,he=new Array(ge),Re=0;Re<ge;Re++)he[Re]=arguments[Re];var Me=X.tokenizer[Ue].apply(ye,he);return Me===!1&&(Me=le.apply(ye,he)),Me}};for(var Ae in X.tokenizer)Pe(Ae);Q.tokenizer=ye}(),X.walkTokens){var ue=re.defaults.walkTokens;Q.walkTokens=function(ye){X.walkTokens.call(this,ye),ue&&ue.call(this,ye)}}x&&(Q.extensions=z),re.setOptions(Q)})},re.walkTokens=function(ae,fe){for(var pe=function(){var X=z.value;switch(fe.call(re,X),X.type){case"table":{for(var ue=P(X.header),ye;!(ye=ue()).done;){var Pe=ye.value;re.walkTokens(Pe.tokens,fe)}for(var Ae=P(X.rows),Fe;!(Fe=Ae()).done;)for(var Ue=Fe.value,le=P(Ue),ge;!(ge=le()).done;){var he=ge.value;re.walkTokens(he.tokens,fe)}break}case"list":{re.walkTokens(X.items,fe);break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[X.type]?re.defaults.extensions.childTokens[X.type].forEach(function(Re){re.walkTokens(X[Re],fe)}):X.tokens&&re.walkTokens(X.tokens,fe)}},Q=P(ae),z;!(z=Q()).done;)pe()},re.parseInline=function(ae,fe){if(typeof ae=="undefined"||ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");fe=f({},re.defaults,fe||{}),F(fe);try{var pe=ie.lexInline(ae,fe);return fe.walkTokens&&re.walkTokens(pe,fe.walkTokens),oe.parseInline(pe,fe)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,fe.silent)return"<p>An error occurred:</p><pre>"+c(Q.message+"",!0)+"</pre>";throw Q}},re.Parser=oe,re.parser=oe.parse,re.Renderer=B,re.TextRenderer=q,re.Lexer=ie,re.lexer=ie.lex,re.Tokenizer=L,re.Slugger=ee,re.parse=re;var de=re.options,Z=re.setOptions,H=re.use,j=re.walkTokens,V=re.parseInline,ne=re,me=oe.parse,De=ie.lex;J.Lexer=ie,J.Parser=oe,J.Renderer=B,J.Slugger=ee,J.TextRenderer=q,J.Tokenizer=L,J.getDefaults=D,J.lexer=De,J.marked=re,J.options=de,J.parse=ne,J.parseInline=V,J.parser=me,J.setOptions=Z,J.use=H,J.walkTokens=j,Object.defineProperty(J,"__esModule",{value:!0})}),function(){function J(w){const P=[];typeof w=="number"&&P.push("code/timeOrigin",w);function D(y){P.push(y,Date.now())}function k(){const y=[];for(let E=0;E<P.length;E+=2)y.push({name:P[E],startTime:P[E+1]});return y}return{mark:D,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const D of performance.getEntriesByType("mark"))P.push({name:D.name,startTime:Math.round(w+D.startTime)});return P}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function _(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=_(t))}(),define(ve[3],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const _="en";let t=!1,w=!1,P=!1,D=!1,k=!1,y=!1,E=!1,T=!1,R,h=_,v,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const g=typeof d?.versions?.electron=="string",b=g&&d?.type==="renderer";if(e.isElectronSandboxed=b&&d?.sandboxed,typeof navigator=="object"&&!b){c=navigator.userAgent,t=c.indexOf("Windows")>=0,w=c.indexOf("Macintosh")>=0,T=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=c.indexOf("Linux")>=0,y=!0,R=navigator.language,h=R;const r=typeof document!="undefined"&&document.getElementById("vscode-remote-nls-configuration"),o=r&&r.getAttribute("data-settings");if(o)try{const f=JSON.parse(o);R=f.locale,v=f._translationsConfigFile,h=f.availableLanguages["*"]||_}catch{}}else if(typeof d=="object"){t=d.platform==="win32",w=d.platform==="darwin",P=d.platform==="linux",D=P&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,E=g,R=_,h=_;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const o=JSON.parse(r),f=o.availableLanguages["*"];R=o.locale,h=f||_,v=o._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var l;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(l=e.Platform||(e.Platform={}));function C(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=C;let p=0;w?p=1:t?p=3:P&&(p=2),e.isWindows=t,e.isMacintosh=w,e.isLinux=P,e.isLinuxSnap=D,e.isNative=k,e.isElectron=E,e.isWeb=y,e.isIOS=T,e.platform=p,e.userAgent=c,e.language=h;var u;(function(r){function o(){return e.language}r.value=o;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=f;function S(){return e.language==="en"}r.isDefault=S})(u=e.Language||(e.Language={})),e.locale=R,e.translationsConfigFile=v,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let S=0,A=r.length;S<A;S++){const I=r[S];if(I.id===f.data.vscodeScheduleAsyncWork){r.splice(S,1),I.callback();return}}});let o=0;return f=>{const S=++o;r.push({id:S,callback:f}),e.globals.postMessage({vscodeScheduleAsyncWork:S},"*")}}return r=>setTimeout(r)})();var s;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=w||T?2:t?1:3;let a=!0,i=!1;function n(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,a=new Uint16Array(r.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=n,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ve[24],we([0,1,3]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof _.globals.vscode!="undefined"&&typeof _.globals.vscode.process!="undefined"){const w=_.globals.vscode.process;t={get platform(){return w.platform},get arch(){return w.arch},get env(){return w.env},cwd(){return w.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ve[4],we([0,1,24]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,w=97,P=90,D=122,k=46,y=47,E=92,T=58,R=63;class h extends Error{constructor(p,u,s){let a;typeof u=="string"&&u.indexOf("not ")===0?(a="must not be",u=u.replace(/^not /,"")):a="must be";const i=p.indexOf(".")!==-1?"property":"argument";let n=`The "${p}" ${i} ${a} of type ${u}`;n+=`. Received type ${typeof s}`;super(n);this.code="ERR_INVALID_ARG_TYPE"}}function v(C,p){if(typeof C!="string")throw new h(p,"string",C)}function c(C){return C===y||C===E}function d(C){return C===y}function g(C){return C>=t&&C<=P||C>=w&&C<=D}function b(C,p,u,s){let a="",i=0,n=-1,r=0,o=0;for(let f=0;f<=C.length;++f){if(f<C.length)o=C.charCodeAt(f);else{if(s(o))break;o=y}if(s(o)){if(!(n===f-1||r===1))if(r===2){if(a.length<2||i!==2||a.charCodeAt(a.length-1)!==k||a.charCodeAt(a.length-2)!==k){if(a.length>2){const S=a.lastIndexOf(u);S===-1?(a="",i=0):(a=a.slice(0,S),i=a.length-1-a.lastIndexOf(u)),n=f,r=0;continue}else if(a.length!==0){a="",i=0,n=f,r=0;continue}}p&&(a+=a.length>0?`${u}..`:"..",i=2)}else a.length>0?a+=`${u}${C.slice(n+1,f)}`:a=C.slice(n+1,f),i=f-n-1;n=f,r=0}else o===k&&r!==-1?++r:r=-1}return a}function l(C,p){if(p===null||typeof p!="object")throw new h("pathObject","Object",p);const u=p.dir||p.root,s=p.base||`${p.name||""}${p.ext||""}`;return u?u===p.root?`${u}${s}`:`${u}${C}${s}`:s}e.win32={resolve(...C){let p="",u="",s=!1;for(let a=C.length-1;a>=-1;a--){let i;if(a>=0){if(i=C[a],v(i,"path"),i.length===0)continue}else p.length===0?i=_.cwd():(i=_.env[`=${p}`]||_.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==p.toLowerCase()&&i.charCodeAt(2)===E)&&(i=`${p}\\`));const n=i.length;let r=0,o="",f=!1;const S=i.charCodeAt(0);if(n===1)c(S)&&(r=1,f=!0);else if(c(S))if(f=!0,c(i.charCodeAt(1))){let A=2,I=A;for(;A<n&&!c(i.charCodeAt(A));)A++;if(A<n&&A!==I){const F=i.slice(I,A);for(I=A;A<n&&c(i.charCodeAt(A));)A++;if(A<n&&A!==I){for(I=A;A<n&&!c(i.charCodeAt(A));)A++;(A===n||A!==I)&&(o=`\\\\${F}\\${i.slice(I,A)}`,r=A)}}}else r=1;else g(S)&&i.charCodeAt(1)===T&&(o=i.slice(0,2),r=2,n>2&&c(i.charCodeAt(2))&&(f=!0,r=3));if(o.length>0)if(p.length>0){if(o.toLowerCase()!==p.toLowerCase())continue}else p=o;if(s){if(p.length>0)break}else if(u=`${i.slice(r)}\\${u}`,s=f,f&&p.length>0)break}return u=b(u,!s,"\\",c),s?`${p}\\${u}`:`${p}${u}`||"."},normalize(C){v(C,"path");const p=C.length;if(p===0)return".";let u=0,s,a=!1;const i=C.charCodeAt(0);if(p===1)return d(i)?"\\":C;if(c(i))if(a=!0,c(C.charCodeAt(1))){let r=2,o=r;for(;r<p&&!c(C.charCodeAt(r));)r++;if(r<p&&r!==o){const f=C.slice(o,r);for(o=r;r<p&&c(C.charCodeAt(r));)r++;if(r<p&&r!==o){for(o=r;r<p&&!c(C.charCodeAt(r));)r++;if(r===p)return`\\\\${f}\\${C.slice(o)}\\`;r!==o&&(s=`\\\\${f}\\${C.slice(o,r)}`,u=r)}}}else u=1;else g(i)&&C.charCodeAt(1)===T&&(s=C.slice(0,2),u=2,p>2&&c(C.charCodeAt(2))&&(a=!0,u=3));let n=u<p?b(C.slice(u),!a,"\\",c):"";return n.length===0&&!a&&(n="."),n.length>0&&c(C.charCodeAt(p-1))&&(n+="\\"),s===void 0?a?`\\${n}`:n:a?`${s}\\${n}`:`${s}${n}`},isAbsolute(C){v(C,"path");const p=C.length;if(p===0)return!1;const u=C.charCodeAt(0);return c(u)||p>2&&g(u)&&C.charCodeAt(1)===T&&c(C.charCodeAt(2))},join(...C){if(C.length===0)return".";let p,u;for(let i=0;i<C.length;++i){const n=C[i];v(n,"path"),n.length>0&&(p===void 0?p=u=n:p+=`\\${n}`)}if(p===void 0)return".";let s=!0,a=0;if(typeof u=="string"&&c(u.charCodeAt(0))){++a;const i=u.length;i>1&&c(u.charCodeAt(1))&&(++a,i>2&&(c(u.charCodeAt(2))?++a:s=!1))}if(s){for(;a<p.length&&c(p.charCodeAt(a));)a++;a>=2&&(p=`\\${p.slice(a)}`)}return e.win32.normalize(p)},relative(C,p){if(v(C,"from"),v(p,"to"),C===p)return"";const u=e.win32.resolve(C),s=e.win32.resolve(p);if(u===s||(C=u.toLowerCase(),p=s.toLowerCase(),C===p))return"";let a=0;for(;a<C.length&&C.charCodeAt(a)===E;)a++;let i=C.length;for(;i-1>a&&C.charCodeAt(i-1)===E;)i--;const n=i-a;let r=0;for(;r<p.length&&p.charCodeAt(r)===E;)r++;let o=p.length;for(;o-1>r&&p.charCodeAt(o-1)===E;)o--;const f=o-r,S=n<f?n:f;let A=-1,I=0;for(;I<S;I++){const U=C.charCodeAt(a+I);if(U!==p.charCodeAt(r+I))break;U===E&&(A=I)}if(I!==S){if(A===-1)return s}else{if(f>S){if(p.charCodeAt(r+I)===E)return s.slice(r+I+1);if(I===2)return s.slice(r+I)}n>S&&(C.charCodeAt(a+I)===E?A=I:I===2&&(A=3)),A===-1&&(A=0)}let F="";for(I=a+A+1;I<=i;++I)(I===i||C.charCodeAt(I)===E)&&(F+=F.length===0?"..":"\\..");return r+=A,F.length>0?`${F}${s.slice(r,o)}`:(s.charCodeAt(r)===E&&++r,s.slice(r,o))},toNamespacedPath(C){if(typeof C!="string")return C;if(C.length===0)return"";const p=e.win32.resolve(C);if(p.length<=2)return C;if(p.charCodeAt(0)===E){if(p.charCodeAt(1)===E){const u=p.charCodeAt(2);if(u!==R&&u!==k)return`\\\\?\\UNC\\${p.slice(2)}`}}else if(g(p.charCodeAt(0))&&p.charCodeAt(1)===T&&p.charCodeAt(2)===E)return`\\\\?\\${p}`;return C},dirname(C){v(C,"path");const p=C.length;if(p===0)return".";let u=-1,s=0;const a=C.charCodeAt(0);if(p===1)return c(a)?C:".";if(c(a)){if(u=s=1,c(C.charCodeAt(1))){let r=2,o=r;for(;r<p&&!c(C.charCodeAt(r));)r++;if(r<p&&r!==o){for(o=r;r<p&&c(C.charCodeAt(r));)r++;if(r<p&&r!==o){for(o=r;r<p&&!c(C.charCodeAt(r));)r++;if(r===p)return C;r!==o&&(u=s=r+1)}}}}else g(a)&&C.charCodeAt(1)===T&&(u=p>2&&c(C.charCodeAt(2))?3:2,s=u);let i=-1,n=!0;for(let r=p-1;r>=s;--r)if(c(C.charCodeAt(r))){if(!n){i=r;break}}else n=!1;if(i===-1){if(u===-1)return".";i=u}return C.slice(0,i)},basename(C,p){p!==void 0&&v(p,"ext"),v(C,"path");let u=0,s=-1,a=!0,i;if(C.length>=2&&g(C.charCodeAt(0))&&C.charCodeAt(1)===T&&(u=2),p!==void 0&&p.length>0&&p.length<=C.length){if(p===C)return"";let n=p.length-1,r=-1;for(i=C.length-1;i>=u;--i){const o=C.charCodeAt(i);if(c(o)){if(!a){u=i+1;break}}else r===-1&&(a=!1,r=i+1),n>=0&&(o===p.charCodeAt(n)?--n==-1&&(s=i):(n=-1,s=r))}return u===s?s=r:s===-1&&(s=C.length),C.slice(u,s)}for(i=C.length-1;i>=u;--i)if(c(C.charCodeAt(i))){if(!a){u=i+1;break}}else s===-1&&(a=!1,s=i+1);return s===-1?"":C.slice(u,s)},extname(C){v(C,"path");let p=0,u=-1,s=0,a=-1,i=!0,n=0;C.length>=2&&C.charCodeAt(1)===T&&g(C.charCodeAt(0))&&(p=s=2);for(let r=C.length-1;r>=p;--r){const o=C.charCodeAt(r);if(c(o)){if(!i){s=r+1;break}continue}a===-1&&(i=!1,a=r+1),o===k?u===-1?u=r:n!==1&&(n=1):u!==-1&&(n=-1)}return u===-1||a===-1||n===0||n===1&&u===a-1&&u===s+1?"":C.slice(u,a)},format:l.bind(null,"\\"),parse(C){v(C,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(C.length===0)return p;const u=C.length;let s=0,a=C.charCodeAt(0);if(u===1)return c(a)?(p.root=p.dir=C,p):(p.base=p.name=C,p);if(c(a)){if(s=1,c(C.charCodeAt(1))){let A=2,I=A;for(;A<u&&!c(C.charCodeAt(A));)A++;if(A<u&&A!==I){for(I=A;A<u&&c(C.charCodeAt(A));)A++;if(A<u&&A!==I){for(I=A;A<u&&!c(C.charCodeAt(A));)A++;A===u?s=A:A!==I&&(s=A+1)}}}}else if(g(a)&&C.charCodeAt(1)===T){if(u<=2)return p.root=p.dir=C,p;if(s=2,c(C.charCodeAt(2))){if(u===3)return p.root=p.dir=C,p;s=3}}s>0&&(p.root=C.slice(0,s));let i=-1,n=s,r=-1,o=!0,f=C.length-1,S=0;for(;f>=s;--f){if(a=C.charCodeAt(f),c(a)){if(!o){n=f+1;break}continue}r===-1&&(o=!1,r=f+1),a===k?i===-1?i=f:S!==1&&(S=1):i!==-1&&(S=-1)}return r!==-1&&(i===-1||S===0||S===1&&i===r-1&&i===n+1?p.base=p.name=C.slice(n,r):(p.name=C.slice(n,i),p.base=C.slice(n,r),p.ext=C.slice(i,r))),n>0&&n!==s?p.dir=C.slice(0,n-1):p.dir=p.root,p},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...C){let p="",u=!1;for(let s=C.length-1;s>=-1&&!u;s--){const a=s>=0?C[s]:_.cwd();v(a,"path"),a.length!==0&&(p=`${a}/${p}`,u=a.charCodeAt(0)===y)}return p=b(p,!u,"/",d),u?`/${p}`:p.length>0?p:"."},normalize(C){if(v(C,"path"),C.length===0)return".";const p=C.charCodeAt(0)===y,u=C.charCodeAt(C.length-1)===y;return C=b(C,!p,"/",d),C.length===0?p?"/":u?"./":".":(u&&(C+="/"),p?`/${C}`:C)},isAbsolute(C){return v(C,"path"),C.length>0&&C.charCodeAt(0)===y},join(...C){if(C.length===0)return".";let p;for(let u=0;u<C.length;++u){const s=C[u];v(s,"path"),s.length>0&&(p===void 0?p=s:p+=`/${s}`)}return p===void 0?".":e.posix.normalize(p)},relative(C,p){if(v(C,"from"),v(p,"to"),C===p||(C=e.posix.resolve(C),p=e.posix.resolve(p),C===p))return"";const u=1,s=C.length,a=s-u,i=1,n=p.length-i,r=a<n?a:n;let o=-1,f=0;for(;f<r;f++){const A=C.charCodeAt(u+f);if(A!==p.charCodeAt(i+f))break;A===y&&(o=f)}if(f===r)if(n>r){if(p.charCodeAt(i+f)===y)return p.slice(i+f+1);if(f===0)return p.slice(i+f)}else a>r&&(C.charCodeAt(u+f)===y?o=f:f===0&&(o=0));let S="";for(f=u+o+1;f<=s;++f)(f===s||C.charCodeAt(f)===y)&&(S+=S.length===0?"..":"/..");return`${S}${p.slice(i+o)}`},toNamespacedPath(C){return C},dirname(C){if(v(C,"path"),C.length===0)return".";const p=C.charCodeAt(0)===y;let u=-1,s=!0;for(let a=C.length-1;a>=1;--a)if(C.charCodeAt(a)===y){if(!s){u=a;break}}else s=!1;return u===-1?p?"/":".":p&&u===1?"//":C.slice(0,u)},basename(C,p){p!==void 0&&v(p,"ext"),v(C,"path");let u=0,s=-1,a=!0,i;if(p!==void 0&&p.length>0&&p.length<=C.length){if(p===C)return"";let n=p.length-1,r=-1;for(i=C.length-1;i>=0;--i){const o=C.charCodeAt(i);if(o===y){if(!a){u=i+1;break}}else r===-1&&(a=!1,r=i+1),n>=0&&(o===p.charCodeAt(n)?--n==-1&&(s=i):(n=-1,s=r))}return u===s?s=r:s===-1&&(s=C.length),C.slice(u,s)}for(i=C.length-1;i>=0;--i)if(C.charCodeAt(i)===y){if(!a){u=i+1;break}}else s===-1&&(a=!1,s=i+1);return s===-1?"":C.slice(u,s)},extname(C){v(C,"path");let p=-1,u=0,s=-1,a=!0,i=0;for(let n=C.length-1;n>=0;--n){const r=C.charCodeAt(n);if(r===y){if(!a){u=n+1;break}continue}s===-1&&(a=!1,s=n+1),r===k?p===-1?p=n:i!==1&&(i=1):p!==-1&&(i=-1)}return p===-1||s===-1||i===0||i===1&&p===s-1&&p===u+1?"":C.slice(p,s)},format:l.bind(null,"/"),parse(C){v(C,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(C.length===0)return p;const u=C.charCodeAt(0)===y;let s;u?(p.root="/",s=1):s=0;let a=-1,i=0,n=-1,r=!0,o=C.length-1,f=0;for(;o>=s;--o){const S=C.charCodeAt(o);if(S===y){if(!r){i=o+1;break}continue}n===-1&&(r=!1,n=o+1),S===k?a===-1?a=o:f!==1&&(f=1):a!==-1&&(f=-1)}if(n!==-1){const S=i===0&&u?1:i;a===-1||f===0||f===1&&a===n-1&&a===i+1?p.base=p.name=C.slice(S,n):(p.name=C.slice(S,a),p.base=C.slice(S,n),p.ext=C.slice(a,n))}return i>0?p.dir=C.slice(0,i-1):u&&(p.dir="/"),p},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=_.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=_.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=_.platform==="win32"?e.win32.join:e.posix.join,e.resolve=_.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=_.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=_.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=_.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=_.platform==="win32"?e.win32.extname:e.posix.extname,e.format=_.platform==="win32"?e.win32.format:e.posix.format,e.parse=_.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=_.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=_.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=_.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[59],we([0,1,4]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(R){R.text="text/plain",R.binary="application/octet-stream",R.unknown="application/unknown",R.markdown="text/markdown",R.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function D(R){const h=(0,_.extname)(R),v=w[h.toLowerCase()];return v!==void 0?v:k(R)}e.getMediaOrTextMime=D;function k(R){const h=(0,_.extname)(R);return P[h.toLowerCase()]}e.getMediaMime=k;function y(R){for(const h in P)if(P[h]===R)return h}e.getExtensionForMimeType=y;const E=/^(.+)\/(.+?)(;.+)?$/;function T(R,h){const v=E.exec(R);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:h?void 0:R}e.normalizeMimeType=T}),define(ve[76],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var _;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(_=e.Source||(e.Source={}));var t;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function w(P,...D){const k=D.reduce((T,R)=>(T[R]=!0,T),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(P).filter(T=>!k[T]).forEach(T=>{for(let R=0;R<y.length;R++)if(T.search(y[R])!==-1){delete P[T];break}})}e.sanitizeProcessEnvironment=w}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var _=e();for(var t in _)(typeof exports=="object"?exports:J)[t]=_[t]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function _(t){if(e[t])return e[t].exports;var w=e[t]={i:t,l:!1,exports:{}};return J[t].call(w.exports,w,w.exports,_),w.l=!0,w.exports}return _.m=J,_.c=e,_.d=function(t,w,P){_.o(t,w)||Object.defineProperty(t,w,{enumerable:!0,get:P})},_.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},_.t=function(t,w){if(1&w&&(t=_(t)),8&w||4&w&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(_.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&w&&typeof t!="string")for(var D in t)_.d(P,D,function(k){return t[k]}.bind(null,D));return P},_.n=function(t){var w=t&&t.__esModule?function(){return t.default}:function(){return t};return _.d(w,"a",w),w},_.o=function(t,w){return Object.prototype.hasOwnProperty.call(t,w)},_.p="",_(_.s=0)}([function(J,e,_){(function(t){var w;e=J.exports=H,w=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],y=e.src=[],E=0,T=E++;y[T]="0|[1-9]\\d*";var R=E++;y[R]="[0-9]+";var h=E++;y[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=E++;y[v]="("+y[T]+")\\.("+y[T]+")\\.("+y[T]+")";var c=E++;y[c]="("+y[R]+")\\.("+y[R]+")\\.("+y[R]+")";var d=E++;y[d]="(?:"+y[T]+"|"+y[h]+")";var g=E++;y[g]="(?:"+y[R]+"|"+y[h]+")";var b=E++;y[b]="(?:-("+y[d]+"(?:\\."+y[d]+")*))";var l=E++;y[l]="(?:-?("+y[g]+"(?:\\."+y[g]+")*))";var C=E++;y[C]="[0-9A-Za-z-]+";var p=E++;y[p]="(?:\\+("+y[C]+"(?:\\."+y[C]+")*))";var u=E++,s="v?"+y[v]+y[b]+"?"+y[p]+"?";y[u]="^"+s+"$";var a="[v=\\s]*"+y[c]+y[l]+"?"+y[p]+"?",i=E++;y[i]="^"+a+"$";var n=E++;y[n]="((?:<|>)?=?)";var r=E++;y[r]=y[R]+"|x|X|\\*";var o=E++;y[o]=y[T]+"|x|X|\\*";var f=E++;y[f]="[v=\\s]*("+y[o]+")(?:\\.("+y[o]+")(?:\\.("+y[o]+")(?:"+y[b]+")?"+y[p]+"?)?)?";var S=E++;y[S]="[v=\\s]*("+y[r]+")(?:\\.("+y[r]+")(?:\\.("+y[r]+")(?:"+y[l]+")?"+y[p]+"?)?)?";var A=E++;y[A]="^"+y[n]+"\\s*"+y[f]+"$";var I=E++;y[I]="^"+y[n]+"\\s*"+y[S]+"$";var F=E++;y[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=E++;y[U]="(?:~>?)";var W=E++;y[W]="(\\s*)"+y[U]+"\\s+",k[W]=new RegExp(y[W],"g");var m=E++;y[m]="^"+y[U]+y[f]+"$";var L=E++;y[L]="^"+y[U]+y[S]+"$";var M=E++;y[M]="(?:\\^)";var Y=E++;y[Y]="(\\s*)"+y[M]+"\\s+",k[Y]=new RegExp(y[Y],"g");var $=E++;y[$]="^"+y[M]+y[f]+"$";var G=E++;y[G]="^"+y[M]+y[S]+"$";var ie=E++;y[ie]="^"+y[n]+"\\s*("+a+")$|^$";var B=E++;y[B]="^"+y[n]+"\\s*("+s+")$|^$";var q=E++;y[q]="(\\s*)"+y[n]+"\\s*("+a+"|"+y[f]+")",k[q]=new RegExp(y[q],"g");var ee=E++;y[ee]="^\\s*("+y[f]+")\\s+-\\s+("+y[f]+")\\s*$";var oe=E++;y[oe]="^\\s*("+y[S]+")\\s+-\\s+("+y[S]+")\\s*$";var re=E++;y[re]="(<|>)?=?\\s*\\*";for(var de=0;de<35;de++)w(de,y[de]),k[de]||(k[de]=new RegExp(y[de]));function Z(le,ge){if(le instanceof H)return le;if(typeof le!="string"||le.length>P||!(ge?k[i]:k[u]).test(le))return null;try{return new H(le,ge)}catch{return null}}function H(le,ge){if(le instanceof H){if(le.loose===ge)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof H))return new H(le,ge);w("SemVer",le,ge),this.loose=ge;var he=le.trim().match(ge?k[i]:k[u]);if(!he)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Re){if(/^[0-9]+$/.test(Re)){var Me=+Re;if(Me>=0&&Me<D)return Me}return Re}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=Z,e.valid=function(le,ge){var he=Z(le,ge);return he?he.version:null},e.clean=function(le,ge){var he=Z(le.trim().replace(/^[=v]+/,""),ge);return he?he.version:null},e.SemVer=H,H.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},H.prototype.toString=function(){return this.version},H.prototype.compare=function(le){return w("SemVer.compare",this.version,this.loose,le),le instanceof H||(le=new H(le,this.loose)),this.compareMain(le)||this.comparePre(le)},H.prototype.compareMain=function(le){return le instanceof H||(le=new H(le,this.loose)),V(this.major,le.major)||V(this.minor,le.minor)||V(this.patch,le.patch)},H.prototype.comparePre=function(le){if(le instanceof H||(le=new H(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var ge=0;do{var he=this.prerelease[ge],Re=le.prerelease[ge];if(w("prerelease compare",ge,he,Re),he===void 0&&Re===void 0)return 0;if(Re===void 0)return 1;if(he===void 0)return-1;if(he!==Re)return V(he,Re)}while(++ge)},H.prototype.inc=function(le,ge){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,ge,he,Re){typeof he=="string"&&(Re=he,he=void 0);try{return new H(le,he).inc(ge,Re).version}catch{return null}},e.diff=function(le,ge){if(ae(le,ge))return null;var he=Z(le),Re=Z(ge);if(he.prerelease.length||Re.prerelease.length){for(var Me in he)if((Me==="major"||Me==="minor"||Me==="patch")&&he[Me]!==Re[Me])return"pre"+Me;return"prerelease"}for(var Me in he)if((Me==="major"||Me==="minor"||Me==="patch")&&he[Me]!==Re[Me])return Me},e.compareIdentifiers=V;var j=/^[0-9]+$/;function V(le,ge){var he=j.test(le),Re=j.test(ge);return he&&Re&&(le=+le,ge=+ge),he&&!Re?-1:Re&&!he?1:le<ge?-1:le>ge?1:0}function ne(le,ge,he){return new H(le,he).compare(new H(ge,he))}function me(le,ge,he){return ne(le,ge,he)>0}function De(le,ge,he){return ne(le,ge,he)<0}function ae(le,ge,he){return ne(le,ge,he)===0}function fe(le,ge,he){return ne(le,ge,he)!==0}function pe(le,ge,he){return ne(le,ge,he)>=0}function Q(le,ge,he){return ne(le,ge,he)<=0}function z(le,ge,he,Re){var Me;switch(ge){case"===":typeof le=="object"&&(le=le.version),typeof he=="object"&&(he=he.version),Me=le===he;break;case"!==":typeof le=="object"&&(le=le.version),typeof he=="object"&&(he=he.version),Me=le!==he;break;case"":case"=":case"==":Me=ae(le,he,Re);break;case"!=":Me=fe(le,he,Re);break;case">":Me=me(le,he,Re);break;case">=":Me=pe(le,he,Re);break;case"<":Me=De(le,he,Re);break;case"<=":Me=Q(le,he,Re);break;default:throw new TypeError("Invalid operator: "+ge)}return Me}function x(le,ge){if(le instanceof x){if(le.loose===ge)return le;le=le.value}if(!(this instanceof x))return new x(le,ge);w("comparator",le,ge),this.loose=ge,this.parse(le),this.semver===X?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}e.rcompareIdentifiers=function(le,ge){return V(ge,le)},e.major=function(le,ge){return new H(le,ge).major},e.minor=function(le,ge){return new H(le,ge).minor},e.patch=function(le,ge){return new H(le,ge).patch},e.compare=ne,e.compareLoose=function(le,ge){return ne(le,ge,!0)},e.rcompare=function(le,ge,he){return ne(ge,le,he)},e.sort=function(le,ge){return le.sort(function(he,Re){return e.compare(he,Re,ge)})},e.rsort=function(le,ge){return le.sort(function(he,Re){return e.rcompare(he,Re,ge)})},e.gt=me,e.lt=De,e.eq=ae,e.neq=fe,e.gte=pe,e.lte=Q,e.cmp=z,e.Comparator=x;var X={};function ue(le,ge){if(le instanceof ue)return le.loose===ge?le:new ue(le.raw,ge);if(le instanceof x)return new ue(le.value,ge);if(!(this instanceof ue))return new ue(le,ge);if(this.loose=ge,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function ye(le){return!le||le.toLowerCase()==="x"||le==="*"}function Pe(le,ge,he,Re,Me,qe,Be,je,He,se,Se,ke,Le){return((ge=ye(he)?"":ye(Re)?">="+he+".0.0":ye(Me)?">="+he+"."+Re+".0":">="+ge)+" "+(je=ye(He)?"":ye(se)?"<"+(+He+1)+".0.0":ye(Se)?"<"+He+"."+(+se+1)+".0":ke?"<="+He+"."+se+"."+Se+"-"+ke:"<="+je)).trim()}function Ae(le,ge){for(var he=0;he<le.length;he++)if(!le[he].test(ge))return!1;if(ge.prerelease.length){for(he=0;he<le.length;he++)if(w(le[he].semver),le[he].semver!==X&&le[he].semver.prerelease.length>0){var Re=le[he].semver;if(Re.major===ge.major&&Re.minor===ge.minor&&Re.patch===ge.patch)return!0}return!1}return!0}function Fe(le,ge,he){try{ge=new ue(ge,he)}catch{return!1}return ge.test(le)}function Ue(le,ge,he,Re){var Me,qe,Be,je,He;switch(le=new H(le,Re),ge=new ue(ge,Re),he){case">":Me=me,qe=Q,Be=De,je=">",He=">=";break;case"<":Me=De,qe=pe,Be=me,je="<",He="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(le,ge,Re))return!1;for(var se=0;se<ge.set.length;++se){var Se=ge.set[se],ke=null,Le=null;if(Se.forEach(function(Oe){Oe.semver===X&&(Oe=new x(">=0.0.0")),ke=ke||Oe,Le=Le||Oe,Me(Oe.semver,ke.semver,Re)?ke=Oe:Be(Oe.semver,Le.semver,Re)&&(Le=Oe)}),ke.operator===je||ke.operator===He||(!Le.operator||Le.operator===je)&&qe(le,Le.semver)||Le.operator===He&&Be(le,Le.semver))return!1}return!0}x.prototype.parse=function(le){var ge=this.loose?k[ie]:k[B],he=le.match(ge);if(!he)throw new TypeError("Invalid comparator: "+le);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new H(he[2],this.loose):this.semver=X},x.prototype.toString=function(){return this.value},x.prototype.test=function(le){return w("Comparator.test",le,this.loose),this.semver===X||(typeof le=="string"&&(le=new H(le,this.loose)),z(le,this.operator,this.semver,this.loose))},x.prototype.intersects=function(le,ge){if(!(le instanceof x))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new ue(le.value,ge),Fe(this.value,he,ge);if(le.operator==="")return he=new ue(this.value,ge),Fe(le.semver,he,ge);var Re=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),qe=this.semver.version===le.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),je=z(this.semver,"<",le.semver,ge)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),He=z(this.semver,">",le.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Re||Me||qe&&Be||je||He},e.Range=ue,ue.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},ue.prototype.toString=function(){return this.range},ue.prototype.parseRange=function(le){var ge=this.loose;le=le.trim(),w("range",le,ge);var he=ge?k[oe]:k[ee];le=le.replace(he,Pe),w("hyphen replace",le),le=le.replace(k[q],"$1$2$3"),w("comparator trim",le,k[q]),le=(le=(le=le.replace(k[W],"$1~")).replace(k[Y],"$1^")).split(/\s+/).join(" ");var Re=ge?k[ie]:k[B],Me=le.split(" ").map(function(qe){return function(Be,je){return w("comp",Be),Be=function(He,se){return He.trim().split(/\s+/).map(function(Se){return function(ke,Le){w("caret",ke,Le);var Oe=Le?k[G]:k[$];return ke.replace(Oe,function(Ye,$e,Ve,Xe,Ge){var Ze;return w("caret",ke,Ye,$e,Ve,Xe,Ge),ye($e)?Ze="":ye(Ve)?Ze=">="+$e+".0.0 <"+(+$e+1)+".0.0":ye(Xe)?Ze=$e==="0"?">="+$e+"."+Ve+".0 <"+$e+"."+(+Ve+1)+".0":">="+$e+"."+Ve+".0 <"+(+$e+1)+".0.0":Ge?(w("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Ze=$e==="0"?Ve==="0"?">="+$e+"."+Ve+"."+Xe+Ge+" <"+$e+"."+Ve+"."+(+Xe+1):">="+$e+"."+Ve+"."+Xe+Ge+" <"+$e+"."+(+Ve+1)+".0":">="+$e+"."+Ve+"."+Xe+Ge+" <"+(+$e+1)+".0.0"):(w("no pr"),Ze=$e==="0"?Ve==="0"?">="+$e+"."+Ve+"."+Xe+" <"+$e+"."+Ve+"."+(+Xe+1):">="+$e+"."+Ve+"."+Xe+" <"+$e+"."+(+Ve+1)+".0":">="+$e+"."+Ve+"."+Xe+" <"+(+$e+1)+".0.0"),w("caret return",Ze),Ze})}(Se,se)}).join(" ")}(Be,je),w("caret",Be),Be=function(He,se){return He.trim().split(/\s+/).map(function(Se){return function(ke,Le){var Oe=Le?k[L]:k[m];return ke.replace(Oe,function(Ye,$e,Ve,Xe,Ge){var Ze;return w("tilde",ke,Ye,$e,Ve,Xe,Ge),ye($e)?Ze="":ye(Ve)?Ze=">="+$e+".0.0 <"+(+$e+1)+".0.0":ye(Xe)?Ze=">="+$e+"."+Ve+".0 <"+$e+"."+(+Ve+1)+".0":Ge?(w("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Ze=">="+$e+"."+Ve+"."+Xe+Ge+" <"+$e+"."+(+Ve+1)+".0"):Ze=">="+$e+"."+Ve+"."+Xe+" <"+$e+"."+(+Ve+1)+".0",w("tilde return",Ze),Ze})}(Se,se)}).join(" ")}(Be,je),w("tildes",Be),Be=function(He,se){return w("replaceXRanges",He,se),He.split(/\s+/).map(function(Se){return function(ke,Le){ke=ke.trim();var Oe=Le?k[I]:k[A];return ke.replace(Oe,function(Ye,$e,Ve,Xe,Ge,Ze){w("xRange",ke,Ye,$e,Ve,Xe,Ge,Ze);var rt=ye(Ve),et=rt||ye(Xe),nt=et||ye(Ge);return $e==="="&&nt&&($e=""),rt?Ye=$e===">"||$e==="<"?"<0.0.0":"*":$e&&nt?(et&&(Xe=0),nt&&(Ge=0),$e===">"?($e=">=",et?(Ve=+Ve+1,Xe=0,Ge=0):nt&&(Xe=+Xe+1,Ge=0)):$e==="<="&&($e="<",et?Ve=+Ve+1:Xe=+Xe+1),Ye=$e+Ve+"."+Xe+"."+Ge):et?Ye=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":nt&&(Ye=">="+Ve+"."+Xe+".0 <"+Ve+"."+(+Xe+1)+".0"),w("xRange return",Ye),Ye})}(Se,se)}).join(" ")}(Be,je),w("xrange",Be),Be=function(He,se){return w("replaceStars",He,se),He.trim().replace(k[re],"")}(Be,je),w("stars",Be),Be}(qe,ge)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(qe){return!!qe.match(Re)})),Me=Me.map(function(qe){return new x(qe,ge)})},ue.prototype.intersects=function(le,ge){if(!(le instanceof ue))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Re){return le.set.some(function(Me){return Me.every(function(qe){return Re.intersects(qe,ge)})})})})},e.toComparators=function(le,ge){return new ue(le,ge).set.map(function(he){return he.map(function(Re){return Re.value}).join(" ").trim().split(" ")})},ue.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new H(le,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Ae(this.set[ge],le))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(le,ge,he){var Re=null,Me=null;try{var qe=new ue(ge,he)}catch{return null}return le.forEach(function(Be){qe.test(Be)&&(Re&&Me.compare(Be)!==-1||(Me=new H(Re=Be,he)))}),Re},e.minSatisfying=function(le,ge,he){var Re=null,Me=null;try{var qe=new ue(ge,he)}catch{return null}return le.forEach(function(Be){qe.test(Be)&&(Re&&Me.compare(Be)!==1||(Me=new H(Re=Be,he)))}),Re},e.validRange=function(le,ge){try{return new ue(le,ge).range||"*"}catch{return null}},e.ltr=function(le,ge,he){return Ue(le,ge,"<",he)},e.gtr=function(le,ge,he){return Ue(le,ge,">",he)},e.outside=Ue,e.prerelease=function(le,ge){var he=Z(le,ge);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(le,ge,he){return le=new ue(le,he),ge=new ue(ge,he),le.intersects(ge)},e.coerce=function(le){if(le instanceof H)return le;if(typeof le!="string")return null;var ge=le.match(k[F]);return ge==null?null:Z((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,_(1))},function(J,e){var _,t,w=J.exports={};function P(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function k(g){if(_===setTimeout)return setTimeout(g,0);if((_===P||!_)&&setTimeout)return _=setTimeout,setTimeout(g,0);try{return _(g,0)}catch{try{return _.call(null,g,0)}catch{return _.call(this,g,0)}}}(function(){try{_=typeof setTimeout=="function"?setTimeout:P}catch{_=P}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var y,E=[],T=!1,R=-1;function h(){T&&y&&(T=!1,y.length?E=y.concat(E):R=-1,E.length&&v())}function v(){if(!T){var g=k(h);T=!0;for(var b=E.length;b;){for(y=E,E=[];++R<b;)y&&y[R].run();R=-1,b=E.length}y=null,T=!1,function(l){if(t===clearTimeout)return clearTimeout(l);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(l);try{t(l)}catch{try{return t.call(null,l)}catch{return t.call(this,l)}}}(g)}}function c(g,b){this.fun=g,this.array=b}function d(){}w.nextTick=function(g){var b=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)b[l-1]=arguments[l];E.push(new c(g,b)),E.length!==1||T||k(v)},c.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=d,w.addListener=d,w.once=d,w.off=d,w.removeListener=d,w.removeAllListeners=d,w.emit=d,w.prependListener=d,w.prependOnceListener=d,w.listeners=function(g){return[]},w.binding=function(g){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(g){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(ve[124],we([0,1]),function(J,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(k,y,E){this.level=k,this.key=y,this.value=E,this.forward=[]}}const w=void 0;class P{constructor(k,y=2**16){this.comparator=k,this[_]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(y)|0),this._header=new t(this._maxLevel,w,w)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,w,w)}has(k){return Boolean(P._search(this,k,this.comparator))}get(k){return P._search(this,k,this.comparator)?.value}set(k,y){return P._insert(this,k,y,this.comparator)&&(this._size+=1),this}delete(k){const y=P._delete(this,k,this.comparator);return y&&(this._size-=1),y}forEach(k,y){let E=this._header.forward[0];for(;E;)k.call(y,E.value,E.key,this),E=E.forward[0]}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this._header.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this._header.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this._header.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",y=this._header.forward[0];for(;y;)k+=`node(${y.key}, ${y.value}, lvl:${y.level})`,y=y.forward[0];return k}static _search(k,y,E){let T=k._header;for(let R=k._level-1;R>=0;R--)for(;T.forward[R]&&E(T.forward[R].key,y)<0;)T=T.forward[R];if(T=T.forward[0],T&&E(T.key,y)===0)return T}static _insert(k,y,E,T){let R=[],h=k._header;for(let v=k._level-1;v>=0;v--){for(;h.forward[v]&&T(h.forward[v].key,y)<0;)h=h.forward[v];R[v]=h}if(h=h.forward[0],h&&T(h.key,y)===0)return h.value=E,!1;{let v=P._randomLevel(k);if(v>k._level){for(let c=k._level;c<v;c++)R[c]=k._header;k._level=v}h=new t(v,y,E);for(let c=0;c<v;c++)h.forward[c]=R[c].forward[c],R[c].forward[c]=h;return!0}}static _randomLevel(k,y=.5){let E=1;for(;Math.random()<y&&E<k._maxLevel;)E+=1;return E}static _delete(k,y,E){let T=[],R=k._header;for(let h=k._level-1;h>=0;h--){for(;R.forward[h]&&E(R.forward[h].key,y)<0;)R=R.forward[h];T[h]=R}if(R=R.forward[0],!R||E(R.key,y)!==0)return!1;for(let h=0;h<k._level&&T[h].forward[h]===R;h++)T[h].forward[h]=R.forward[h];for(;k._level>0&&k._header.forward[k._level-1]===w;)k._level-=1;return!0}}e.SkipList=P}),define(ve[125],we([0,1,3]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=_.globals.performance&&typeof _.globals.performance.now=="function";class w{constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new w(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?_.globals.performance.now():Date.now()}}e.StopWatch=w}),define(ve[7],we([0,1,11,75,2,122,125]),function(J,e,_,t,w,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(p){p.None=()=>w.Disposable.None;function u(ie){return(B,q=null,ee)=>{let oe=!1,re;return re=ie(de=>{if(!oe)return re?re.dispose():oe=!0,B.call(q,de)},null,ee),oe&&re.dispose(),re}}p.once=u;function s(ie,B){return f((q,ee=null,oe)=>ie(re=>q.call(ee,B(re)),null,oe))}p.map=s;function a(ie,B){return f((q,ee=null,oe)=>ie(re=>{B(re),q.call(ee,re)},null,oe))}p.forEach=a;function i(ie,B){return f((q,ee=null,oe)=>ie(re=>B(re)&&q.call(ee,re),null,oe))}p.filter=i;function n(ie){return ie}p.signal=n;function r(...ie){return(B,q=null,ee)=>(0,w.combinedDisposable)(...ie.map(oe=>oe(re=>B.call(q,re),null,ee)))}p.any=r;function o(ie,B,q){let ee=q;return s(ie,oe=>(ee=B(ee,oe),ee))}p.reduce=o;function f(ie){let B;const q=new h({onFirstListenerAdd(){B=ie(q.fire,q)},onLastListenerRemove(){B.dispose()}});return q.event}function S(ie,B,q,ee=100,oe=!1){let re,de,Z=0;return ie(H=>{Z++,re=q(re,H),oe&&!de&&(B(re),re=void 0),clearTimeout(de),de=setTimeout(()=>{const j=re;re=void 0,de=void 0,(!oe||Z>1)&&B(j),Z=0},ee)})}p.debouncedListener=S;function A(ie,B,q=100,ee=!1,oe){let re,de,Z,H=0;const j=new h({leakWarningThreshold:oe,onFirstListenerAdd(){re=ie(V=>{H++,de=B(de,V),ee&&!Z&&(j.fire(de),de=void 0),clearTimeout(Z),Z=setTimeout(()=>{const ne=de;de=void 0,Z=void 0,(!ee||H>1)&&j.fire(ne),H=0},q)})},onLastListenerRemove(){re.dispose()}});return j.event}p.debounce=A;function I(ie,B=(q,ee)=>q===ee){let q=!0,ee;return i(ie,oe=>{const re=q||!B(oe,ee);return q=!1,ee=oe,re})}p.latch=I;function F(ie,B){return[p.filter(ie,B),p.filter(ie,q=>!B(q))]}p.split=F;function U(ie,B=!1,q=[]){let ee=q.slice(),oe=ie(Z=>{ee?ee.push(Z):de.fire(Z)});const re=()=>{ee&&ee.forEach(Z=>de.fire(Z)),ee=null},de=new h({onFirstListenerAdd(){oe||(oe=ie(Z=>de.fire(Z)))},onFirstListenerDidAdd(){ee&&(B?setTimeout(re):re())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return de.event}p.buffer=U;class W{constructor(B){this.event=B}map(B){return new W(s(this.event,B))}forEach(B){return new W(a(this.event,B))}filter(B){return new W(i(this.event,B))}reduce(B,q){return new W(o(this.event,B,q))}latch(){return new W(I(this.event))}debounce(B,q=100,ee=!1,oe){return new W(A(this.event,B,q,ee,oe))}on(B,q,ee){return this.event(B,q,ee)}once(B,q,ee){return u(this.event)(B,q,ee)}}function m(ie){return new W(ie)}p.chain=m;function L(ie,B,q=ee=>ee){const ee=(...Z)=>de.fire(q(...Z)),oe=()=>ie.on(B,ee),re=()=>ie.removeListener(B,ee),de=new h({onFirstListenerAdd:oe,onLastListenerRemove:re});return de.event}p.fromNodeEventEmitter=L;function M(ie,B,q=ee=>ee){const ee=(...Z)=>de.fire(q(...Z)),oe=()=>ie.addEventListener(B,ee),re=()=>ie.removeEventListener(B,ee),de=new h({onFirstListenerAdd:oe,onLastListenerRemove:re});return de.event}p.fromDOMEventEmitter=M;function Y(ie){return new Promise(B=>u(ie)(B))}p.toPromise=Y;function $(ie,B){return B(void 0),ie(q=>B(q))}p.runAndSubscribe=$;function G(ie,B){let q=null;function ee(re){q?.dispose(),q=new w.DisposableStore,B(re,q)}ee(void 0);const oe=ie(re=>ee(re));return(0,w.toDisposable)(()=>{oe.dispose(),q?.dispose()})}p.runAndSubscribeWithStore=G})(k=e.Event||(e.Event={}));class y{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${y._idPool++}`}start(u){this._stopWatch=new D.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let E=-1;function T(p){const u=E;return E=p,{dispose(){E=u}}}e.setGlobalLeakWarningThreshold=T;class R{constructor(u,s=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let s=E;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||u<s)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(a)||0;if(this._stacks.set(a,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let n,r=0;for(const[o,f]of this._stacks)(!n||r<f)&&(n=o,r=f);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${r}):`),console.warn(n)}return()=>{const n=this._stacks.get(a)||0;this._stacks.set(a,n-1)}}}class h{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=E>0?new R(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(u,s,a)=>{this._listeners||(this._listeners=new P.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(s?[u,s]:u);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,s);const r=this._leakageMon?.check(this._listeners.size),o=(0,w.toDisposable)(()=>{r&&r(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof w.DisposableStore?a.add(o):Array.isArray(a)&&a.push(o),o}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new P.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,a]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,a):s[0].call(s[1],a)}catch(i){(0,_.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=h;class v extends h{async fireAsync(u,s,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,u]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[i,n]=this._asyncDeliveryQueue.shift(),r=[],o={...n,token:s,waitUntil:f=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");a&&(f=a(f,typeof i=="function"?i:i[0])),r.push(f)}};try{typeof i=="function"?i.call(void 0,o):i[0].call(i[1],o)}catch(f){(0,_.onUnexpectedError)(f);continue}Object.freeze(r),await Promise.allSettled(r).then(f=>{for(const S of f)S.status==="rejected"&&(0,_.onUnexpectedError)(S.reason)})}}}}e.AsyncEmitter=v;class c extends h{constructor(u){super(u);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=c;class d extends c{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=d;class g extends h{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]})}}e.MicrotaskEmitter=g;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const s={event:u,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const a=()=>{this.hasListeners&&this.unhook(s);const i=this.events.indexOf(s);this.events.splice(i,1)};return(0,w.toDisposable)((0,t.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(s=>this.emitter.fire(s))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=b;class l{constructor(){this.buffers=[]}wrapEvent(u){return(s,a,i)=>u(n=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>s.call(a,n)):s.call(a,n)},void 0,i)}bufferEvents(u){const s=[];this.buffers.push(s);const a=u();return this.buffers.pop(),s.forEach(i=>i()),a}}e.EventBufferer=l;class C{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=w.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=C}),define(ve[21],we([0,1,7]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(k,y){const E=setTimeout(k.bind(y),0);return{dispose(){clearTimeout(E)}}});var w;(function(k){function y(E){return E===k.None||E===k.Cancelled||E instanceof P?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}k.isCancellationToken=y,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(w=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=w.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=w.None}}e.CancellationTokenSource=D}),define(ve[126],we([0,1,21]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(D){this.task=D,this.result=null}get(){if(this.result)return this.result;const D=new _.CancellationTokenSource,k=this.task(D.token);return this.result={promise:k,dispose:()=>{this.result=null,D.cancel(),D.dispose()}},this.result}}e.Cache=t;class w{constructor(D){this.computeFn=D,this.lastCache=void 0,this.lastArgKey=void 0}get(D){const k=JSON.stringify(D);return this.lastArgKey!==k&&(this.lastArgKey=k,this.lastCache=this.computeFn(D)),this.lastCache}}e.LRUCachedComputed=w}),define(ve[43],we([0,1,11,2]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function w(C){const p=C;return p?[p.on,p.pause,p.resume,p.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=w;function P(C){const p=C;return p?w(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=P;function D(C,p){return new k(C,p)}e.newWriteableStream=D;class k{constructor(p,u){this.reducer=p,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(u=>u(p))}emitError(p){this.listeners.error.length===0?(0,_.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(u=>u(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,u){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(p,u){if(this.state.destroyed)return;let s;switch(p){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const a=s.indexOf(u);a>=0&&s.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(C,p){const u=[];let s;for(;(s=C.read())!==null;)u.push(s);return p(u)}e.consumeReadable=y;function E(C,p,u){const s=[];let a;for(;(a=C.read())!==null&&s.length<u;)s.push(a);return a===null&&s.length>0?p(s):{read:()=>{if(s.length>0)return s.shift();if(typeof a!="undefined"){const i=a;return a=void 0,i}return C.read()}}}e.peekReadable=E;function T(C,p){return new Promise((u,s)=>{const a=[];R(C,{onData:i=>{p&&a.push(i)},onError:i=>{p?s(i):u(void 0)},onEnd:()=>{u(p?p(a):void 0)}})})}e.consumeStream=T;function R(C,p){let u=!1;return C.on("error",s=>{u||p.onError(s)}),C.on("end",()=>{u||p.onEnd()}),C.on("data",s=>{u||p.onData(s)}),(0,t.toDisposable)(()=>u=!0)}e.listenStream=R;function h(C,p){return new Promise((u,s)=>{const a=new t.DisposableStore,i=[],n=f=>{if(i.push(f),i.length>p)return a.dispose(),C.pause(),u({stream:C,buffer:i,ended:!1})},r=f=>s(f),o=()=>u({stream:C,buffer:i,ended:!0});a.add((0,t.toDisposable)(()=>C.removeListener("error",r))),C.on("error",r),a.add((0,t.toDisposable)(()=>C.removeListener("end",o))),C.on("end",o),a.add((0,t.toDisposable)(()=>C.removeListener("data",n))),C.on("data",n)})}e.peekStream=h;function v(C,p){const u=D(p);return u.end(C),u}e.toStream=v;function c(){const C=D(()=>{throw new Error("not supported")});return C.end(),C}e.emptyStream=c;function d(C){let p=!1;return{read:()=>p?null:(p=!0,C)}}e.toReadable=d;function g(C,p,u){const s=D(u);return R(C,{onData:a=>s.write(p.data(a)),onError:a=>s.error(p.error?p.error(a):a),onEnd:()=>s.end()}),s}e.transform=g;function b(C,p,u){let s=!1;return{read:()=>{const a=p.read();return s?a:(s=!0,a!==null?u([C,a]):C)}}}e.prefixedReadable=b;function l(C,p,u){let s=!1;const a=D(u);return R(p,{onData:i=>s?a.write(i):(s=!0,a.write(u([C,i]))),onError:i=>a.error(i),onEnd:()=>{s||(s=!0,a.write(C)),a.end()}}),a}e.prefixedStream=l}),define(ve[15],we([0,1,43]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let w,P;class D{constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}static alloc(S){return t?new D(Buffer.allocUnsafe(S)):new D(new Uint8Array(S))}static wrap(S){return t&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new D(S)}static fromString(S,A){return!(A?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(S)):(w||(w=new TextEncoder),new D(w.encode(S)))}static fromByteArray(S){const A=D.alloc(S.length);for(let I=0,F=S.length;I<F;I++)A.buffer[I]=S[I];return A}static concat(S,A){if(typeof A=="undefined"){A=0;for(let U=0,W=S.length;U<W;U++)A+=S[U].byteLength}const I=D.alloc(A);let F=0;for(let U=0,W=S.length;U<W;U++){const m=S[U];I.set(m,F),F+=m.byteLength}return I}clone(){const S=D.alloc(this.byteLength);return S.set(this),S}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(S,A){return new D(this.buffer.subarray(S,A))}set(S,A){if(S instanceof D)this.buffer.set(S.buffer,A);else if(S instanceof Uint8Array)this.buffer.set(S,A);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),A);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),A);else throw new Error("Unkown argument 'array'")}readUInt32BE(S){return E(this.buffer,S)}writeUInt32BE(S,A){T(this.buffer,S,A)}readUInt32LE(S){return R(this.buffer,S)}writeUInt32LE(S,A){h(this.buffer,S,A)}readUInt8(S){return v(this.buffer,S)}writeUInt8(S,A){c(this.buffer,S,A)}}e.VSBuffer=D;function k(f,S){return f[S+0]<<0>>>0|f[S+1]<<8>>>0}e.readUInt16LE=k;function y(f,S,A){f[A+0]=S&255,S=S>>>8,f[A+1]=S&255}e.writeUInt16LE=y;function E(f,S){return f[S]*2**24+f[S+1]*2**16+f[S+2]*2**8+f[S+3]}e.readUInt32BE=E;function T(f,S,A){f[A+3]=S,S=S>>>8,f[A+2]=S,S=S>>>8,f[A+1]=S,S=S>>>8,f[A]=S}e.writeUInt32BE=T;function R(f,S){return f[S+0]<<0>>>0|f[S+1]<<8>>>0|f[S+2]<<16>>>0|f[S+3]<<24>>>0}e.readUInt32LE=R;function h(f,S,A){f[A+0]=S&255,S=S>>>8,f[A+1]=S&255,S=S>>>8,f[A+2]=S&255,S=S>>>8,f[A+3]=S&255}e.writeUInt32LE=h;function v(f,S){return f[S]}e.readUInt8=v;function c(f,S,A){f[A]=S}e.writeUInt8=c;function d(f){return _.consumeReadable(f,S=>D.concat(S))}e.readableToBuffer=d;function g(f){return _.toReadable(f)}e.bufferToReadable=g;function b(f){return _.consumeStream(f,S=>D.concat(S))}e.streamToBuffer=b;async function l(f){return f.ended?D.concat(f.buffer):D.concat([...f.buffer,await b(f.stream)])}e.bufferedStreamToBuffer=l;function C(f){return _.toStream(f,S=>D.concat(S))}e.bufferToStream=C;function p(f){return _.transform(f,{data:S=>typeof S=="string"?D.fromString(S):D.wrap(S)},S=>D.concat(S))}e.streamToBufferReadableStream=p;function u(f){return _.newWriteableStream(S=>D.concat(S),f)}e.newWriteableBufferStream=u;function s(f,S){return _.prefixedReadable(f,S,A=>D.concat(A))}e.prefixedBufferReadable=s;function a(f,S){return _.prefixedStream(f,S,A=>D.concat(A))}e.prefixedBufferStream=a;function i(f){let S=0,A=0,I=0;const F=new Uint8Array(Math.floor(f.length/4*3)),U=m=>{switch(A){case 3:F[I++]=S|m,A=0;break;case 2:F[I++]=S|m>>>2,S=m<<6,A=3;break;case 1:F[I++]=S|m>>>4,S=m<<4,A=2;break;default:S=m<<2,A=1}};for(let m=0;m<f.length;m++){const L=f.charCodeAt(m);if(L>=65&&L<=90)U(L-65);else if(L>=97&&L<=122)U(L-97+26);else if(L>=48&&L<=57)U(L-48+52);else if(L===43||L===45)U(62);else if(L===47||L===95)U(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${f[m]}`)}}const W=I;for(;A>0;)U(0);return D.wrap(F).slice(0,W)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:f},S=!0,A=!1){const I=A?r:n;let F="";const U=f.byteLength%3;let W=0;for(;W<f.byteLength-U;W+=3){const m=f[W+0],L=f[W+1],M=f[W+2];F+=I[m>>>2],F+=I[(m<<4|L>>>4)&63],F+=I[(L<<2|M>>>6)&63],F+=I[M&63]}if(U===1){const m=f[W+0];F+=I[m>>>2],F+=I[m<<4&63],S&&(F+="==")}else if(U===2){const m=f[W+0],L=f[W+1];F+=I[m>>>2],F+=I[(m<<4|L>>>4)&63],F+=I[L<<2&63],S&&(F+="=")}return F}e.encodeBase64=o}),define(ve[18],we([0,1,126,121]),function(J,e,_,t){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(se){return!se||typeof se!="string"?!0:se.trim().length===0}e.isFalsyOrWhitespace=P;const D=/{(\d+)}/g;function k(se,...Se){return Se.length===0?se:se.replace(D,function(ke,Le){const Oe=parseInt(Le,10);return isNaN(Oe)||Oe<0||Oe>=Se.length?ke:Se[Oe]})}e.format=k;const y=/{([^}]+)}/g;function E(se,Se){return se.replace(y,(ke,Le)=>Se[Le]??ke)}e.format2=E;function T(se){return se.replace(/[<>&]/g,function(Se){switch(Se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Se}})}e.escape=T;function R(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=R;function h(se,Se){let ke=0;const Le=Se.charCodeAt(0);for(let Oe=se.length-1;Oe>=0;Oe--)se.charCodeAt(Oe)===Le&&ke++;return ke}e.count=h;function v(se,Se,ke="\u2026"){return se.length<=Se?se:`${se.substr(0,Se)}${ke}`}e.truncate=v;function c(se,Se=" "){const ke=d(se,Se);return g(ke,Se)}e.trim=c;function d(se,Se){if(!se||!Se)return se;const ke=Se.length;if(ke===0||se.length===0)return se;let Le=0;for(;se.indexOf(Se,Le)===Le;)Le=Le+ke;return se.substring(Le)}e.ltrim=d;function g(se,Se){if(!se||!Se)return se;const ke=Se.length,Le=se.length;if(ke===0||Le===0)return se;let Oe=Le,Ye=-1;for(;Ye=se.lastIndexOf(Se,Oe-1),!(Ye===-1||Ye+ke!==Oe);){if(Ye===0)return"";Oe=Ye}return se.substring(0,Oe)}e.rtrim=g;function b(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=b;function l(se){return se.replace(/\*/g,"")}e.stripWildcards=l;function C(se,Se,ke={}){if(!se)throw new Error("Cannot create regex from empty string");Se||(se=R(se)),ke.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let Le="";return ke.global&&(Le+="g"),ke.matchCase||(Le+="i"),ke.multiline&&(Le+="m"),ke.unicode&&(Le+="u"),new RegExp(se,Le)}e.createRegExp=C;function p(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function u(se){return!!se.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function s(se){return(se.global?"g":"")+(se.ignoreCase?"i":"")+(se.multiline?"m":"")+(se.unicode?"u":"")}e.regExpFlags=s;function a(se){return se.split(/\r\n|\r|\n/)}e.splitLines=a;function i(se){for(let Se=0,ke=se.length;Se<ke;Se++){const Le=se.charCodeAt(Se);if(Le!==32&&Le!==9)return Se}return-1}e.firstNonWhitespaceIndex=i;function n(se,Se=0,ke=se.length){for(let Le=Se;Le<ke;Le++){const Oe=se.charCodeAt(Le);if(Oe!==32&&Oe!==9)return se.substring(Se,Le)}return se.substring(Se,ke)}e.getLeadingWhitespace=n;function r(se,Se=se.length-1){for(let ke=Se;ke>=0;ke--){const Le=se.charCodeAt(ke);if(Le!==32&&Le!==9)return ke}return-1}e.lastNonWhitespaceIndex=r;function o(se,Se){return se<Se?-1:se>Se?1:0}e.compare=o;function f(se,Se,ke=0,Le=se.length,Oe=0,Ye=Se.length){for(;ke<Le&&Oe<Ye;ke++,Oe++){let Xe=se.charCodeAt(ke),Ge=Se.charCodeAt(Oe);if(Xe<Ge)return-1;if(Xe>Ge)return 1}const $e=Le-ke,Ve=Ye-Oe;return $e<Ve?-1:$e>Ve?1:0}e.compareSubstring=f;function S(se,Se){return A(se,Se,0,se.length,0,Se.length)}e.compareIgnoreCase=S;function A(se,Se,ke=0,Le=se.length,Oe=0,Ye=Se.length){for(;ke<Le&&Oe<Ye;ke++,Oe++){let Xe=se.charCodeAt(ke),Ge=Se.charCodeAt(Oe);if(Xe===Ge)continue;if(Xe>=128||Ge>=128)return f(se.toLowerCase(),Se.toLowerCase(),ke,Le,Oe,Ye);I(Xe)&&(Xe-=32),I(Ge)&&(Ge-=32);const Ze=Xe-Ge;if(Ze!==0)return Ze}const $e=Le-ke,Ve=Ye-Oe;return $e<Ve?-1:$e>Ve?1:0}e.compareSubstringIgnoreCase=A;function I(se){return se>=97&&se<=122}e.isLowerAsciiLetter=I;function F(se){return se>=65&&se<=90}e.isUpperAsciiLetter=F;function U(se,Se){return se.length===Se.length&&A(se,Se)===0}e.equalsIgnoreCase=U;function W(se,Se){const ke=Se.length;return Se.length>se.length?!1:A(se,Se,0,ke)===0}e.startsWithIgnoreCase=W;function m(se,Se){let ke,Le=Math.min(se.length,Se.length);for(ke=0;ke<Le;ke++)if(se.charCodeAt(ke)!==Se.charCodeAt(ke))return ke;return Le}e.commonPrefixLength=m;function L(se,Se){let ke,Le=Math.min(se.length,Se.length);const Oe=se.length-1,Ye=Se.length-1;for(ke=0;ke<Le;ke++)if(se.charCodeAt(Oe-ke)!==Se.charCodeAt(Ye-ke))return ke;return Le}e.commonSuffixLength=L;function M(se){return 55296<=se&&se<=56319}e.isHighSurrogate=M;function Y(se){return 56320<=se&&se<=57343}e.isLowSurrogate=Y;function $(se,Se){return(se-55296<<10)+(Se-56320)+65536}e.computeCodePoint=$;function G(se,Se,ke){const Le=se.charCodeAt(ke);if(M(Le)&&ke+1<Se){const Oe=se.charCodeAt(ke+1);if(Y(Oe))return $(Le,Oe)}return Le}e.getNextCodePoint=G;function ie(se,Se){const ke=se.charCodeAt(Se-1);if(Y(ke)&&Se>1){const Le=se.charCodeAt(Se-2);if(M(Le))return $(Le,ke)}return ke}class B{constructor(Se,ke=0){this._str=Se,this._len=Se.length,this._offset=ke}get offset(){return this._offset}setOffset(Se){this._offset=Se}prevCodePoint(){const Se=ie(this._str,this._offset);return this._offset-=Se>=65536?2:1,Se}nextCodePoint(){const Se=G(this._str,this._len,this._offset);return this._offset+=Se>=65536?2:1,Se}eol(){return this._offset>=this._len}}e.CodePointIterator=B;class q{constructor(Se,ke=0){this._iterator=new B(Se,ke)}get offset(){return this._iterator.offset}nextGraphemeLength(){const Se=ge.getInstance(),ke=this._iterator,Le=ke.offset;let Oe=Se.getGraphemeBreakType(ke.nextCodePoint());for(;!ke.eol();){const Ye=ke.offset,$e=Se.getGraphemeBreakType(ke.nextCodePoint());if(Ue(Oe,$e)){ke.setOffset(Ye);break}Oe=$e}return ke.offset-Le}prevGraphemeLength(){const Se=ge.getInstance(),ke=this._iterator,Le=ke.offset;let Oe=Se.getGraphemeBreakType(ke.prevCodePoint());for(;ke.offset>0;){const Ye=ke.offset,$e=Se.getGraphemeBreakType(ke.prevCodePoint());if(Ue($e,Oe)){ke.setOffset(Ye);break}Oe=$e}return Le-ke.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=q;function ee(se,Se){return new q(se,Se).nextGraphemeLength()}e.nextCharLength=ee;function oe(se,Se){return new q(se,Se).prevGraphemeLength()}e.prevCharLength=oe;function re(se,Se){Se>0&&Y(se.charCodeAt(Se))&&Se--;const ke=Se+ee(se,Se);return[ke-oe(se,ke),ke]}e.getCharContainingOffset=re;const de=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Z(se){return de.test(se)}e.containsRTL=Z;const H=/^[\t\n\r\x20-\x7E]*$/;function j(se){return H.test(se)}e.isBasicASCII=j,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function V(se){return e.UNUSUAL_LINE_TERMINATORS.test(se)}e.containsUnusualLineTerminators=V;function ne(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}e.isFullWidthCharacter=ne;function me(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}e.isEmojiImprecise=me;function De(se,Se){if(se.length<Se)return se;const ke=/\b/g;let Le=0;for(;ke.test(se)&&!(se.length-ke.lastIndex<Se);)Le=ke.lastIndex,ke.lastIndex+=1;return se.substring(Le).replace(/^\s/,"")}e.lcut=De;const ae=/\x1B\x5B[12]?K/g,fe=/\x1b\[\d+m/g,pe=/\x1b\[0?m/g;function Q(se){return se&&(se=se.replace(ae,""),se=se.replace(fe,""),se=se.replace(pe,"")),se}e.removeAnsiEscapeCodes=Q,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function z(se){return!!(se&&se.length>0&&se.charCodeAt(0)===65279)}e.startsWithUTF8BOM=z;function x(se){return z(se)?se.substr(1):se}e.stripUTF8BOM=x;function X(se,Se){if(!se||!Se||se.length<Se.length)return!1;const ke=Se.length,Le=se.toLowerCase();let Oe=0,Ye=-1;for(;Oe<ke;){const $e=Le.indexOf(Se[Oe],Ye+1);if($e<0)return!1;Ye=$e,Oe++}return!0}e.fuzzyContains=X;function ue(se,Se=!1){return se?(Se&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}e.containsUppercaseCharacter=ue;function ye(se){return se.charAt(0).toUpperCase()+se.slice(1)}e.uppercaseFirstLetter=ye;function Pe(se,Se=1){if(Se===0)return"";let ke=-1;do ke=se.indexOf(`
`,ke+1),Se--;while(Se>0&&ke>=0);return ke===-1?se:(se[ke-1]==="\r"&&ke--,se.substr(0,ke))}e.getNLines=Pe;function Ae(se){const Se=90-65+1;return se=se%(2*Se),se<Se?String.fromCharCode(97+se):String.fromCharCode(65+se-Se)}e.singleLetterHash=Ae;function Fe(se){return ge.getInstance().getGraphemeBreakType(se)}e.getGraphemeBreakType=Fe;function Ue(se,Se){return se===0?Se!==5&&Se!==7:se===2&&Se===3?!1:se===4||se===2||se===3||Se===4||Se===2||Se===3?!0:!(se===8&&(Se===8||Se===9||Se===11||Se===12)||(se===11||se===9)&&(Se===9||Se===10)||(se===12||se===10)&&Se===10||Se===5||Se===13||Se===7||se===1||se===13&&Se===14||se===6&&Se===6)}var le;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(le=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ge{constructor(){this._data=he()}static getInstance(){return ge._INSTANCE||(ge._INSTANCE=new ge),ge._INSTANCE}getGraphemeBreakType(Se){if(Se<32)return Se===10?3:Se===13?2:4;if(Se<127)return 0;const ke=this._data,Le=ke.length/3;let Oe=1;for(;Oe<=Le;)if(Se<ke[3*Oe])Oe=2*Oe;else if(Se>ke[3*Oe+1])Oe=2*Oe+1;else return ke[3*Oe+2];return 0}}ge._INSTANCE=null;function he(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Re(se,Se){if(se===0)return 0;const ke=Me(se,Se);if(ke!==void 0)return ke;const Le=new B(Se,se);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=Re;function Me(se,Se){const ke=new B(Se,se);let Le=ke.prevCodePoint();for(;qe(Le)||Le===65039||Le===8419;){if(ke.offset===0)return;Le=ke.prevCodePoint()}if(!me(Le))return;let Oe=ke.offset;return Oe>0&&ke.prevCodePoint()===8205&&(Oe=ke.offset),Oe}function qe(se){return 127995<=se&&se<=127999}var Be;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.noBreakWhitespace="\xA0";class je{constructor(Se){this.confusableDictionary=Se}static getInstance(Se){return je.cache.get(Array.from(Se))}static getLocales(){return je._locales.getValue()}isAmbiguous(Se){return this.confusableDictionary.has(Se)}getPrimaryConfusable(Se){return this.confusableDictionary.get(Se)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=je,w=je,je.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.cache=new _.LRUCachedComputed(se=>{function Se(Ge){const Ze=new Map;for(let rt=0;rt<Ge.length;rt+=2)Ze.set(Ge[rt],Ge[rt+1]);return Ze}function ke(Ge,Ze){const rt=new Map(Ge);for(const[et,nt]of Ze)rt.set(et,nt);return rt}function Le(Ge,Ze){if(!Ge)return Ze;const rt=new Map;for(const[et,nt]of Ge)Ze.has(et)&&rt.set(et,nt);return rt}const Oe=w.ambiguousCharacterData.getValue();let Ye=se.filter(Ge=>!Ge.startsWith("_")&&Ge in Oe);Ye.length===0&&(Ye=["_default"]);let $e;for(const Ge of Ye){const Ze=Se(Oe[Ge]);$e=Le($e,Ze)}const Ve=Se(Oe._common),Xe=ke(Ve,$e);return new je(Xe)}),je._locales=new t.Lazy(()=>Object.keys(je.ambiguousCharacterData.getValue()).filter(se=>!se.startsWith("_")));class He{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(He.getRawData())),this._data}static isInvisibleCharacter(Se){return He.getData().has(Se)}static get codePoints(){return He.getData()}}e.InvisibleCharacters=He,He._data=void 0}),define(ve[127],we([0,1,18]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(b){return w(b,0)}e.hash=t;function w(b,l){switch(typeof b){case"object":return b===null?P(349,l):Array.isArray(b)?y(b,l):E(b,l);case"string":return k(b,l);case"boolean":return D(b,l);case"number":return P(b,l);case"undefined":return P(937,l);default:return P(617,l)}}e.doHash=w;function P(b,l){return(l<<5)-l+b|0}e.numberHash=P;function D(b,l){return P(b?433:863,l)}function k(b,l){l=P(149417,l);for(let C=0,p=b.length;C<p;C++)l=P(b.charCodeAt(C),l);return l}e.stringHash=k;function y(b,l){return l=P(104579,l),b.reduce((C,p)=>w(p,C),l)}function E(b,l){return l=P(181387,l),Object.keys(b).sort().reduce((C,p)=>(C=k(p,C),w(b[p],C)),l)}class T{constructor(){this._value=0}get value(){return this._value}hash(l){return this._value=w(l,this._value),this._value}}e.Hasher=T;var R;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function h(b,l,C=32){const p=C-l,u=~((1<<p)-1);return(b<<l|(u&b)>>>p)>>>0}function v(b,l=0,C=b.byteLength,p=0){for(let u=0;u<C;u++)b[l+u]=p}function c(b,l,C="0"){for(;b.length<l;)b=C+b;return b}function d(b,l=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(C=>C.toString(16).padStart(2,"0")).join(""):c((b>>>0).toString(16),l/4)}e.toHexString=d;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(l){const C=l.length;if(C===0)return;const p=this._buff;let u=this._buffLen,s=this._leftoverHighSurrogate,a,i;for(s!==0?(a=s,i=-1,s=0):(a=l.charCodeAt(0),i=0);;){let n=a;if(_.isHighSurrogate(a))if(i+1<C){const r=l.charCodeAt(i+1);_.isLowSurrogate(r)?(i++,n=_.computeCodePoint(a,r)):n=65533}else{s=a;break}else _.isLowSurrogate(a)&&(n=65533);if(u=this._push(p,u,n),i++,i<C)a=l.charCodeAt(i);else break}this._buffLen=u,this._leftoverHighSurrogate=s}_push(l,C,p){return p<128?l[C++]=p:p<2048?(l[C++]=192|(p&1984)>>>6,l[C++]=128|(p&63)>>>0):p<65536?(l[C++]=224|(p&61440)>>>12,l[C++]=128|(p&4032)>>>6,l[C++]=128|(p&63)>>>0):(l[C++]=240|(p&1835008)>>>18,l[C++]=128|(p&258048)>>>12,l[C++]=128|(p&4032)>>>6,l[C++]=128|(p&63)>>>0),C>=64&&(this._step(),C-=64,this._totalLen+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),C}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const l=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(l/4294967296),!1),this._buffDV.setUint32(60,l%4294967296,!1),this._step()}_step(){const l=g._bigBlock32,C=this._buffDV;for(let f=0;f<64;f+=4)l.setUint32(f,C.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)l.setUint32(f,h(l.getUint32(f-12,!1)^l.getUint32(f-32,!1)^l.getUint32(f-56,!1)^l.getUint32(f-64,!1),1),!1);let p=this._h0,u=this._h1,s=this._h2,a=this._h3,i=this._h4,n,r,o;for(let f=0;f<80;f++)f<20?(n=u&s|~u&a,r=1518500249):f<40?(n=u^s^a,r=1859775393):f<60?(n=u&s|u&a|s&a,r=2400959708):(n=u^s^a,r=3395469782),o=h(p,5)+n+i+r+l.getUint32(f*4,!1)&4294967295,i=a,a=s,s=h(u,30),u=p,p=o;this._h0=this._h0+p&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))});var Et=this&&this.__classPrivateFieldSet||function(J,e,_,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!w:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(J,_):w?w.value=_:e.set(J,_),_},tt=this&&this.__classPrivateFieldGet||function(J,e,_,t){if(_==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?t:_==="a"?t.call(J):t?t.value:e.get(J)};define(ve[30],we([0,1,17,18]),function(J,e,_,t){"use strict";var w,P,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(i,n,r){let o=i.get(n);return o===void 0&&(o=r,i.set(n,o)),o}e.getOrSet=k;function y(i){const n=[];return i.forEach((r,o)=>{n.push(`${o} => ${r}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=y;function E(i){const n=[];return i.forEach(r=>{n.push(r)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=E;class T{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const r=n.charCodeAt(0),o=this._value.charCodeAt(this._pos);return r-o}value(){return this._value[this._pos]}}e.StringIterator=T;class R{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class h{constructor(n=!0,r=!0){this._splitOnBackslash=n,this._caseSensitive=r}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let r=n.length-1;r>=0;r--,this._valueLen--){const o=this._value.charCodeAt(r);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=h;var v;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(v||(v={}));class c{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new h(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(g||(g={}));class b{constructor(n){this._iter=n}static forUris(n=()=>!1){return new b(new c(n))}static forPaths(n=!1){return new b(new h(void 0,!n))}static forStrings(){return new b(new T)}static forConfigKeys(){return new b(new R)}clear(){this._root=void 0}fill(n,r){if(r){const o=r.slice(0);(0,_.shuffle)(o);for(let f of o)this.set(f,n)}else{const o=n.slice(0);(0,_.shuffle)(o);for(let f of o)this.set(f[0],f[1])}}set(n,r){const o=this._iter.reset(n);let f;this._root||(this._root=new d,this._root.segment=o.value());const S=[];for(f=this._root;;){const I=o.cmp(f.segment);if(I>0)f.left||(f.left=new d,f.left.segment=o.value()),S.push([-1,f]),f=f.left;else if(I<0)f.right||(f.right=new d,f.right.segment=o.value()),S.push([1,f]),f=f.right;else if(o.hasNext())o.next(),f.mid||(f.mid=new d,f.mid.segment=o.value()),S.push([0,f]),f=f.mid;else break}const A=f.value;f.value=r,f.key=n;for(let I=S.length-1;I>=0;I--){const F=S[I][1];F.updateHeight();const U=F.balanceFactor();if(U<-1||U>1){const W=S[I][0],m=S[I+1][0];if(W===1&&m===1)S[I][1]=F.rotateLeft();else if(W===-1&&m===-1)S[I][1]=F.rotateRight();else if(W===1&&m===-1)F.right=S[I+1][1]=S[I+1][1].rotateRight(),S[I][1]=F.rotateLeft();else if(W===-1&&m===1)F.left=S[I+1][1]=S[I+1][1].rotateLeft(),S[I][1]=F.rotateRight();else throw new Error;if(I>0)switch(S[I-1][0]){case-1:S[I-1][1].left=S[I][1];break;case 1:S[I-1][1].right=S[I][1];break;case 0:S[I-1][1].mid=S[I][1];break}else this._root=S[0][1]}}return A}get(n){return this._getNode(n)?.value}_getNode(n){const r=this._iter.reset(n);let o=this._root;for(;o;){const f=r.cmp(o.segment);if(f>0)o=o.left;else if(f<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(n){const r=this._getNode(n);return!(r?.value===void 0&&r?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,r){const o=this._iter.reset(n),f=[];let S=this._root;for(;S;){const A=o.cmp(S.segment);if(A>0)f.push([-1,S]),S=S.left;else if(A<0)f.push([1,S]),S=S.right;else if(o.hasNext())o.next(),f.push([0,S]),S=S.mid;else break}if(!!S){if(r?(S.left=void 0,S.mid=void 0,S.right=void 0,S.height=1):(S.key=void 0,S.value=void 0),!S.mid&&!S.value)if(S.left&&S.right){const A=this._min(S.right),{key:I,value:F,segment:U}=A;this._delete(A.key,!1),S.key=I,S.value=F,S.segment=U}else{const A=S.left??S.right;if(f.length>0){const[I,F]=f[f.length-1];switch(I){case-1:F.left=A;break;case 0:F.mid=A;break;case 1:F.right=A;break}}else this._root=A}for(let A=f.length-1;A>=0;A--){const I=f[A][1];I.updateHeight();const F=I.balanceFactor();if(F>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),f[A][1]=I.rotateLeft()):F<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),f[A][1]=I.rotateRight()),A>0)switch(f[A-1][0]){case-1:f[A-1][1].left=f[A][1];break;case 1:f[A-1][1].right=f[A][1];break;case 0:f[A-1][1].mid=f[A][1];break}else this._root=f[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const r=this._iter.reset(n);let o=this._root,f;for(;o;){const S=r.cmp(o.segment);if(S>0)o=o.left;else if(S<0)o=o.right;else if(r.hasNext())r.next(),f=o.value||f,o=o.mid;else break}return o&&o.value||f}findSuperstr(n){const r=this._iter.reset(n);let o=this._root;for(;o;){const f=r.cmp(o.segment);if(f>0)o=o.left;else if(f<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(n){for(const[r,o]of this)n(o,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=r=>{if(!r)return!0;const o=r.balanceFactor();return o<-1||o>1?!1:n(r.left)&&n(r.right)};return n(this._root)}}e.TernarySearchTree=b;class l{constructor(n,r){this.uri=n,this.value=r}}class C{constructor(n,r){this[w]="ResourceMap",n instanceof C?(this.map=new Map(n.map),this.toKey=r??C.defaultToKey):(this.map=new Map,this.toKey=n??C.defaultToKey)}set(n,r){return this.map.set(this.toKey(n),new l(n,r)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,r){typeof r!="undefined"&&(n=n.bind(r));for(let[o,f]of this.map)n(f.value,f.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=C,C.defaultToKey=i=>i.toString();var p;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class u{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,r=0){const o=this._map.get(n);if(!!o)return r!==0&&this.touch(o,r),o.value}set(n,r,o=0){let f=this._map.get(n);if(f)f.value=r,o!==0&&this.touch(f,o);else{switch(f={key:n,value:r,next:void 0,previous:void 0},o){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(n,f),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this._map.get(n);if(!!r)return this._map.delete(n),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,r){const o=this._state;let f=this._head;for(;f;){if(r?n.bind(r)(f.value,f.key,this):n(f.value,f.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const n=this,r=this._state;let o=this._head;const f={[Symbol.iterator](){return f},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const S={value:o.key,done:!1};return o=o.next,S}else return{value:void 0,done:!0}}};return f}values(){const n=this,r=this._state;let o=this._head;const f={[Symbol.iterator](){return f},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const S={value:o.value,done:!1};return o=o.next,S}else return{value:void 0,done:!0}}};return f}entries(){const n=this,r=this._state;let o=this._head;const f={[Symbol.iterator](){return f},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const S={value:[o.key,o.value],done:!1};return o=o.next,S}else return{value:void 0,done:!0}}};return f}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this._head,o=this.size;for(;r&&o>n;)this._map.delete(r.key),r=r.next,o--;this._head=r,this._size=o,r&&(r.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const r=n.next,o=n.previous;if(!r||!o)throw new Error("Invalid list");r.previous=o,o.next=r}n.next=void 0,n.previous=void 0,this._state++}touch(n,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this._head)return;const o=n.next,f=n.previous;n===this._tail?(f.next=void 0,this._tail=f):(o.previous=f,f.next=o),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(r===2){if(n===this._tail)return;const o=n.next,f=n.previous;n===this._head?(o.previous=void 0,this._head=o):(o.previous=f,f.next=o),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((r,o)=>{n.push([o,r])}),n}fromJSON(n){this.clear();for(const[r,o]of n)this.set(r,o)}}e.LinkedMap=u;class s extends u{constructor(n,r=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class a{constructor(n){D.set(this,void 0),Et(this,D,n,"f")}get size(){return tt(this,D,"f").size}forEach(n,r){tt(this,D,"f").forEach(n,r)}get(n){return tt(this,D,"f").get(n)}has(n){return tt(this,D,"f").has(n)}entries(){return tt(this,D,"f").entries()}keys(){return tt(this,D,"f").keys()}values(){return tt(this,D,"f").values()}[(D=new WeakMap,Symbol.iterator)](){return tt(this,D,"f").entries()}}e.ReadonlyMapView=a}),define(ve[128],we([0,1,30,18]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...z){return function(x,X){for(let ue=0,ye=z.length;ue<ye;ue++){const Pe=z[ue](x,X);if(Pe)return Pe}return null}}e.or=w,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(z,x,X){if(!X||X.length<x.length)return null;let ue;return z?ue=t.startsWithIgnoreCase(X,x):ue=X.indexOf(x)===0,ue?x.length>0?[{start:0,end:x.length}]:[]:null}function D(z,x){const X=x.toLowerCase().indexOf(z.toLowerCase());return X===-1?null:[{start:X,end:X+z.length}]}e.matchesContiguousSubString=D;function k(z,x){return y(z.toLowerCase(),x.toLowerCase(),0,0)}e.matchesSubString=k;function y(z,x,X,ue){if(X===z.length)return[];if(ue===x.length)return null;if(z[X]===x[ue]){let ye=null;return(ye=y(z,x,X+1,ue+1))?b({start:ue,end:ue+1},ye):null}return y(z,x,X,ue+1)}function E(z){return 97<=z&&z<=122}function T(z){return 65<=z&&z<=90}e.isUpper=T;function R(z){return 48<=z&&z<=57}function h(z){return z===32||z===9||z===10||z===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(z=>v.add(z.charCodeAt(0)));function c(z){return h(z)||v.has(z)}function d(z,x){return z===x||c(z)&&c(x)}function g(z){return E(z)||T(z)||R(z)}function b(z,x){return x.length===0?x=[z]:z.end===x[0].start?x[0].start=z.start:x.unshift(z),x}function l(z,x){for(let X=x;X<z.length;X++){const ue=z.charCodeAt(X);if(T(ue)||R(ue)||X>0&&!g(z.charCodeAt(X-1)))return X}return z.length}function C(z,x,X,ue){if(X===z.length)return[];if(ue===x.length)return null;if(z[X]!==x[ue].toLowerCase())return null;{let ye=null,Pe=ue+1;for(ye=C(z,x,X+1,ue+1);!ye&&(Pe=l(x,Pe))<x.length;)ye=C(z,x,X+1,Pe),Pe++;return ye===null?null:b({start:ue,end:ue+1},ye)}}function p(z){let x=0,X=0,ue=0,ye=0,Pe=0;for(let ge=0;ge<z.length;ge++)Pe=z.charCodeAt(ge),T(Pe)&&x++,E(Pe)&&X++,g(Pe)&&ue++,R(Pe)&&ye++;const Ae=x/z.length,Fe=X/z.length,Ue=ue/z.length,le=ye/z.length;return{upperPercent:Ae,lowerPercent:Fe,alphaPercent:Ue,numericPercent:le}}function u(z){const{upperPercent:x,lowerPercent:X}=z;return X===0&&x>.6}function s(z){const{upperPercent:x,lowerPercent:X,alphaPercent:ue,numericPercent:ye}=z;return X>.2&&x<.8&&ue>.6&&ye<.2}function a(z){let x=0,X=0,ue=0,ye=0;for(let Pe=0;Pe<z.length;Pe++)ue=z.charCodeAt(Pe),T(ue)&&x++,E(ue)&&X++,h(ue)&&ye++;return(x===0||X===0)&&ye===0?z.length<=30:x<=5}function i(z,x){if(!x||(x=x.trim(),x.length===0)||!a(z)||x.length>60)return null;const X=p(x);if(!s(X)){if(!u(X))return null;x=x.toLowerCase()}let ue=null,ye=0;for(z=z.toLowerCase();ye<x.length&&(ue=C(z,x,0,ye))===null;)ye=l(x,ye+1);return ue}e.matchesCamelCase=i;function n(z,x,X=!1){if(!x||x.length===0)return null;let ue=null,ye=0;for(z=z.toLowerCase(),x=x.toLowerCase();ye<x.length&&(ue=r(z,x,0,ye,X))===null;)ye=o(x,ye+1);return ue}e.matchesWords=n;function r(z,x,X,ue,ye){if(X===z.length)return[];if(ue===x.length)return null;if(d(z.charCodeAt(X),x.charCodeAt(ue))){let Pe=null,Ae=ue+1;if(Pe=r(z,x,X+1,ue+1,ye),!ye)for(;!Pe&&(Ae=o(x,Ae))<x.length;)Pe=r(z,x,X+1,Ae,ye),Ae++;return Pe===null?null:b({start:ue,end:ue+1},Pe)}else return null}function o(z,x){for(let X=x;X<z.length;X++)if(c(z.charCodeAt(X))||X>0&&c(z.charCodeAt(X-1)))return X;return z.length}const f=w(e.matchesPrefix,i,D),S=w(e.matchesPrefix,i,k),A=new _.LRUCache(1e4);function I(z,x,X=!1){if(typeof z!="string"||typeof x!="string")return null;let ue=A.get(z);ue||(ue=new RegExp(t.convertSimple2RegExpPattern(z),"i"),A.set(z,ue));const ye=ue.exec(x);return ye?[{start:ye.index,end:ye.index+ye[0].length}]:X?S(z,x):f(z,x)}e.matchesFuzzy=I;function F(z,x){const X=ne(z,z.toLowerCase(),0,x,x.toLowerCase(),0,!0);return X?W(X):null}e.matchesFuzzy2=F;function U(z,x,X,ue,ye,Pe){const Ae=Math.min(13,z.length);for(;X<Ae;X++){const Fe=ne(z,x,X,ue,ye,Pe,!1);if(Fe)return Fe}return[0,Pe]}e.anyScore=U;function W(z){if(typeof z=="undefined")return[];const x=[],X=z[1];for(let ue=z.length-1;ue>1;ue--){const ye=z[ue]+X,Pe=x[x.length-1];Pe&&Pe.end===ye?Pe.end=ye+1:x.push({start:ye,end:ye+1})}return x}e.createMatches=W;const m=128;function L(){const z=[],x=[];for(let X=0;X<=m;X++)x[X]=0;for(let X=0;X<=m;X++)z.push(x.slice(0));return z}function M(z){const x=[];for(let X=0;X<=z;X++)x[X]=0;return x}const Y=M(2*m),$=M(2*m),G=L(),ie=L(),B=L(),q=!1;function ee(z,x,X,ue,ye){function Pe(Fe,Ue,le=" "){for(;Fe.length<Ue;)Fe=le+Fe;return Fe}let Ae=` |   |${ue.split("").map(Fe=>Pe(Fe,3)).join("|")}
`;for(let Fe=0;Fe<=X;Fe++)Fe===0?Ae+=" |":Ae+=`${x[Fe-1]}|`,Ae+=z[Fe].slice(0,ye+1).map(Ue=>Pe(Ue.toString(),3)).join("|")+`
`;return Ae}function oe(z,x,X,ue){z=z.substr(x),X=X.substr(ue),console.log(ee(ie,z,z.length,X,X.length)),console.log(ee(B,z,z.length,X,X.length)),console.log(ee(G,z,z.length,X,X.length))}function re(z,x){if(x<0||x>=z.length)return!1;const X=z.codePointAt(x);switch(X){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(X)}}function de(z,x){if(x<0||x>=z.length)return!1;switch(z.charCodeAt(x)){case 32:case 9:return!0;default:return!1}}function Z(z,x,X){return x[z]!==X[z]}function H(z,x,X,ue,ye,Pe,Ae=!1){for(;x<X&&ye<Pe;)z[x]===ue[ye]&&(Ae&&(Y[x]=ye),x+=1),ye+=1;return x===X}e.isPatternInWord=H;var j;(function(z){z[z.Diag=1]="Diag",z[z.Left=2]="Left",z[z.LeftLeft=3]="LeftLeft"})(j||(j={}));var V;(function(z){z.Default=[-100,0];function x(X){return!X||X.length===2&&X[0]===-100&&X[1]===0}z.isDefault=x})(V=e.FuzzyScore||(e.FuzzyScore={}));function ne(z,x,X,ue,ye,Pe,Ae){const Fe=z.length>m?m:z.length,Ue=ue.length>m?m:ue.length;if(X>=Fe||Pe>=Ue||Fe-X>Ue-Pe||!H(x,X,Fe,ye,Pe,Ue,!0))return;me(Fe,Ue,X,Pe,x,ye);let le=1,ge=1,he=X,Re=Pe;const Me=[!1];for(le=1,he=X;he<Fe;le++,he++){const se=Y[he],Se=$[he],ke=he+1<Fe?$[he+1]:Ue;for(ge=se-Pe+1,Re=se;Re<ke;ge++,Re++){let Le=Number.MIN_SAFE_INTEGER,Oe=!1;Re<=Se&&(Le=De(z,x,he,X,ue,ye,Re,Ue,Pe,G[le-1][ge-1]===0,Me));let Ye=0;Le!==Number.MAX_SAFE_INTEGER&&(Oe=!0,Ye=Le+ie[le-1][ge-1]);const $e=Re>se,Ve=$e?ie[le][ge-1]+(G[le][ge-1]>0?-5:0):0,Xe=Re>se+1&&G[le][ge-1]>0,Ge=Xe?ie[le][ge-2]+(G[le][ge-2]>0?-5:0):0;if(Xe&&(!$e||Ge>=Ve)&&(!Oe||Ge>=Ye))ie[le][ge]=Ge,B[le][ge]=3,G[le][ge]=0;else if($e&&(!Oe||Ve>=Ye))ie[le][ge]=Ve,B[le][ge]=2,G[le][ge]=0;else if(Oe)ie[le][ge]=Ye,B[le][ge]=1,G[le][ge]=G[le-1][ge-1]+1;else throw new Error("not possible")}}if(q&&oe(z,X,ue,Pe),!Me[0]&&!Ae)return;le--,ge--;const qe=[ie[le][ge],Pe];let Be=0,je=0;for(;le>=1;){let se=ge;do{const Se=B[le][se];if(Se===3)se=se-2;else if(Se===2)se=se-1;else break}while(se>=1);Be>1&&x[X+le-1]===ye[Pe+ge-1]&&!Z(se+Pe-1,ue,ye)&&Be+1>G[le][se]&&(se=ge),se===ge?Be++:Be=1,je||(je=se),le--,ge=se-1,qe.push(ge)}Ue===Fe&&(qe[0]+=2);const He=je-Fe;return qe[0]-=He,qe}e.fuzzyScore=ne;function me(z,x,X,ue,ye,Pe){let Ae=z-1,Fe=x-1;for(;Ae>=X&&Fe>=ue;)ye[Ae]===Pe[Fe]&&($[Ae]=Fe,Ae--),Fe--}function De(z,x,X,ue,ye,Pe,Ae,Fe,Ue,le,ge){if(x[X]!==Pe[Ae])return Number.MIN_SAFE_INTEGER;let he=1,Re=!1;return Ae===X-ue?he=z[X]===ye[Ae]?7:5:Z(Ae,ye,Pe)&&(Ae===0||!Z(Ae-1,ye,Pe))?(he=z[X]===ye[Ae]?7:5,Re=!0):re(Pe,Ae)&&(Ae===0||!re(Pe,Ae-1))?he=5:(re(Pe,Ae-1)||de(Pe,Ae-1))&&(he=5,Re=!0),he>1&&X===ue&&(ge[0]=!0),Re||(Re=Z(Ae,ye,Pe)||re(Pe,Ae-1)||de(Pe,Ae-1)),X===ue?Ae>Ue&&(he-=Re?3:5):le?he+=Re?2:0:he+=Re?0:1,Ae+1===Fe&&(he-=Re?3:5),he}function ae(z,x,X,ue,ye,Pe,Ae){return pe(z,x,X,ue,ye,Pe,!0,Ae)}e.fuzzyScoreGracefulAggressive=ae;function fe(z,x,X,ue,ye,Pe,Ae){return pe(z,x,X,ue,ye,Pe,!1,Ae)}e.fuzzyScoreGraceful=fe;function pe(z,x,X,ue,ye,Pe,Ae,Fe){let Ue=ne(z,x,X,ue,ye,Pe,Fe);if(Ue&&!Ae)return Ue;if(z.length>=3){const le=Math.min(7,z.length-1);for(let ge=X+1;ge<le;ge++){const he=Q(z,ge);if(he){const Re=ne(he,he.toLowerCase(),X,ue,ye,Pe,Fe);Re&&(Re[0]-=3,(!Ue||Re[0]>Ue[0])&&(Ue=Re))}}}return Ue}function Q(z,x){if(x+1>=z.length)return;const X=z[x],ue=z[x+1];if(X!==ue)return z.slice(0,x)+ue+X+z.slice(x+2)}}),define(ve[129],we([0,1,37,128,18]),function(J,e,_,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(_.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${P.source}`,"g");function y(g){return g.replace(k,(b,l)=>l?b:`\\${b}`)}e.escapeIcons=y;const E=new RegExp(`\\\\${P.source}`,"g");function T(g){return g.replace(E,b=>`\\${b}`)}e.markdownEscapeEscapedIcons=T;const R=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function h(g){return g.indexOf(e.iconStartMarker)===-1?g:g.replace(R,(b,l,C,p)=>C?b:l||p||"")}e.stripIcons=h;function v(g){const b=g.indexOf(e.iconStartMarker);return b===-1?{text:g}:c(g,b)}e.parseLabelWithIcons=v;function c(g,b){const l=[];let C="";function p(f){if(f){C+=f;for(const S of f)l.push(a)}}let u=-1,s="",a=0,i,n,r=b;const o=g.length;for(p(g.substr(0,b));r<o;)i=g[r],n=g[r+1],i===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(u=r,p(s),s=e.iconStartMarker,r++):i===")"&&u!==-1?(a+=r-u+1,u=-1,s=""):u!==-1?D.test(i)?s+=i:(p(s),u=-1,s=""):p(i),r++;return p(s),{text:C,iconOffsets:l}}function d(g,b,l=!1){const{text:C,iconOffsets:p}=b;if(!p||p.length===0)return(0,t.matchesFuzzy)(g,C,l);const u=(0,w.ltrim)(C," "),s=C.length-u.length,a=(0,t.matchesFuzzy)(g,u,l);if(a)for(const i of a){const n=p[i.start+s]+s;i.start+=n,i.end+=n}return a}e.matchesFuzzyIconAware=d}),define(ve[77],we([0,1,11,129]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(w=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class P{constructor(v="",c=!1){if(this.value=v,typeof this.value!="string")throw(0,_.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(v,c=0){return this.value+=E(this.supportThemeIcons?(0,t.escapeIcons)(v):v).replace(/([ \t]+)/g,(d,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(v){return this.value+=v,this}appendCodeblock(v,c){return this.value+="\n```",this.value+=v,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=P;function D(h){return k(h)?!h.value:Array.isArray(h)?h.every(D):!0}e.isEmptyMarkdownString=D;function k(h){return h instanceof P?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function y(h,v){return h===v?!0:!h||!v?!1:h.value===v.value&&h.isTrusted===v.isTrusted&&h.supportThemeIcons===v.supportThemeIcons}e.markdownStringEqual=y;function E(h){return h.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function T(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=T;function R(h){const v=[],c=h.split("|").map(g=>g.trim());h=c[0];const d=c[1];if(d){const g=/height=(\d+)/.exec(d),b=/width=(\d+)/.exec(d),l=g?g[1]:"",C=b?b[1]:"",p=isFinite(parseInt(C)),u=isFinite(parseInt(l));p&&v.push(`width="${C}"`),u&&v.push(`height="${l}"`)}return{href:h,dimensions:v}}e.parseHrefAndDimensions=R}),define(ve[78],we([0,1,30]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new _.LRUCache(1e4);function w(E){return y(E,"NFC",t)}e.normalizeNFC=w;const P=new _.LRUCache(1e4);function D(E){return y(E,"NFD",P)}e.normalizeNFD=D;const k=/[^\u0000-\u0080]/;function y(E,T,R){if(!E)return E;const h=R.get(E);if(h)return h;let v;return k.test(E)?v=E.normalize(T):v=E,R.set(E,v),v}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(T){return D(T).replace(E,"")}}()}),define(ve[79],we([0,1,18]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(t||(t={})),function(w){const P="error",D="warning",k="warn",y="info",E="ignore";function T(h){return h?_.equalsIgnoreCase(P,h)?w.Error:_.equalsIgnoreCase(D,h)||_.equalsIgnoreCase(k,h)?w.Warning:_.equalsIgnoreCase(y,h)?w.Info:w.Ignore:w.Ignore}w.fromValue=T;function R(h){switch(h){case w.Error:return P;case w.Warning:return D;case w.Info:return y;default:return E}}w.toString=R}(t||(t={})),e.default=t}),define(ve[12],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function _(o){return Array.isArray(o)}e.isArray=_;function t(o){return typeof o=="string"}e.isString=t;function w(o){return Array.isArray(o)&&o.every(f=>t(f))}e.isStringArray=w;function P(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=P;function D(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=D;function k(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=k;function y(o){return o===!0||o===!1}e.isBoolean=y;function E(o){return typeof o=="undefined"}e.isUndefined=E;function T(o){return!R(o)}e.isDefined=T;function R(o){return E(o)||o===null}e.isUndefinedOrNull=R;function h(o,f){if(!o)throw new Error(f?`Unexpected type, expected '${f}'`:"Unexpected type")}e.assertType=h;function v(o){if(R(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=v;function c(...o){const f=[];for(let S=0;S<o.length;S++){const A=o[S];if(R(A))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);f.push(A)}return f}e.assertAllDefined=c;const d=Object.prototype.hasOwnProperty;function g(o){if(!P(o))return!1;for(let f in o)if(d.call(o,f))return!1;return!0}e.isEmptyObject=g;function b(o){return typeof o=="function"}e.isFunction=b;function l(...o){return o.length>0&&o.every(b)}e.areFunctions=l;function C(o,f){const S=Math.min(o.length,f.length);for(let A=0;A<S;A++)p(o[A],f[A])}e.validateConstraints=C;function p(o,f){if(t(f)){if(typeof o!==f)throw new Error(`argument does not match constraint: typeof ${f}`)}else if(b(f)){try{if(o instanceof f)return}catch{}if(!R(o)&&o.constructor===f||f.length===1&&f.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p;function u(o){let f=[],S=Object.getPrototypeOf(o);for(;Object.prototype!==S;)f=f.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return f}e.getAllPropertyNames=u;function s(o){const f=[];for(const S of u(o))typeof o[S]=="function"&&f.push(S);return f}e.getAllMethodNames=s;function a(o,f){const S=I=>function(){const F=Array.prototype.slice.call(arguments,0);return f(I,F)};let A={};for(const I of o)A[I]=S(I);return A}e.createProxyObject=a;function i(o){return o===null?void 0:o}e.withNullAsUndefined=i;function n(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=n;function r(o,f="Unreachable"){throw new Error(f)}e.assertNever=r}),define(ve[31],we([0,1,4,3,18,12]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(r){return r===47||r===92}e.isPathSeparator=D;function k(r){return r.replace(/[\\/]/g,_.posix.sep)}e.toSlashes=k;function y(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=y;function E(r,o=_.posix.sep){if(!r)return"";const f=r.length,S=r.charCodeAt(0);if(D(S)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let I=3;const F=I;for(;I<f&&!D(r.charCodeAt(I));I++);if(F!==I&&!D(r.charCodeAt(I+1))){for(I+=1;I<f;I++)if(D(r.charCodeAt(I)))return r.slice(0,I+1).replace(/[\\/]/g,o)}}return o}else if(b(S)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let A=r.indexOf("://");if(A!==-1){for(A+=3;A<f;A++)if(D(r.charCodeAt(A)))return r.slice(0,A+1)}return""}e.getRoot=E;function T(r){if(!t.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let f=2;const S=f;for(;f<r.length&&(o=r.charCodeAt(f),o!==92);f++);return!(S===f||(o=r.charCodeAt(f+1),isNaN(o)||o===92))}e.isUNC=T;const R=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(r,o=t.isWindows){const f=o?R:h;return!(!r||r.length===0||/^\s+$/.test(r)||(f.lastIndex=0,f.test(r))||o&&v.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=c;function d(r,o,f){const S=r===o;return!f||S?S:!r||!o?!1:(0,w.equalsIgnoreCase)(r,o)}e.isEqual=d;function g(r,o,f,S=_.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(f){if(!(0,w.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let I=o.length;return o.charAt(o.length-1)===S&&I--,r.charAt(I)===S}return o.charAt(o.length-1)!==S&&(o+=S),r.indexOf(o)===0}e.isEqualOrParent=g;function b(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=b;function l(r,o){return t.isWindows&&r.endsWith(":")&&(r+=_.sep),(0,_.isAbsolute)(r)||(r=(0,_.join)(o,r)),r=(0,_.normalize)(r),t.isWindows?(r=(0,w.rtrim)(r,_.sep),r.endsWith(":")&&(r+=_.sep)):(r=(0,w.rtrim)(r,_.sep),r||(r=_.sep)),r}e.sanitizeFilePath=l;function C(r){const o=(0,_.normalize)(r);return t.isWindows?r.length>3?!1:p(o)&&(r.length===2||o.charCodeAt(2)===92):o===_.posix.sep}e.isRootOrDriveLetter=C;function p(r,o){return(o!==void 0?o:t.isWindows)?b(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function u(r){return p(r)?r[0]:void 0}e.getDriveLetter=u;function s(r,o,f){return o.length>r.length?-1:r===o?0:(f&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=s;function a(r){const o=r.split(":");let f,S,A;for(const I of o){const F=Number(I);(0,P.isNumber)(F)?S===void 0?S=F:A===void 0&&(A=F):f=f?[f,I].join(":"):I}if(!f)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:f,line:S!==void 0?S:void 0,column:A!==void 0?A:S!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(r,o,f=8){let S="";for(let I=0;I<f;I++)S+=i.charAt(Math.floor(Math.random()*i.length));let A;return o?A=`${o}-${S}`:A=S,r?(0,_.join)(r,A):A}e.randomPath=n}),define(ve[20],we([0,1,12]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const g=Array.isArray(d)?[]:{};return Object.keys(d).forEach(b=>{d[b]&&typeof d[b]=="object"?g[b]=t(d[b]):g[b]=d[b]}),g}e.deepClone=t;function w(d){if(!d||typeof d!="object")return d;const g=[d];for(;g.length>0;){const b=g.shift();Object.freeze(b);for(const l in b)if(P.call(b,l)){const C=b[l];typeof C=="object"&&!Object.isFrozen(C)&&g.push(C)}}return d}e.deepFreeze=w;const P=Object.prototype.hasOwnProperty;function D(d,g){return k(d,g,new Set)}e.cloneAndChange=D;function k(d,g,b){if((0,_.isUndefinedOrNull)(d))return d;const l=g(d);if(typeof l!="undefined")return l;if((0,_.isArray)(d)){const C=[];for(const p of d)C.push(k(p,g,b));return C}if((0,_.isObject)(d)){if(b.has(d))throw new Error("Cannot clone recursive data-structure");b.add(d);const C={};for(let p in d)P.call(d,p)&&(C[p]=k(d[p],g,b));return b.delete(d),C}return d}function y(d,g,b=!0){return(0,_.isObject)(d)?((0,_.isObject)(g)&&Object.keys(g).forEach(l=>{l in d?b&&((0,_.isObject)(d[l])&&(0,_.isObject)(g[l])?y(d[l],g[l],b):d[l]=g[l]):d[l]=g[l]}),d):g}e.mixin=y;function E(d,g){if(d===g)return!0;if(d==null||g===null||g===void 0||typeof d!=typeof g||typeof d!="object"||Array.isArray(d)!==Array.isArray(g))return!1;let b,l;if(Array.isArray(d)){if(d.length!==g.length)return!1;for(b=0;b<d.length;b++)if(!E(d[b],g[b]))return!1}else{const C=[];for(l in d)C.push(l);C.sort();const p=[];for(l in g)p.push(l);if(p.sort(),!E(C,p))return!1;for(b=0;b<C.length;b++)if(!E(d[C[b]],g[C[b]]))return!1}return!0}e.equals=E;function T(d){const g=new Set;return JSON.stringify(d,(b,l)=>{if((0,_.isObject)(l)||Array.isArray(l)){if(g.has(l))return"[Circular]";g.add(l)}return l})}e.safeStringify=T;function R(d,g,b){const l=g(d);return typeof l=="undefined"?b:l}e.getOrDefault=R;function h(d,g){const b=Object.create(null);return!d||!g||Object.keys(g).forEach(C=>{const p=d[C],u=g[C];E(p,u)||(b[C]=u)}),b}e.distinct=h;function v(d,g){const b=g.toLowerCase(),l=Object.keys(d).find(C=>C.toLowerCase()===b);return l?d[l]:d[g]}e.getCaseInsensitive=v;function c(d,g){const b=Object.create(null);for(const[l,C]of Object.entries(d))g(l,C)&&(b[l]=C);return b}e.filter=c}),define(ve[5],we([0,1,4,3]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const w=/^\w[\w\d+.-]*$/,P=/^\//,D=/^\/\//;function k(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!w.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!P.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(i,n){return!i&&!n?"file":i}function E(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==R&&(n=R+n):n=R;break}return n}const T="",R="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(n,r,o,f,S,A=!1){typeof n=="object"?(this.scheme=n.scheme||T,this.authority=n.authority||T,this.path=n.path||T,this.query=n.query||T,this.fragment=n.fragment||T):(this.scheme=y(n,A),this.authority=r||T,this.path=E(this.scheme,o||T),this.query=f||T,this.fragment=S||T,k(this,A))}static isUri(n){return n instanceof v?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return C(this,!1)}with(n){if(!n)return this;let{scheme:r,authority:o,path:f,query:S,fragment:A}=n;return r===void 0?r=this.scheme:r===null&&(r=T),o===void 0?o=this.authority:o===null&&(o=T),f===void 0?f=this.path:f===null&&(f=T),S===void 0?S=this.query:S===null&&(S=T),A===void 0?A=this.fragment:A===null&&(A=T),r===this.scheme&&o===this.authority&&f===this.path&&S===this.query&&A===this.fragment?this:new d(r,o,f,S,A)}static parse(n,r=!1){const o=h.exec(n);return o?new d(o[2]||T,a(o[4]||T),a(o[5]||T),a(o[7]||T),a(o[9]||T),r):new d(T,T,T,T,T)}static file(n){let r=T;if(t.isWindows&&(n=n.replace(/\\/g,R)),n[0]===R&&n[1]===R){const o=n.indexOf(R,2);o===-1?(r=n.substring(2),n=R):(r=n.substring(2,o),n=n.substring(o)||R)}return new d("file",r,n,T,T)}static from(n){const r=new d(n.scheme,n.authority,n.path,n.query,n.fragment);return k(r,!0),r}static joinPath(n,...r){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return t.isWindows&&n.scheme==="file"?o=v.file(_.win32.join(C(n,!0),...r)).path:o=_.posix.join(n.path,...r),n.with({path:o})}toString(n=!1){return p(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof v)return n;{const r=new d(n);return r._formatted=n.external,r._fsPath=n._sep===c?n.fsPath:null,r}}else return n}}e.URI=v;const c=t.isWindows?1:void 0;class d extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=C(this,!1)),this._fsPath}toString(n=!1){return n?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=c),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(i,n){let r,o=-1;for(let f=0;f<i.length;f++){const S=i.charCodeAt(f);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||n&&S===47)o!==-1&&(r+=encodeURIComponent(i.substring(o,f)),o=-1),r!==void 0&&(r+=i.charAt(f));else{r===void 0&&(r=i.substr(0,f));const A=g[S];A!==void 0?(o!==-1&&(r+=encodeURIComponent(i.substring(o,f)),o=-1),r+=A):o===-1&&(o=f)}}return o!==-1&&(r+=encodeURIComponent(i.substring(o))),r!==void 0?r:i}function l(i){let n;for(let r=0;r<i.length;r++){const o=i.charCodeAt(r);o===35||o===63?(n===void 0&&(n=i.substr(0,r)),n+=g[o]):n!==void 0&&(n+=i[r])}return n!==void 0?n:i}function C(i,n){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=C;function p(i,n){const r=n?l:b;let o="",{scheme:f,authority:S,path:A,query:I,fragment:F}=i;if(f&&(o+=f,o+=":"),(S||f==="file")&&(o+=R,o+=R),S){let U=S.indexOf("@");if(U!==-1){const W=S.substr(0,U);S=S.substr(U+1),U=W.indexOf(":"),U===-1?o+=r(W,!1):(o+=r(W.substr(0,U),!1),o+=":",o+=r(W.substr(U+1),!1)),o+="@"}S=S.toLowerCase(),U=S.indexOf(":"),U===-1?o+=r(S,!1):(o+=r(S.substr(0,U),!1),o+=S.substr(U))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const U=A.charCodeAt(1);U>=65&&U<=90&&(A=`/${String.fromCharCode(U+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const U=A.charCodeAt(0);U>=65&&U<=90&&(A=`${String.fromCharCode(U+32)}:${A.substr(2)}`)}o+=r(A,!0)}return I&&(o+="?",o+=r(I,!1)),F&&(o+="#",o+=n?F:b(F,!1)),o}function u(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+u(i.substr(3)):i}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(s)?i.replace(s,n=>u(n)):i}}),define(ve[80],we([0,1,5]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(E){const T=E;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=t;function w(E){const T=[];let R;try{const h=JSON.parse(E.arguments),v=h[h.length-1];v&&v.__$stack&&(h.pop(),R=v.__$stack),T.push(...h)}catch{T.push("Unable to log remote console arguments",E.arguments)}return{args:T,stack:R}}e.parse=w;function P(E){if(typeof E!="string")return P(w(E).stack);const T=E;if(T){const R=D(T),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(R||"");if(h&&h.length===4)return{uri:_.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}e.getFirstFrame=P;function D(E){if(!E)return E;const T=E.indexOf(`
`);return T===-1?E:E.substring(0,T)}function k(E,T){const{args:R,stack:h}=w(E),v=typeof R[0]=="string"&&R.length===1;let c=D(h);c&&(c=`(${c.trim()})`);let d=[];if(typeof R[0]=="string"?c&&v?d=[`%c[${T}] %c${R[0]} %c${c}`,y("blue"),y(""),y("grey")]:d=[`%c[${T}] %c${R[0]}`,y("blue"),y(""),...R.slice(1)]:d=[`%c[${T}]%`,y("blue"),...R],c&&!v&&d.push(c),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,d)}e.log=k;function y(E){return`color: ${E}`}}),define(ve[52],we([0,1,15,18,5]),function(J,e,_,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function P(T){return JSON.stringify(T,y)}e.stringify=P;function D(T){let R=JSON.parse(T);return R=E(R),R}e.parse=D;var k;(function(T){T[T.Uri=1]="Uri",T[T.Regexp=2]="Regexp",T[T.ScmResource=3]="ScmResource",T[T.ScmResourceGroup=4]="ScmResourceGroup",T[T.ScmProvider=5]="ScmProvider",T[T.CommentController=6]="CommentController",T[T.CommentThread=7]="CommentThread",T[T.CommentThreadReply=8]="CommentThreadReply",T[T.CommentNode=9]="CommentNode",T[T.CommentThreadNode=10]="CommentThreadNode",T[T.TimelineActionContext=11]="TimelineActionContext",T[T.NotebookCellActionContext=12]="NotebookCellActionContext",T[T.TestItemContext=13]="TestItemContext",T[T.Date=14]="Date"})(k=e.MarshalledId||(e.MarshalledId={}));function y(T,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,t.regExpFlags)(R)}:R}function E(T,R=0){if(!T||R>200)return T;if(typeof T=="object"){switch(T.$mid){case 1:return w.URI.revive(T);case 2:return new RegExp(T.source,T.flags);case 14:return new Date(T.source)}if(T instanceof _.VSBuffer||T instanceof Uint8Array)return T;if(Array.isArray(T))for(let h=0;h<T.length;++h)T[h]=E(T[h],R+1);else for(const h in T)Object.hasOwnProperty.call(T,h)&&(T[h]=E(T[h],R+1))}return T}e.revive=E}),define(ve[8],we([0,1,3,5]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var w;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(w=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,E,T){this._hosts[y]=E,this._ports[y]=T}setConnectionToken(y,E){this._connectionTokens[y]=E}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(y){if(this._delegate)return this._delegate(y);const E=y.authority;let T=this._hosts[E];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const R=this._ports[E],h=this._connectionTokens[E];let v=`path=${encodeURIComponent(y.path)}`;return typeof h=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(h)}`),t.URI.from({scheme:_.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:_.isWeb?window.location.host:`${T}:${R}`,path:_.isWeb?t.URI.joinPath(t.URI.parse(window.location.href),"/vscode-remote-resource").path:"/vscode-remote-resource",query:v})}}e.RemoteAuthorities=new P;class D{asBrowserUri(y,E){const T=this.toUri(y,E);return T.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===w.file&&(_.isNative||typeof _.globals.importScripts=="function"&&_.globals.origin===`${w.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?T.with({scheme:w.vscodeFileResource,authority:T.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):T}asFileUri(y,E){const T=this.toUri(y,E);return T.scheme===w.vscodeFileResource?T.with({scheme:w.file,authority:T.authority!==D.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(y,E){return t.URI.isUri(y)?y:t.URI.parse(E.toUrl(y))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(ve[22],we([0,1,31,8,4,3,18,5]),function(J,e,_,t,w,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(v){return(0,k.uriToFsPath)(v,!0)}e.originalFSPath=y;class E{constructor(c){this._ignorePathCasing=c}compare(c,d,g=!1){return c===d?0:(0,D.compare)(this.getComparisonKey(c,g),this.getComparisonKey(d,g))}isEqual(c,d,g=!1){return c===d?!0:!c||!d?!1:this.getComparisonKey(c,g)===this.getComparisonKey(d,g)}getComparisonKey(c,d=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,d,g=!1){if(c.scheme===d.scheme){if(c.scheme===t.Schemas.file)return _.isEqualOrParent(y(c),y(d),this._ignorePathCasing(c))&&c.query===d.query&&(g||c.fragment===d.fragment);if((0,e.isEqualAuthority)(c.authority,d.authority))return _.isEqualOrParent(c.path,d.path,this._ignorePathCasing(c),"/")&&c.query===d.query&&(g||c.fragment===d.fragment)}return!1}joinPath(c,...d){return k.URI.joinPath(c,...d)}basenameOrAuthority(c){return(0,e.basename)(c)||c.authority}basename(c){return w.posix.basename(c.path)}extname(c){return w.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let d;return c.scheme===t.Schemas.file?d=k.URI.file(w.dirname(y(c))).path:(d=w.posix.dirname(c.path),c.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),d="/")),c.with({path:d})}normalizePath(c){if(!c.path.length)return c;let d;return c.scheme===t.Schemas.file?d=k.URI.file(w.normalize(y(c))).path:d=w.posix.normalize(c.path),c.with({path:d})}relativePath(c,d){if(c.scheme!==d.scheme||!(0,e.isEqualAuthority)(c.authority,d.authority))return;if(c.scheme===t.Schemas.file){const l=w.relative(y(c),y(d));return P.isWindows?_.toSlashes(l):l}let g=c.path||"/",b=d.path||"/";if(this._ignorePathCasing(c)){let l=0;for(const C=Math.min(g.length,b.length);l<C&&!(g.charCodeAt(l)!==b.charCodeAt(l)&&g.charAt(l).toLowerCase()!==b.charAt(l).toLowerCase());l++);g=b.substr(0,l)+g.substr(l)}return w.posix.relative(g,b)}resolvePath(c,d){if(c.scheme===t.Schemas.file){const g=k.URI.file(w.resolve(y(c),d));return c.with({authority:g.authority,path:g.path})}return d=_.toPosixPath(d),c.with({path:w.posix.resolve(c.path,d)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,d){return c===d||c!==void 0&&d!==void 0&&(0,D.equalsIgnoreCase)(c,d)}hasTrailingPathSeparator(c,d=w.sep){if(c.scheme===t.Schemas.file){const g=y(c);return g.length>_.getRoot(g).length&&g[g.length-1]===d}else{const g=c.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,d=w.sep){return(0,e.hasTrailingPathSeparator)(c,d)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,d=w.sep){let g=!1;if(c.scheme===t.Schemas.file){const b=y(c);g=b!==void 0&&b.length===_.getRoot(b).length&&b[b.length-1]===d}else{d="/";const b=c.path;g=b.length===1&&b.charCodeAt(b.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(c,d)?c.with({path:c.path+"/"}):c}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(v=>v.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new E(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(v,c){const d=[];for(let g=0;g<v.length;g++){const b=c(v[g]);v.some((l,C)=>C===g?!1:(0,e.isEqualOrParent)(b,c(l)))||d.push(v[g])}return d}e.distinctParents=T;var R;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function c(d){const g=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(C=>{const[p,u]=C.split(":");p&&u&&g.set(p,u)});const l=d.path.substring(0,d.path.indexOf(";"));return l&&g.set(v.META_DATA_MIME,l),g}v.parseMetaData=c})(R=e.DataUri||(e.DataUri={}));function h(v,c,d){if(c){let g=v.path;return g&&g[0]!==w.posix.sep&&(g=w.posix.sep+g),v.with({scheme:d,authority:c,path:g})}return v.with({scheme:d})}e.toLocalResource=h}),define(ve[13],we([0,1,21,11,7,2,22,3]),function(J,e,_,t,w,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(Z){return!!Z&&typeof Z.then=="function"}e.isThenable=y;function E(Z){const H=new _.CancellationTokenSource,j=Z(H.token),V=new Promise((ne,me)=>{const De=H.token.onCancellationRequested(()=>{De.dispose(),H.dispose(),me(new t.CancellationError)});Promise.resolve(j).then(ae=>{De.dispose(),H.dispose(),ne(ae)},ae=>{De.dispose(),H.dispose(),me(ae)})});return new class{cancel(){H.cancel()}then(ne,me){return V.then(ne,me)}catch(ne){return this.then(void 0,ne)}finally(ne){return V.finally(ne)}}}e.createCancelablePromise=E;function T(Z,H,j){return new Promise((V,ne)=>{const me=H.onCancellationRequested(()=>{me.dispose(),V(j)});Z.then(V,ne).finally(()=>me.dispose())})}e.raceCancellation=T;function R(Z,H){return new Promise((j,V)=>{const ne=H.onCancellationRequested(()=>{ne.dispose(),V(new t.CancellationError)});Z.then(j,V).finally(()=>ne.dispose())})}e.raceCancellationError=R;async function h(Z){let H=-1;const j=Z.map((ne,me)=>ne.then(De=>(H=me,De))),V=await Promise.race(j);return Z.forEach((ne,me)=>{me!==H&&ne.cancel()}),V}e.raceCancellablePromises=h;function v(Z,H,j){let V;const ne=setTimeout(()=>{V?.(void 0),j?.()},H);return Promise.race([Z.finally(()=>clearTimeout(ne)),new Promise(me=>V=me)])}e.raceTimeout=v;function c(Z){return new Promise((H,j)=>{const V=Z();y(V)?V.then(H,j):H(V)})}e.asPromise=c;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(H){if(this.activePromise){if(this.queuedPromiseFactory=H,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(j,j).then(V)})}return new Promise((j,V)=>{this.queuedPromise.then(j,V)})}return this.activePromise=H(),new Promise((j,V)=>{this.activePromise.then(ne=>{this.activePromise=null,j(ne)},ne=>{this.activePromise=null,V(ne)})})}}e.Throttler=d;class g{constructor(){this.current=Promise.resolve(null)}queue(H){return this.current=this.current.then(()=>H(),()=>H())}}e.Sequencer=g;class b{constructor(){this.promiseMap=new Map}queue(H,j){const ne=(this.promiseMap.get(H)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(H)===ne&&this.promiseMap.delete(H)});return this.promiseMap.set(H,ne),ne}}e.SequencerByKey=b;const l=(Z,H)=>{let j=!0;const V=setTimeout(()=>{j=!1,H()},Z);return{isTriggered:()=>j,dispose:()=>{clearTimeout(V),j=!1}}},C=Z=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,Z())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class p{constructor(H){this.defaultDelay=H,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(H,j=this.defaultDelay){this.task=H,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ne,me)=>{this.doResolve=ne,this.doReject=me}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ne=this.task;return this.task=null,ne()}}));const V=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=j===e.MicrotaskDelay?C(V):l(j,V),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class u{constructor(H){this.delayer=new p(H),this.throttler=new d}trigger(H,j){return this.delayer.trigger(()=>this.throttler.queue(H),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class s{constructor(){this._isOpen=!1,this._promise=new Promise((H,j)=>{this._completePromise=H})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class a extends s{constructor(H){super();this._timeout=setTimeout(()=>this.open(),H)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function i(Z,H){return H?new Promise((j,V)=>{const ne=setTimeout(()=>{me.dispose(),j()},Z),me=H.onCancellationRequested(()=>{clearTimeout(ne),me.dispose(),V(new t.CancellationError)})}):E(j=>i(Z,j))}e.timeout=i;function n(Z,H=0){const j=setTimeout(Z,H);return(0,P.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=n;function r(Z){const H=[];let j=0;const V=Z.length;function ne(){return j<V?Z[j++]():null}function me(De){De!=null&&H.push(De);const ae=ne();return ae?ae.then(me):Promise.resolve(H)}return Promise.resolve(null).then(me)}e.sequence=r;function o(Z,H=V=>!!V,j=null){let V=0;const ne=Z.length,me=()=>{if(V>=ne)return Promise.resolve(j);const De=Z[V++];return Promise.resolve(De()).then(fe=>H(fe)?Promise.resolve(fe):me())};return me()}e.first=o;function f(Z,H=V=>!!V,j=null){if(Z.length===0)return Promise.resolve(j);let V=Z.length;const ne=()=>{V=-1;for(const me of Z)me.cancel?.()};return new Promise((me,De)=>{for(const ae of Z)ae.then(fe=>{--V>=0&&H(fe)?(ne(),me(fe)):V===0&&me(j)}).catch(fe=>{--V>=0&&(ne(),De(fe))})})}e.firstParallel=f;class S{constructor(H){this._size=0,this.maxDegreeOfParalellism=H,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new w.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(H){return this._size++,new Promise((j,V)=>{this.outstandingPromises.push({factory:H,c:j,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const H=this.outstandingPromises.shift();this.runningPromises++;const j=H.factory();j.then(H.c,H.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=S;class A extends S{constructor(){super(1)}}e.Queue=A;class I{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const H=new B;return this.drainers.add(H),H.p}isDrained(){for(const[,H]of this.queues)if(H.size>0)return!1;return!0}queueFor(H,j=D.extUri){const V=j.getComparisonKey(H);let ne=this.queues.get(V);return ne||(ne=new A,w.Event.once(ne.onFinished)(()=>{ne?.dispose(),this.queues.delete(V),this.onDidQueueFinish()}),this.queues.set(V,ne)),ne}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const H of this.drainers)H.complete();this.drainers.clear()}dispose(){for(const[,H]of this.queues)H.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=I;class F{constructor(H,j){this._token=-1,typeof H=="function"&&typeof j=="number"&&this.setIfNotSet(H,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(H,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,H()},j)}setIfNotSet(H,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,H()},j))}}e.TimeoutTimer=F;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(H,j){this.cancel(),this._token=setInterval(()=>{H()},j)}}e.IntervalTimer=U;class W{constructor(H,j){this.timeoutToken=-1,this.runner=H,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(H=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,H)}get delay(){return this.timeout}set delay(H){this.timeout=H}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=W;class m{constructor(H,j){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.runner=H,this.timeout=j,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(H=this.timeout){H%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(H/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=m;class L extends W{constructor(H,j){super(H,j);this.units=[]}work(H){this.units.push(H),this.isScheduled()||this.schedule()}doRun(){const H=this.units;this.units=[],this.runner&&this.runner(H)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L;class M extends P.Disposable{constructor(H,j){super();this.options=H,this.handler=j,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(H){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+H.length>this.options.maxBufferedWork)return!1}else if(this.pending+H.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...H),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new W(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Z=>{(0,k.setTimeout0)(()=>{if(H)return;const j=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,j-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.runWhenIdle=(Z,H)=>{const j=requestIdleCallback(Z,typeof H=="number"?{timeout:H}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(j))}}}}();class Y{constructor(H){this._didRun=!1,this._executor=()=>{try{this._value=H()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=Y;async function $(Z,H,j){let V;for(let ne=0;ne<j;ne++)try{return await Z()}catch(me){V=me,await i(H)}throw V}e.retry=$;class G{hasPending(H){return this._pending?typeof H=="number"?this._pending.taskId===H:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(H,j,V){return this._pending={taskId:H,cancel:()=>V?.(),promise:j},j.then(()=>this.donePending(H),()=>this.donePending(H)),j}donePending(H){this._pending&&H===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const H=this._next;this._next=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}setNext(H){if(this._next)this._next.run=H;else{let j,V;const ne=new Promise((me,De)=>{j=me,V=De});this._next={run:H,promise:ne,promiseResolve:j,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=G;class ie{constructor(H,j=()=>Date.now()){this.interval=H,this.nowFn=j,this.lastIncrementTime=0,this.value=0}increment(){const H=this.nowFn();return H-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=H,this.value=0),this.value++,this.value}}e.IntervalCounter=ie;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((H,j)=>{this.completeCallback=H,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(H){return new Promise(j=>{this.completeCallback(H),this.resolved=!0,j()})}error(H){return new Promise(j=>{this.errorCallback(H),this.rejected=!0,j()})}cancel(){new Promise(H=>{this.errorCallback(new t.CancellationError),this.rejected=!0,H()})}}e.DeferredPromise=B;var q;(function(Z){async function H(V){let ne;const me=await Promise.all(V.map(De=>De.then(ae=>ae,ae=>{ne||(ne=ae)})));if(typeof ne!="undefined")throw ne;return me}Z.settled=H;function j(V){return new Promise(async(ne,me)=>{try{await V(ne,me)}catch(De){me(De)}})}Z.withAsyncBody=j})(q=e.Promises||(e.Promises={}));var ee;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(ee||(ee={}));class oe{constructor(H){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const j={emitOne:V=>this.emitOne(V),emitMany:V=>this.emitMany(V),reject:V=>this.reject(V)};try{await Promise.resolve(H(j)),this.resolve()}catch(V){this.reject(V)}finally{j.emitOne=void 0,j.emitMany=void 0,j.reject=void 0}})}static fromArray(H){return new oe(j=>{j.emitMany(H)})}static fromPromise(H){return new oe(async j=>{j.emitMany(await H)})}static fromPromises(H){return new oe(async j=>{await Promise.all(H.map(async V=>j.emitOne(await V)))})}static merge(H){return new oe(async j=>{await Promise.all(H.map(async V=>{for await(const ne of V)j.emitOne(ne)}))})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(H<this._results.length)return{done:!1,value:this._results[H++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(H,j){return new oe(async V=>{for await(const ne of H)V.emitOne(j(ne))})}map(H){return oe.map(this,H)}static filter(H,j){return new oe(async V=>{for await(const ne of H)j(ne)&&V.emitOne(ne)})}filter(H){return oe.filter(this,H)}static coalesce(H){return oe.filter(H,j=>!!j)}coalesce(){return oe.coalesce(this)}static async toPromise(H){const j=[];for await(const V of H)j.push(V);return j}toPromise(){return oe.toPromise(this)}emitOne(H){this._state===0&&(this._results.push(H),this._onStateChanged.fire())}emitMany(H){this._state===0&&(this._results=this._results.concat(H),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(H){this._state===0&&(this._state=2,this._error=H,this._onStateChanged.fire())}}e.AsyncIterableObject=oe,oe.EMPTY=oe.fromArray([]);class re extends oe{constructor(H,j){super(j);this._source=H}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=re;function de(Z){const H=new _.CancellationTokenSource,j=Z(H.token);return new re(H,async V=>{const ne=H.token.onCancellationRequested(()=>{ne.dispose(),H.dispose(),V.reject(new t.CancellationError)});try{for await(const me of j){if(H.token.isCancellationRequested)return;V.emitOne(me)}ne.dispose(),H.dispose()}catch(me){ne.dispose(),H.dispose(),V.reject(me)}})}e.createCancelableAsyncIterable=de}),define(ve[60],we([0,1,13,31,30,4,3,18]),function(J,e,_,t,w,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",T="[^/\\\\]",R=/\//g;function h(B){switch(B){case 0:return"";case 1:return`${T}*?`;default:return`(?:${E}|${T}+${E}|${E}${T}+)*?`}}function v(B,q){if(!B)return[];const ee=[];let oe=!1,re=!1,de="";for(const Z of B){switch(Z){case q:if(!oe&&!re){ee.push(de),de="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":re=!0;break;case"]":re=!1;break}de+=Z}return de&&ee.push(de),ee}e.splitGlobAware=v;function c(B){if(!B)return"";let q="";const ee=v(B,e.GLOB_SPLIT);if(ee.every(oe=>oe===e.GLOBSTAR))q=".*";else{let oe=!1;ee.forEach((re,de)=>{if(re===e.GLOBSTAR){oe||(q+=h(2),oe=!0);return}let Z=!1,H="",j=!1,V="";for(const ne of re){if(ne!=="}"&&Z){H+=ne;continue}if(j&&(ne!=="]"||!V)){let me;ne==="-"?me=ne:(ne==="^"||ne==="!")&&!V?me="^":ne===e.GLOB_SPLIT?me="":me=(0,k.escapeRegExpCharacters)(ne),V+=me;continue}switch(ne){case"{":Z=!0;continue;case"[":j=!0;continue;case"}":{q+=`(?:${v(H,",").map(ae=>c(ae)).join("|")})`,Z=!1,H="";break}case"]":q+="["+V+"]",j=!1,V="";break;case"?":q+=T;continue;case"*":q+=h(1);continue;default:q+=(0,k.escapeRegExpCharacters)(ne)}}de<ee.length-1&&(ee[de+1]!==e.GLOBSTAR||de+2<ee.length)&&(q+=E),oe=!1})}return q}const d=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,C=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new w.LRUCache(1e4),s=function(){return!1},a=function(){return null};function i(B,q){if(!B)return a;let ee;typeof B!="string"?ee=B.pattern:ee=B,ee=ee.trim();const oe=`${ee}_${!!q.trimForExclusions}`;let re=u.get(oe);if(re)return n(re,B);let de;if(d.test(ee)){const Z=ee.substr(4);re=function(H,j){return typeof H=="string"&&H.endsWith(Z)?ee:null}}else(de=g.exec(r(ee,q)))?re=o(de[1],ee):(q.trimForExclusions?l:b).test(ee)?re=f(ee,q):(de=C.exec(r(ee,q)))?re=S(de[1].substr(1),ee,!0):(de=p.exec(r(ee,q)))?re=S(de[1],ee,!1):re=A(ee);return u.set(oe,re),n(re,B)}function n(B,q){return typeof q=="string"?B:function(ee,oe){return(0,t.isEqualOrParent)(ee,q.base,!D.isLinux)?B(ee.substr(q.base.length+1),oe):null}}function r(B,q){return q.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function o(B,q){const ee=`/${B}`,oe=`\\${B}`,re=function(Z,H){return typeof Z!="string"?null:H?H===B?q:null:Z===B||Z.endsWith(ee)||Z.endsWith(oe)?q:null},de=[B];return re.basenames=de,re.patterns=[q],re.allBasenames=de,re}function f(B,q){const ee=ie(B.slice(1,-1).split(",").map(H=>i(H,q)).filter(H=>H!==a),B),oe=ee.length;if(!oe)return a;if(oe===1)return ee[0];const re=function(H,j){for(let V=0,ne=ee.length;V<ne;V++)if(ee[V](H,j))return B;return null},de=ee.find(H=>!!H.allBasenames);de&&(re.allBasenames=de.allBasenames);const Z=ee.reduce((H,j)=>j.allPaths?H.concat(j.allPaths):H,[]);return Z.length&&(re.allPaths=Z),re}function S(B,q,ee){const oe=P.sep===P.posix.sep,re=oe?B:B.replace(R,P.sep),de=P.sep+re,Z=P.posix.sep+B,H=ee?function(j,V){return typeof j=="string"&&(j===re||j.endsWith(de)||!oe&&(j===B||j.endsWith(Z)))?q:null}:function(j,V){return typeof j=="string"&&(j===re||!oe&&j===B)?q:null};return H.allPaths=[(ee?"*/":"./")+B],H}function A(B){try{const q=new RegExp(`^${c(B)}$`);return function(ee){return q.lastIndex=0,typeof ee=="string"&&q.test(ee)?B:null}}catch{return a}}function I(B,q,ee){return!B||typeof q!="string"?!1:F(B)(q,void 0,ee)}e.match=I;function F(B,q={}){if(!B)return s;if(typeof B=="string"||L(B)){const ee=i(B,q);if(ee===a)return s;const oe=function(re,de){return!!ee(re,de)};return ee.allBasenames&&(oe.allBasenames=ee.allBasenames),ee.allPaths&&(oe.allPaths=ee.allPaths),oe}return $(B,q)}e.parse=F;function U(B){if(!B)return;let q;return ee=>(q||(q=(B()||Promise.resolve([])).then(oe=>oe?m(oe):{})),q.then(oe=>!!oe[ee]))}e.hasSiblingPromiseFn=U;function W(B){if(!B)return;let q;return ee=>{if(!q){const oe=B();q=oe?m(oe):{}}return!!q[ee]}}e.hasSiblingFn=W;function m(B){const q={};for(const ee of B)q[ee]=!0;return q}function L(B){const q=B;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=L;function M(B){return B.allBasenames||[]}e.getBasenameTerms=M;function Y(B){return B.allPaths||[]}e.getPathTerms=Y;function $(B,q){const ee=ie(Object.getOwnPropertyNames(B).map(H=>G(H,B[H],q)).filter(H=>H!==a)),oe=ee.length;if(!oe)return a;if(!ee.some(H=>!!H.requiresSiblings)){if(oe===1)return ee[0];const H=function(ne,me){for(let De=0,ae=ee.length;De<ae;De++){const fe=ee[De](ne,me);if(fe)return fe}return null},j=ee.find(ne=>!!ne.allBasenames);j&&(H.allBasenames=j.allBasenames);const V=ee.reduce((ne,me)=>me.allPaths?ne.concat(me.allPaths):ne,[]);return V.length&&(H.allPaths=V),H}const re=function(H,j,V){let ne;for(let me=0,De=ee.length;me<De;me++){const ae=ee[me];ae.requiresSiblings&&V&&(j||(j=(0,P.basename)(H)),ne||(ne=j.substr(0,j.length-(0,P.extname)(H).length)));const fe=ae(H,j,ne,V);if(fe)return fe}return null},de=ee.find(H=>!!H.allBasenames);de&&(re.allBasenames=de.allBasenames);const Z=ee.reduce((H,j)=>j.allPaths?H.concat(j.allPaths):H,[]);return Z.length&&(re.allPaths=Z),re}function G(B,q,ee){if(q===!1)return a;const oe=i(B,ee);if(oe===a)return a;if(typeof q=="boolean")return oe;if(q){const re=q.when;if(typeof re=="string"){const de=(Z,H,j,V)=>{if(!V||!oe(Z,H))return null;const ne=re.replace("$(basename)",j),me=V(ne);return(0,_.isThenable)(me)?me.then(De=>De?B:null):me?B:null};return de.requiresSiblings=!0,de}}return oe}function ie(B,q){const ee=B.filter(H=>!!H.basenames);if(ee.length<2)return B;const oe=ee.reduce((H,j)=>{const V=j.basenames;return V?H.concat(V):H},[]);let re;if(q){re=[];for(let H=0,j=oe.length;H<j;H++)re.push(q)}else re=ee.reduce((H,j)=>{const V=j.patterns;return V?H.concat(V):H},[]);const de=function(H,j){if(typeof H!="string")return null;if(!j){let ne;for(ne=H.length;ne>0;ne--){const me=H.charCodeAt(ne-1);if(me===47||me===92)break}j=H.substr(ne)}const V=oe.indexOf(j);return V!==-1?re[V]:null};de.basenames=oe,de.patterns=re,de.allBasenames=oe;const Z=B.filter(H=>!H.basenames);return Z.push(de),Z}}),define(ve[61],we([0,1,31,8,4,3,22,18,5]),function(J,e,_,t,w,P,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function E(n,r,o){if(typeof n=="string"&&(n=y.URI.file(n)),o){const S=o.getWorkspaceFolder(n);if(S){const A=o.getWorkspace().folders.length>1;let I;if((0,D.isEqual)(S.uri,n)?I="":I=(0,D.relativePath)(S.uri,n),A){const F=S.name?S.name:(0,D.basename)(S.uri);I=I?F+" \u2022 "+I:F}return I}}if(n.scheme!==t.Schemas.file&&n.scheme!==t.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,_.hasDriveLetter)(n.fsPath))return(0,w.normalize)(R(n.fsPath));let f=(0,w.normalize)(n.fsPath);return!P.isWindows&&r?.userHome&&(f=v(f,r.userHome.fsPath)),f}e.getPathLabel=E;function T(n){if(!n)return;typeof n=="string"&&(n=y.URI.file(n));const r=(0,D.basename)(n)||(n.scheme===t.Schemas.file?n.fsPath:n.path);return P.isWindows&&(0,_.isRootOrDriveLetter)(r)?R(r):r}e.getBaseLabel=T;function R(n,r){return(0,_.hasDriveLetter)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=R;let h=Object.create(null);function v(n,r){if(P.isWindows||!n||!r)return n;let o=h.original===r?h.normalized:void 0;return o||(o=`${(0,k.rtrim)(r,w.posix.sep)}${w.posix.sep}`,h={original:r,normalized:o}),(P.isLinux?n.startsWith(o):(0,k.startsWithIgnoreCase)(n,o))&&(n=`~/${n.substr(o.length)}`),n}e.tildify=v;function c(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=c;const d="\u2026",g="\\\\",b="~";function l(n,r=w.sep){const o=new Array(n.length);let f=!1;for(let S=0;S<n.length;S++){let A=n[S];if(A===""){o[S]=`.${r}`;continue}if(!A){o[S]=A;continue}f=!0;let I="";A.indexOf(g)===0?(I=A.substr(0,A.indexOf(g)+g.length),A=A.substr(A.indexOf(g)+g.length)):A.indexOf(r)===0?(I=A.substr(0,A.indexOf(r)+r.length),A=A.substr(A.indexOf(r)+r.length)):A.indexOf(b)===0&&(I=A.substr(0,A.indexOf(b)+b.length),A=A.substr(A.indexOf(b)+b.length));const F=A.split(r);for(let U=1;f&&U<=F.length;U++)for(let W=F.length-U;f&&W>=0;W--){f=!1;let m=F.slice(W,W+U).join(r);for(let L=0;!f&&L<n.length;L++)if(L!==S&&n[L]&&n[L].indexOf(m)>-1){const M=W+U===F.length,Y=W>0&&n[L].indexOf(r)>-1?r+m:m,$=n[L].endsWith(Y);f=!M||$}if(!f){let L="";(F[0].endsWith(":")||I!=="")&&(W===1&&(W=0,U++,m=F[0]+r+m),W>0&&(L=F[0]+r),L=I+L),W>0&&(L=L+d+r),L=L+m,W+U<F.length&&(L=L+r+d),o[S]=L}}f&&(o[S]=A)}return o}e.shorten=l;var C;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(C||(C={}));function p(n,r=Object.create(null)){const o=[];let f=!1,S="";for(const A of n)if(A==="$"||f&&A==="{")S&&o.push({value:S,type:C.TEXT}),S="",f=!0;else if(A==="}"&&f){const I=r[S];if(typeof I=="string")I.length&&o.push({value:I,type:C.VARIABLE});else if(I){const F=o[o.length-1];(!F||F.type!==C.SEPARATOR)&&o.push({value:I.label,type:C.SEPARATOR})}S="",f=!1}else S+=A;return S&&!f&&o.push({value:S,type:C.TEXT}),o.filter((A,I)=>{if(A.type===C.SEPARATOR){const F=o[I-1],U=o[I+1];return[F,U].every(W=>W&&(W.type===C.VARIABLE||W.type===C.TEXT)&&W.value.length>0)}return!0}).map(A=>A.value).join("")}e.template=p;function u(n,r){return P.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):n.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function s(n,r){return P.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,""):P.isWindows?n.replace(/&&|&/g,o=>o==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=s;function a(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=a;function i(n){const r=n.indexOf("/")!==-1?w.posix:w.win32,o=r.basename(n),f=r.dirname(n);return o.length?{name:o,parentPath:f}:{name:f,parentPath:""}}e.splitName=i}),define(ve[62],we([0,1,5]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(T){return T.toJSON()}class w{constructor(R){this._uriTransformer=R}transformIncoming(R){const h=this._uriTransformer.transformIncoming(R);return h===R?R:t(_.URI.from(h))}transformOutgoing(R){const h=this._uriTransformer.transformOutgoing(R);return h===R?R:t(_.URI.from(h))}transformOutgoingURI(R){const h=this._uriTransformer.transformOutgoing(R);return h===R?R:_.URI.from(h)}transformOutgoingScheme(R){return this._uriTransformer.transformOutgoingScheme(R)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function P(T,R,h){if(!T||h>200)return null;if(typeof T=="object"){if(T instanceof _.URI)return R.transformOutgoing(T);for(let v in T)if(Object.hasOwnProperty.call(T,v)){const c=P(T[v],R,h+1);c!==null&&(T[v]=c)}}return null}function D(T,R){const h=P(T,R,0);return h===null?T:h}e.transformOutgoingURIs=D;function k(T,R,h,v){if(!T||v>200)return null;if(typeof T=="object"){if(T.$mid===1)return h?_.URI.revive(R.transformIncoming(T)):R.transformIncoming(T);for(let c in T)if(Object.hasOwnProperty.call(T,c)){const d=k(T[c],R,h,v+1);d!==null&&(T[c]=d)}}return null}function y(T,R){const h=k(T,R,!1,0);return h===null?T:h}e.transformIncomingURIs=y;function E(T,R){const h=k(T,R,!0,0);return h===null?T:h}e.transformAndReviveIncomingURIs=E}),define(ve[23],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(y){return _.test(y)}e.isUUID=t;const w=new Uint8Array(16),P=[];for(let y=0;y<256;y++)P.push(y.toString(16).padStart(2,"0"));let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(y){for(let E=0;E<y.length;E++)y[E]=Math.floor(Math.random()*256);return y};function k(){D(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let y=0,E="";return E+=P[w[y++]],E+=P[w[y++]],E+=P[w[y++]],E+=P[w[y++]],E+="-",E+=P[w[y++]],E+=P[w[y++]],E+="-",E+=P[w[y++]],E+=P[w[y++]],E+="-",E+=P[w[y++]],E+=P[w[y++]],E+="-",E+=P[w[y++]],E+=P[w[y++]],E+=P[w[y++]],E+=P[w[y++]],E+=P[w[y++]],E+=P[w[y++]],E}e.generateUuid=k}),define(ve[130],we([0,1,261]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(P="utf8"){this.stringDecoder=new _.StringDecoder(P),this.remaining=null}write(P){const D=[],k=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(k.length<1)return D;let y=0,E,T=y;for(;T<k.length;)if(E=k.charCodeAt(T),E===13||E===10){if(D.push(k.substring(y,T)),T++,T<k.length){const R=E;E=k.charCodeAt(T),(R===13&&E===10||R===10&&E===13)&&T++}y=T}else T++;return this.remaining=y<k.length?k.substr(y):null,D}end(){return this.remaining}}e.LineDecoder=t}),function(){"use strict";function J(e,_,t,w){function P(c){return new Promise(d=>t.exists(c,d))}function D(c){return new Promise((d,g)=>{const b=new Date;t.utimes(c,b,b,l=>l?g(l):d())})}function k(c){return new Promise((d,g)=>t.mkdir(c,{recursive:!0},b=>b&&b.code!=="EEXIST"?g(b):d(c)))}function y(c){return new Promise((d,g)=>t.rmdir(c,{recursive:!0},b=>b&&b.code!=="ENOENT"?g(b):d()))}function E(c){return new Promise((d,g)=>t.readFile(c,"utf8",(b,l)=>b?g(b):d(l)))}function T(c,d){return new Promise((g,b)=>t.writeFile(c,d,"utf8",l=>l?b(l):g()))}function R(c){const d=_.join(c,"languagepacks.json");try{return e(d)}catch{}}function h(c,d){try{for(;d;){if(c[d])return d;{const g=d.lastIndexOf("-");if(g>0)d=d.substring(0,g);else return}}}catch(g){console.error("Resolving language pack configuration failed.",g)}}function v(c,d,g,b){if(b==="pseudo")return Promise.resolve({locale:b,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:b,availableLanguages:{}});if(b&&(b==="en"||b==="en-us"))return Promise.resolve({locale:b,availableLanguages:{}});const l=b;w.mark("code/willGenerateNls");const C=function(p){return w.mark("code/didGenerateNls"),Promise.resolve({locale:p,availableLanguages:{}})};try{if(!c)return C(l);const p=R(d);if(!p||(b=h(p,b),!b))return C(l);const u=p[b];let s;return!u||typeof u.hash!="string"||!u.translations||typeof(s=u.translations.vscode)!="string"?C(l):P(s).then(a=>{if(!a)return C(l);const i=u.hash+"."+b,n=_.join(d,"clp",i),r=_.join(n,c),o=_.join(n,"tcf.json"),f=_.join(n,"corrupted.info"),S={locale:l,availableLanguages:{"*":b},_languagePackId:i,_translationsConfigFile:o,_cacheRoot:n,_resolvedLanguagePackCoreLocation:r,_corruptedFile:f};return P(f).then(A=>{let I;return A?I=y(n):I=Promise.resolve(void 0),I.then(()=>P(r).then(F=>F?(D(r).catch(()=>{}),w.mark("code/didGenerateNls"),S):k(r).then(()=>Promise.all([E(g),E(s)])).then(U=>{const W=JSON.parse(U[0]),m=JSON.parse(U[1]).contents,L=Object.keys(W.bundles),M=[];for(const Y of L){const $=W.bundles[Y],G=Object.create(null);for(const ie of $){const B=W.keys[ie],q=W.messages[ie],ee=m[ie];let oe;if(ee){oe=[];for(let re=0;re<B.length;re++){const de=B[re],Z=typeof de=="string"?de:de.key;let H=ee[Z];H===void 0&&(H=q[re]),oe.push(H)}}else oe=q;G[ie]=oe}M.push(T(_.join(r,Y.replace(/\//g,"!")+".nls.json"),JSON.stringify(G)))}return M.push(T(o,JSON.stringify(u.translations))),Promise.all(M)}).then(()=>(w.mark("code/didGenerateNls"),S)).catch(U=>(console.error("Generating translation files failed.",U),C(b)))))})})}catch(p){return console.error("Generating translation files failed.",p),C(b)}}return{getNLSConfiguration:v}}if(typeof define=="function")define(ve[131],we([0,132,27,44]),function(e,_,t,w){return J(e.__$__nodeRequire,_,t,w)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),_=require("fs"),t=require("../common/performance");module.exports=J(require,e,_,t)}else throw new Error("Unknown context")}(),define(ve[133],we([0,1,25]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function w(D){const k=D.replace(/\-/g,":").toLowerCase();return!t.has(k)}function P(){const D=(0,_.networkInterfaces)();for(let k in D){const y=D[k];if(y){for(const{mac:E}of y)if(w(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=P}),define(ve[81],we([0,1,25,11,30,23,133]),function(J,e,_,t,w,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(T){return this._virtualMachineOUIs||(this._virtualMachineOUIs=w.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(T)}value(){if(this._value===void 0){let T=0,R=0;const h=(0,_.networkInterfaces)();for(let v in h){const c=h[v];if(c)for(const{mac:d,internal:g}of c)g||(R+=1,this._isVirtualMachineMacAddress(d.toUpperCase())&&(T+=1))}this._value=R>0?T/R:0}return this._value}};let k;async function y(){return k||(k=(async()=>await E()||P.generateUuid())()),k}e.getMachineId=y;async function E(){try{const T=await new Promise((h,v)=>{J(["crypto"],h,v)}),R=(0,D.getMac)();return T.createHash("sha256").update(R,"utf8").digest("hex")}catch(T){t.onUnexpectedError(T);return}}}),define(ve[19],we([0,1,27,25,134,13,31,78,4,3,22,5]),function(J,e,_,t,w,P,D,k,y,E,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var h;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(h=e.RimRafMode||(e.RimRafMode={}));async function v(M,Y=h.UNLINK){if((0,D.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return Y===h.UNLINK?d(M):c(M)}async function c(M){try{const Y=(0,D.randomPath)((0,t.tmpdir)());try{await _.promises.rename(M,Y)}catch{return d(M)}d(Y).catch($=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function d(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function g(M){if((0,D.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");_.rmdirSync(M,{recursive:!0})}e.rimrafSync=g;async function b(M,Y){return p(await(Y?l(M):(0,w.promisify)(_.readdir)(M)))}async function l(M){try{return await(0,w.promisify)(_.readdir)(M,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const Y=[],$=await b(M);for(const G of $){let ie=!1,B=!1,q=!1;try{const ee=await e.Promises.lstat((0,y.join)(M,G));ie=ee.isFile(),B=ee.isDirectory(),q=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}Y.push({name:G,isFile:()=>ie,isDirectory:()=>B,isSymbolicLink:()=>q})}return Y}function C(M){return p(_.readdirSync(M))}e.readdirSync=C;function p(M){return M.map(Y=>typeof Y=="string"?E.isMacintosh?(0,k.normalizeNFC)(Y):Y:(Y.name=E.isMacintosh?(0,k.normalizeNFC)(Y.name):Y.name,Y))}async function u(M){const Y=await b(M),$=[];for(const G of Y)await a.existsDirectory((0,y.join)(M,G))&&$.push(G);return $}function s(M,Y=1e3){return new Promise($=>{let G=!1;const ie=setInterval(()=>{G||(G=!0,_.access(M,B=>{G=!1,B&&(clearInterval(ie),$(void 0))}))},Y)})}e.whenDeleted=s;var a;(function(M){async function Y(ie){let B;try{if(B=await e.Promises.lstat(ie),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(ie),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(E.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ie)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw ee}throw q}}M.stat=Y;async function $(ie){try{const{stat:B,symbolicLink:q}=await M.stat(ie);return B.isFile()&&q?.dangling!==!0}catch{}return!1}M.existsFile=$;async function G(ie){try{const{stat:B,symbolicLink:q}=await M.stat(ie);return B.isDirectory()&&q?.dangling!==!0}catch{}return!1}M.existsDirectory=G})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new P.ResourceQueue;function n(M,Y,$){return i.queueFor(R.URI.file(M),T.extUriBiasedIgnorePathCase).queue(()=>{const G=S($);return new Promise((ie,B)=>o(M,Y,G,q=>q?B(q):ie()))})}let r=!0;function o(M,Y,$,G){if(!r)return _.writeFile(M,Y,{mode:$.mode,flag:$.flag},G);_.open(M,$.flag,$.mode,(ie,B)=>{if(ie)return G(ie);_.writeFile(B,Y,q=>{if(q)return _.close(B,()=>G(q));_.fdatasync(B,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),r=!1),_.close(B,oe=>G(oe))))})})}function f(M,Y,$){const G=S($);if(!r)return _.writeFileSync(M,Y,{mode:G.mode,flag:G.flag});const ie=_.openSync(M,G.flag,G.mode);try{_.writeFileSync(ie,Y);try{_.fdatasyncSync(ie)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),r=!1}}finally{_.closeSync(ie)}}e.writeFileSync=f;function S(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function A(M,Y){if(M===Y)return;async function $(G){try{const ie=await e.Promises.lstat(G);if(ie.isDirectory()||ie.isSymbolicLink())return;await e.Promises.utimes(G,ie.atime,new Date)}catch{}}try{await e.Promises.rename(M,Y),await $(Y)}catch(G){if(M.toLowerCase()!==Y.toLowerCase()&&G.code==="EXDEV"||M.endsWith("."))await I(M,Y,{preserveSymlinks:!1}),await v(M,h.MOVE),await $(Y);else throw G}}async function I(M,Y,$){return U(M,Y,{root:{source:M,target:Y},options:$,handledSourcePaths:new Set})}const F=511;async function U(M,Y,$){if($.handledSourcePaths.has(M))return;$.handledSourcePaths.add(M);const{stat:G,symbolicLink:ie}=await a.stat(M);if(ie){if($.options.preserveSymlinks)try{return await L(M,Y,$)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(ie.dangling)return}return G.isDirectory()?W(M,Y,G.mode&F,$):m(M,Y,G.mode&F)}async function W(M,Y,$,G){await e.Promises.mkdir(Y,{recursive:!0,mode:$});const ie=await b(M);for(const B of ie)await U((0,y.join)(M,B),(0,y.join)(Y,B),G)}async function m(M,Y,$){await e.Promises.copyFile(M,Y),await e.Promises.chmod(Y,$)}async function L(M,Y,$){let G=await e.Promises.readlink(M);(0,D.isEqualOrParent)(G,$.root.source,!E.isLinux)&&(G=(0,y.join)($.root.target,G.substr($.root.source.length+1))),await e.Promises.symlink(G,Y)}e.Promises=new class{get access(){return(0,w.promisify)(_.access)}get stat(){return(0,w.promisify)(_.stat)}get lstat(){return(0,w.promisify)(_.lstat)}get utimes(){return(0,w.promisify)(_.utimes)}get read(){return(M,Y,$,G,ie)=>new Promise((B,q)=>{_.read(M,Y,$,G,ie,(ee,oe,re)=>ee?q(ee):B({bytesRead:oe,buffer:re}))})}get readFile(){return(0,w.promisify)(_.readFile)}get write(){return(M,Y,$,G,ie)=>new Promise((B,q)=>{_.write(M,Y,$,G,ie,(ee,oe,re)=>ee?q(ee):B({bytesWritten:oe,buffer:re}))})}get appendFile(){return(0,w.promisify)(_.appendFile)}get fdatasync(){return(0,w.promisify)(_.fdatasync)}get truncate(){return(0,w.promisify)(_.truncate)}get rename(){return(0,w.promisify)(_.rename)}get copyFile(){return(0,w.promisify)(_.copyFile)}get open(){return(0,w.promisify)(_.open)}get close(){return(0,w.promisify)(_.close)}get symlink(){return(0,w.promisify)(_.symlink)}get readlink(){return(0,w.promisify)(_.readlink)}get chmod(){return(0,w.promisify)(_.chmod)}get mkdir(){return(0,w.promisify)(_.mkdir)}get unlink(){return(0,w.promisify)(_.unlink)}get rmdir(){return(0,w.promisify)(_.rmdir)}get realpath(){return(0,w.promisify)(_.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return u}get writeFile(){return n}get rm(){return v}get move(){return A}get copy(){return I}}}),define(ve[135],we([0,1,27,4,3,18,19]),function(J,e,_,t,w,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(h){if(w.isLinux)return h;const v=(0,t.dirname)(h);if(h===v)return h;const c=((0,t.basename)(h)||h).toLowerCase();try{const g=(0,D.readdirSync)(v).filter(b=>b.toLowerCase()===c);if(g.length===1){const b=k(v);if(b)return(0,t.join)(b,g[0])}else if(g.length>1){const b=g.indexOf(c);if(b>=0){const l=k(v);if(l)return(0,t.join)(l,g[b])}}}catch{}return null}e.realcaseSync=k;async function y(h){if(w.isLinux)return h;const v=(0,t.dirname)(h);if(h===v)return h;const c=((0,t.basename)(h)||h).toLowerCase();try{const g=(await D.Promises.readdir(v)).filter(b=>b.toLowerCase()===c);if(g.length===1){const b=await y(v);if(b)return(0,t.join)(b,g[0])}else if(g.length>1){const b=g.indexOf(c);if(b>=0){const l=await y(v);if(l)return(0,t.join)(l,g[b])}}}catch{}return null}e.realcase=y;async function E(h){try{return await D.Promises.realpath(h)}catch{const c=R(h);return await D.Promises.access(c,_.constants.R_OK),c}}e.realpath=E;function T(h){try{return _.realpathSync(h)}catch{const c=R(h);return _.accessSync(c,_.constants.R_OK),c}}e.realpathSync=T;function R(h){return(0,P.rtrim)((0,t.normalize)(h),t.sep)}}),define(ve[136],we([0,1,82]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(k,y,E,T=1){let R=!1;return new Promise(h=>{const v=setTimeout(()=>{if(!R)return R=!0,h(0)},E);w(k,y,T,c=>{if(!R)return R=!0,clearTimeout(v),h(c)})})}e.findFreePort=t;function w(k,y,E,T){if(y===0)return T(0);const R=new _.Socket;R.once("connect",()=>(D(R),w(k+E,y-1,E,T))),R.once("data",()=>{}),R.once("error",h=>(D(R),h.code!=="ECONNREFUSED"?w(k+E,y-1,E,T):T(k))),R.connect(k,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(k,y,E){let T=!1,R,h=1;const v=_.createServer({pauseOnConnect:!0});function c(d,g){T||(T=!0,v.removeAllListeners(),v.close(),R&&clearTimeout(R),g(d))}return new Promise(d=>{R=setTimeout(()=>{c(0,d)},E),v.on("listening",()=>{c(k,d)}),v.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&h<y?(k++,h++,v.listen(k,"127.0.0.1")):c(0,d)}),v.on("close",()=>{c(0,d)}),v.listen(k,"127.0.0.1")})}e.findFreePortFaster=P;function D(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(y){console.error(y)}}}),define(ve[83],we([0,1,25,4,19]),function(J,e,_,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const P=/^\d+$/,D=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var y;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(y||(y={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class R{constructor(u,s,a){this.exePath=u,this.displayName=s,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:p=!1}={}){return p?E===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:p=!1,findPreview:u=!1}={}){const s=h({useAlternateBitness:p});if(!s)return null;const a=t.join(s,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(a))return null;let i=-1,n=null;for(const f of await w.Promises.readdir(a)){let S=-1;if(u){const I=f.indexOf("-");if(I<0)continue;const F=f.substring(0,I);if(!P.test(F)||f.substring(I+1)!=="preview")continue;S=parseInt(F,10)}else{if(!P.test(f))continue;S=parseInt(f,10)}if(S<=i)continue;const A=t.join(a,f,"pwsh.exe");!await w.SymlinkSupport.existsFile(A)||(n=A,i=S)}if(!n)return null;const r=s.includes("x86")?" (x86)":"",o=u?" Preview":"";return new R(n,`PowerShell${o}${r}`,!0)}async function c({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const u=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:s,pwshMsixName:a}=p?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await w.Promises.readdir(u))if(s.test(i)){const n=t.join(u,i,"pwsh.exe");return new R(n,a)}return null}function d(){const p=t.join(_.homedir(),".dotnet","tools","pwsh.exe");return new R(p,".NET Core PowerShell Global Tool")}function g(){const p=t.join(process.env.windir,E===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new R(p,"Windows PowerShell",!0)}async function*b(){let p=await v();p&&(yield p),p=await v({useAlternateBitness:!0}),p&&(yield p),p=await c(),p&&(yield p),p=d(),p&&(yield p),p=await v({findPreview:!0}),p&&(yield p),p=await c({findPreview:!0}),p&&(yield p),p=await v({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=g(),p&&(yield p)}async function*l(){for await(const p of b())await p.exists()&&(yield p)}e.enumeratePowerShellInstallations=l;async function C(){for await(const p of l())return p;return null}e.getFirstAvailablePowerShellInstallation=C}),define(ve[84],we([0,1,39,8]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function w(D){return new Promise((k,y)=>{let E;const T=new Map;function R(v,c,d,g,b){const l=T.get(c);if(v===D||l){const C={name:h(d),cmd:d,pid:v,ppid:c,load:g,mem:b};T.set(v,C),v===D&&(E=C),l&&(l.children||(l.children=[]),l.children.push(C),l.children.length>1&&(l.children=l.children.sort((p,u)=>p.pid-u.pid)))}}function h(v){const c=/--vscode-window-kind=shared-process/,d=/--vscode-window-kind=issue-reporter/,g=/--vscode-window-kind=process-explorer/,b=/--utility-sub-type=network/,l=/--crashes-directory/,C=/\\pipe\\winpty-control/,p=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(l.exec(v))return"electron-crash-reporter";if(C.exec(v))return"winpty-process";if(p.exec(v))return"console-window-host (Windows internal process)";let s=u.exec(v);if(s&&s.length===2)return s[1]==="renderer"?c.exec(v)?"shared-process":d.exec(v)?"issue-reporter":g.exec(v)?"process-explorer":"window":s[1]==="utility"&&b.exec(v)?"utility-network-service":s[1];const a=/[a-zA-Z-]+\.js/g;let i="";do s=a.exec(v),s&&(i+=s+" ");while(s);return i&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${i}`:v}if(process.platform==="win32"){const v=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substr(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substr(5):c;new Promise((c,d)=>{J(["windows-process-tree"],c,d)}).then(c=>{c.getProcessList(D,d=>{c.getProcessCpuUsage(d,g=>{const b=new Map;g.forEach(l=>{const C=v(l.commandLine||"");b.set(l.pid,{name:h(C),cmd:C,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),E=b.get(D),E?(b.forEach(l=>{const C=b.get(l.ppid);C&&(C.children||(C.children=[]),C.children.push(l))}),b.forEach(l=>{l.children&&(l.children=l.children.sort((C,p)=>C.pid-p.pid))}),k(E)):y(new Error(`Root process ${D} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let v=function(){let c=[E];const d=[];for(;c.length;){const b=c.shift();b&&(d.push(b.pid),b.children&&(c=c.concat(b.children)))}let g=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);g+=" "+d.join(" "),(0,_.exec)(g,{},(b,l,C)=>{if(b||C)y(b||new Error(C.toString()));else{const p=l.toString().split(`
`);for(let u=0;u<d.length;u++){const s=T.get(d[u]);s.load=parseFloat(p[u])}if(!E){y(new Error(`Root process ${D} not found`));return}k(E)}})};(0,_.exec)("which ps",{},(c,d,g)=>{if(c||g)if(process.platform!=="linux")y(c||new Error(g.toString()));else{const b=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,_.exec)(b,{},(l,C,p)=>{l||p?y(l||new Error(p.toString())):(P(C,R),v())})}else{const b=d.toString().trim(),l="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,_.exec)(`${b} ${l}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(C,p,u)=>{C||u&&!u.includes("screen size is bogus")?y(C||new Error(u.toString())):(P(p,R),process.platform==="linux"?v():E?k(E):y(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=w;function P(D,k){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=D.toString().split(`
`);for(const T of E){const R=y.exec(T.trim());R&&R.length===6&&k(parseInt(R[1]),parseInt(R[2]),R[5],parseFloat(R[3]),parseFloat(R[4]))}}});var Te=this&&this.__decorate||function(J,e,_,t){var w=arguments.length,P=w<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,_):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(J,e,_,t);else for(var k=J.length-1;k>=0;k--)(D=J[k])&&(P=(w<3?D(P):w>3?D(e,_,P):D(e,_))||P);return w>3&&P&&Object.defineProperty(e,_,P),P};define(ve[40],we([0,1,17,13,15,21,74,11,7,2,52,18,12]),function(J,e,_,t,w,P,D,k,y,E,T,R,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function c(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function g(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(b||(b={}));class l{constructor(q){this.buffer=q,this.pos=0}read(q){const ee=this.buffer.slice(this.pos,this.pos+q);return this.pos+=ee.byteLength,ee}}class C{constructor(){this.buffers=[]}get buffer(){return w.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}var p;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(p||(p={}));function u(B){const q=w.VSBuffer.alloc(4);return q.writeUInt32BE(B,0),q}function s(B){return B.read(4).readUInt32BE(0)}function a(B){const q=w.VSBuffer.alloc(1);return q.writeUInt8(B,0),q}const i={Undefined:a(p.Undefined),String:a(p.String),Buffer:a(p.Buffer),VSBuffer:a(p.VSBuffer),Array:a(p.Array),Object:a(p.Object)},n=typeof Buffer!="undefined";function r(B,q){if(typeof q=="undefined")B.write(i.Undefined);else if(typeof q=="string"){const ee=w.VSBuffer.fromString(q);B.write(i.String),B.write(u(ee.byteLength)),B.write(ee)}else if(n&&Buffer.isBuffer(q)){const ee=w.VSBuffer.wrap(q);B.write(i.Buffer),B.write(u(ee.byteLength)),B.write(ee)}else if(q instanceof w.VSBuffer)B.write(i.VSBuffer),B.write(u(q.byteLength)),B.write(q);else if(Array.isArray(q)){B.write(i.Array),B.write(u(q.length));for(const ee of q)r(B,ee)}else{const ee=w.VSBuffer.fromString(JSON.stringify(q));B.write(i.Object),B.write(u(ee.byteLength)),B.write(ee)}}function o(B){switch(B.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return B.read(s(B)).toString();case p.Buffer:return B.read(s(B)).buffer;case p.VSBuffer:return B.read(s(B));case p.Array:{const ee=s(B),oe=[];for(let re=0;re<ee;re++)oe.push(o(B));return oe}case p.Object:return JSON.parse(B.read(s(B)).toString())}}class f{constructor(q,ee,oe=null,re=1e3){this.protocol=q,this.ctx=ee,this.logger=oe,this.timeoutDelay=re,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(de=>this.onRawMessage(de)),this.sendResponse({type:200})}registerChannel(q,ee){this.channels.set(q,ee),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const ee=this.send([q.type]);this.logger&&this.logger.logOutgoing(ee,0,1,g(q.type));return}case 201:case 202:case 204:case 203:{const ee=this.send([q.type,q.id],q.data);this.logger&&this.logger.logOutgoing(ee,q.id,1,g(q.type),q.data);return}}}send(q,ee=void 0){const oe=new C;return r(oe,q),r(oe,ee),this.sendBuffer(oe.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const ee=new l(q),oe=o(ee),re=o(ee),de=oe[0];switch(de){case 100:return this.logger&&this.logger.logIncoming(q.byteLength,oe[1],1,`${c(de)}: ${oe[2]}.${oe[3]}`,re),this.onPromise({type:de,id:oe[1],channelName:oe[2],name:oe[3],arg:re});case 102:return this.logger&&this.logger.logIncoming(q.byteLength,oe[1],1,`${c(de)}: ${oe[2]}.${oe[3]}`,re),this.onEventListen({type:de,id:oe[1],channelName:oe[2],name:oe[3],arg:re});case 101:return this.logger&&this.logger.logIncoming(q.byteLength,oe[1],1,`${c(de)}`),this.disposeActiveRequest({type:de,id:oe[1]});case 103:return this.logger&&this.logger.logIncoming(q.byteLength,oe[1],1,`${c(de)}`),this.disposeActiveRequest({type:de,id:oe[1]})}}onPromise(q){const ee=this.channels.get(q.channelName);if(!ee){this.collectPendingRequest(q);return}const oe=new P.CancellationTokenSource;let re;try{re=ee.call(this.ctx,q.name,q.arg,oe.token)}catch(H){re=Promise.reject(H)}const de=q.id;re.then(H=>{this.sendResponse({id:de,data:H,type:201}),this.activeRequests.delete(q.id)},H=>{H instanceof Error?this.sendResponse({id:de,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split?H.stack.split(`
`):H.stack:void 0},type:202}):this.sendResponse({id:de,data:H,type:203}),this.activeRequests.delete(q.id)});const Z=(0,E.toDisposable)(()=>oe.cancel());this.activeRequests.set(q.id,Z)}onEventListen(q){const ee=this.channels.get(q.channelName);if(!ee){this.collectPendingRequest(q);return}const oe=q.id,de=ee.listen(this.ctx,q.name,q.arg)(Z=>this.sendResponse({id:oe,data:Z,type:204}));this.activeRequests.set(q.id,de)}disposeActiveRequest(q){const ee=this.activeRequests.get(q.id);ee&&(ee.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let ee=this.pendingRequests.get(q.channelName);ee||(ee=[],this.pendingRequests.set(q.channelName,ee));const oe=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ee.push({request:q,timeoutTimer:oe})}flushPendingRequests(q){const ee=this.pendingRequests.get(q);if(ee){for(const oe of ee)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.onPromise(oe.request);break;case 102:this.onEventListen(oe.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var S;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(q,ee=null){this.protocol=q,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(oe=>this.onBuffer(oe)),this.logger=ee}getChannel(q){const ee=this;return{call(oe,re,de){return ee.isDisposed?Promise.reject(k.canceled()):ee.requestPromise(q,oe,re,de)},listen(oe,re){return ee.isDisposed?Promise.reject(k.canceled()):ee.requestEvent(q,oe,re)}}}requestPromise(q,ee,oe,re=P.CancellationToken.None){const de=this.lastRequestId++,H={id:de,type:100,channelName:q,name:ee,arg:oe};if(re.isCancellationRequested)return Promise.reject(k.canceled());let j;return new Promise((ne,me)=>{if(re.isCancellationRequested)return me(k.canceled());const De=()=>{const Q=z=>{switch(z.type){case 201:this.handlers.delete(de),ne(z.data);break;case 202:{this.handlers.delete(de);const x=new Error(z.data.message);x.stack=z.data.stack,x.name=z.data.name,me(x);break}case 203:this.handlers.delete(de),me(z.data);break}};this.handlers.set(de,Q),this.sendRequest(H)};let ae=null;this.state===b.Idle?De():(ae=(0,t.createCancelablePromise)(Q=>this.whenInitialized()),ae.then(()=>{ae=null,De()}));const fe=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:de,type:101}),me(k.canceled())},pe=re.onCancellationRequested(fe);j=(0,E.combinedDisposable)((0,E.toDisposable)(fe),pe),this.activeRequests.add(j)}).finally(()=>{this.activeRequests.delete(j)})}requestEvent(q,ee,oe){const re=this.lastRequestId++,Z={id:re,type:102,channelName:q,name:ee,arg:oe};let H=null;const j=new y.Emitter({onFirstListenerAdd:()=>{H=(0,t.createCancelablePromise)(ne=>this.whenInitialized()),H.then(()=>{H=null,this.activeRequests.add(j),this.sendRequest(Z)})},onLastListenerRemove:()=>{H?(H.cancel(),H=null):(this.activeRequests.delete(j),this.sendRequest({id:re,type:103}))}}),V=ne=>j.fire(ne.data);return this.handlers.set(re,V),j.event}sendRequest(q){switch(q.type){case 100:case 102:{const ee=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger&&this.logger.logOutgoing(ee,q.id,0,`${c(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const ee=this.send([q.type,q.id]);this.logger&&this.logger.logOutgoing(ee,q.id,0,c(q.type));return}}}send(q,ee=void 0){const oe=new C;return r(oe,q),r(oe,ee),this.sendBuffer(oe.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const ee=new l(q),oe=o(ee),re=o(ee),de=oe[0];switch(de){case 200:return this.logger&&this.logger.logIncoming(q.byteLength,0,0,g(de)),this.onResponse({type:oe[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(q.byteLength,oe[1],0,g(de),re),this.onResponse({type:oe[0],id:oe[1],data:re})}}onResponse(q){if(q.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const ee=this.handlers.get(q.id);ee&&ee(q)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}Te([D.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class I{constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,q(({protocol:ee,onDidClientDisconnect:oe})=>{y.Event.once(ee.onMessage)(de=>{const Z=new l(de),H=o(Z),j=new f(ee,H),V=new A(ee);this.channels.forEach((me,De)=>j.registerChannel(De,me));const ne={channelServer:j,channelClient:V,ctx:H};this._connections.add(ne),this._onDidAddConnection.fire(ne),oe(()=>{j.dispose(),V.dispose(),this._connections.delete(ne),this._onDidRemoveConnection.fire(ne)})})})}get connections(){const q=[];return this._connections.forEach(ee=>q.push(ee)),q}getChannel(q,ee){const oe=this;return{call(re,de,Z){let H;if((0,h.isFunction)(ee)){let V=(0,_.getRandomElement)(oe.connections.filter(ee));H=V?Promise.resolve(V):y.Event.toPromise(y.Event.filter(oe.onDidAddConnection,ee))}else H=ee.routeCall(oe,re,de);const j=H.then(V=>V.channelClient.getChannel(q));return U(j).call(re,de,Z)},listen(re,de){if((0,h.isFunction)(ee))return oe.getMulticastEvent(q,ee,re,de);const Z=ee.routeEvent(oe,re,de).then(H=>H.channelClient.getChannel(q));return U(Z).listen(re,de)}}}getMulticastEvent(q,ee,oe,re){const de=this;let Z=new E.DisposableStore;const H=new y.Emitter({onFirstListenerAdd:()=>{Z=new E.DisposableStore;const j=new y.EventMultiplexer,V=new Map,ne=De=>{const fe=De.channelClient.getChannel(q).listen(oe,re),pe=j.add(fe);V.set(De,pe)},me=De=>{const ae=V.get(De);!ae||(ae.dispose(),V.delete(De))};de.connections.filter(ee).forEach(ne),y.Event.filter(de.onDidAddConnection,ee)(ne,void 0,Z),de.onDidRemoveConnection(me,void 0,Z),j.event(H.fire,H,Z),Z.add(j)},onLastListenerRemove:()=>{Z.dispose()}});return H.event}registerChannel(q,ee){this.channels.set(q,ee),this._connections.forEach(oe=>{oe.channelServer.registerChannel(q,ee)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class F{constructor(q,ee,oe=null){const re=new C;r(re,ee),q.send(re.buffer),this.channelClient=new A(q,oe),this.channelServer=new f(q,ee,oe)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,ee){this.channelServer.registerChannel(q,ee)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function U(B){return{call(q,ee,oe){return B.then(re=>re.call(q,ee,oe))},listen(q,ee){const oe=new y.Relay;return B.then(re=>oe.input=re.listen(q,ee)),oe.event}}}e.getDelayedChannel=U;function W(B){let q=!1;return{call(ee,oe,re){return q?B.call(ee,oe,re):(0,t.timeout)(0).then(()=>q=!0).then(()=>B.call(ee,oe,re))},listen(ee,oe){if(q)return B.listen(ee,oe);const re=new y.Relay;return(0,t.timeout)(0).then(()=>q=!0).then(()=>re.input=B.listen(ee,oe)),re.event}}}e.getNextTickChannel=W;class m{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const ee of q.connections)if(await Promise.resolve(this.fn(ee.ctx)))return Promise.resolve(ee);return await y.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=m;var L;(function(B){function q(de,Z){const H=de,j=Z&&Z.disableMarshalling,V=new Map;for(const ne in H)oe(ne)&&V.set(ne,y.Event.buffer(H[ne],!0));return new class{listen(ne,me,De){const ae=V.get(me);if(ae)return ae;if(re(me)){const fe=H[me];if(typeof fe=="function")return fe.call(H,De)}throw new Error(`Event not found: ${me}`)}call(ne,me,De){const ae=H[me];if(typeof ae=="function"){if(!j&&Array.isArray(De))for(let fe=0;fe<De.length;fe++)De[fe]=(0,T.revive)(De[fe]);return ae.apply(H,De)}throw new Error(`Method not found: ${me}`)}}}B.fromService=q;function ee(de,Z){const H=Z&&Z.disableMarshalling;return new Proxy({},{get(j,V){if(typeof V=="string")return Z?.properties?.has(V)?Z.properties.get(V):re(V)?function(ne){return de.listen(V,ne)}:oe(V)?de.listen(V):async function(...ne){let me;Z&&!(0,h.isUndefinedOrNull)(Z.context)?me=[Z.context,...ne]:me=ne;const De=await de.call(V,me);return H?De:(0,T.revive)(De)};throw new Error(`Property not found: ${String(V)}`)}})}B.toService=ee;function oe(de){return de[0]==="o"&&de[1]==="n"&&R.isUpperAsciiLetter(de.charCodeAt(2))}function re(de){return/^onDynamic/.test(de)&&R.isUpperAsciiLetter(de.charCodeAt(9))}})(L=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Y(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let q=B.toString();if(q!=="[object Object]")return q}return B}function $(B){return Array.isArray(B)?B.map(Y):Y(B)}function G(B,q,ee,oe,re,de,Z){Z=$(Z);const H=M[re],j=H[oe%H.length];let V=[`%c[${B}]%c[${String(q).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${de}`,"color: darkgreen","color: grey","color: grey",`color: ${j}`];/\($/.test(de)?(V=V.concat(Z),V.push(")")):V.push(Z),console.log.apply(console,V)}e.logWithColors=G;class ie{constructor(q,ee){this._outgoingPrefix=q,this._incomingPrefix=ee,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,ee,oe,re,de){this._totalOutgoing+=q,G(this._outgoingPrefix,this._totalOutgoing,q,ee,oe,re,de)}logIncoming(q,ee,oe,re,de){this._totalIncoming+=q,G(this._incomingPrefix,this._totalIncoming,q,ee,oe,re,de)}}e.IPCLogger=ie}),define(ve[85],we([0,1,15,7,2,40]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(n){n.enableDiagnostics=!1,n.records=[];const r=new WeakMap;let o=0;function f(A,I){if(!r.has(A)){const F=String(++o);r.set(A,F)}return r.get(A)}function S(A,I,F,U){if(!n.enableDiagnostics)return;const W=f(A,I);if(U instanceof _.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const m=_.VSBuffer.alloc(U.byteLength);m.set(U),n.records.push({timestamp:Date.now(),id:W,label:I,type:F,buff:m})}else n.records.push({timestamp:Date.now(),id:W,label:I,type:F,data:U})}n.traceSocketEvent=S})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var y;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function T(){return E||(E=_.VSBuffer.alloc(0)),E}class R{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,o){if(r===0)return T();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const I=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=r),I}if(this._chunks[0].byteLength>r){const I=this._chunks[0].slice(0,r);return o&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),I}let f=_.VSBuffer.alloc(r),S=0,A=0;for(;r>0;){const I=this._chunks[A];if(I.byteLength>r){const F=I.slice(0,r);f.set(F,S),S+=r,o&&(this._chunks[A]=I.slice(r),this._totalLength-=r),r-=r}else f.set(I,S),S+=I.byteLength,o?(this._chunks.shift(),this._totalLength-=I.byteLength):A++,r-=I.byteLength}return f}}e.ChunkStream=R;var h;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume"})(h||(h={}));function v(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var c;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(c=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(r,o,f,S){this.type=r,this.id=o,this.ack=f,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends w.Disposable{constructor(r){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new R,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:v(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const f=this._state.messageType,S=this._state.id,A=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new d(f,S,A,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class b{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=_.VSBuffer.alloc(13);o.writeUInt8(r.type,0),o.writeUInt32BE(r.id,1),o.writeUInt32BE(r.ack,5),o.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:v(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(o,r.data)}_bufferAdd(r,o){const f=this._totalLength===0;return this._data.push(r,o),this._totalLength+=r.byteLength+o.byteLength,f}_bufferTake(){const r=_.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,o){this._bufferAdd(r,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class l extends w.Disposable{constructor(r){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new b(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new d(1,0,0,r))}}e.Protocol=l;class C extends P.IPCClient{constructor(r,o,f=null){super(r,o,f);this.protocol=r}static fromSocket(r,o){return new C(new l(r),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=C;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class u{constructor(r){this.data=r,this.next=null}}class s{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],o=0,f=this._first;for(;f;)r[o++]=f.data,f=f.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const o=new u(r);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class a{constructor(){this.lastRuns=[];const r=Date.now();for(let o=0;o<a._HISTORY_LENGTH;o++)this.lastRuns[o]=r-1e3*o;setInterval(()=>{for(let o=a._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const r=Date.now(),o=(1+a._HISTORY_LENGTH)*1e3;let f=0;for(let S=0;S<a._HISTORY_LENGTH;S++)r-this.lastRuns[S]<=o&&f++;return 1-f/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class i{constructor(r,o=null,f=a.getInstance()){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=f,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(S=>this._receiveMessage(S))),this._socketDisposables.push(this._socket.onClose(S=>this._onSocketClose.fire(S))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,w.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new d(5,0,0,T());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new d(7,0,0,T());this._socketWriter.write(r)}sendResume(){const r=new d(8,0,0,T());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,o){this._isReconnecting=!0,this._socketDisposables=(0,w.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,T());this._socketWriter.write(r);const o=this._outgoingUnackMsg.toArray();for(let f=0,S=o.length;f<S;f++)this._socketWriter.write(o[f]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new d(6,0,0,T())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let f=0,S=o.length;f<S;f++)this._socketWriter.write(o[f]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const f=new d(1,o,this._incomingAckId,r);this._outgoingUnackMsg.push(f),this._isReconnecting||(this._socketWriter.write(f),this._recvAckCheck())}sendControl(r){const o=new d(2,0,0,r);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),o=Date.now()-r.writtenTime,f=Date.now()-this._socketReader.lastReadTime,S=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&f>=2e4&&S>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const A=Math.max(2e4-o,2e4-f,2e4-S,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},A)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,T());this._socketWriter.write(r)}}e.PersistentProtocol=i}),define(ve[137],we([0,1,13,7,2,12]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function k(R){const h=R;return h?.changed instanceof Map||h?.deleted instanceof Set}e.isStorageItemsChangeEvent=k;var y;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(y||(y={}));class E extends w.Disposable{constructor(h,v=Object.create(null)){super();this.database=h,this.options=v,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=y.None,this.cache=new Map,this.flushDelayer=new _.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((v,c)=>this.accept(c,v)),h.deleted?.forEach(v=>this.accept(v,void 0))}accept(h,v){if(this.state===y.Closed)return;let c=!1;(0,P.isUndefinedOrNull)(v)?c=this.cache.delete(h):this.cache.get(h)!==v&&(this.cache.set(h,v),c=!0),c&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===y.None&&(this.state=y.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,v){const c=this.cache.get(h);return(0,P.isUndefinedOrNull)(c)?v:c}getBoolean(h,v){const c=this.get(h);return(0,P.isUndefinedOrNull)(c)?v:c==="true"}getNumber(h,v){const c=this.get(h);return(0,P.isUndefinedOrNull)(c)?v:parseInt(c,10)}async set(h,v){if(this.state===y.Closed)return;if((0,P.isUndefinedOrNull)(v))return this.delete(h);const c=String(v);if(this.cache.get(h)!==c)return this.cache.set(h,c),this.pendingInserts.set(h,c),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async delete(h){if(!(this.state===y.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=y.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(!!this.hasPending)return this.doFlush(h)}async doFlush(h){return this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class T{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert&&h.insert.forEach((v,c)=>this.items.set(c,v)),h.delete&&h.delete.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=T}),define(ve[86],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(w,P){this.lineNumber=w,this.column=P}with(w=this.lineNumber,P=this.column){return w===this.lineNumber&&P===this.column?this:new _(w,P)}delta(w=0,P=0){return this.with(this.lineNumber+w,this.column+P)}equals(w){return _.equals(this,w)}static equals(w,P){return!w&&!P?!0:!!w&&!!P&&w.lineNumber===P.lineNumber&&w.column===P.column}isBefore(w){return _.isBefore(this,w)}static isBefore(w,P){return w.lineNumber<P.lineNumber?!0:P.lineNumber<w.lineNumber?!1:w.column<P.column}isBeforeOrEqual(w){return _.isBeforeOrEqual(this,w)}static isBeforeOrEqual(w,P){return w.lineNumber<P.lineNumber?!0:P.lineNumber<w.lineNumber?!1:w.column<=P.column}static compare(w,P){const D=w.lineNumber|0,k=P.lineNumber|0;if(D===k){const y=w.column|0,E=P.column|0;return y-E}return D-k}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(w){return new _(w.lineNumber,w.column)}static isIPosition(w){return w&&typeof w.lineNumber=="number"&&typeof w.column=="number"}}e.Position=_}),define(ve[63],we([0,1,86]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,D,k,y){P>k||P===k&&D>y?(this.startLineNumber=k,this.startColumn=y,this.endLineNumber=P,this.endColumn=D):(this.startLineNumber=P,this.startColumn=D,this.endLineNumber=k,this.endColumn=y)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,D){return!(D.lineNumber<P.startLineNumber||D.lineNumber>P.endLineNumber||D.lineNumber===P.startLineNumber&&D.column<P.startColumn||D.lineNumber===P.endLineNumber&&D.column>P.endColumn)}static strictContainsPosition(P,D){return!(D.lineNumber<P.startLineNumber||D.lineNumber>P.endLineNumber||D.lineNumber===P.startLineNumber&&D.column<=P.startColumn||D.lineNumber===P.endLineNumber&&D.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,D){return!(D.startLineNumber<P.startLineNumber||D.endLineNumber<P.startLineNumber||D.startLineNumber>P.endLineNumber||D.endLineNumber>P.endLineNumber||D.startLineNumber===P.startLineNumber&&D.startColumn<P.startColumn||D.endLineNumber===P.endLineNumber&&D.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,D){return!(D.startLineNumber<P.startLineNumber||D.endLineNumber<P.startLineNumber||D.startLineNumber>P.endLineNumber||D.endLineNumber>P.endLineNumber||D.startLineNumber===P.startLineNumber&&D.startColumn<=P.startColumn||D.endLineNumber===P.endLineNumber&&D.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,D){let k,y,E,T;return D.startLineNumber<P.startLineNumber?(k=D.startLineNumber,y=D.startColumn):D.startLineNumber===P.startLineNumber?(k=D.startLineNumber,y=Math.min(D.startColumn,P.startColumn)):(k=P.startLineNumber,y=P.startColumn),D.endLineNumber>P.endLineNumber?(E=D.endLineNumber,T=D.endColumn):D.endLineNumber===P.endLineNumber?(E=D.endLineNumber,T=Math.max(D.endColumn,P.endColumn)):(E=P.endLineNumber,T=P.endColumn),new t(k,y,E,T)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,D){let k=P.startLineNumber,y=P.startColumn,E=P.endLineNumber,T=P.endColumn,R=D.startLineNumber,h=D.startColumn,v=D.endLineNumber,c=D.endColumn;return k<R?(k=R,y=h):k===R&&(y=Math.max(y,h)),E>v?(E=v,T=c):E===v&&(T=Math.min(T,c)),k>E||k===E&&y>T?null:new t(k,y,E,T)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,D){return!!P&&!!D&&P.startLineNumber===D.startLineNumber&&P.startColumn===D.startColumn&&P.endLineNumber===D.endLineNumber&&P.endColumn===D.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new _.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new _.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,D){return new t(this.startLineNumber,this.startColumn,P,D)}setStartPosition(P,D){return new t(P,D,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,D=P){return new t(P.lineNumber,P.column,D.lineNumber,D.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,D){return!(P.endLineNumber<D.startLineNumber||P.endLineNumber===D.startLineNumber&&P.endColumn<D.startColumn||D.endLineNumber<P.startLineNumber||D.endLineNumber===P.startLineNumber&&D.endColumn<P.startColumn)}static areIntersecting(P,D){return!(P.endLineNumber<D.startLineNumber||P.endLineNumber===D.startLineNumber&&P.endColumn<=D.startColumn||D.endLineNumber<P.startLineNumber||D.endLineNumber===P.startLineNumber&&D.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,D){if(P&&D){const E=P.startLineNumber|0,T=D.startLineNumber|0;if(E===T){const R=P.startColumn|0,h=D.startColumn|0;if(R===h){const v=P.endLineNumber|0,c=D.endLineNumber|0;if(v===c){const d=P.endColumn|0,g=D.endColumn|0;return d-g}return v-c}return R-h}return E-T}return(P?1:0)-(D?1:0)}static compareRangesUsingEnds(P,D){return P.endLineNumber===D.endLineNumber?P.endColumn===D.endColumn?P.startLineNumber===D.startLineNumber?P.startColumn-D.startColumn:P.startLineNumber-D.startLineNumber:P.endColumn-D.endColumn:P.endLineNumber-D.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}}e.Range=t}),define(ve[138],we([0,1,60,4]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function w(P,D,k,y){if(Array.isArray(P)){let E=0;for(const T of P){const R=w(T,D,k,y);if(R===10)return R;R>E&&(E=R)}return E}else{if(typeof P=="string")return y?P==="*"?5:P===k?10:0:0;if(P){const{language:E,pattern:T,scheme:R,hasAccessToAllModels:h}=P;if(!y&&!h)return 0;let v=0;if(R)if(R===D.scheme)v=10;else if(R==="*")v=5;else return 0;if(E)if(E===k)v=10;else if(E==="*")v=Math.max(v,5);else return 0;if(T){let c;if(typeof T=="string"?c=T:c={...T,base:(0,t.normalize)(T.base)},c===D.fsPath||(0,_.match)(c,D.fsPath))v=10;else return 0}return v}else return 0}}e.score=w}),define(ve[139],we([0,1,20]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var w;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(w=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(l){l[l.Both=0]="Both",l[l.Right=1]="Right",l[l.Left=2]="Left",l[l.None=3]="None"})(P=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var D;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var k;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(k=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class E{constructor(C){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,C.tabSize|0),this.indentSize=C.tabSize|0,this.insertSpaces=Boolean(C.insertSpaces),this.defaultEOL=C.defaultEOL|0,this.trimAutoWhitespace=Boolean(C.trimAutoWhitespace),this.bracketPairColorizationOptions=C.bracketPairColorizationOptions}equals(C){return this.tabSize===C.tabSize&&this.indentSize===C.indentSize&&this.insertSpaces===C.insertSpaces&&this.defaultEOL===C.defaultEOL&&this.trimAutoWhitespace===C.trimAutoWhitespace&&(0,_.equals)(this.bracketPairColorizationOptions,C.bracketPairColorizationOptions)}createChangeEvent(C){return{tabSize:this.tabSize!==C.tabSize,indentSize:this.indentSize!==C.indentSize,insertSpaces:this.insertSpaces!==C.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==C.trimAutoWhitespace}}}e.TextModelResolvedOptions=E;class T{constructor(C,p){this._findMatchBrand=void 0,this.range=C,this.matches=p}}e.FindMatch=T;var R;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(R=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var h;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None"})(h=e.PositionAffinity||(e.PositionAffinity={}));var v;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v=e.ModelConstants||(e.ModelConstants={}));class c{constructor(C,p,u,s,a,i){this.identifier=C,this.range=p,this.text=u,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=a,this._isTracked=i}}e.ValidAnnotatedEditOperation=c;class d{constructor(C,p,u){this.regex=C,this.wordSeparators=p,this.simpleSearch=u}}e.SearchData=d;class g{constructor(C,p,u){this.reverseEdits=C,this.changes=p,this.trimAutoWhitespaceLineNumbers=u}}e.ApplyEditsResult=g;function b(l){return!l.isTooLargeForSyncing()&&!l.isForSimpleWidget}e.shouldSynchronizeModel=b}),define(ve[140],we([0,1,7,2,139,138]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRegistry=void 0;function D(y){return typeof y=="string"?!1:Array.isArray(y)?y.every(D):!!y.exclusive}class k{constructor(){this._clock=0,this._entries=[],this._onDidChange=new _.Emitter}get onDidChange(){return this._onDidChange.event}register(E,T){let R={selector:E,provider:T,_score:-1,_time:this._clock++};return this._entries.push(R),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,t.toDisposable)(()=>{if(R){const h=this._entries.indexOf(R);h>=0&&(this._entries.splice(h,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),R=void 0)}})}has(E){return this.all(E).length>0}all(E){if(!E)return[];this._updateScores(E);const T=[];for(let R of this._entries)R._score>0&&T.push(R.provider);return T}ordered(E){const T=[];return this._orderedForEach(E,R=>T.push(R.provider)),T}orderedGroups(E){const T=[];let R,h;return this._orderedForEach(E,v=>{R&&h===v._score?R.push(v.provider):(h=v._score,R=[v.provider],T.push(R))}),T}_orderedForEach(E,T){if(!!E){this._updateScores(E);for(const R of this._entries)R._score>0&&T(R)}}_updateScores(E){const T={uri:E.uri.toString(),language:E.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===T.language&&this._lastCandidate.uri===T.uri)){this._lastCandidate=T;for(let R of this._entries)if(R._score=(0,P.score)(R.selector,E.uri,E.getLanguageId(),(0,w.shouldSynchronizeModel)(E)),D(R.selector)&&R._score>0){for(let h of this._entries)h._score=0;R._score=1e3;break}this._entries.sort(k._compareByScoreAndTime)}}static _compareByScoreAndTime(E,T){return E._score<T._score?1:E._score>T._score?-1:E._time<T._time?1:E._time>T._time?-1:0}}e.LanguageFeatureRegistry=k}),define(ve[141],we([0,1,7,2]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class w{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,y){return this._map.set(k,y),this.fire([k]),(0,t.toDisposable)(()=>{this._map.get(k)===y&&(this._map.delete(k),this.fire([k]))})}registerFactory(k,y){this._factories.get(k)?.dispose();const E=new P(this,k,y);return this._factories.set(k,E),(0,t.toDisposable)(()=>{const T=this._factories.get(k);!T||T!==E||(this._factories.delete(k),T.dispose())})}async getOrCreate(k){const y=this.get(k);if(y)return y;const E=this._factories.get(k);return!E||E.isResolved?null:(await E.resolve(),this.get(k))}get(k){return this._map.get(k)||null}isResolved(k){if(this.get(k))return!0;const E=this._factories.get(k);return!!(!E||E.isResolved)}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=w;class P extends t.Disposable{constructor(k,y,E){super();this._registry=k,this._languageId=y,this._factory=E,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const k=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,k&&!this._isDisposed&&this._register(this._registry.register(this._languageId,k))}}}),define(ve[142],we([0,1,5,63,140,141,37]),function(J,e,_,t,w,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(m){m[m.Null=0]="Null",m[m.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var y;(function(m){m[m.NotSet=-1]="NotSet",m[m.None=0]="None",m[m.Italic=1]="Italic",m[m.Bold=2]="Bold",m[m.Underline=4]="Underline",m[m.Strikethrough=8]="Strikethrough"})(y=e.FontStyle||(e.FontStyle={}));var E;(function(m){m[m.None=0]="None",m[m.DefaultForeground=1]="DefaultForeground",m[m.DefaultBackground=2]="DefaultBackground"})(E=e.ColorId||(e.ColorId={}));var T;(function(m){m[m.Other=0]="Other",m[m.Comment=1]="Comment",m[m.String=2]="String",m[m.RegEx=3]="RegEx"})(T=e.StandardTokenType||(e.StandardTokenType={}));var R;(function(m){m[m.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",m[m.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",m[m.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",m[m.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",m[m.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",m[m.ITALIC_MASK=1024]="ITALIC_MASK",m[m.BOLD_MASK=2048]="BOLD_MASK",m[m.UNDERLINE_MASK=4096]="UNDERLINE_MASK",m[m.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",m[m.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",m[m.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",m[m.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",m[m.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",m[m.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",m[m.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",m[m.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",m[m.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",m[m.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",m[m.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",m[m.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(R=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(L){return(L&255)>>>0}static getTokenType(L){return(L&768)>>>8}static getFontStyle(L){return(L&15360)>>>10}static getForeground(L){return(L&8372224)>>>14}static getBackground(L){return(L&4286578688)>>>23}static getClassNameFromMetadata(L){const M=this.getForeground(L);let Y="mtk"+M;const $=this.getFontStyle(L);return $&1&&(Y+=" mtki"),$&2&&(Y+=" mtkb"),$&4&&(Y+=" mtku"),$&8&&(Y+=" mtks"),Y}static getInlineStyleFromMetadata(L,M){const Y=this.getForeground(L),$=this.getFontStyle(L);let G=`color: ${M[Y]};`;$&1&&(G+="font-style: italic;"),$&2&&(G+="font-weight: bold;");let ie="";return $&4&&(ie+=" underline"),$&8&&(ie+=" line-through"),ie&&(G+=`text-decoration:${ie};`),G}static getPresentationFromMetadata(L){const M=this.getForeground(L),Y=this.getFontStyle(L);return{foreground:M,italic:Boolean(Y&1),bold:Boolean(Y&2),underline:Boolean(Y&4),strikethrough:Boolean(Y&8)}}}e.TokenMetadata=h;class v{constructor(L,M,Y){this._tokenBrand=void 0,this.offset=L,this.type=M,this.language=Y}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=v;class c{constructor(L,M){this._tokenizationResultBrand=void 0,this.tokens=L,this.endState=M}}e.TokenizationResult=c;class d{constructor(L,M){this._encodedTokenizationResultBrand=void 0,this.tokens=L,this.endState=M}}e.EncodedTokenizationResult=d;var g;(function(m){m[m.Method=0]="Method",m[m.Function=1]="Function",m[m.Constructor=2]="Constructor",m[m.Field=3]="Field",m[m.Variable=4]="Variable",m[m.Class=5]="Class",m[m.Struct=6]="Struct",m[m.Interface=7]="Interface",m[m.Module=8]="Module",m[m.Property=9]="Property",m[m.Event=10]="Event",m[m.Operator=11]="Operator",m[m.Unit=12]="Unit",m[m.Value=13]="Value",m[m.Constant=14]="Constant",m[m.Enum=15]="Enum",m[m.EnumMember=16]="EnumMember",m[m.Keyword=17]="Keyword",m[m.Text=18]="Text",m[m.Color=19]="Color",m[m.File=20]="File",m[m.Reference=21]="Reference",m[m.Customcolor=22]="Customcolor",m[m.Folder=23]="Folder",m[m.TypeParameter=24]="TypeParameter",m[m.User=25]="User",m[m.Issue=26]="Issue",m[m.Snippet=27]="Snippet"})(g=e.CompletionItemKind||(e.CompletionItemKind={}));var b;(function(m){const L=new Map;L.set(0,D.Codicon.symbolMethod),L.set(1,D.Codicon.symbolFunction),L.set(2,D.Codicon.symbolConstructor),L.set(3,D.Codicon.symbolField),L.set(4,D.Codicon.symbolVariable),L.set(5,D.Codicon.symbolClass),L.set(6,D.Codicon.symbolStruct),L.set(7,D.Codicon.symbolInterface),L.set(8,D.Codicon.symbolModule),L.set(9,D.Codicon.symbolProperty),L.set(10,D.Codicon.symbolEvent),L.set(11,D.Codicon.symbolOperator),L.set(12,D.Codicon.symbolUnit),L.set(13,D.Codicon.symbolValue),L.set(15,D.Codicon.symbolEnum),L.set(14,D.Codicon.symbolConstant),L.set(15,D.Codicon.symbolEnum),L.set(16,D.Codicon.symbolEnumMember),L.set(17,D.Codicon.symbolKeyword),L.set(27,D.Codicon.symbolSnippet),L.set(18,D.Codicon.symbolText),L.set(19,D.Codicon.symbolColor),L.set(20,D.Codicon.symbolFile),L.set(21,D.Codicon.symbolReference),L.set(22,D.Codicon.symbolCustomColor),L.set(23,D.Codicon.symbolFolder),L.set(24,D.Codicon.symbolTypeParameter),L.set(25,D.Codicon.account),L.set(26,D.Codicon.issues);function M(G){let ie=L.get(G);return ie||(console.info("No codicon found for CompletionItemKind "+G),ie=D.Codicon.symbolProperty),ie}m.toIcon=M;const Y=new Map;Y.set("method",0),Y.set("function",1),Y.set("constructor",2),Y.set("field",3),Y.set("variable",4),Y.set("class",5),Y.set("struct",6),Y.set("interface",7),Y.set("module",8),Y.set("property",9),Y.set("event",10),Y.set("operator",11),Y.set("unit",12),Y.set("value",13),Y.set("constant",14),Y.set("enum",15),Y.set("enum-member",16),Y.set("enumMember",16),Y.set("keyword",17),Y.set("snippet",27),Y.set("text",18),Y.set("color",19),Y.set("file",20),Y.set("reference",21),Y.set("customcolor",22),Y.set("folder",23),Y.set("type-parameter",24),Y.set("typeParameter",24),Y.set("account",25),Y.set("issue",26);function $(G,ie){let B=Y.get(G);return typeof B=="undefined"&&!ie&&(B=9),B}m.fromString=$})(b=e.CompletionItemKinds||(e.CompletionItemKinds={}));var l;(function(m){m[m.Deprecated=1]="Deprecated"})(l=e.CompletionItemTag||(e.CompletionItemTag={}));var C;(function(m){m[m.KeepWhitespace=1]="KeepWhitespace",m[m.InsertAsSnippet=4]="InsertAsSnippet"})(C=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var p;(function(m){m[m.Invoke=0]="Invoke",m[m.TriggerCharacter=1]="TriggerCharacter",m[m.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var u;(function(m){m[m.Automatic=0]="Automatic",m[m.Explicit=1]="Explicit"})(u=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var s;(function(m){m[m.Invoke=1]="Invoke",m[m.Auto=2]="Auto"})(s=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var a;(function(m){m[m.Invoke=1]="Invoke",m[m.TriggerCharacter=2]="TriggerCharacter",m[m.ContentChange=3]="ContentChange"})(a=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var i;(function(m){m[m.Text=0]="Text",m[m.Read=1]="Read",m[m.Write=2]="Write"})(i=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function n(m){return m&&_.URI.isUri(m.uri)&&t.Range.isIRange(m.range)&&(t.Range.isIRange(m.originSelectionRange)||t.Range.isIRange(m.targetSelectionRange))}e.isLocationLink=n;var r;(function(m){m[m.File=0]="File",m[m.Module=1]="Module",m[m.Namespace=2]="Namespace",m[m.Package=3]="Package",m[m.Class=4]="Class",m[m.Method=5]="Method",m[m.Property=6]="Property",m[m.Field=7]="Field",m[m.Constructor=8]="Constructor",m[m.Enum=9]="Enum",m[m.Interface=10]="Interface",m[m.Function=11]="Function",m[m.Variable=12]="Variable",m[m.Constant=13]="Constant",m[m.String=14]="String",m[m.Number=15]="Number",m[m.Boolean=16]="Boolean",m[m.Array=17]="Array",m[m.Object=18]="Object",m[m.Key=19]="Key",m[m.Null=20]="Null",m[m.EnumMember=21]="EnumMember",m[m.Struct=22]="Struct",m[m.Event=23]="Event",m[m.Operator=24]="Operator",m[m.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var o;(function(m){m[m.Deprecated=1]="Deprecated"})(o=e.SymbolTag||(e.SymbolTag={}));var f;(function(m){const L=new Map;L.set(0,D.Codicon.symbolFile),L.set(1,D.Codicon.symbolModule),L.set(2,D.Codicon.symbolNamespace),L.set(3,D.Codicon.symbolPackage),L.set(4,D.Codicon.symbolClass),L.set(5,D.Codicon.symbolMethod),L.set(6,D.Codicon.symbolProperty),L.set(7,D.Codicon.symbolField),L.set(8,D.Codicon.symbolConstructor),L.set(9,D.Codicon.symbolEnum),L.set(10,D.Codicon.symbolInterface),L.set(11,D.Codicon.symbolFunction),L.set(12,D.Codicon.symbolVariable),L.set(13,D.Codicon.symbolConstant),L.set(14,D.Codicon.symbolString),L.set(15,D.Codicon.symbolNumber),L.set(16,D.Codicon.symbolBoolean),L.set(17,D.Codicon.symbolArray),L.set(18,D.Codicon.symbolObject),L.set(19,D.Codicon.symbolKey),L.set(20,D.Codicon.symbolNull),L.set(21,D.Codicon.symbolEnumMember),L.set(22,D.Codicon.symbolStruct),L.set(23,D.Codicon.symbolEvent),L.set(24,D.Codicon.symbolOperator),L.set(25,D.Codicon.symbolTypeParameter);function M(Y){let $=L.get(Y);return $||(console.info("No codicon found for SymbolKind "+Y),$=D.Codicon.symbolProperty),$}m.toIcon=M})(f=e.SymbolKinds||(e.SymbolKinds={}));class S{constructor(L){this.value=L}}e.FoldingRangeKind=S,S.Comment=new S("comment"),S.Imports=new S("imports"),S.Region=new S("region");var A;(function(m){function L(M){return!M||typeof M!="object"?!1:typeof M.id=="string"&&typeof M.title=="string"}m.is=L})(A=e.Command||(e.Command={}));var I;(function(m){m[m.Collapsed=0]="Collapsed",m[m.Expanded=1]="Expanded"})(I=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var F;(function(m){m[m.Editing=0]="Editing",m[m.Preview=1]="Preview"})(F=e.CommentMode||(e.CommentMode={}));var U;(function(m){m[m.Other=0]="Other",m[m.Type=1]="Type",m[m.Parameter=2]="Parameter"})(U=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new w.LanguageFeatureRegistry,e.RenameProviderRegistry=new w.LanguageFeatureRegistry,e.CompletionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new w.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new w.LanguageFeatureRegistry,e.HoverProviderRegistry=new w.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new w.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new w.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new w.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new w.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new w.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.LinkProviderRegistry=new w.LanguageFeatureRegistry,e.ColorProviderRegistry=new w.LanguageFeatureRegistry,e.SelectionRangeRegistry=new w.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistry;var W;(function(m){m[m.None=0]="None",m[m.Option=1]="Option",m[m.Default=2]="Default",m[m.Preferred=3]="Preferred"})(W=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[143],we([9,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(ve[144],we([0,1,143]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,w=t*60,P=w*24,D=P*7,k=P*30,y=P*365;function E(R,h,v){typeof R!="number"&&(R=R.getTime());const c=Math.round((new Date().getTime()-R)/1e3);if(c<-30)return(0,_.localize)(0,null,E(new Date().getTime()+c*1e3,!1));if(c<30)return(0,_.localize)(1,null);let d;return c<t?(d=c,h?d===1?v?(0,_.localize)(2,null,d):(0,_.localize)(3,null,d):v?(0,_.localize)(4,null,d):(0,_.localize)(5,null,d):d===1?v?(0,_.localize)(6,null,d):(0,_.localize)(7,null,d):v?(0,_.localize)(8,null,d):(0,_.localize)(9,null,d)):c<w?(d=Math.floor(c/t),h?d===1?v?(0,_.localize)(10,null,d):(0,_.localize)(11,null,d):v?(0,_.localize)(12,null,d):(0,_.localize)(13,null,d):d===1?v?(0,_.localize)(14,null,d):(0,_.localize)(15,null,d):v?(0,_.localize)(16,null,d):(0,_.localize)(17,null,d)):c<P?(d=Math.floor(c/w),h?d===1?v?(0,_.localize)(18,null,d):(0,_.localize)(19,null,d):v?(0,_.localize)(20,null,d):(0,_.localize)(21,null,d):d===1?v?(0,_.localize)(22,null,d):(0,_.localize)(23,null,d):v?(0,_.localize)(24,null,d):(0,_.localize)(25,null,d)):c<D?(d=Math.floor(c/P),h?d===1?(0,_.localize)(26,null,d):(0,_.localize)(27,null,d):d===1?(0,_.localize)(28,null,d):(0,_.localize)(29,null,d)):c<k?(d=Math.floor(c/D),h?d===1?v?(0,_.localize)(30,null,d):(0,_.localize)(31,null,d):v?(0,_.localize)(32,null,d):(0,_.localize)(33,null,d):d===1?v?(0,_.localize)(34,null,d):(0,_.localize)(35,null,d):v?(0,_.localize)(36,null,d):(0,_.localize)(37,null,d)):c<y?(d=Math.floor(c/k),h?d===1?v?(0,_.localize)(38,null,d):(0,_.localize)(39,null,d):v?(0,_.localize)(40,null,d):(0,_.localize)(41,null,d):d===1?v?(0,_.localize)(42,null,d):(0,_.localize)(43,null,d):v?(0,_.localize)(44,null,d):(0,_.localize)(45,null,d)):(d=Math.floor(c/y),h?d===1?v?(0,_.localize)(46,null,d):(0,_.localize)(47,null,d):v?(0,_.localize)(48,null,d):(0,_.localize)(49,null,d):d===1?v?(0,_.localize)(50,null,d):(0,_.localize)(51,null,d):v?(0,_.localize)(52,null,d):(0,_.localize)(53,null,d))}e.fromNow=E;function T(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(ve[145],we([9,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ve[36],we([0,1,17,12,145]),function(J,e,_,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(E,T){return T&&(E.stack||E.stacktrace)?w.localize(0,null,k(E),D(E.stack)||D(E.stacktrace)):k(E)}function D(E){return Array.isArray(E)?E.join(`
`):E}function k(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?w.localize(1,null,E.message):E.message||w.localize(2,null)}function y(E=null,T=!1){if(!E)return w.localize(3,null);if(Array.isArray(E)){const R=_.coalesce(E),h=y(R[0],T);return R.length>1?w.localize(4,null,h,R.length):h}if(t.isString(E))return E;if(E.detail){const R=E.detail;if(R.error)return P(R.error,T);if(R.exception)return P(R.exception,T)}return E.stack?P(E,T):E.message?E.message:w.localize(5,null)}e.toErrorMessage=y}),define(ve[146],we([9,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ve[147],we([0,1,146]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(w){switch(w){case 1:return(0,_.localize)(0,null);case 2:return(0,_.localize)(1,null);case 3:return(0,_.localize)(2,null);case 4:return(0,_.localize)(3,null);case 5:return(0,_.localize)(4,null);case 6:return(0,_.localize)(5,null);case 7:return(0,_.localize)(6,null);case 8:return(0,_.localize)(7,null);case 9:return(0,_.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ve[148],we([9,10]),function(J,e){return J.create("vs/base/node/processes",e)}),define(ve[64],we([0,1,39,31,8,20,4,3,24,76,12,130,19,148]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return E.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return E.TerminateResponseCode}});function c(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(s,a){if(k.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};a&&(i.cwd=a);const n=_.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],i);return new Promise(r=>{n.once("error",o=>{r({success:!1,error:o})}),n.once("exit",(o,f)=>{r(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?c(i.status):1})}else if(k.isLinux||k.isMacintosh)try{const i=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(n=>{_.execFile(i,[s.pid.toString()],{encoding:"utf8",shell:!0},(r,o,f)=>{n(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function g(s){!s||(delete s.DEBUG,k.isMacintosh&&delete s.DYLD_LIBRARY_PATH,k.isLinux&&delete s.LD_PRELOAD)}e.removeDangerousEnvVariables=g;function b(s=y.env){return s.comspec||"cmd.exe"}e.getWindowsShell=b;class l{constructor(a,i,n,r){if(i!==void 0&&n!==void 0&&r!==void 0)this.cmd=a,this.args=i,this.shell=n,this.options=r;else{const o=a;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(y.env).forEach(f=>{o[f]=y.env[f]}),Object.keys(this.options.env).forEach(f=>{o[f]=this.options.env[f]}),this.options.env=o}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const i=a.lastIndexOf(D.sep);return i!==-1&&(a=a.substring(i+1)),l.WellKnowCommands[a]?a:"other"}start(a){return k.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(y.cwd()))?Promise.reject(new Error(v.localize(0,null))):this.useExec().then(i=>{let n,r;const o=new Promise((f,S)=>{n=f,r=S});if(i){let f=this.cmd;this.args&&(f=f+" "+this.args.join(" ")),this.childProcess=_.exec(f,this.options,(S,A,I)=>{this.childProcess=null;const F=S;F&&F.killed?r({killed:this.terminateRequested,stdout:A.toString(),stderr:I.toString()}):this.handleExec(n,a,S,A,I)})}else{let f=null;const S=A=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(A,n,a,r);const I={terminated:this.terminateRequested};T.isNumber(A)&&(I.cmdCode=A),n(I)};if(this.shell&&k.isWindows){const A=P.deepClone(this.options);A.windowsVerbatimArguments=!0,A.detached=!1;let I=!1,F=!1;const U=[];let W=this.ensureQuotes(this.cmd);U.push(W.value),I=W.quoted,this.args&&this.args.forEach(L=>{W=this.ensureQuotes(L),U.push(W.value),F=F&&W.quoted});const m=["/s","/c"];I?F?m.push('"'+U.join(" ")+'"'):U.length>1?m.push('"'+U[0]+'" '+U.slice(1).join(" ")):m.push('"'+U[0]+'"'):m.push(U.join(" ")),f=_.spawn(b(),m,A)}else this.cmd&&(f=_.spawn(this.cmd,this.args,this.options));f&&(this.childProcess=f,this.childProcessPromise=Promise.resolve(f),this.pidResolve&&(this.pidResolve(T.isNumber(f.pid)?f.pid:-1),this.pidResolve=void 0),f.on("error",A=>{this.childProcess=null,r({terminated:this.terminateRequested,error:A})}),f.pid&&(this.childProcess.on("close",S),this.handleSpawn(f,n,a,r,!0)))}return o})}handleClose(a,i,n,r){}ensureQuotes(a){return l.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,d(a,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!k.isWindows)return a(!1);const i=_.spawn(b(),["/s","/c"]);i.on("error",n=>a(!0)),i.on("exit",n=>a(!1))})}}e.AbstractProcess=l,l.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},l.regexp=/^[^"].* .*[^"]/;class C extends l{constructor(a,i,n,r){super(a,i,n,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,i,n,r,o){[r,o].forEach((f,S)=>{const A=new R.LineDecoder;A.write(f).forEach(U=>{i({line:U,source:S===0?0:1})});const F=A.end();F&&i({line:F,source:S===0?0:1})}),a({terminated:this.terminateRequested,error:n})}handleSpawn(a,i,n,r,o){const f=new R.LineDecoder,S=new R.LineDecoder;a.stdout.on("data",A=>{f.write(A).forEach(F=>n({line:F,source:0}))}),a.stderr.on("data",A=>{S.write(A).forEach(F=>n({line:F,source:1}))}),this.stdoutLineDecoder=f,this.stderrLineDecoder=S}handleClose(a,i,n,r){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&n({line:o,source:0});const f=this.stderrLineDecoder?this.stderrLineDecoder.end():null;f&&n({line:f,source:1})}}e.LineProcess=C;function p(s){let a=[],i=!1;const n=function(r){if(i){a.push(r);return}(!s.send(r,f=>{if(f&&console.error(f),i=!1,a.length>0){const S=a.slice(0);a=[],S.forEach(A=>n(A))}})||k.isWindows)&&(i=!0)};return{send:n}}e.createQueuedSender=p;var u;(function(s){async function a(i,n,r){if(D.isAbsolute(i))return i;if(n===void 0&&(n=y.cwd()),D.dirname(i)!=="."||(r===void 0&&T.isString(y.env.PATH)&&(r=y.env.PATH.split(D.delimiter)),r===void 0||r.length===0))return D.join(n,i);async function f(S){if(await h.Promises.exists(S)){let A;try{A=await h.Promises.stat(S)}catch(I){I.message.startsWith("EACCES")&&(A=await h.Promises.lstat(S))}return A?!A.isDirectory():!1}return!1}for(let S of r){let A;if(D.isAbsolute(S)?A=D.join(S,i):A=D.join(n,S,i),await f(A))return A;let I=A+".com";if(await f(I)||(I=A+".exe",await f(I)))return I}return D.join(n,i)}s.findExecutable=a})(u=e.win32||(e.win32={}))}),define(ve[149],we([0,1,25,3,83,64]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(v,c){return v===1?t.isWindows?R():P.getWindowsShell(c):E(v,c)}e.getSystemShell=D;function k(v,c){return v===1?t.isWindows?h(c):P.getWindowsShell(c):E(v,c)}e.getSystemShellSync=k;let y=null;function E(v,c){if(t.isLinux&&v===2||t.isMacintosh&&v===3)return"/bin/bash";if(!y){let d;if(t.isWindows)d="/bin/bash";else{if(d=c.SHELL,!d)try{d=(0,_.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}y=d}return y}let T=null;async function R(){return T||(T=(await(0,w.getFirstAvailablePowerShellInstallation)()).exePath),T}function h(v){if(T)return T;const c=t.isWindows&&parseFloat((0,_.release)())>=10,d=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${v.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?g:P.getWindowsShell(v)}}),define(ve[87],we([0,1,39,13,15,21,80,11,7,2,20,64,40]),function(J,e,_,t,w,P,D,k,y,E,T,R,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class v extends h.ChannelServer{constructor(g){super({send:b=>{try{process.send&&process.send(b.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",b=>w.VSBuffer.wrap(Buffer.from(b,"base64")))},g);process.once("disconnect",()=>this.dispose())}}e.Server=v;class c{constructor(g,b){this.modulePath=g,this.options=b,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new y.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const l=b&&b.timeout?b.timeout:6e4;this.disposeDelayer=new t.Delayer(l),this.child=null,this._client=null}getChannel(g){const b=this;return{call(l,C,p){return b.requestPromise(g,l,C,p)},listen(l,C){return b.requestEvent(g,l,C)}}}requestPromise(g,b,l,C=P.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(C.isCancellationRequested)return Promise.reject(k.canceled());this.disposeDelayer.cancel();const p=this.getCachedChannel(g),u=(0,t.createCancelablePromise)(i=>p.call(b,l,i)),s=C.onCancellationRequested(()=>u.cancel()),a=(0,E.toDisposable)(()=>u.cancel());return this.activeRequests.add(a),u.finally(()=>{s.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(g,b,l){if(!this.disposeDelayer)return y.Event.None;this.disposeDelayer.cancel();let C;const p=new y.Emitter({onFirstListenerAdd:()=>{C=this.getCachedChannel(g).listen(b,l)(p.fire,p),this.activeRequests.add(C)},onLastListenerRemove:()=>{this.activeRequests.delete(C),C.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return p.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],b=Object.create(null);b.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(b.env={...b.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(b.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(b.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(b.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),b.execArgv===void 0&&(b.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,R.removeDangerousEnvVariables)(b.env),this.child=(0,_.fork)(this.modulePath,g,b);const l=new y.Emitter;y.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,D.isRemoteConsoleLog)(n)){(0,D.log)(n,`IPC Library: ${this.options.serverName}`);return}l.fire(w.VSBuffer.wrap(Buffer.from(n,"base64")))});const p=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,u=n=>this.child&&this.child.connected&&p.send(n.buffer.toString("base64")),s=l.event,a={send:u,onMessage:s};this._client=new h.ChannelClient(a);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,r)=>{process.removeListener("exit",i),this.activeRequests.forEach(o=>(0,E.dispose)(o)),this.activeRequests.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:r})})}return this._client}getCachedChannel(g){let b=this.channels.get(g);return b||(b=this.client.getChannel(g),this.channels.set(g,b)),b}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=c}),define(ve[150],we([9,10]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ve[151],we([9,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[152],we([9,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(ve[153],we([9,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(ve[154],we([9,10]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(ve[155],we([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ve[156],we([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[157],we([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(ve[158],we([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ve[159],we([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ve[160],we([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ve[161],we([9,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[162],we([9,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ve[163],we([9,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ve[164],we([9,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ve[165],we([9,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ve[166],we([9,10]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(ve[167],we([9,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ve[168],we([9,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ve[169],we([9,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ve[170],we([9,10]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[171],we([9,10]),function(J,e){return J.create("vs/server/node/remoteAgentEnvironmentImpl",e)}),define(ve[172],we([9,10]),function(J,e){return J.create("vs/server/node/serverEnvironmentService",e)}),define(ve[173],we([9,10]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(ve[174],we([9,10]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[175],we([9,10]),function(J,e){return J.create("vs/workbench/services/extensions/node/extensionPoints",e)}),define(ve[176],we([0,1,7,2]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class w{constructor(){this._onCloseEmitter=new _.Emitter,this._onReloadEmitter=new _.Emitter,this._onTerminateEmitter=new _.Emitter,this._onAttachEmitter=new _.Emitter}call(k,y,E){switch(y){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:E[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:E[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:E[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:E[0],port:E[1],subId:E[2]}))}throw new Error("Method not implemented.")}listen(k,y,E){switch(y){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=w,w.ChannelName="extensionhostdebugservice";class P extends t.Disposable{constructor(k){super();this.channel=k}reload(k){this.channel.call("reload",[k])}get onReload(){return this.channel.listen("reload")}close(k){this.channel.call("close",[k])}get onClose(){return this.channel.listen("close")}attachSession(k,y,E){this.channel.call("attach",[k,y,E])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(k,y){this.channel.call("terminate",[k,y])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(k,y){return this.channel.call("openExtensionDevelopmentHostWindow",[k,y])}}e.ExtensionHostDebugChannelClient=P}),define(ve[177],we([0,1,5]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class t{constructor(D){this.service=D}listen(D,k,y){throw new Error("Invalid listen")}call(D,k,y){switch(k){case"download":return this.service.download(_.URI.revive(y[0]),_.URI.revive(y[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=t;class w{constructor(D,k){this.channel=D,this.getUriTransformer=k}async download(D,k){const y=this.getUriTransformer();y&&(D=y.transformOutgoingURI(D),k=y.transformOutgoingURI(k)),await this.channel.call("download",[D,k])}}e.DownloadServiceChannelClient=w}),define(ve[178],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var _;(function(D){D[D.ACTIVATE=1]="ACTIVATE",D[D.RESTORE=2]="RESTORE",D[D.PRESERVE=3]="PRESERVE"})(_=e.EditorActivation||(e.EditorActivation={}));var t;(function(D){D[D.PICK=0]="PICK",D[D.DISABLED=1]="DISABLED",D[D.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var w;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(w=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[179],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class _{constructor(w){this.machineId=w}encryption(){return new Promise((w,P)=>J(["vscode-encrypt"],w,P))}async encrypt(w){try{return(await this.encryption()).encrypt(this.machineId,w)}catch{return w}}async decrypt(w){try{return(await this.encryption()).decrypt(this.machineId,w)}catch{return w}}}e.EncryptionMainService=_}),define(ve[88],we([0,1,144,74,8,4,24,22,5]),function(J,e,_,t,w,P,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(d,g,b){this._args=d,this.paths=g,this.productService=b}get appRoot(){return(0,P.dirname)(w.FileAccess.asFileUri("",J).fsPath)}get userHome(){return y.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return y.URI.file((0,P.join)(this.userDataPath,"User"))}get tmpDir(){return y.URI.file(this.paths.tmpDir)}get cacheHome(){return y.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,P.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return y.URI.file((0,P.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(y.URI.file((0,P.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return y.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return y.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=D.env.VSCODE_PORTABLE;return d?y.URI.file((0,P.join)(d,"argv.json")):(0,k.joinPath)(this.appSettingsHome,"argv.json")}get snippetsHome(){return(0,k.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return y.URI.file((0,P.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,P.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,P.resolve)(d):(0,P.normalize)((0,P.join)(w.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,P.resolve)(d):(0,P.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,P.resolve)(d);const g=D.env.VSCODE_EXTENSIONS;if(g)return g;const b=D.env.VSCODE_PORTABLE;return b?(0,P.join)(b,"extensions"):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(g=>/^[^:/?#]+?:\/\//.test(g)?y.URI.parse(g):y.URI.file((0,P.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?y.URI.parse(d):y.URI.file((0,P.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return T(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,k.joinPath)(y.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return y.URI.file((0,P.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}Te([t.memoize],E.prototype,"appRoot",null),Te([t.memoize],E.prototype,"userHome",null),Te([t.memoize],E.prototype,"userDataPath",null),Te([t.memoize],E.prototype,"appSettingsHome",null),Te([t.memoize],E.prototype,"tmpDir",null),Te([t.memoize],E.prototype,"cacheHome",null),Te([t.memoize],E.prototype,"userRoamingDataHome",null),Te([t.memoize],E.prototype,"settingsResource",null),Te([t.memoize],E.prototype,"userDataSyncHome",null),Te([t.memoize],E.prototype,"userDataSyncLogResource",null),Te([t.memoize],E.prototype,"sync",null),Te([t.memoize],E.prototype,"machineSettingsResource",null),Te([t.memoize],E.prototype,"globalStorageHome",null),Te([t.memoize],E.prototype,"workspaceStorageHome",null),Te([t.memoize],E.prototype,"keybindingsResource",null),Te([t.memoize],E.prototype,"keyboardLayoutResource",null),Te([t.memoize],E.prototype,"argvResource",null),Te([t.memoize],E.prototype,"snippetsHome",null),Te([t.memoize],E.prototype,"isExtensionDevelopment",null),Te([t.memoize],E.prototype,"untitledWorkspacesHome",null),Te([t.memoize],E.prototype,"installSourcePath",null),Te([t.memoize],E.prototype,"builtinExtensionsPath",null),Te([t.memoize],E.prototype,"extensionsPath",null),Te([t.memoize],E.prototype,"extensionDevelopmentLocationURI",null),Te([t.memoize],E.prototype,"extensionDevelopmentKind",null),Te([t.memoize],E.prototype,"extensionTestsLocationURI",null),Te([t.memoize],E.prototype,"debugExtensionHost",null),Te([t.memoize],E.prototype,"serviceMachineIdResource",null),Te([t.memoize],E.prototype,"telemetryLogResource",null),Te([t.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function T(c,d){return v(c["inspect-extensions"],c["inspect-brk-extensions"],5870,d,c.debugId,c.extensionEnvironment)}e.parseExtensionHostPort=T;function R(c,d){return v(c["inspect-search"],c["inspect-brk-search"],5876,d,c.extensionEnvironment)}e.parseSearchPort=R;function h(c,d){return v(c["inspect-ptyhost"],c["inspect-brk-ptyhost"],5877,d,c.extensionEnvironment)}e.parsePtyHostPort=h;function v(c,d,g,b,l,C){const u=Number(d||c)||(b?null:g),s=u?Boolean(!!d):!1;let a;if(C)try{a=JSON.parse(C)}catch{}return{port:u,break:s,debugId:l,env:a}}}),define(ve[53],we([0,1,262,3,152]),function(J,e,_,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const P={o:(0,w.localize)(0,null),e:(0,w.localize)(1,null),t:(0,w.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,w.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,w.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,w.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,w.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,w.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,w.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,w.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,w.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,w.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,w.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,w.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,w.localize)(14,null)},category:{type:"string",cat:"e",description:(0,w.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,w.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,w.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,w.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,w.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,w.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,w.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,w.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,w.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,w.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,w.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,w.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,w.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,w.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,w.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,w.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,w.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,w.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function k(c,d,g=D){const b={},l=[],C=[];for(let a in d){const i=d[a];i.alias&&(b[a]=i.alias),i.type==="string"||i.type==="string[]"?(l.push(a),i.deprecates&&l.push(...i.deprecates)):i.type==="boolean"&&(C.push(a),i.deprecates&&C.push(...i.deprecates))}const p=_(c,{string:l,boolean:C,alias:b}),u={},s=p;u._=p._.map(a=>String(a)).filter(a=>a.length>0),delete s._;for(let a in d){const i=d[a];i.alias&&delete s[i.alias];let n=s[a];if(i.deprecates)for(const r of i.deprecates)s.hasOwnProperty(r)&&(n||(n=s[r],n&&g.onDeprecatedOption(r,i.deprecationMessage||(0,w.localize)(33,null))),delete s[r]);typeof n!="undefined"&&(i.type==="string[]"?n&&!Array.isArray(n)&&(n=[n]):i.type==="string"&&Array.isArray(n)&&(n=n.pop(),g.onMultipleValues(a,n)),u[a]=n,i.deprecationMessage&&g.onDeprecatedOption(a,i.deprecationMessage)),delete s[a]}for(let a in s)g.onUnknownOption(a);return u}e.parseArgs=k;function y(c,d){let g="";return d.args&&(Array.isArray(d.args)?g=` <${d.args.join("> <")}>`:g=` <${d.args}>`),d.alias?`-${d.alias} --${c}${g}`:`--${c}${g}`}function E(c,d){let g=0,b=[];for(const u in c){const s=c[u],a=y(u,s);g=Math.max(g,a.length),b.push([a,s.description])}let l=g+2+1;if(d-l<25)return b.reduce((u,s)=>u.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);let C=d-l-1,p=[];for(const u of b){let s=u[0],a=R(u[1],C),i=T(l-s.length-2);p.push("  "+s+i+a[0]);for(let n=1;n<a.length;n++)p.push(T(l)+a[n])}return p}e.formatOptions=E;function T(c){return" ".repeat(c)}function R(c,d){let g=[];for(;c.length;){let b=c.length<d?c.length:c.lastIndexOf(" ",d),l=c.slice(0,b).trim();c=c.slice(b),g.push(l)}return g}function h(c,d,g,b,l){const C=process.stdout.isTTY&&process.stdout.columns||80,p=l?.noInputFiles!==!0?`[${(0,w.localize)(34,null)}...]`:"",u=[`${c} ${g}`];u.push(""),u.push(`${(0,w.localize)(35,null)}: ${d} [${(0,w.localize)(36,null)}]${p}`),u.push(""),l?.noPipe!==!0&&(t.isWindows?u.push((0,w.localize)(37,null,d)):u.push((0,w.localize)(38,null,d)),u.push(""));const s={};for(const a in b){const i=b[a];if(i.description&&i.cat){let n=s[i.cat];n||(s[i.cat]=n={}),n[a]=i}}for(let a in s){const i=a;let n=s[i];n&&(u.push(P[i]),u.push(...E(n,C)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=h;function v(c,d){return`${c||(0,w.localize)(39,null)}
${d||(0,w.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=v}),function(){"use strict";function J(e,_,t,w){function P(k){const y=D(k),E=[y];return e.isAbsolute(y)||E.unshift(w),e.resolve(...E)}function D(k){const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,t);const T=k["user-data-dir"];if(T)return T;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(R,"AppData","Roaming")}break;case"darwin":E=e.join(_.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(_.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,t)}return{getUserDataPath:P}}if(typeof define=="function")define(ve[180],we([0,132,25,8,22,24]),function(e,_,t,w,P,D){const k=P.dirname(w.FileAccess.asFileUri("",e)),y=e.__$__nodeRequire(P.joinPath(k,"package.json").fsPath);return J(_,t,y.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),_=require("path"),t=require("os");module.exports=J(_,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ve[181],we([0,1,25,88,180]),function(J,e,_,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class P extends t.AbstractNativeEnvironmentService{constructor(k,y){super(k,{homeDir:(0,_.homedir)(),tmpDir:(0,_.tmpdir)(),userDataDir:(0,w.getUserDataPath)(k)},y)}}e.NativeEnvironmentService=P}),define(ve[182],we([0,1,20]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const t=/^%([\w\d.-]+)%$/i;function w(P,D){const k=y=>{if(typeof y!="string")return;const E=t.exec(y);if(!E)return;const T=D[E[1]]??y;return typeof T=="string"?T:typeof T.message=="string"?T.message:y};return(0,_.cloneAndChange)(P,k)}e.localizeManifest=w}),define(ve[65],we([0,1,161]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function P(h){return h=h.trim(),h==="*"||t.test(h)}e.isValidVersionStr=P;function D(h){if(!P(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=h.match(t);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=D;function k(h){if(!h)return null;let v=h.majorBase,c=h.majorMustEqual,d=h.minorBase,g=h.minorMustEqual,b=h.patchBase,l=h.patchMustEqual;h.hasCaret&&(v===0||(g=!1),l=!1);let C=0;if(h.preRelease){const p=w.exec(h.preRelease);if(p){const[,u,s,a]=p;C=Date.UTC(Number(u),Number(s)-1,Number(a))}}return{majorBase:v,majorMustEqual:c,minorBase:d,minorMustEqual:g,patchBase:b,patchMustEqual:l,isMinimum:h.hasGreaterEquals,notBefore:C}}e.normalizeVersion=k;function y(h,v,c){let d;typeof h=="string"?d=k(D(h)):d=h;let g;v instanceof Date?g=v.getTime():typeof v=="string"&&(g=new Date(v).getTime());let b;if(typeof c=="string"?b=k(D(c)):b=c,!d||!b)return!1;let l=d.majorBase,C=d.minorBase,p=d.patchBase,u=b.majorBase,s=b.minorBase,a=b.patchBase,i=b.notBefore,n=b.majorMustEqual,r=b.minorMustEqual,o=b.patchMustEqual;return b.isMinimum?l>u?!0:l<u?!1:C>s?!0:C<s||g&&g<i?!1:p>=a:(l===1&&u===0&&(!n||!r||!o)&&(u=1,s=0,a=0,n=!0,r=!1,o=!1),l<u?!1:l>u?!n:C<s?!1:C>s?!r:p<a?!1:p>a?!o:!(g&&g<i))}e.isValidVersion=y;function E(h,v,c,d){return c.isBuiltin||typeof c.main=="undefined"?!0:R(h,v,c.engines.vscode,d)}e.isValidExtensionVersion=E;function T(h,v,c){return h==="*"||R(v,c,h)}e.isEngineValid=T;function R(h,v,c,d=[]){let g=k(D(c));if(!g)return d.push(_.localize(0,null,c)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return d.push(_.localize(1,null,c)),!1}else if(!g.majorMustEqual)return d.push(_.localize(2,null,c)),!1;return y(h,v,g)?!0:(d.push(_.localize(3,null,h,c)),!1)}}),define(ve[183],we([0,1,15,23]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function w(P,D,k){let y=k&&k.get("storage.serviceMachineId",0)||null;if(y)return y;try{const T=(await D.readFile(P.serviceMachineIdResource)).value.toString();y=(0,t.isUUID)(T)?T:null}catch{y=null}if(!y){y=(0,t.generateUuid)();try{await D.writeFile(P.serviceMachineIdResource,_.VSBuffer.fromString(y))}catch{}}return k&&k.store("storage.serviceMachineId",y,0,1),y}e.getServiceMachineId=w}),define(ve[54],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class _{constructor(w,P=[],D=!1){this.ctor=w,this.staticArguments=P,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=_}),define(ve[184],we([0,1,54]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function w(D,k,y){k instanceof _.SyncDescriptor||(k=new _.SyncDescriptor(k,[],y)),t.push([D,k])}e.registerSingleton=w;function P(){return t}e.getSingletonServiceDescriptors=P}),define(ve[185],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=_;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let D of this._nodes.values())D.outgoing.size===0&&P.push(D);return P}insertEdge(P,D){const k=this.lookupOrInsertNode(P),y=this.lookupOrInsertNode(D);k.outgoing.set(this._hashFn(D),y),y.incoming.set(this._hashFn(P),k)}removeNode(P){const D=this._hashFn(P);this._nodes.delete(D);for(let k of this._nodes.values())k.outgoing.delete(D),k.incoming.delete(D)}lookupOrInsertNode(P){const D=this._hashFn(P);let k=this._nodes.get(D);return k||(k=new _(P),this._nodes.set(D,k)),k}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[D,k]of this._nodes)P.push(`${D}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,D]of this._nodes){const k=new Set([P]),y=this._findCycle(D,k);if(y)return y}}_findCycle(P,D){for(let[k,y]of P.outgoing){if(D.has(k))return[...D,k].join(" -> ");D.add(k);const E=this._findCycle(y,D);if(E)return E;D.delete(k)}}}e.Graph=t}),define(ve[6],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function k(y){return y[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=k})(_=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function t(D,k,y,E){k[_.DI_TARGET]===k?k[_.DI_DEPENDENCIES].push({id:D,index:y,optional:E}):(k[_.DI_DEPENDENCIES]=[{id:D,index:y,optional:E}],k[_.DI_TARGET]=k)}function w(D){if(_.serviceIds.has(D))return _.serviceIds.get(D);const k=function(y,E,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,y,T,!1)};return k.toString=()=>D,_.serviceIds.set(D,k),k}e.createDecorator=w;function P(D){return D}e.refineServiceDecorator=P}),define(ve[28],we([0,1,12,5,6]),function(J,e,_,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function P(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof t.URI)}e.isConfigurationOverrides=P;function D(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||_.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var k;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=y;function E(g,b){const l=Object.create(null);for(let C in g)T(l,C,g[C],b);return l}e.toValuesTree=E;function T(g,b,l,C){const p=b.split("."),u=p.pop();let s=g;for(let a=0;a<p.length;a++){let i=p[a],n=s[i];switch(typeof n){case"undefined":n=s[i]=Object.create(null);break;case"object":break;default:C(`Ignoring ${b} as ${p.slice(0,a+1).join(".")} is ${JSON.stringify(n)}`);return}s=n}if(typeof s=="object"&&s!==null)try{s[u]=l}catch{C(`Ignoring ${b} as ${p.join(".")} is ${JSON.stringify(s)}`)}else C(`Ignoring ${b} as ${p.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=T;function R(g,b){const l=b.split(".");h(g,l)}e.removeFromValueTree=R;function h(g,b){const l=b.shift();if(b.length===0){delete g[l];return}if(Object.keys(g).indexOf(l)!==-1){const C=g[l];typeof C=="object"&&!Array.isArray(C)&&(h(C,b),Object.keys(C).length===0&&delete g[l])}}function v(g,b,l){function C(s,a){let i=s;for(const n of a){if(typeof i!="object"||i===null)return;i=i[n]}return i}const p=b.split("."),u=C(g,p);return typeof u=="undefined"?l:u}e.getConfigurationValue=v;function c(g,b,l){Object.keys(b).forEach(C=>{C!=="__proto__"&&(C in g?_.isObject(g[C])&&_.isObject(b[C])?c(g[C],b[C],l):l&&(g[C]=b[C]):g[C]=b[C])})}e.merge=c;function d(g,b,l){const C=g.inspect(b),p=g.inspect(l);return typeof C.userValue!="undefined"||typeof C.workspaceValue!="undefined"||typeof C.workspaceFolderValue!="undefined"?C.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:C.defaultValue}e.getMigratedSettingValue=d}),define(ve[89],we([0,1,3,18,6]),function(J,e,_,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",_.isMacintosh),P.set("isLinux",_.isLinux),P.set("isWindows",_.isWindows),P.set("isWeb",_.isWeb),P.set("isMacNative",_.isMacintosh&&!_.isWeb),P.set("isEdge",_.isEdge),P.set("isFirefox",_.isFirefox),P.set("isChrome",_.isChrome),P.set("isSafari",_.isSafari);const D=Object.prototype.hasOwnProperty;var k;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(k=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return R.INSTANCE}static true(){return h.INSTANCE}static has(m){return v.create(m)}static equals(m,L){return c.create(m,L)}static notEquals(m,L){return b.create(m,L)}static regex(m,L){return i.create(m,L)}static in(m,L){return d.create(m,L)}static not(m){return l.create(m)}static and(...m){return o.create(m,null)}static or(...m){return f.create(m,null,!0)}static greater(m,L){return p.create(m,L)}static greaterEquals(m,L){return u.create(m,L)}static smaller(m,L){return s.create(m,L)}static smallerEquals(m,L){return a.create(m,L)}static deserialize(m,L=!1){if(!!m)return this._deserializeOrExpression(m,L)}static _deserializeOrExpression(m,L){let M=m.split("||");return f.create(M.map(Y=>this._deserializeAndExpression(Y,L)),null,!0)}static _deserializeAndExpression(m,L){let M=m.split("&&");return o.create(M.map(Y=>this._deserializeOne(Y,L)),null)}static _deserializeOne(m,L){if(m=m.trim(),m.indexOf("!=")>=0){let M=m.split("!=");return b.create(M[0].trim(),this._deserializeValue(M[1],L))}if(m.indexOf("==")>=0){let M=m.split("==");return c.create(M[0].trim(),this._deserializeValue(M[1],L))}if(m.indexOf("=~")>=0){let M=m.split("=~");return i.create(M[0].trim(),this._deserializeRegexValue(M[1],L))}if(m.indexOf(" in ")>=0){let M=m.split(" in ");return d.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(m)){const M=m.split(">=");return u.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(m)){const M=m.split(">");return p.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(m)){const M=m.split("<=");return a.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(m)){const M=m.split("<");return s.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(m)?l.create(m.substr(1).trim()):v.create(m)}static _deserializeValue(m,L){if(m=m.trim(),m==="true")return!0;if(m==="false")return!1;let M=/^'([^']*)'$/.exec(m);return M?M[1].trim():m}static _deserializeRegexValue(m,L){if((0,t.isFalsyOrWhitespace)(m)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=m.indexOf("/"),Y=m.lastIndexOf("/");if(M===Y||M<0){if(L)throw new Error(`bad regexp-value '${m}', missing /-enclosure`);return console.warn(`bad regexp-value '${m}', missing /-enclosure`),null}let $=m.slice(M+1,Y),G=m[Y+1]==="i"?"i":"";try{return new RegExp($,G)}catch(ie){if(L)throw new Error(`bad regexp-value '${m}', parse error: ${ie}`);return console.warn(`bad regexp-value '${m}', parse error: ${ie}`),null}}}e.ContextKeyExpr=y;function E(W,m){const L=W?W.substituteConstants():void 0,M=m?m.substituteConstants():void 0;return!L&&!M?!0:!L||!M?!1:L.equals(M)}e.expressionsAreEqualWithConstantSubstitution=E;function T(W,m){return W.cmp(m)}class R{constructor(){this.type=0}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}substituteConstants(){return this}evaluate(m){return!1}serialize(){return"false"}keys(){return[]}map(m){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=R,R.INSTANCE=new R;class h{constructor(){this.type=1}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}substituteConstants(){return this}evaluate(m){return!0}serialize(){return"true"}keys(){return[]}map(m){return this}negate(){return R.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class v{constructor(m,L){this.key=m,this.negated=L,this.type=2}static create(m,L=null){const M=P.get(m);return typeof M=="boolean"?M?h.INSTANCE:R.INSTANCE:new v(m,L)}cmp(m){return m.type!==this.type?this.type-m.type:A(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}substituteConstants(){const m=P.get(this.key);return typeof m=="boolean"?m?h.INSTANCE:R.INSTANCE:this}evaluate(m){return!!m.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(m){return m.mapDefined(this.key)}negate(){return this.negated||(this.negated=l.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=v;class c{constructor(m,L,M){this.key=m,this.value=L,this.negated=M,this.type=4}static create(m,L,M=null){if(typeof L=="boolean")return L?v.create(m,M):l.create(m,M);const Y=P.get(m);return typeof Y=="boolean"?L===(Y?"true":"false")?h.INSTANCE:R.INSTANCE:new c(m,L,M)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){const m=P.get(this.key);if(typeof m=="boolean"){const L=m?"true":"false";return this.value===L?h.INSTANCE:R.INSTANCE}return this}evaluate(m){return m.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(m){return m.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=c;class d{constructor(m,L){this.key=m,this.valueKey=L,this.type=10,this.negated=null}static create(m,L){return new d(m,L)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.valueKey,m.key,m.valueKey)}equals(m){return m.type===this.type?this.key===m.key&&this.valueKey===m.valueKey:!1}substituteConstants(){return this}evaluate(m){const L=m.getValue(this.valueKey),M=m.getValue(this.key);return Array.isArray(L)?L.indexOf(M)>=0:typeof M=="string"&&typeof L=="object"&&L!==null?D.call(L,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(m){return m.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=g.create(this)),this.negated}}e.ContextKeyInExpr=d;class g{constructor(m){this._actual=m,this.type=11}static create(m){return new g(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}substituteConstants(){return this}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new g(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotInExpr=g;class b{constructor(m,L,M){this.key=m,this.value=L,this.negated=M,this.type=5}static create(m,L,M=null){if(typeof L=="boolean")return L?l.create(m,M):v.create(m,M);const Y=P.get(m);return typeof Y=="boolean"?L===(Y?"true":"false")?R.INSTANCE:h.INSTANCE:new b(m,L,M)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){const m=P.get(this.key);if(typeof m=="boolean"){const L=m?"true":"false";return this.value===L?R.INSTANCE:h.INSTANCE}return this}evaluate(m){return m.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(m){return m.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class l{constructor(m,L){this.key=m,this.negated=L,this.type=3}static create(m,L=null){const M=P.get(m);return typeof M=="boolean"?M?R.INSTANCE:h.INSTANCE:new l(m,L)}cmp(m){return m.type!==this.type?this.type-m.type:A(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}substituteConstants(){const m=P.get(this.key);return typeof m=="boolean"?m?R.INSTANCE:h.INSTANCE:this}evaluate(m){return!m.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(m){return m.mapNot(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=l;function C(W,m){if(typeof W=="string"){const L=parseFloat(W);isNaN(L)||(W=L)}return typeof W=="string"||typeof W=="number"?m(W):R.INSTANCE}class p{constructor(m,L,M){this.key=m,this.value=L,this.negated=M,this.type=12}static create(m,L,M=null){return C(L,Y=>new p(m,Y,M))}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=p;class u{constructor(m,L,M){this.key=m,this.value=L,this.negated=M,this.type=13}static create(m,L,M=null){return C(L,Y=>new u(m,Y,M))}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class s{constructor(m,L,M){this.key=m,this.value=L,this.negated=M,this.type=14}static create(m,L,M=null){return C(L,Y=>new s(m,Y,M))}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class a{constructor(m,L,M){this.key=m,this.value=L,this.negated=M,this.type=15}static create(m,L,M=null){return C(L,Y=>new a(m,Y,M))}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=a;class i{constructor(m,L){this.key=m,this.regexp=L,this.type=7,this.negated=null}static create(m,L){return new i(m,L)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.key<m.key)return-1;if(this.key>m.key)return 1;const L=this.regexp?this.regexp.source:"",M=m.regexp?m.regexp.source:"";return L<M?-1:L>M?1:0}equals(m){if(m.type===this.type){const L=this.regexp?this.regexp.source:"",M=m.regexp?m.regexp.source:"";return this.key===m.key&&L===M}return!1}substituteConstants(){return this}evaluate(m){let L=m.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const m=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${m}`}keys(){return[this.key]}map(m){return m.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class n{constructor(m){this._actual=m,this.type=8}static create(m){return new n(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}substituteConstants(){return this}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new n(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function r(W){let m=null;for(let L=0,M=W.length;L<M;L++){const Y=W[L].substituteConstants();if(W[L]!==Y&&m===null){m=[];for(let $=0;$<L;$++)m[$]=W[$]}m!==null&&(m[L]=Y)}return m===null?W:m}class o{constructor(m,L){this.expr=m,this.negated=L,this.type=6}static create(m,L){return o._normalizeArr(m,L)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let L=0,M=this.expr.length;L<M;L++){const Y=T(this.expr[L],m.expr[L]);if(Y!==0)return Y}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let L=0,M=this.expr.length;L<M;L++)if(!this.expr[L].equals(m.expr[L]))return!1;return!0}return!1}substituteConstants(){const m=r(this.expr);return m===this.expr?this:o.create(m,this.negated)}evaluate(m){for(let L=0,M=this.expr.length;L<M;L++)if(!this.expr[L].evaluate(m))return!1;return!0}static _normalizeArr(m,L){const M=[];let Y=!1;for(const $ of m)if(!!$){if($.type===1){Y=!0;continue}if($.type===0)return R.INSTANCE;if($.type===6){M.push(...$.expr);continue}M.push($)}if(M.length===0&&Y)return h.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(T);for(let $=1;$<M.length;$++)M[$-1].equals(M[$])&&(M.splice($,1),$--);if(M.length===1)return M[0];for(;M.length>1;){const $=M[M.length-1];if($.type!==9)break;M.pop();const G=M.pop(),ie=M.length===0,B=f.create($.expr.map(q=>o.create([q,G],null)),null,ie);B&&(M.push(B),M.sort(T))}return M.length===1?M[0]:new o(M,L)}}serialize(){return this.expr.map(m=>m.serialize()).join(" && ")}keys(){const m=[];for(let L of this.expr)m.push(...L.keys());return m}map(m){return new o(this.expr.map(L=>L.map(m)),null)}negate(){if(!this.negated){const m=[];for(let L of this.expr)m.push(L.negate());this.negated=f.create(m,this,!0)}return this.negated}}class f{constructor(m,L){this.expr=m,this.negated=L,this.type=9}static create(m,L,M){return f._normalizeArr(m,L,M)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let L=0,M=this.expr.length;L<M;L++){const Y=T(this.expr[L],m.expr[L]);if(Y!==0)return Y}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let L=0,M=this.expr.length;L<M;L++)if(!this.expr[L].equals(m.expr[L]))return!1;return!0}return!1}substituteConstants(){const m=r(this.expr);return m===this.expr?this:f.create(m,this.negated,!1)}evaluate(m){for(let L=0,M=this.expr.length;L<M;L++)if(this.expr[L].evaluate(m))return!0;return!1}static _normalizeArr(m,L,M){let Y=[],$=!1;if(m){for(let G=0,ie=m.length;G<ie;G++){const B=m[G];if(!!B){if(B.type===0){$=!0;continue}if(B.type===1)return h.INSTANCE;if(B.type===9){Y=Y.concat(B.expr);continue}Y.push(B)}}if(Y.length===0&&$)return R.INSTANCE;Y.sort(T)}if(Y.length!==0){if(Y.length===1)return Y[0];for(let G=1;G<Y.length;G++)Y[G-1].equals(Y[G])&&(Y.splice(G,1),G--);if(Y.length===1)return Y[0];if(M){for(let G=0;G<Y.length;G++)for(let ie=G+1;ie<Y.length;ie++)F(Y[G],Y[ie])&&(Y.splice(ie,1),ie--);if(Y.length===1)return Y[0]}return new f(Y,L)}}serialize(){return this.expr.map(m=>m.serialize()).join(" || ")}keys(){const m=[];for(let L of this.expr)m.push(...L.keys());return m}map(m){return new f(this.expr.map(L=>L.map(m)),null)}negate(){if(!this.negated){let m=[];for(let L of this.expr)m.push(L.negate());for(;m.length>1;){const L=m.shift(),M=m.shift(),Y=[];for(const G of U(L))for(const ie of U(M))Y.push(o.create([G,ie],null));const $=m.length===0;m.unshift(f.create(Y,null,$))}this.negated=m[0]}return this.negated}}class S extends v{constructor(m,L,M){super(m,null);this._defaultValue=L,typeof M=="object"?S._info.push({...M,key:m}):M!==!0&&S._info.push({key:m,description:M,type:L!=null?typeof L:void 0})}static all(){return S._info.values()}bindTo(m){return m.createKey(this.key,this._defaultValue)}getValue(m){return m.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(m){return c.create(this.key,m)}notEqualsTo(m){return b.create(this.key,m)}}e.RawContextKey=S,S._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function A(W,m){return W<m?-1:W>m?1:0}function I(W,m,L,M){return W<L?-1:W>L?1:m<M?-1:m>M?1:0}function F(W,m){if(m.type===6&&W.type!==9&&W.type!==6){for(const Y of m.expr)if(W.equals(Y))return!0}const L=W.negate(),M=U(L).concat(U(m));M.sort(T);for(let Y=0;Y<M.length;Y++){const G=M[Y].negate();for(let ie=Y+1;ie<M.length;ie++){const B=M[ie];if(G.equals(B))return!0}}return!1}e.implies=F;function U(W){return W.type===9?W.expr:[W]}}),define(ve[90],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,_.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,_.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(P,D){return this.secretVault[P]?.[D]??null}async setPassword(P,D,k){this.secretVault[P]=this.secretVault[P]??{},this.secretVault[P][D]=k}async deletePassword(P,D){return this.secretVault[P]?.[D]?(delete this.secretVault[P][D],Object.keys(this.secretVault[P]).length===0&&delete this.secretVault[P],!0):!1}async findPassword(P){return JSON.stringify(this.secretVault[P])??null}async findCredentials(P){const D=[];for(const k of Object.keys(this.secretVault[P]||{}))D.push({account:k,password:this.secretVault[P][k]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(ve[186],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,_.createDecorator)(e.ID);function t(w){return!!w.hostName&&!!w.errorMessage}e.isRemoteDiagnosticError=t}),define(ve[66],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,_.createDecorator)("downloadService")}),define(ve[187],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,_.createDecorator)("encryptionMainService")}),define(ve[26],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[16],we([0,1,30,4,18,12,5,163,6]),function(J,e,_,t,w,P,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function E($){return $.create===!0}e.isFileOpenForWriteOptions=E;var T;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var R;(function($){$[$.Readonly=1]="Readonly"})(R=e.FilePermission||(e.FilePermission={}));var h;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead"})(h=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v($){return!!($.capabilities&2)}e.hasReadWriteCapability=v;function c($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=c;function d($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function g($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=g;function b($){return v($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var l;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(l=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class C extends Error{constructor(G,ie){super(G);this.code=ie}}e.FileSystemProviderError=C;function p($,G){const ie=new C($.toString(),G);return s(ie,G),ie}e.createFileSystemProviderError=p;function u($){return $||p((0,k.localize)(0,null),l.Unknown)}e.ensureFileSystemProviderError=u;function s($,G){return $.name=G?`${G} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=s;function a($){if(!$)return l.Unknown;if($ instanceof C)return $.code;const G=/^(.+) \(FileSystemError\)$/.exec($.name);if(!G)return l.Unknown;switch(G[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileExceedsMemoryLimit:return l.FileExceedsMemoryLimit;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.toFileSystemProviderErrorCode=a;function i($){if($ instanceof A)return $.fileOperationResult;switch(a($)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 10;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileExceedsMemoryLimit:return 9;case l.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var n;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class r{constructor(G,ie,B){this.resource=G,this.operation=ie,this.target=B}isOperation(G){return this.operation===G}}e.FileOperationEvent=r;var o;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class f{constructor(G,ie){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=G;const B=new Map;for(const q of G){const ee=B.get(q.type);switch(ee?ee.push([q.resource,q]):B.set(q.type,[[q.resource,q]]),q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}}for(const[q,ee]of B)switch(q){case 1:this.added=_.TernarySearchTree.forUris(()=>ie),this.added.fill(ee);break;case 0:this.updated=_.TernarySearchTree.forUris(()=>ie),this.updated.fill(ee);break;case 2:this.deleted=_.TernarySearchTree.forUris(()=>ie),this.deleted.fill(ee);break}}contains(G,...ie){return this.doContains(G,{includeChildren:!1},...ie)}affects(G,...ie){return this.doContains(G,{includeChildren:!0},...ie)}doContains(G,ie,...B){if(!G)return!1;const q=B.length>0;return!!((!q||B.includes(1))&&(this.added?.get(G)||ie.includeChildren&&this.added?.findSuperstr(G))||(!q||B.includes(0))&&(this.updated?.get(G)||ie.includeChildren&&this.updated?.findSuperstr(G))||(!q||B.includes(2))&&(this.deleted?.findSubstr(G)||ie.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=f;function S($,G,ie){return!$||!G||$===G||G.length>$.length?!1:(G.charAt(G.length-1)!==t.sep&&(G+=t.sep),ie?(0,w.startsWithIgnoreCase)($,G):$.indexOf(G)===0)}e.isParent=S;class A extends Error{constructor(G,ie,B){super(G);this.fileOperationResult=ie,this.options=B}}e.FileOperationError=A;class I extends A{constructor(G,ie,B){super(G,2,B);this.stat=ie}}e.NotModifiedSinceFileOperationError=I;var F;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function W($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=W;async function m($,G){if(!G.hasProvider(D.URI.from({scheme:$.scheme})))return new Promise(ie=>{const B=G.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===$.scheme&&q.added&&(B.dispose(),ie())})})}e.whenProviderRegistered=m,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(G){return(0,P.isNumber)(G)||(G=0),G<L.KB?(0,k.localize)(1,null,G.toFixed(0)):G<L.MB?(0,k.localize)(2,null,(G/L.KB).toFixed(2)):G<L.GB?(0,k.localize)(3,null,(G/L.MB).toFixed(2)):G<L.TB?(0,k.localize)(4,null,(G/L.GB).toFixed(2)):(0,k.localize)(5,null,(G/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var M;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(M=e.Arch||(e.Arch={}));function Y($){return{maxFileSize:$===0?300*L.MB:16*L.GB,maxHeapSize:$===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=Y}),define(ve[188],we([0,1,263,153,53,16]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function D(h,v){const c={onUnknownOption:g=>{console.warn((0,t.localize)(0,null,g))},onMultipleValues:(g,b)=>{console.warn((0,t.localize)(1,null,g,b))},onDeprecatedOption:(g,b)=>{console.warn((0,t.localize)(2,null,g,b))}},d=(0,w.parseArgs)(h,w.OPTIONS,v?c:void 0);return d.goto&&d._.forEach(g=>_(/^(\w:)?[^:]+(:\d*){0,2}$/.test(g),(0,t.localize)(3,null))),d["max-memory"]&&_(parseInt(d["max-memory"])>=P.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${P.MIN_MAX_MEMORY_SIZE_MB} MB.`),d}function k(h){const v=h.findIndex(c=>!/^-/.test(c));if(v>-1)return[...h.slice(0,v),...h.slice(v+1)]}function y(h){let[,...v]=h;process.env.VSCODE_DEV&&(v=k(v)||[]);const c=!R(process.env);return D(v,c)}e.parseMainProcessArgv=y;function E(h){const[,,...v]=h;return D(v,!0)}e.parseCLIProcessArgv=E;function T(h,...v){const c=h.indexOf("--");return c===-1?h.push(...v):h.splice(c,0,...v),h}e.addArg=T;function R(h){return h.VSCODE_CLI==="1"}e.isLaunchedFromCli=R}),define(ve[67],we([0,1,39,4,154,21,36,11,3,23,149,188,13]),function(J,e,_,t,w,P,D,k,y,E,T,R,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const v=1e4;let c;async function d(b,l,C){return l["force-disable-user-env"]?(b.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):y.isWindows?(b.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,R.isLaunchedFromCli)(C)&&!l["force-user-env"]?(b.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,R.isLaunchedFromCli)(C)?b.trace("resolveShellEnv(): running (--force-user-env)"):b.trace("resolveShellEnv(): running (macOS/Linux)"),c||(c=h.Promises.withAsyncBody(async(p,u)=>{const s=new P.CancellationTokenSource,a=setTimeout(()=>{s.dispose(!0),u(new Error((0,w.localize)(0,null)))},v);try{p(await g(b,s.token))}catch(i){!(0,k.isCancellationError)(i)&&!s.token.isCancellationRequested?u(new Error((0,w.localize)(1,null,(0,D.toErrorMessage)(i)))):p({})}finally{clearTimeout(a),s.dispose()}})),c)}e.getResolvedShellEnv=d;async function g(b,l){const C=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",C);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",p);const u=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(u+"(.*)"+u),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};b.trace("getUnixShellEnvironment#env",a);const i=await(0,T.getSystemShell)(y.OS,a);return b.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(l.isCancellationRequested)return r((0,k.canceled)());const o=(0,t.basename)(i);let f,S;const A=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(f=`& '${process.execPath}' ${A} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,S=["-Login","-Command"]):(f=`'${process.execPath}' ${A} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,o==="tcsh"?S=["-ic"]:S=["-ilc"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),f);const I=(0,_.spawn)(i,[...S,f],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});l.onCancellationRequested(()=>(I.kill(),r((0,k.canceled)()))),I.on("error",W=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(W)),r(W)});const F=[];I.stdout.on("data",W=>F.push(W));const U=[];I.stderr.on("data",W=>U.push(W)),I.on("close",(W,m)=>{const L=Buffer.concat(F).toString("utf8");b.trace("getUnixShellEnvironment#raw",L);const M=Buffer.concat(U).toString("utf8");if(M.trim()&&b.trace("getUnixShellEnvironment#stderr",M),W||m)return r(new Error((0,w.localize)(2,null,W,m)));const Y=s.exec(L),$=Y?Y[1]:"{}";try{const G=JSON.parse($);C?G.ELECTRON_RUN_AS_NODE=C:delete G.ELECTRON_RUN_AS_NODE,p?G.ELECTRON_NO_ATTACH_CONSOLE=p:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",G),n(G)}catch(G){b.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(G)),r(G)}})})}}),define(ve[189],we([0,1,15,36,11,7,2,43,5,23,16]),function(J,e,_,t,w,P,D,k,y,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class R extends D.Disposable{constructor(v,c){super();this.channel=v,this.extraCapabilities=c,this.onDidChangeCapabilities=P.Event.None,this._onDidChange=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new P.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(v){return this.channel.call("stat",[v])}readdir(v){return this.channel.call("readdir",[v])}async readFile(v,c){const{buffer:d}=await this.channel.call("readFile",[v,c]);return d}readFileStream(v,c,d){const g=(0,k.newWriteableStream)(l=>_.VSBuffer.concat(l.map(C=>_.VSBuffer.wrap(C))).buffer),b=this.channel.listen("readFileStream",[v,c])(l=>{if(l instanceof _.VSBuffer)g.write(l.buffer);else{if(l==="end")g.end();else{let C=l;C instanceof Error||(C=(0,T.createFileSystemProviderError)((0,t.toErrorMessage)(C),T.FileSystemProviderErrorCode.Unknown)),g.error(C),g.end()}b.dispose()}});return d.onCancellationRequested(()=>{g.error((0,w.canceled)()),g.end(),b.dispose()}),g}writeFile(v,c,d){return this.channel.call("writeFile",[v,_.VSBuffer.wrap(c),d])}open(v,c){return this.channel.call("open",[v,c])}close(v){return this.channel.call("close",[v])}async read(v,c,d,g,b){const[l,C]=await this.channel.call("read",[v,c,b]);return d.set(l.buffer.slice(0,C),g),C}write(v,c,d,g,b){return this.channel.call("write",[v,c,_.VSBuffer.wrap(d),g,b])}mkdir(v){return this.channel.call("mkdir",[v])}delete(v,c){return this.channel.call("delete",[v,c])}rename(v,c,d){return this.channel.call("rename",[v,c,d])}copy(v,c,d){return this.channel.call("copy",[v,c,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(v=>{if(Array.isArray(v)){const c=v;this._onDidChange.fire(c.map(d=>({resource:y.URI.revive(d.resource),type:d.type})))}else{const c=v;this._onDidWatchError.fire(c)}}))}watch(v,c){const d=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,d,v,c]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,d]))}}e.DiskFileSystemProviderClient=R}),define(ve[91],we([0,1,15,11,164,16]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(T,R,h,v,c,d){let g;try{await k(T,R,h,v,c,d)}catch(b){g=b}finally{g&&c.errorTransformer&&(g=c.errorTransformer(g)),typeof g!="undefined"&&h.error(g),h.end()}}e.readFileIntoStream=D;async function k(T,R,h,v,c,d){y(d);const g=await T.open(R,{create:!1});try{y(d);let b=0,l=0,C=c&&typeof c.length=="number"?c.length:void 0,p=_.VSBuffer.alloc(Math.min(c.bufferSize,typeof C=="number"?C:c.bufferSize)),u=c&&typeof c.position=="number"?c.position:0,s=0;do l=await T.read(g,u,p.buffer,s,p.byteLength-s),u+=l,s+=l,b+=l,typeof C=="number"&&(C-=l),s===p.byteLength&&(await h.write(v(p)),p=_.VSBuffer.alloc(Math.min(c.bufferSize,typeof C=="number"?C:c.bufferSize)),s=0);while(l>0&&(typeof C!="number"||C>0)&&y(d)&&E(b,c));if(s>0){let a=s;typeof C=="number"&&(a=Math.min(s,C)),h.write(v(p.slice(0,a)))}}catch(b){throw(0,P.ensureFileSystemProviderError)(b)}finally{await T.close(g)}}function y(T){if(T.isCancellationRequested)throw(0,t.canceled)();return!0}function E(T,R){if(R?.limits){if(typeof R.limits.memory=="number"&&T>R.limits.memory)throw(0,P.createFileSystemProviderError)((0,w.localize)(0,null),P.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof R.limits.size=="number"&&T>R.limits.size)throw(0,P.createFileSystemProviderError)((0,w.localize)(1,null),P.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ve[55],we([0,1,2,3,5,16]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function D(v){return v.recursive===!0}e.isRecursiveWatchRequest=D;class k extends _.Disposable{constructor(c,d,g,b){super();this.onFileChanges=c,this.onLogMessage=d,this.verboseLogging=g,this.options=b,this.watcherDisposables=this._register(new _.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const c=new _.DisposableStore;this.watcherDisposables.value=c,this.watcher=this.createWatcher(c),this.watcher.setVerboseLogging(this.verboseLogging),c.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),c.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),c.add(this.watcher.onDidError(d=>this.onError(d)))}onError(c){this.options.restartOnError?this.restartCounter<k.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${c}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${c}`):this.error(c)}restart(c){this.restartCounter++,this.init(),this.watch(c)}async watch(c){this.requests=c,await this.watcher?.watch(c)}async setVerboseLogging(c){this.verboseLogging=c,await this.watcher?.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${c}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=k,k.MAX_RESTARTS=5;class y extends k{constructor(c,d,g){super(c,d,g,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=y;class E extends k{constructor(c,d,g){super(c,d,g,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function T(v){return v.map(c=>({type:c.type,resource:w.URI.file(c.path)}))}e.toFileChanges=T;function R(v){const c=new h;for(const d of v)c.processEvent(d);return c.coalesce()}e.coalesceEvents=R;class h{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(c){return t.isLinux?c.path:c.path.toLowerCase()}processEvent(c){const d=this.mapPathToChange.get(this.toKey(c));let g=!1;if(d){const b=d.type,l=c.type;d.path!==c.path&&(c.type===2||c.type===1)?g=!0:b===1&&l===2?(this.mapPathToChange.delete(this.toKey(c)),this.coalesced.delete(d)):b===2&&l===1?d.type=0:b===1&&l===0||(d.type=l)}else g=!0;g&&(this.coalesced.add(c),this.mapPathToChange.set(this.toKey(c),c))}coalesce(){const c=[],d=[];return Array.from(this.coalesced).filter(g=>g.type!==2?(c.push(g),!1):!0).sort((g,b)=>g.path.length-b.path.length).filter(g=>d.some(b=>(0,P.isParent)(g.path,b,!t.isLinux))?!1:(d.push(g.path),!0)).concat(c)}}}),define(ve[190],we([0,1,27,13,21,31,60,2,78,4,3,135,19,55]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class c extends k.Disposable{constructor(b,l,C,p){super();this.request=b,this.onDidFilesChange=l,this.onLogMessage=C,this.verboseLogging=p,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.onDidFilesChange(u)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(c.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(u=>(0,D.parse)(u)),this.cts=new w.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const b=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const l=await h.Promises.stat(b);this._register(await this.doWatch(b,l.isDirectory()))}catch(b){b.code!=="ENOENT"?this.error(b):this.trace(b)}}async normalizePath(b){let l=b.path;try{l=await h.Promises.realpath(b.path),b.path===l&&(l=await(0,R.realcase)(b.path)??b.path),b.path!==l&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${b.path}, real: ${l})`)}catch{}return l}async doWatch(b,l){if(T.isMacintosh&&(0,P.isEqualOrParent)(b,"/Volumes/",!0))return this.error(`Refusing to watch ${b} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const C=new w.CancellationTokenSource(this.cts.token);let p=new k.DisposableStore;try{const u=(0,E.basename)(b),s=(0,_.watch)(b);p.add((0,k.toDisposable)(()=>{s.removeAllListeners(),s.close()})),this.trace(`Started watching: '${b}'`);const a=new Set;if(l)try{for(const n of await h.Promises.readdir(b))a.add(n)}catch(n){this.error(n)}const i=new Map;p.add((0,k.toDisposable)(()=>{for(const[,n]of i)n.dispose();i.clear()})),s.on("error",(n,r)=>{this.error(`Failed to watch ${b} for changes using fs.watch() (${n}, ${r})`),this.dispose()}),s.on("change",(n,r)=>{if(C.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${r}`);let o="";if(r&&(o=r.toString(),T.isMacintosh&&(o=(0,y.normalizeNFC)(o))),!(!o||n!=="change"&&n!=="rename"))if(l)if(n==="rename"){i.get(o)?.dispose();const f=setTimeout(async()=>{if(i.delete(o),o===u&&!await h.Promises.exists(b)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const S=await this.existsChildStrictCase((0,E.join)(b,o));if(C.token.isCancellationRequested)return;let A;S?a.has(o)?A=0:(A=1,a.add(o)):(a.delete(o),A=2),this.onFileChange({path:(0,E.join)(this.request.path,o),type:A})},c.FILE_DELETE_HANDLER_DELAY);i.set(o,(0,k.toDisposable)(()=>clearTimeout(f)))}else{let f;a.has(o)?f=0:(f=1,a.add(o)),this.onFileChange({path:(0,E.join)(this.request.path,o),type:f})}else if(n==="rename"||o!==u){const f=setTimeout(async()=>{const S=await h.Promises.exists(b);C.token.isCancellationRequested||(S?(this.onFileChange({path:this.request.path,type:0},!0),p.add(await this.doWatch(b,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},c.FILE_DELETE_HANDLER_DELAY);p.clear(),p.add((0,k.toDisposable)(()=>clearTimeout(f)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(u){await h.Promises.exists(b)&&!C.token.isCancellationRequested&&this.error(`Failed to watch ${b} for changes using fs.watch() (${u.toString()})`)}return(0,k.toDisposable)(()=>{C.dispose(!0),p.dispose()})}async onFileChange(b,l=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),!l&&this.excludes.some(C=>C(b.path))?this.verboseLogging&&this.trace(` >> ignored ${b.path}`):this.fileChangesBuffer.push(b);try{await this.fileChangesDelayer.trigger(async()=>{const C=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,v.coalesceEvents)(C);if(p.length>0){if(this.verboseLogging)for(const s of p)this.trace(`>> normalized ${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.path}`);this.throttledFileChangesWorker.work(p)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${p[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${p.length}, most recent change: ${p[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(b){if(T.isLinux)return h.Promises.exists(b);try{const l=(0,E.basename)(b);return(await h.Promises.readdir((0,E.dirname)(b))).some(p=>p===l)}catch(l){return this.trace(l),!1}}setVerboseLogging(b){this.verboseLogging=b}error(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${b}`})}warn(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${b}`})}trace(b){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=c,c.FILE_DELETE_HANDLER_DELAY=100,c.FILE_CHANGES_HANDLER_DELAY=50;async function d(g,b,l,C,p=512){const u=await h.Promises.open(g,"r"),s=Buffer.allocUnsafe(p),a=new w.CancellationTokenSource(C);let i,n=!1;const r={path:g,excludes:[],recursive:!1},o=new c(r,f=>{(async()=>{for(const{type:S}of f)if(S===0){if(n)return;n=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:A}=await h.Promises.read(u,s,0,p,null);if(!A||a.token.isCancellationRequested)break;b(s.slice(0,A))}}catch(A){i=new Error(A),a.dispose(!0)}finally{n=!1}}})()});return await o.ready,l(),new Promise((f,S)=>{a.token.onCancellationRequested(async()=>{o.dispose();try{await h.Promises.close(u)}catch(A){i=new Error(A)}i?S(i):f()})})}e.watchFileContents=d}),define(ve[191],we([0,1,17,7,2,3,190]),function(J,e,_,t,w,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class k extends w.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new t.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new t.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=t.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(E){const T=this.normalizeRequests(E),R=T.filter(v=>{const c=this.watchers.get(v.path);return c?!(0,_.equals)(c.request.excludes,v.excludes):!0}),h=Array.from(this.watchers.values()).filter(({request:v})=>!T.find(c=>c.path===v.path&&(0,_.equals)(c.excludes,v.excludes))).map(({request:v})=>v.path);R.length&&this.trace(`Request to start watching: ${R.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"})`).join(",")}`),h.length&&this.trace(`Request to stop watching: ${h.join(",")}`);for(const v of h)this.stopWatching(v);for(const v of R)this.startWatching(v)}startWatching(E){const T=new D.NodeJSFileWatcherLibrary(E,h=>this._onDidChangeFile.fire(h),h=>this._onDidLogMessage.fire(h),this.verboseLogging),R={request:E,instance:T};this.watchers.set(E.path,R)}async stop(){for(const[E]of this.watchers)this.stopWatching(E);this.watchers.clear()}stopWatching(E){const T=this.watchers.get(E);T&&(this.watchers.delete(E),T.instance.dispose())}normalizeRequests(E){const T=new Map;for(const R of E){const h=P.isLinux?R.path:R.path.toLowerCase();T.set(h,R)}return Array.from(T.values())}async setVerboseLogging(E){this.verboseLogging=E;for(const[,T]of this.watchers)T.instance.setVerboseLogging(E)}trace(E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(E)})}toMessage(E,T){return T?`[File Watcher (node.js)] ${E} (path: ${T.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=k}),define(ve[192],we([0,1,55,191]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class w extends _.AbstractNonRecursiveWatcherClient{constructor(D,k,y){super(D,k,y);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=w}),define(ve[193],we([0,1,8,40,87,55]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends P.AbstractUniversalWatcherClient{constructor(y,E,T){super(y,E,T);this.init()}createWatcher(y){const E=y.add(new w.Client(_.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(E.onDidProcessExit(({code:T,signal:R})=>this.onError(`terminated by itself with code ${T}, signal: ${R}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(ve[68],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...w){this._entries=new Map;for(let[P,D]of w)this.set(P,D)}set(w,P){const D=this._entries.get(w);return this._entries.set(w,P),D}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=_}),define(ve[92],we([0,1,13,11,54,185,6,68]),function(J,e,_,t,w,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class E extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class T{constructor(c=new k.ServiceCollection,d=!1,g){this._activeInstantiations=new Set,this._services=c,this._strict=d,this._parent=g,this._services.set(D.IInstantiationService,this)}createChild(c){return new T(c,this._strict,this)}invokeFunction(c,...d){let g=h.traceInvocation(c),b=!1;try{return c({get:C=>{if(b)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(C,g);if(!p)throw new Error(`[invokeFunction] unknown service '${C}'`);return p}},...d)}finally{b=!0,g.stop()}}createInstance(c,...d){let g,b;return c instanceof w.SyncDescriptor?(g=h.traceCreation(c.ctor),b=this._createInstance(c.ctor,c.staticArguments.concat(d),g)):(g=h.traceCreation(c),b=this._createInstance(c,d,g)),g.stop(),b}_createInstance(c,d=[],g){let b=D._util.getServiceDependencies(c).sort((p,u)=>p.index-u.index),l=[];for(const p of b){let u=this._getOrCreateServiceInstance(p.id,g);if(!u&&this._strict&&!p.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${p.id}.`);l.push(u)}let C=b.length>0?b[0].index:d.length;if(d.length!==C){console.warn(`[createInstance] First service dependency of ${c.name} at position ${C+1} conflicts with ${d.length} static arguments`);let p=C-d.length;p>0?d=d.concat(new Array(p)):d=d.slice(0,C)}return new c(...[...d,...l])}_setServiceInstance(c,d){if(this._services.get(c)instanceof w.SyncDescriptor)this._services.set(c,d);else if(this._parent)this._parent._setServiceInstance(c,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let d=this._services.get(c);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):d}_getOrCreateServiceInstance(c,d){let g=this._getServiceInstanceOrDescriptor(c);return g instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,g,d.branch(c,!0)):(d.branch(c,!1),g)}_safeCreateAndCacheServiceInstance(c,d,g){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,d,g)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,d,g){const b=new P.Graph(p=>p.id.toString());let l=0;const C=[{id:c,desc:d,_trace:g}];for(;C.length;){const p=C.pop();if(b.lookupOrInsertNode(p),l++>1e3)throw new E(b);for(let u of D._util.getServiceDependencies(p.desc.ctor)){let s=this._getServiceInstanceOrDescriptor(u.id);if(!s&&!u.optional&&console.warn(`[createInstance] ${c} depends on ${u.id} which is NOT registered.`),s instanceof w.SyncDescriptor){const a={id:u.id,desc:s,_trace:p._trace.branch(u.id,!0)};b.insertEdge(p,a),C.push(a)}}}for(;;){const p=b.roots();if(p.length===0){if(!b.isEmpty())throw new E(b);break}for(const{data:u}of p){if(this._getServiceInstanceOrDescriptor(u.id)instanceof w.SyncDescriptor){const a=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,a)}b.removeNode(u)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,d,g=[],b,l){if(this._services.get(c)instanceof w.SyncDescriptor)return this._createServiceInstance(d,g,b,l);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,d,g,b,l);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(c,d=[],g,b){if(g){const l=new _.IdleValue(()=>this._createInstance(c,d,b));return new Proxy(Object.create(null),{get(C,p){if(p in C)return C[p];let u=l.value,s=u[p];return typeof s!="function"||(s=s.bind(u),C[p]=s),s},set(C,p,u){return l.value[p]=u,!0}})}else return this._createInstance(c,d,b)}}e.InstantiationService=T;var R;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(R||(R={}));class h{constructor(c,d){this.type=c,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return y?new h(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(c){return y?new h(0,c.name):h._None}branch(c,d){let g=new h(2,c.toString());return this._dep.push([c,d,g]),g}stop(){let c=Date.now()-this._start;h._totals+=c;let d=!1;function g(l,C){let p=[],u=new Array(l+1).join("	");for(const[s,a,i]of C._dep)if(a&&i){d=!0,p.push(`${u}CREATES -> ${s}`);let n=g(l+1,i);n&&p.push(n)}else p.push(`${u}uses -> ${s}`);return p.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(c>2||d)&&console.log(b.join(`
`))}}e.Trace=h,h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(ve[194],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,_.createDecorator)("labelService")}),define(ve[69],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,_.createDecorator)("localizationsService");function t(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const P of w.translations)if(typeof P.id!="string"||typeof P.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}e.isValidLocalization=t}),define(ve[14],we([0,1,36,7,2,3,6]),function(J,e,_,t,w,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function k(){return new Date().toISOString()}var y;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function E(a,i,n){switch(i){case y.Trace:a.trace(n);break;case y.Debug:a.debug(n);break;case y.Info:a.info(n);break;case y.Warning:a.warn(n);break;case y.Error:a.error(n);break;case y.Critical:a.critical(n);break;default:throw new Error("Invalid log level")}}e.log=E;function T(a){let i="";for(let n=0;n<a.length;n++){let r=a[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}i+=(n>0?" ":"")+r}return i}e.format=T;class R extends w.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=R;class h extends R{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(y.Trace)&&this.log(y.Trace,T([i,...n]))}debug(i,...n){this.checkLogLevel(y.Debug)&&this.log(y.Debug,T([i,...n]))}info(i,...n){this.checkLogLevel(y.Info)&&this.log(y.Info,T([i,...n]))}warn(i,...n){this.checkLogLevel(y.Warning)&&this.log(y.Warning,T([i,...n]))}error(i,...n){if(this.checkLogLevel(y.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(y.Error,T(r))}else this.log(y.Error,T([i,...n]))}critical(i,...n){this.checkLogLevel(y.Critical)&&this.log(y.Critical,T([i,...n]))}flush(){}}e.AbstractMessageLogger=h;class v extends R{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!P.isWindows}trace(i,...n){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...n):console.log(`[main ${k()}]`,i,...n))}debug(i,...n){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...n):console.log(`[main ${k()}]`,i,...n))}info(i,...n){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...n):console.log(`[main ${k()}]`,i,...n))}warn(i,...n){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,i,...n):console.warn(`[main ${k()}]`,i,...n))}error(i,...n){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,i,...n):console.error(`[main ${k()}]`,i,...n))}critical(i,...n){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,i,...n):console.error(`[main ${k()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class c extends R{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...n){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=c;class d extends R{constructor(i,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,_.toErrorMessage)(i,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class g extends R{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const r of this.logServices)r.trace(i,...n)}debug(i,...n){for(const r of this.logServices)r.debug(i,...n)}info(i,...n){for(const r of this.logServices)r.info(i,...n)}warn(i,...n){for(const r of this.logServices)r.warn(i,...n)}error(i,...n){for(const r of this.logServices)r.error(i,...n)}critical(i,...n){for(const r of this.logServices)r.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=g;class b extends w.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=b;class l extends w.Disposable{constructor(i,n){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,n?.always?y.Trace:this.logLevel,n),this.loggers.set(i.toString(),r),n?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=l;class C{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return y.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=C;function p(a){if(a.verbose)return y.Trace;if(typeof a.logLevel=="string"){const i=u(a.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function u(a){switch(a){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=u;function s(a){switch(a){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=s});var Ne=this&&this.__param||function(J,e){return function(_,t){e(_,t,J)}};define(ve[195],we([0,1,39,13,36,7,2,8,4,19,26,14]),function(J,e,_,t,w,P,D,k,y,E,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let h=class extends D.Disposable{constructor(c,d){super();this.environmentService=c,this.logService=d,this.processesLimiter=new t.Limiter(5)}async postUninstall(c){const d=this.parseScript(c,"uninstall");return d&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(d.script,"uninstall",d.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),g=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${g}`)))),E.Promises.rm(this.getExtensionStoragePath(c)).then(void 0,g=>this.logService.error("Error while removing extension storage path",g))}parseScript(c,d){const g=`vscode:${d}`;if(c.location.scheme===k.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[g]=="string"){const b=c.manifest.scripts[g].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${g} should be a node script`),null):{script:(0,y.join)(c.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}runLifecycleHook(c,d,g,b,l){return new Promise((C,p)=>{const u=this.start(c,d,g,l);let s;const a=i=>{s&&(clearTimeout(s),s=null),i?p(i):C(void 0)};u.on("error",i=>{a((0,w.toErrorMessage)(i)||"Unknown")}),u.on("exit",(i,n)=>{a(i?`post-${d} process exited with code ${i}`:void 0)}),b&&(s=setTimeout(()=>{s=null,u.kill(),p("timed out")},5e3))})}start(c,d,g,b){const l={silent:!0,execArgv:void 0},C=(0,_.fork)(c,[`--type=extension-post-${d}`,...g],l);C.stdout.setEncoding("utf8"),C.stderr.setEncoding("utf8");const p=P.Event.fromNodeEventEmitter(C.stdout,"data"),u=P.Event.fromNodeEventEmitter(C.stderr,"data");p(i=>this.logService.info(b.identifier.id,b.manifest.version,`post-${d}`,i)),u(i=>this.logService.error(b.identifier.id,b.manifest.version,`post-${d}`,i));const s=P.Event.any(P.Event.map(p,i=>({data:`%c${i}`,format:[""]})),P.Event.map(u,i=>({data:`%c${i}`,format:["color: red"]})));return P.Event.debounce(s,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(b.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),C}getExtensionStoragePath(c){return(0,y.join)(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};h=Te([Ne(0,T.IEnvironmentService),Ne(1,R.ILogService)],h),e.ExtensionsLifecycle=h}),define(ve[196],we([0,1,17,13,11,7,2,4,55,14]),function(J,e,_,t,w,P,D,k,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends D.Disposable{constructor(h,v){super();this.logService=h,this.options=v,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new P.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(h,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(h,v):this.watchNonRecursive(h,v)}watchUniversal(h,v){const c={path:this.toFilePath(h),excludes:v.excludes,recursive:v.recursive},d=(0,_.insert)(this.universalPathsToWatch,c);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{d(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(h=>(0,w.onUnexpectedError)(h))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,y.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})));const h=this.options?.watcher?.recursive?.usePolling;if(h===!0)for(const v of this.universalPathsToWatch)(0,y.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const v of this.universalPathsToWatch)(0,y.isRecursiveWatchRequest)(v)&&h.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(h,v){const c={path:this.toFilePath(h),excludes:v.excludes,recursive:!1},d=(0,_.insert)(this.nonRecursivePathsToWatch,c);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{d(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(h=>(0,w.onUnexpectedError)(h))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(h=>this._onDidChangeFile.fire((0,y.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(h){h.type==="error"&&this._onDidWatchError.fire(h.message),this.logService[h.type](h.message)}toFilePath(h){return(0,k.normalize)(h.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(ve[93],we([0,1,17,13,15,21,7,127,51,2,30,8,44,22,43,162,16,91,14]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c,d,g,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let C=class extends E.Disposable{constructor(u){super();this.logService=u,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(u,s){if(this.provider.has(u))throw new Error(`A filesystem provider for the scheme '${u}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${u}`);const a=new E.DisposableStore;return this.provider.set(u,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:u,provider:s}),a.add(s.onDidChangeFile(i=>this._onDidFilesChange.fire(new g.FileChangesEvent(i,!this.isPathCaseSensitive(s))))),typeof s.onDidWatchError=="function"&&a.add(s.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),a.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:u}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:u,provider:s}),this.provider.delete(u),(0,E.dispose)(a)})}getProvider(u){return this.provider.get(u)}async activateProvider(u){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:u,join(a){s.push(a)}}),!this.provider.has(u)&&await t.Promises.settled(s)}async canHandleResource(u){return await this.activateProvider(u.scheme),this.hasProvider(u)}hasProvider(u){return this.provider.has(u.scheme)}hasCapability(u,s){const a=this.provider.get(u.scheme);return!!(a&&a.capabilities&s)}listCapabilities(){return y.Iterable.map(this.provider,([u,s])=>({scheme:u,capabilities:s.capabilities}))}async withProvider(u){if(!(0,v.isAbsolutePath)(u))throw new g.FileOperationError((0,d.localize)(0,null,this.resourceForError(u)),8);await this.activateProvider(u.scheme);const s=this.provider.get(u.scheme);if(!s){const a=new Error;throw a.name="ENOPRO",a.message=(0,d.localize)(1,null,u.toString()),a}return s}async withReadProvider(u){const s=await this.withProvider(u);if((0,g.hasOpenReadWriteCloseCapability)(s)||(0,g.hasReadWriteCapability)(s)||(0,g.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(u){const s=await this.withProvider(u);if((0,g.hasOpenReadWriteCloseCapability)(s)||(0,g.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(u,s){try{return await this.doResolveFile(u,s)}catch(a){throw(0,g.toFileSystemProviderErrorCode)(a)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,d.localize)(2,null,this.resourceForError(u)),1):(0,g.ensureFileSystemProviderError)(a)}}async doResolveFile(u,s){const a=await this.withProvider(u),i=this.isPathCaseSensitive(a),n=s?.resolveTo,r=s?.resolveSingleChildDescendants,o=s?.resolveMetadata,f=await a.stat(u);let S;return this.toFileStat(a,u,f,void 0,!!o,(A,I)=>(S||(S=T.TernarySearchTree.forUris(()=>!i),S.set(u,!0),n&&S.fill(!0,n)),S.get(A.resource)||S.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&r?I===1:!1))}async toFileStat(u,s,a,i,n,r){const{providerExtUri:o}=this.getExtUri(u),f={resource:s,name:o.basename(s),isFile:(a.type&g.FileType.File)!=0,isDirectory:(a.type&g.FileType.Directory)!=0,isSymbolicLink:(a.type&g.FileType.SymbolicLink)!=0,mtime:a.mtime,ctime:a.ctime,size:a.size,readonly:Boolean((a.permissions??0)&g.FilePermission.Readonly)||Boolean(u.capabilities&2048),etag:(0,g.etag)({mtime:a.mtime,size:a.size})};if(f.isDirectory&&r(f,i)){try{const S=await u.readdir(s),A=await t.Promises.settled(S.map(async([I,F])=>{try{const U=o.joinPath(s,I),W=n?await u.stat(U):{type:F};return await this.toFileStat(u,U,W,S.length,n,r)}catch(U){return this.logService.trace(U),null}}));f.children=(0,_.coalesce)(A)}catch(S){this.logService.trace(S),f.children=[]}return f}return f}async resolveAll(u){return t.Promises.settled(u.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(a){return this.logService.trace(a),{stat:void 0,success:!1}}}))}async exists(u){const s=await this.withProvider(u);try{return!!await s.stat(u)}catch{return!1}}async canCreateFile(u,s){try{await this.doValidateCreateFile(u,s)}catch(a){return a}return!0}async doValidateCreateFile(u,s){if(!s?.overwrite&&await this.exists(u))throw new g.FileOperationError((0,d.localize)(3,null,this.resourceForError(u)),3,s)}async createFile(u,s=w.VSBuffer.fromString(""),a){await this.doValidateCreateFile(u,a);const i=await this.writeFile(u,s);return this._onDidRunOperation.fire(new g.FileOperationEvent(u,0,i)),i}async writeFile(u,s,a){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,u,a)||await this.mkdirp(i,n.dirname(u));let o;if((0,g.hasReadWriteCapability)(i)&&!(s instanceof w.VSBuffer))if((0,c.isReadableStream)(s)){const f=await(0,c.peekStream)(s,3);f.ended?o=w.VSBuffer.concat(f.buffer):o=f}else o=(0,c.peekReadable)(s,f=>w.VSBuffer.concat(f),3);else o=s;!(0,g.hasOpenReadWriteCloseCapability)(i)||(0,g.hasReadWriteCapability)(i)&&o instanceof w.VSBuffer?await this.doWriteUnbuffered(i,u,a,o):await this.doWriteBuffered(i,u,a,o instanceof w.VSBuffer?(0,w.bufferToReadable)(o):o)}catch(r){throw new g.FileOperationError((0,d.localize)(4,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),a)}return this.resolve(u,{resolveMetadata:!0})}async validateWriteFile(u,s,a){if(!!a?.unlock&&!(u.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(s)));let n;try{n=await u.stat(s)}catch{return}if((n.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,d.localize)(6,null,this.resourceForError(s)),0,a);if(this.throwIfFileIsReadonly(s,n),typeof a?.mtime=="number"&&typeof a.etag=="string"&&a.etag!==g.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&a.mtime<n.mtime&&a.etag!==(0,g.etag)({mtime:a.mtime,size:n.size}))throw new g.FileOperationError((0,d.localize)(7,null),3,a);return n}async readFile(u,s,a){const i=await this.withReadProvider(u);return s?.atomic?this.doReadFileAtomic(i,u,s,a):this.doReadFile(i,u,s,a)}async doReadFileAtomic(u,s,a,i){return new Promise((n,r)=>{this.writeQueue.queueFor(s,this.getExtUri(u).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(u,s,a,i);n(o)}catch(o){r(o)}})})}async doReadFile(u,s,a,i){const n=await this.doReadFileStream(u,s,{...a,preferUnbuffered:!0},i);return{...n,value:await(0,w.streamToBuffer)(n.value)}}async readFileStream(u,s,a){const i=await this.withReadProvider(u);return this.doReadFileStream(i,u,s,a)}async doReadFileStream(u,s,a,i){const n=new P.CancellationTokenSource(i),r=this.validateReadFile(s,a).then(f=>f,f=>{throw n.cancel(),f});let o;try{return typeof a?.etag=="string"&&a.etag!==g.ETAG_DISABLED&&await r,a?.atomic&&(0,g.hasFileAtomicReadCapability)(u)||!((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasFileReadStreamCapability)(u))||(0,g.hasReadWriteCapability)(u)&&a?.preferUnbuffered?o=this.readFileUnbuffered(u,s,a):(0,g.hasFileReadStreamCapability)(u)?o=this.readFileStreamed(u,s,n.token,a):o=this.readFileBuffered(u,s,n.token,a),{...await r,value:o}}catch(f){o&&await(0,c.consumeStream)(o);const S=(0,d.localize)(8,null,this.resourceForError(s),(0,g.ensureFileSystemProviderError)(f).toString());throw f instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(S,f.stat,a):new g.FileOperationError(S,(0,g.toFileOperationResult)(f),a)}}readFileStreamed(u,s,a,i=Object.create(null)){const n=u.readFileStream(s,i,a);return(0,c.transform)(n,{data:r=>r instanceof w.VSBuffer?r:w.VSBuffer.wrap(r),error:r=>new g.FileOperationError((0,d.localize)(9,null,this.resourceForError(s),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),i)},r=>w.VSBuffer.concat(r))}readFileBuffered(u,s,a,i=Object.create(null)){const n=(0,w.newWriteableBufferStream)();return(0,b.readFileIntoStream)(u,s,n,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new g.FileOperationError((0,d.localize)(10,null,this.resourceForError(s),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),i)},a),n}readFileUnbuffered(u,s,a){const i=(0,c.newWriteableStream)(n=>w.VSBuffer.concat(n));return(async()=>{try{let n;a?.atomic&&(0,g.hasFileAtomicReadCapability)(u)?n=await u.readFile(s,{atomic:!0}):n=await u.readFile(s),typeof a?.position=="number"&&(n=n.slice(a.position)),typeof a?.length=="number"&&(n=n.slice(0,a.length)),this.validateReadFileLimits(s,n.byteLength,a),i.end(w.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(u,s){const a=await this.resolve(u,{resolveMetadata:!0});if(a.isDirectory)throw new g.FileOperationError((0,d.localize)(11,null,this.resourceForError(u)),0,s);if(typeof s?.etag=="string"&&s.etag!==g.ETAG_DISABLED&&s.etag===a.etag)throw new g.NotModifiedSinceFileOperationError((0,d.localize)(12,null),a,s);return this.validateReadFileLimits(u,a.size,s),a}validateReadFileLimits(u,s,a){if(a?.limits){let i;if(typeof a.limits.memory=="number"&&s>a.limits.memory&&(i=9),typeof a.limits.size=="number"&&s>a.limits.size&&(i=7),typeof i=="number")throw new g.FileOperationError((0,d.localize)(13,null,this.resourceForError(u)),i)}}async canMove(u,s,a){return this.doCanMoveCopy(u,s,"move",a)}async canCopy(u,s,a){return this.doCanMoveCopy(u,s,"copy",a)}async doCanMoveCopy(u,s,a,i){if(u.toString()!==s.toString())try{const n=a==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u):await this.withReadProvider(u),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,u,r,s,a,i)}catch(n){return n}return!0}async move(u,s,a){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,u,n,s,"move",!!a),o=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(u,r==="move"?2:3,o)),o}async copy(u,s,a){const i=await this.withReadProvider(u),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,u,n,s,"copy",!!a),o=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(u,r==="copy"?3:2,o)),o}async doMoveCopy(u,s,a,i,n,r){if(s.toString()===i.toString())return n;const{exists:o,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(u,s,a,i,n,r);if(o&&!f&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(a,this.getExtUri(a).providerExtUri.dirname(i)),n==="copy"){if(u===a&&(0,g.hasFileFolderCopyCapability)(u))await u.copy(s,i,{overwrite:r});else{const S=await this.resolve(s);S.isDirectory?await this.doCopyFolder(u,S,a,i):await this.doCopyFile(u,s,a,i)}return n}else return u===a?(await u.rename(s,i,{overwrite:r}),n):(await this.doMoveCopy(u,s,a,i,"copy",r),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(u,s,a,i){if((0,g.hasOpenReadWriteCloseCapability)(u)&&(0,g.hasOpenReadWriteCloseCapability)(a))return this.doPipeBuffered(u,s,a,i);if((0,g.hasOpenReadWriteCloseCapability)(u)&&(0,g.hasReadWriteCapability)(a))return this.doPipeBufferedToUnbuffered(u,s,a,i);if((0,g.hasReadWriteCapability)(u)&&(0,g.hasOpenReadWriteCloseCapability)(a))return this.doPipeUnbufferedToBuffered(u,s,a,i);if((0,g.hasReadWriteCapability)(u)&&(0,g.hasReadWriteCapability)(a))return this.doPipeUnbuffered(u,s,a,i)}async doCopyFolder(u,s,a,i){await a.mkdir(i),Array.isArray(s.children)&&await t.Promises.settled(s.children.map(async n=>{const r=this.getExtUri(a).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(u,await this.resolve(n.resource),a,r):this.doCopyFile(u,n.resource,a,r)}))}async doValidateMoveCopy(u,s,a,i,n,r){let o=!1;if(u===a){const{providerExtUri:S,isPathCaseSensitive:A}=this.getExtUri(u);if(A||(o=S.isEqual(s,i)),o&&n==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!o&&S.isEqualOrParent(i,s))throw new Error((0,d.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const f=await this.exists(i);if(f&&!o){if(!r)throw new g.FileOperationError((0,d.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(u===a){const{providerExtUri:S}=this.getExtUri(u);if(S.isEqualOrParent(s,i))throw new Error((0,d.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:f,isSameResourceWithDifferentPathCase:o}}getExtUri(u){const s=this.isPathCaseSensitive(u);return{providerExtUri:s?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(u){return!!(u.capabilities&1024)}async createFolder(u){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);await this.mkdirp(s,u);const a=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(u,0,a)),a}async mkdirp(u,s){const a=[],{providerExtUri:i}=this.getExtUri(u);for(;!i.isEqual(s,i.dirname(s));)try{if(((await u.stat(s)).type&g.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,g.toFileSystemProviderErrorCode)(n)!==g.FileSystemProviderErrorCode.FileNotFound)throw n;a.push(i.basename(s)),s=i.dirname(s)}for(let n=a.length-1;n>=0;n--){s=i.joinPath(s,a[n]);try{await u.mkdir(s)}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(u,s){try{await this.doValidateDelete(u,s)}catch(a){return a}return!0}async doValidateDelete(u,s){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);if(!!s?.useTrash&&!(a.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(u)));let n;try{n=await a.stat(u)}catch{}if(n)this.throwIfFileIsReadonly(u,n);else throw new g.FileOperationError((0,d.localize)(20,null,this.resourceForError(u)),1);if(!!!s?.recursive){const o=await this.resolve(u);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(u)))}return a}async del(u,s){const a=await this.doValidateDelete(u,s),i=!!s?.useTrash,n=!!s?.recursive;await a.delete(u,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new g.FileOperationEvent(u,1))}watch(u,s={recursive:!1,excludes:[]}){const a=new E.DisposableStore;let i=!1,n=()=>{i=!0};return a.add((0,E.toDisposable)(()=>n())),(async()=>{try{const r=await this.doWatch(u,s);i?(0,E.dispose)(r):n=()=>(0,E.dispose)(r)}catch(r){this.logService.error(r)}})(),a}async doWatch(u,s){const a=await this.withProvider(u),i=(0,k.hash)([this.getExtUri(a).providerExtUri.getComparisonKey(u),s]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:a.watch(u,s)},this.activeWatchers.set(i,n)),n.count+=1,(0,E.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,E.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,u]of this.activeWatchers)(0,E.dispose)(u.disposable);this.activeWatchers.clear()}async doWriteBuffered(u,s,a,i){return this.writeQueue.queueFor(s,this.getExtUri(u).providerExtUri).queue(async()=>{const n=await u.open(s,{create:!0,unlock:a?.unlock??!1});try{(0,c.isReadableStream)(i)||(0,c.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(u,n,i):await this.doWriteReadableBufferedQueued(u,n,i)}catch(r){throw(0,g.ensureFileSystemProviderError)(r)}finally{await u.close(n)}})}async doWriteStreamBufferedQueued(u,s,a){let i=0,n;if((0,c.isReadableBufferedStream)(a)){if(a.buffer.length>0){const r=w.VSBuffer.concat(a.buffer);await this.doWriteBuffer(u,s,r,r.byteLength,i,0),i+=r.byteLength}if(a.ended)return;n=a.stream}else n=a;return new Promise((r,o)=>{(0,c.listenStream)(n,{onData:async f=>{n.pause();try{await this.doWriteBuffer(u,s,f,f.byteLength,i,0)}catch(S){return o(S)}i+=f.byteLength,setTimeout(()=>n.resume())},onError:f=>o(f),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(u,s,a){let i=0,n;for(;(n=a.read())!==null;)await this.doWriteBuffer(u,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(u,s,a,i,n,r){let o=0;for(;o<i;)o+=await u.write(s,n+o,a.buffer,r+o,i-o)}async doWriteUnbuffered(u,s,a,i){return this.writeQueue.queueFor(s,this.getExtUri(u).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(u,s,a,i))}async doWriteUnbufferedQueued(u,s,a,i){let n;i instanceof w.VSBuffer?n=i:(0,c.isReadableStream)(i)?n=await(0,w.streamToBuffer)(i):(0,c.isReadableBufferedStream)(i)?n=await(0,w.bufferedStreamToBuffer)(i):n=(0,w.readableToBuffer)(i),await u.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:a?.unlock??!1})}async doPipeBuffered(u,s,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeBufferedQueued(u,s,a,i))}async doPipeBufferedQueued(u,s,a,i){let n,r;try{n=await u.open(s,{create:!1}),r=await a.open(i,{create:!0,unlock:!1});const o=w.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,S=0,A=0;do A=await u.read(n,f,o.buffer,S,o.byteLength-S),await this.doWriteBuffer(a,r,o,A,f,S),f+=A,S+=A,S===o.byteLength&&(S=0);while(A>0)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await t.Promises.settled([typeof n=="number"?u.close(n):Promise.resolve(),typeof r=="number"?a.close(r):Promise.resolve()])}}async doPipeUnbuffered(u,s,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(u,s,a,i))}async doPipeUnbufferedQueued(u,s,a,i){return a.writeFile(i,await u.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(u,s,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(u,s,a,i))}async doPipeUnbufferedToBufferedQueued(u,s,a,i){const n=await a.open(i,{create:!0,unlock:!1});try{const r=await u.readFile(s);await this.doWriteBuffer(a,n,w.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,g.ensureFileSystemProviderError)(r)}finally{await a.close(n)}}async doPipeBufferedToUnbuffered(u,s,a,i){const n=await(0,w.streamToBuffer)(this.readFileBuffered(u,s,P.CancellationToken.None));await this.doWriteUnbuffered(a,i,void 0,n)}throwIfFileSystemIsReadonly(u,s){if(u.capabilities&2048)throw new g.FileOperationError((0,d.localize)(22,null,this.resourceForError(s)),6);return u}throwIfFileIsReadonly(u,s){if((s.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,d.localize)(23,null,this.resourceForError(u)),6)}resourceForError(u){return u.scheme===R.Schemas.file?u.fsPath:u.toString(!0)}};C=Te([Ne(0,l.ILogService)],C),e.FileService=C}),define(ve[56],we([0,1,27,264,13,30,15,7,31,2,4,3,22,43,19,165,16,91,196,36,193,192]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c,d,g,b,l,C,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(_)}catch(a){console.error(`Error enabling graceful-fs: ${(0,C.toErrorMessage)(a)}`)}})();class s extends l.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n);this.onDidChangeCapabilities=k.Event.None,this.resourceLocks=new P.ResourceMap(r=>h.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:r}=await c.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await c.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async o=>{try{let f;o.isSymbolicLink()?f=(await this.stat((0,h.joinPath)(i,o.name))).type:f=this.toType(o),r.push([o.name,f])}catch(f){this.logService.trace(f)}})),r}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let r;return n?.dangling?r=g.FileType.Unknown:i.isFile()?r=g.FileType.File:i.isDirectory()?r=g.FileType.Directory:r=g.FileType.Unknown,n&&(r|=g.FileType.SymbolicLink),r}async createResourceLock(i){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(i)})`);let n;for(;n=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(i)})`),await n.wait();const r=new w.Barrier;return this.resourceLocks.set(i,r),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(i)})`),(0,E.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(i)})`),this.resourceLocks.delete(i),r.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),r=await this.createResourceLock(i));const o=this.toFilePath(i);return await c.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{r?.dispose()}}readFileStream(i,n,r){const o=(0,v.newWriteableStream)(f=>D.VSBuffer.concat(f.map(S=>D.VSBuffer.wrap(S))).buffer);return(0,b.readFileIntoStream)(this,i,o,f=>f.buffer,{...n,bufferSize:256*1024},r),o}async writeFile(i,n,r){let o;try{const f=this.toFilePath(i);if(!r.create||!r.overwrite){if(await c.Promises.exists(f)){if(!r.overwrite)throw(0,g.createFileSystemProviderError)((0,d.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,g.createFileSystemProviderError)((0,d.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(o,0,n,0,n.byteLength)}catch(f){throw await this.toFileSystemProviderWriteError(i,f)}finally{typeof o=="number"&&await this.close(o)}}async open(i,n){let r;(0,g.isFileOpenForWriteOptions)(n)&&(r=await this.createResourceLock(i));let o;try{const f=this.toFilePath(i);if((0,g.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:A}=await c.SymlinkSupport.stat(f);A.mode&128||await c.Promises.chmod(f,A.mode|128)}catch(A){this.logService.trace(A)}let S;if((0,g.isFileOpenForWriteOptions)(n)){if(R.isWindows)try{await c.Promises.truncate(f,0),S="r+"}catch(A){A.code!=="ENOENT"&&this.logService.trace(A)}S||(S="w")}else S="r";o=await c.Promises.open(f,S)}catch(f){throw r?.dispose(),(0,g.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,f):this.toFileSystemProviderError(f)}return this.mapHandleToPos.set(o,0),(0,g.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(o,i),r&&this.mapHandleToLock.set(o,r),o}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await c.Promises.fdatasync(i)}catch(n){this.canFlush=!1,this.logService.error(n)}return await c.Promises.close(i)}catch(n){throw this.toFileSystemProviderError(n)}finally{const n=this.mapHandleToLock.get(i);n&&(this.mapHandleToLock.delete(i),n.dispose())}}async read(i,n,r,o,f){const S=this.normalizePos(i,n);let A=null;try{A=(await c.Promises.read(i,r,o,f,S)).bytesRead}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(i,S,A)}return A}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,r){const o=this.mapHandleToPos.get(i);typeof o=="number"&&(typeof n=="number"||(typeof r=="number"?this.mapHandleToPos.set(i,o+r):this.mapHandleToPos.delete(i)))}async write(i,n,r,o,f){return(0,w.retry)(()=>this.doWrite(i,n,r,o,f),100,3)}async doWrite(i,n,r,o,f){const S=this.normalizePos(i,n);let A=null;try{A=(await c.Promises.write(i,r,o,f,S)).bytesWritten}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),I)}finally{this.updatePos(i,S,A)}return A}async mkdir(i){try{await c.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const r=this.toFilePath(i);n.recursive?await c.Promises.rm(r,c.RimRafMode.MOVE):await c.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(i,n,r){const o=this.toFilePath(i),f=this.toFilePath(n);if(o!==f)try{await this.validateTargetDeleted(i,n,"move",r.overwrite),await c.Promises.move(o,f)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,d.localize)(2,null,(0,T.basename)(o),(0,T.basename)((0,T.dirname)(f)),S.toString()))),this.toFileSystemProviderError(S)}}async copy(i,n,r){const o=this.toFilePath(i),f=this.toFilePath(n);if(o!==f)try{await this.validateTargetDeleted(i,n,"copy",r.overwrite),await c.Promises.copy(o,f,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,d.localize)(3,null,(0,T.basename)(o),(0,T.basename)((0,T.dirname)(f)),S.toString()))),this.toFileSystemProviderError(S)}}async validateTargetDeleted(i,n,r,o){const f=this.toFilePath(i),S=this.toFilePath(n);let A=!1;if(!!(this.capabilities&1024)||(A=(0,y.isEqual)(f,S,!0)),A&&r==="copy")throw(0,g.createFileSystemProviderError)((0,d.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(!A&&await c.Promises.exists(S)){if(!o)throw(0,g.createFileSystemProviderError)((0,d.localize)(5,null),g.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createUniversalWatcher(i,n,r){return new p.UniversalWatcherClient(o=>i(o),o=>n(o),r)}createNonRecursiveWatcher(i,n,r){return new u.NodeJSWatcherClient(o=>i(o),o=>n(o),r)}toFileSystemProviderError(i){if(i instanceof g.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=g.FileSystemProviderErrorCode.NoPermissions;break;default:n=g.FileSystemProviderErrorCode.Unknown}return(0,g.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let r=this.toFileSystemProviderError(n);if(i&&r.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await c.SymlinkSupport.stat(this.toFilePath(i));o.mode&128||(r=(0,g.createFileSystemProviderError)(n,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return r}}e.DiskFileSystemProvider=s}),define(ve[197],we([0,1,7,56,2,15,43,21]),function(J,e,_,t,w,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class y extends w.Disposable{constructor(R,h){super();this.provider=R,this.logService=h,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(R,h,v){const c=this.getUriTransformer(R);switch(h){case"stat":return this.stat(c,v[0]);case"readdir":return this.readdir(c,v[0]);case"open":return this.open(c,v[0],v[1]);case"close":return this.close(v[0]);case"read":return this.read(v[0],v[1],v[2]);case"readFile":return this.readFile(c,v[0],v[1]);case"write":return this.write(v[0],v[1],v[2],v[3],v[4]);case"writeFile":return this.writeFile(c,v[0],v[1],v[2]);case"rename":return this.rename(c,v[0],v[1],v[2]);case"copy":return this.copy(c,v[0],v[1],v[2]);case"mkdir":return this.mkdir(c,v[0]);case"delete":return this.delete(c,v[0],v[1]);case"watch":return this.watch(c,v[0],v[1],v[2],v[3]);case"unwatch":return this.unwatch(v[0],v[1])}throw new Error(`IPC Command ${h} not found`)}listen(R,h,v){const c=this.getUriTransformer(R);switch(h){case"fileChange":return this.onFileChange(c,v[0]);case"readFileStream":return this.onReadFileStream(c,v[0],v[1])}throw new Error(`Unknown event ${h}`)}stat(R,h){const v=this.transformIncoming(R,h,!0);return this.provider.stat(v)}readdir(R,h){const v=this.transformIncoming(R,h);return this.provider.readdir(v)}async readFile(R,h,v){const c=this.transformIncoming(R,h,!0),d=await this.provider.readFile(c,v);return P.VSBuffer.wrap(d)}onReadFileStream(R,h,v){const c=this.transformIncoming(R,h,!0),d=new k.CancellationTokenSource,g=new _.Emitter({onLastListenerRemove:()=>{d.cancel()}}),b=this.provider.readFileStream(c,v,d.token);return(0,D.listenStream)(b,{onData:l=>g.fire(P.VSBuffer.wrap(l)),onError:l=>g.fire(l),onEnd:()=>{g.fire("end"),g.dispose(),d.dispose()}}),g.event}writeFile(R,h,v,c){const d=this.transformIncoming(R,h);return this.provider.writeFile(d,v.buffer,c)}open(R,h,v){const c=this.transformIncoming(R,h,!0);return this.provider.open(c,v)}close(R){return this.provider.close(R)}async read(R,h,v){const c=P.VSBuffer.alloc(v),d=0,g=await this.provider.read(R,h,c.buffer,d,v);return[c,g]}write(R,h,v,c,d){return this.provider.write(R,h,v.buffer,c,d)}mkdir(R,h){const v=this.transformIncoming(R,h);return this.provider.mkdir(v)}delete(R,h,v){const c=this.transformIncoming(R,h);return this.provider.delete(c,v)}rename(R,h,v,c){const d=this.transformIncoming(R,h),g=this.transformIncoming(R,v);return this.provider.rename(d,g,c)}copy(R,h,v,c){const d=this.transformIncoming(R,h),g=this.transformIncoming(R,v);return this.provider.copy(d,g,c)}onFileChange(R,h){const v=new _.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(h,this.createSessionFileWatcher(R,v))},onLastListenerRemove:()=>{(0,w.dispose)(this.sessionToWatcher.get(h)),this.sessionToWatcher.delete(h)}});return v.event}async watch(R,h,v,c,d){const g=this.sessionToWatcher.get(h);if(g){const b=this.transformIncoming(R,c),l=g.watch(v,b,d);this.watchRequests.set(h+v,l)}}async unwatch(R,h){const v=R+h,c=this.watchRequests.get(v);c&&((0,w.dispose)(c),this.watchRequests.delete(v))}dispose(){super.dispose();for(const[,R]of this.watchRequests)R.dispose();this.watchRequests.clear();for(const[,R]of this.sessionToWatcher)R.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=y;class E extends w.Disposable{constructor(R,h,v,c){super();this.uriTransformer=R,this.logService=v,this.environmentService=c,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(h)}registerListeners(R){const h=this._register(new _.Emitter);this._register(h.event(v=>{R.fire(v.map(c=>({resource:this.uriTransformer.transformOutgoingURI(c.resource),type:c.type})))})),this._register(this.fileWatcher.onDidChangeFile(v=>h.fire(v))),this._register(this.fileWatcher.onDidWatchError(v=>R.fire(v)))}getRecursiveWatcherOptions(R){}getExtraExcludes(R){}watch(R,h,v){const c=this.getExtraExcludes(this.environmentService);return Array.isArray(c)&&(v.excludes=[...v.excludes,...c]),this.watcherRequests.set(R,this.fileWatcher.watch(h,v)),(0,w.toDisposable)(()=>{(0,w.dispose)(this.watcherRequests.get(R)),this.watcherRequests.delete(R)})}dispose(){super.dispose();for(const[,R]of this.watcherRequests)R.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=E}),define(ve[94],we([0,1,7,5,14]),function(J,e,_,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class P{constructor(h){this.service=h,this.onDidChangeLogLevel=_.Event.buffer(h.onDidChangeLogLevel,!0)}listen(h,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(h,v,c){switch(v){case"setLevel":return this.service.setLevel(c)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=P;class D{constructor(h){this.channel=h}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(h){D.setLevel(this.channel,h)}static setLevel(h,v){return h.call("setLevel",v)}}e.LogLevelChannelClient=D;class k{constructor(h){this.loggerService=h,this.loggers=new Map}listen(h,v){throw new Error(`Event not found: ${v}`)}async call(h,v,c){switch(v){case"createLogger":this.createLogger(t.URI.revive(c[0]),c[1]);return;case"log":return this.log(t.URI.revive(c[0]),c[1]);case"consoleLog":return this.consoleLog(c[0],c[1])}throw new Error(`Call not found: ${v}`)}createLogger(h,v){this.loggers.set(h.toString(),this.loggerService.createLogger(h,v))}consoleLog(h,v){let c=console.log;switch(h){case w.LogLevel.Error:c=console.error;break;case w.LogLevel.Warning:c=console.warn;break;case w.LogLevel.Info:c=console.info;break}c.call(console,...v)}log(h,v){const c=this.loggers.get(h.toString());if(!c)throw new Error("Create the logger before logging");for(const[d,g]of v)(0,w.log)(c,d,g)}}e.LoggerChannel=k;class y extends w.AbstractLoggerService{constructor(h,v,c){super(h,v);this.channel=c}createConsoleMainLogger(){return new w.AdapterLogger({log:(h,v)=>{this.channel.call("consoleLog",[h,v])}})}doCreateLogger(h,v,c){return new E(this.channel,h,v,c)}}e.LoggerChannelClient=y;class E extends w.AbstractMessageLogger{constructor(h,v,c,d){super(d?.always);this.channel=h,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.channel.call("createLogger",[v,d]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(h,v){const c=[[h,v]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(h){this.channel.call("log",[this.file,h])}}class T extends w.LogService{constructor(h,v){super(v);this.parent=h,this._register(h.onDidChangeLogLevel(c=>v.setLevel(c)))}setLevel(h){super.setLevel(h),this.parent.setLevel(h)}}e.FollowerLogService=T}),define(ve[95],we([0,1,16,14]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function w(k,y,E,T,R){try{const h=await new Promise((c,d)=>{J(["spdlog"],c,d)});h.setFlushOn(t.LogLevel.Trace);const v=await h.createAsyncRotatingLogger(k,y,E,T);return R&&v.clearFormatters(),v}catch(h){console.error(h)}return null}function P(k,y,E){switch(y){case t.LogLevel.Trace:k.trace(E);break;case t.LogLevel.Debug:k.debug(E);break;case t.LogLevel.Info:k.info(E);break;case t.LogLevel.Warning:k.warn(E);break;case t.LogLevel.Error:k.error(E);break;case t.LogLevel.Critical:k.critical(E);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(y,E,T,R,h){super();this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(y,E,T,R),this._register(this.onDidChangeLogLevel(v=>{this._logger&&this._logger.setLevel(v)}))}async _createSpdLogLogger(y,E,T,R){const h=T?6:1,v=30/h*_.ByteSize.MB,c=await w(y,E,v,h,R);if(c){this._logger=c,this._logger.setLevel(this.getLevel());for(const{level:d,message:g}of this.buffer)P(this._logger,d,g);this.buffer=[]}}log(y,E){this._logger?P(this._logger,y,E):this.getLevel()<=y&&this.buffer.push({level:y,message:E})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(ve[198],we([0,1,79,166,6]),function(J,e,_,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var D;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function E(c,d){return d-c}y.compare=E;const T=Object.create(null);T[y.Error]=(0,t.localize)(0,null),T[y.Warning]=(0,t.localize)(1,null),T[y.Info]=(0,t.localize)(2,null);function R(c){return T[c]||""}y.toString=R;function h(c){switch(c){case _.default.Error:return y.Error;case _.default.Warning:return y.Warning;case _.default.Info:return y.Info;case _.default.Ignore:return y.Hint}}y.fromSeverity=h;function v(c){switch(c){case y.Error:return _.default.Error;case y.Warning:return _.default.Warning;case y.Info:return _.default.Info;case y.Hint:return _.default.Ignore}}y.toSeverity=v}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(y){const E="";function T(h){return R(h,!0)}y.makeKey=T;function R(h,v){let c=[E];return h.source?c.push(h.source.replace("\xA6","\\\xA6")):c.push(E),h.code?typeof h.code=="string"?c.push(h.code.replace("\xA6","\\\xA6")):c.push(h.code.value.replace("\xA6","\\\xA6")):c.push(E),h.severity!==void 0&&h.severity!==null?c.push(D.toString(h.severity)):c.push(E),h.message&&v?c.push(h.message.replace("\xA6","\\\xA6")):c.push(E),h.startLineNumber!==void 0&&h.startLineNumber!==null?c.push(h.startLineNumber.toString()):c.push(E),h.startColumn!==void 0&&h.startColumn!==null?c.push(h.startColumn.toString()):c.push(E),h.endLineNumber!==void 0&&h.endLineNumber!==null?c.push(h.endLineNumber.toString()):c.push(E),h.endColumn!==void 0&&h.endColumn!==null?c.push(h.endColumn.toString()):c.push(E),c.push(E),c.join("\xA6")}y.makeKeyOptionalMessage=R})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(ve[199],we([0,1,7,79,6]),function(J,e,_,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,w.createDecorator)("notificationService");var P;(function(E){E[E.WORKSPACE=0]="WORKSPACE",E[E.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(E){E[E.OFF=0]="OFF",E[E.SILENT=1]="SILENT",E[E.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new y,this.onDidClose=_.Event.None,this.onDidChangeVisibility=_.Event.None}updateSeverity(T){}updateMessage(T){}updateActions(T){}close(){}}e.NoOpNotification=k;class y{infinite(){}done(){}total(T){}worked(T){}}e.NoOpProgress=y}),define(ve[45],we([0,1,8,3,24,22]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const k=t.globals.vscode.context.configuration();if(k)D=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const k=(0,P.dirname)(_.FileAccess.asFileUri("",J));D=J.__$__nodeRequire((0,P.joinPath)(k,"product.json").fsPath);const y=J.__$__nodeRequire((0,P.joinPath)(k,"package.json").fsPath);w.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),Object.assign(D,{version:y.version,extensionsGallery:w.env.EXTENSIONS_GALLERY?JSON.parse(w.env.EXTENSIONS_GALLERY):D.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else D={nameShort:"Code - OSS",nameLong:"Code - OSS",applicationName:"code-oss",dataFolderName:".vscode-oss",win32MutexName:"vscodeoss",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",win32DirName:"Microsoft Code OSS",win32NameVersion:"Microsoft Code OSS",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"Microsoft.CodeOSS",win32ShellNameShort:"C&ode - OSS",darwinBundleIdentifier:"com.visualstudio.code.oss",linuxIconName:"com.visualstudio.code.oss",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-webview.net/insider/d372f9187401bd145a0a6e15ba369e2d82d02005/out/vs/workbench/contrib/webview/browser/pre/",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"],builtInExtensions:[{name:"ms-vscode.references-view",version:"0.0.81",repo:"https://github.com/microsoft/vscode-references-view",metadata:{id:"dc489f46-520d-4556-ae85-1f9eab3c412d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug-companion",version:"1.0.15",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.64.3",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"0.0.18",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],version:"1.64.2",date:"2022-03-22T20:16:06.512Z"},Object.keys(D).length===0&&Object.assign(D,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=D}),define(ve[32],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,_.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ve[200],we([0,1,90,7,2,14,3,26,32]),function(J,e,_,t,w,P,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsMainService=void 0;let E=class Lt extends w.Disposable{constructor(R,h,v,c){super();this.isRunningOnServer=R,this.logService=h,this.environmentMainService=v,this.productService=c,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getSecretStoragePrefix(){return`${this.productService.urlProtocol}${this.isRunningOnServer?"-server":""}`}async getPassword(R,h){const v=await this.withKeytar(),c=await v.getPassword(R,h);if(c)try{let{content:d,hasNextChunk:g}=JSON.parse(c);if(!d||!g)return c;let b=1;for(;g;){const l=await v.getPassword(R,`${h}-${b}`),C=JSON.parse(l);d+=C.content,g=C.hasNextChunk,b++}return d}catch{return c}return c}async setPassword(R,h,v){const c=await this.withKeytar(),d=3,g=async(b,l,C)=>{let p=0,u;for(;p<d;)try{await c.setPassword(b,l,C);return}catch(s){u=s,this.logService.warn("Error attempting to set a password: ",s),p++,await new Promise(a=>setTimeout(a,200))}throw u};if(D.isWindows&&v.length>Lt.MAX_PASSWORD_LENGTH){let b=0,l=0,C=!0;for(;C;){const p=v.substring(b,b+Lt.PASSWORD_CHUNK_SIZE);b+=Lt.PASSWORD_CHUNK_SIZE,C=v.length-b>0;const u={content:p,hasNextChunk:C};await g(R,l?`${h}-${l}`:h,JSON.stringify(u)),l++}}else await g(R,h,v);this._onDidChangePassword.fire({service:R,account:h})}async deletePassword(R,h){const c=await(await this.withKeytar()).deletePassword(R,h);return c&&this._onDidChangePassword.fire({service:R,account:h}),c}async findPassword(R){return(await this.withKeytar()).findPassword(R)}async findCredentials(R){return(await this.withKeytar()).findCredentials(R)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new _.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((R,h)=>{J(["keytar"],R,h)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(R){this.logService.warn(`Switching to using in-memory credential store instead because Keytar failed to load: ${R.message}`),this._keytarCache=new _.InMemoryCredentialsProvider}return this._keytarCache}clear(){return this._keytarCache instanceof _.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};E.MAX_PASSWORD_LENGTH=2500,E.PASSWORD_CHUNK_SIZE=E.MAX_PASSWORD_LENGTH-100,E=Te([Ne(1,P.ILogService),Ne(2,k.INativeEnvironmentService),Ne(3,y.IProductService)],E),e.CredentialsMainService=E}),define(ve[35],we([0,1,118,12]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(D,k){_.ok(t.isString(D)),_.ok(t.isObject(k)),_.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,k)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new w}),define(ve[201],we([0,1,7,35]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class P{constructor(){this._onDidChangeSchema=new _.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,E){this.schemasById[w(y)]=E,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new P;t.Registry.add(e.Extensions.JSONContribution,D)}),define(ve[46],we([0,1,17,7,12,151,201,35]),function(J,e,_,t,w,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const T=k.Registry.as(D.Extensions.JSONContribution);class R{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(u,s=!0){this.registerConfigurations([u],s)}registerConfigurations(u,s=!0){const a=this.doRegisterConfigurations(u,s);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(u){const s=this.doDeregisterConfigurations(u);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:u,remove:s}){const a=[];a.push(...this.doDeregisterConfigurations(s)),a.push(...this.doRegisterConfigurations(u,!1)),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,_.distinct)(a)})}registerDefaultConfigurations(u){const s=[],a=[];for(const{overrides:i,source:n}of u)for(const r in i)if(s.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const o={...this.configurationDefaultsOverrides.get(r)?.value||{},...i[r]};this.configurationDefaultsOverrides.set(r,{source:n,value:o});const f={type:"object",default:o,description:P.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:w.isString(n)?void 0:n};a.push(...c(r)),this.configurationProperties[r]=f,this.defaultLanguageConfigurationOverridesNode.properties[r]=f}else{this.configurationDefaultsOverrides.set(r,{value:i[r],source:n});const o=this.configurationProperties[r];o&&(this.updatePropertyDefaultValue(r,o),this.updateSchema(r,o))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(u){const s=[];for(const{overrides:a,source:i}of u)for(const n in a){const r=this.configurationDefaultsOverrides.get(n),o=w.isString(i)?i:i?.id,f=w.isString(r?.source)?r?.source:r?.source?.id;if(o===f)if(s.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const S=this.configurationProperties[n];S&&(this.updatePropertyDefaultValue(n,S),this.updateSchema(n,S))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const s of u)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,s){const a=[];return u.forEach(i=>{a.push(...this.validateAndRegisterProperties(i,s,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),a}doDeregisterConfigurations(u){const s=[],a=i=>{if(i.properties)for(const n in i.properties)s.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,i.properties[n]);i.allOf&&i.allOf.forEach(n=>a(n))};for(const i of u){a(i);const n=this.configurationContributors.indexOf(i);n!==-1&&this.configurationContributors.splice(n,1)}return s}validateAndRegisterProperties(u,s=!0,a,i,n=3){n=w.isUndefinedOrNull(u.scope)?n:u.scope;let r=[],o=u.properties;if(o)for(let S in o){if(s&&l(S)){delete o[S];continue}const A=o[S];if(A.source=a,A.defaultDefaultValue=o[S].default,this.updatePropertyDefaultValue(S,A),e.OVERRIDE_PROPERTY_REGEX.test(S)?A.scope=void 0:(A.scope=w.isUndefinedOrNull(A.scope)?n:A.scope,A.restricted=w.isUndefinedOrNull(A.restricted)?!!i?.includes(S):A.restricted),o[S].hasOwnProperty("included")&&!o[S].included){this.excludedConfigurationProperties[S]=o[S],delete o[S];continue}else this.configurationProperties[S]=o[S];!o[S].deprecationMessage&&o[S].markdownDeprecationMessage&&(o[S].deprecationMessage=o[S].markdownDeprecationMessage),r.push(S)}let f=u.allOf;if(f)for(let S of f)r.push(...this.validateAndRegisterProperties(S,s,a,i,n));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(u){const s=a=>{let i=a.properties;if(i)for(const r in i)this.updateSchema(r,i[r]);let n=a.allOf;n&&n.forEach(s)};s(u)}updateSchema(u,s){switch(e.allSettings.properties[u]=s,s.scope){case 1:e.applicationSettings.properties[u]=s;break;case 2:e.machineSettings.properties[u]=s;break;case 6:e.machineOverridableSettings.properties[u]=s;break;case 3:e.windowSettings.properties[u]=s;break;case 4:e.resourceSettings.properties[u]=s;break;case 5:e.resourceSettings.properties[u]=s,this.resourceLanguageSettingsSchema.properties[u]=s;break}}removeFromSchema(u,s){switch(delete e.allSettings.properties[u],s.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u],delete this.resourceLanguageSettingsSchema.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const s=`[${u}]`,a={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,a),e.allSettings.properties[s]=a,e.applicationSettings.properties[s]=a,e.machineSettings.properties[s]=a,e.machineOverridableSettings.properties[s]=a,e.windowSettings.properties[s]=a,e.resourceSettings.properties[s]=a}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const u={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,s){const a=this.configurationDefaultsOverrides.get(u);let i=a?.value,n=a?.source;w.isUndefined(i)&&(i=s.defaultDefaultValue,n=void 0),w.isUndefined(i)&&(i=g(s.type)),s.default=i,s.defaultValueSource=n}}const h="\\[([^\\]]+)\\]",v=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function c(p){const u=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let s=v.exec(p);for(;s?.length;){const a=s[1].trim();a&&u.push(a),s=v.exec(p)}}return(0,_.distinct)(u)}e.overrideIdentifiersFromKey=c;function d(p){return p.reduce((u,s)=>`${u}[${s}]`,"")}e.keyFromOverrideIdentifiers=d;function g(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const b=new R;k.Registry.add(e.Extensions.Configuration,b);function l(p){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?P.localize(7,null,p):b.getConfigurationProperties()[p]!==void 0?P.localize(8,null,p):null:P.localize(6,null)}e.validateProperty=l;function C(){const p=[],u=b.getConfigurationProperties();for(const s of Object.keys(u))p.push([s,u[s].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=C}),define(ve[202],we([0,1,17,7,38,2,30,20,12,5,28,46,35]),function(J,e,_,t,w,P,D,k,y,E,T,R,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(i={},n=[],r=[]){this._contents=i,this._keys=n,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,T.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,n){const r=this.getContentsForOverrideIdentifer(n);return r?i?(0,T.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return _.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return _.distinct(i)}override(i){let n=this.overrideConfigurations.get(i);return n||(n=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,n)),n}merge(...i){const n=k.deepClone(this.contents),r=k.deepClone(this.overrides),o=[...this.keys];for(const f of i){this.mergeContents(n,f.contents);for(const S of f.overrides){const[A]=r.filter(I=>_.equals(I.identifiers,S.identifiers));A?(this.mergeContents(A.contents,S.contents),A.keys.push(...S.keys),A.keys=_.distinct(A.keys)):r.push(k.deepClone(S))}for(const S of f.keys)o.indexOf(S)===-1&&o.push(S)}return new v(n,o,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const n=this.getContentsForOverrideIdentifer(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let r={};for(const o of _.distinct([...Object.keys(this.contents),...Object.keys(n)])){let f=this.contents[o],S=n[o];S&&(typeof f=="object"&&typeof S=="object"?(f=k.deepClone(f),this.mergeContents(f,S)):f=S),r[o]=f}return new v(r,this.keys,this.overrides)}mergeContents(i,n){for(const r of Object.keys(n)){if(r in i&&y.isObject(i[r])&&y.isObject(n[r])){this.mergeContents(i[r],n[r]);continue}i[r]=k.deepClone(n[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?k.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let n=null,r=null;const o=f=>{f&&(r?this.mergeContents(r,f):r=k.deepClone(f))};for(const f of this.overrides)_.equals(f.identifiers,[i])?n=f.contents:f.identifiers.includes(i)&&o(f.contents);return o(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,n){this.addKey(i),(0,T.addToValueTree)(this.contents,i,n,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,T.removeFromValueTree)(this.contents,i)}addKey(i){let n=this.keys.length;for(let r=0;r<n;r++)i.indexOf(this.keys[r])===0&&(n=r);this.keys.splice(n,1,i)}removeKey(i){let n=this.keys.indexOf(i);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=v;class c extends v{constructor(i={}){const n=h.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(n),o=Object.create(null),f=[];for(const S in n){const A=i[S],I=A!==void 0?A:n[S].default;(0,T.addToValueTree)(o,S,I,F=>console.error(`Conflict in default settings: ${F}`))}for(const S of Object.keys(o))R.OVERRIDE_PROPERTY_REGEX.test(S)&&f.push({identifiers:(0,R.overrideIdentifiersFromKey)(S),keys:Object.keys(o[S]),contents:(0,T.toValuesTree)(o[S],A=>console.error(`Conflict in default settings file: ${A}`))});super(o,r,f)}}e.DefaultConfigurationModel=c;class d{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,n){if(!y.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,n)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,n){this._raw=i;const{contents:r,keys:o,overrides:f,restricted:S}=this.doParseRaw(i,n);this._configurationModel=new v(r,o,f),this._restrictedConfigurations=S||[]}doParseContent(i){let n={},r=null,o=[],f=[],S=[];function A(F){Array.isArray(o)?o.push(F):r!==null&&(o[r]=F)}let I={onObjectBegin:()=>{let F={};A(F),f.push(o),o=F,r=null},onObjectProperty:F=>{r=F},onObjectEnd:()=>{o=f.pop()},onArrayBegin:()=>{let F=[];A(F),f.push(o),o=F,r=null},onArrayEnd:()=>{o=f.pop()},onLiteralValue:A,onError:(F,U,W)=>{S.push({error:F,offset:U,length:W})}};if(i)try{w.visit(i,I),n=o[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return n}doParseRaw(i,n){const r=h.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,r,!0,n);i=o.raw;const f=(0,T.toValuesTree)(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),S=Object.keys(i),A=this.toOverrides(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:f,keys:S,overrides:A,restricted:o.restricted}}filter(i,n,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[]};const f={},S=[];for(let A in i)if(R.OVERRIDE_PROPERTY_REGEX.test(A)&&r){const I=this.filter(i[A],n,!1,o);f[A]=I.raw,S.push(...I.restricted)}else{const I=n[A],F=I?typeof I.scope!="undefined"?I.scope:3:void 0;I?.restricted&&S.push(A),(F===void 0||o.scopes===void 0||o.scopes.includes(F))&&(o.skipRestricted&&I?.restricted||(f[A]=i[A]))}return{raw:f,restricted:S}}toOverrides(i,n){const r=[];for(const o of Object.keys(i))if(R.OVERRIDE_PROPERTY_REGEX.test(o)){const f={};for(const S in i[o])f[S]=i[o][S];r.push({identifiers:(0,R.overrideIdentifiersFromKey)(o),keys:Object.keys(f),contents:(0,T.toValuesTree)(f,n)})}return r}}e.ConfigurationModelParser=d;class g extends P.Disposable{constructor(i,n,r,o){super();this.userSettingsResource=i,this.scopes=n,this.fileService=o,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class b{constructor(i,n,r=new v,o=new v,f=new D.ResourceMap,S=new v,A=new D.ResourceMap,I=!0){this._defaultConfiguration=i,this._localUserConfiguration=n,this._remoteUserConfiguration=r,this._workspaceConfiguration=o,this._folderConfigurations=f,this._memoryConfiguration=S,this._memoryConfigurationByResource=A,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(i,n,r){return this.getConsolidateConfigurationModel(n,r).getValue(i)}updateValue(i,n,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new v,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,n===void 0?o.removeValue(i):o.setValue(i,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,n,r){const o=this.getConsolidateConfigurationModel(n,r),f=this.getFolderConfigurationModelForResource(n.resource,r),S=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,A=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),I=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),F=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),U=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),W=r?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,m=f?n.overrideIdentifier?f.freeze().override(n.overrideIdentifier).getValue(i):f.freeze().getValue(i):void 0,L=n.overrideIdentifier?S.override(n.overrideIdentifier).getValue(i):S.getValue(i),M=o.getValue(i),Y=_.distinct(_.flatten(o.overrides.map($=>$.identifiers))).filter($=>o.getOverrideValue(i,$)!==void 0);return{defaultValue:A,userValue:I,userLocalValue:F,userRemoteValue:U,workspaceValue:W,workspaceFolderValue:m,memoryValue:L,value:M,default:A!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspace:W!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspaceFolder:m!==void 0?{value:f?.freeze().getValue(i),override:n.overrideIdentifier?f?.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,memory:L!==void 0?{value:S.getValue(i),override:n.overrideIdentifier?S.getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Y.length?Y:void 0}}keys(i){const n=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,n){this._folderConfigurations.set(i,n),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:o,updated:f,removed:S}=u(this._defaultConfiguration,i);n=[...o,...f,...S]}for(const o of n)for(const f of(0,R.overrideIdentifiersFromKey)(o)){const S=this._defaultConfiguration.getKeysForOverrideIdentifier(f),A=i.getKeysForOverrideIdentifier(f),I=[...A.filter(F=>S.indexOf(F)===-1),...S.filter(F=>A.indexOf(F)===-1),...S.filter(F=>!k.equals(this._defaultConfiguration.override(f).getValue(F),i.override(f).getValue(F)))];r.push([f,I])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:f}=u(this.localUserConfiguration,i),S=[...n,...r,...o];return S.length&&this.updateLocalUserConfiguration(i),{keys:S,overrides:f}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:f}=u(this.remoteUserConfiguration,i);let S=[...n,...r,...o];return S.length&&this.updateRemoteUserConfiguration(i),{keys:S,overrides:f}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:o,overrides:f}=u(this.workspaceConfiguration,i);let S=[...n,...r,...o];return S.length&&this.updateWorkspaceConfiguration(i),{keys:S,overrides:f}}compareAndUpdateFolderConfiguration(i,n){const r=this.folderConfigurations.get(i),{added:o,updated:f,removed:S,overrides:A}=u(r,n);let I=[...o,...f,...S];return(I.length||!r)&&this.updateFolderConfiguration(i,n),{keys:I,overrides:A}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:o,removed:f,overrides:S}=u(n,void 0);return{keys:[...r,...o,...f],overrides:S}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,n){let r=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&i){const o=n.getFolder(i);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const f=this._memoryConfigurationByResource.get(i);f&&(r=r.merge(f))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let n=this._foldersConsolidatedConfigurations.get(i);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(n=r.merge(o),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(i,n)):n=r}return n}getFolderConfigurationModelForResource(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,n)=>{const{contents:r,overrides:o,keys:f}=this._folderConfigurations.get(n);return i.push([n,{contents:r,overrides:o,keys:f}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>i.add(n)),this.userConfiguration.freeze().keys.forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o))),[...n.values()]}static parse(i){const n=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),o=this.parseConfigurationModel(i.workspace),f=i.folders.reduce((S,A)=>(S.set(E.URI.revive(A[0]),this.parseConfigurationModel(A[1])),S),new D.ResourceMap);return new b(n,r,new v,o,f,new v,new D.ResourceMap,!1)}static parseConfigurationModel(i){return new v(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=b;function l(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,n=new Map;for(const o of a)o.keys.forEach(f=>i.add(f)),o.overrides.forEach(([f,S])=>{const A=(0,D.getOrSet)(n,f,new Set);S.forEach(I=>A.add(I))});const r=[];return n.forEach((o,f)=>r.push([f,[...o.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=l;class C{constructor(i,n,r,o){this.change=i,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const f=new Set;i.keys.forEach(A=>f.add(A)),i.overrides.forEach(([,A])=>A.forEach(I=>f.add(I))),this.affectedKeys=[...f.values()];const S=new v;this.affectedKeys.forEach(A=>S.setValue(A,{})),this.affectedKeysTree=S.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(i,n,this.currentWorkspace);return!k.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(i,n){let r=(0,T.toValuesTree)({[n]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(i=i[o],!i)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=C;class p extends C{constructor(i,n,r,o){super({keys:i.allKeys(),overrides:[]},void 0,i,n);this.source=r,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=p;function u(a,i){const{added:n,removed:r,updated:o}=s(i,a),f=[],S=a?.getAllOverrideIdentifiers()||[],A=i?.getAllOverrideIdentifiers()||[];if(i){const I=A.filter(F=>!S.includes(F));for(const F of I)f.push([F,i.getKeysForOverrideIdentifier(F)])}if(a){const I=S.filter(F=>!A.includes(F));for(const F of I)f.push([F,a.getKeysForOverrideIdentifier(F)])}if(i&&a){for(const I of S)if(A.includes(I)){const F=s({contents:a.getOverrideValue(void 0,I)||{},keys:a.getKeysForOverrideIdentifier(I)},{contents:i.getOverrideValue(void 0,I)||{},keys:i.getKeysForOverrideIdentifier(I)});f.push([I,[...F.added,...F.removed,...F.updated]])}}return{added:n,removed:r,updated:o,overrides:f}}function s(a,i){const n=a?i?a.keys.filter(f=>i.keys.indexOf(f)===-1):[...a.keys]:[],r=i?a?i.keys.filter(f=>a.keys.indexOf(f)===-1):[...i.keys]:[],o=[];if(a&&i){for(const f of i.keys)if(a.keys.indexOf(f)!==-1){const S=(0,T.getConfigurationValue)(i.contents,f),A=(0,T.getConfigurationValue)(a.contents,f);k.equals(S,A)||o.push(f)}}return{added:n,removed:r,updated:o}}}),define(ve[96],we([0,1,13,7,2,22,28,202,46,35]),function(J,e,_,t,w,P,D,k,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class T extends w.Disposable{constructor(h,v){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new k.UserSettings(this.settingsResource,void 0,P.extUriBiasedIgnorePathCase,v)),this.configuration=new k.Configuration(new k.DefaultConfigurationModel,new k.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new _.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(y.Extensions.Configuration).onDidUpdateConfiguration(({properties:c})=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const h=await this.userConfiguration.loadConfiguration();this.configuration=new k.Configuration(new k.DefaultConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(h,v){const c=typeof h=="string"?h:void 0,d=(0,D.isConfigurationOverrides)(h)?h:(0,D.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(c,d,void 0)}updateValue(h,v,c,d){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const v=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(c,v,1)}onDidDefaultConfigurationChange(h){const v=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new k.DefaultConfigurationModel,h);this.trigger(c,v,6)}trigger(h,v,c){const d=new k.ConfigurationChangeEvent(h,{data:v},this.configuration);d.source=c,d.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(h){switch(h){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=T}),define(ve[97],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var t;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class w extends Error{constructor(D,k=t.Unknown,y){super(D);this._message=D,this._code=k,this._detail=y,this.isHandled=k===t.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype)}static isTemporarilyNotAvailable(D){return D instanceof w&&D._code===t.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof w&&D._code===t.NoResolverFound}static isHandled(D){return D instanceof w&&D.isHandled}}e.RemoteAuthorityResolverError=w}),define(ve[98],we([0,1,8]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function t(P){return P.scheme===_.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=t;function w(P){if(!P)return;const D=P.indexOf("+");return D<0?P:P.substr(0,D)}e.getRemoteName=w}),define(ve[41],we([0,1,18,6,98]),function(J,e,_,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=P;function D(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class y{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,c){if(typeof v=="undefined"||v===null)return typeof c=="undefined"||c===null;if(typeof c=="undefined"||c===null)return!1;if(typeof v=="string"||typeof c=="string"){let d=typeof v=="string"?v:v.value,g=typeof c=="string"?c:c.value;return _.equalsIgnoreCase(d,g)}return v._lower===c._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=y;function E(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function T(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=T;function R(h,v){if(v){const c=`onResolveRemoteAuthority:${(0,w.getRemoteName)(v)}`;return h.activationEvents?.indexOf(c)!==-1}return!1}e.isResolverExtension=R,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[33],we([0,1,18,41]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function w(c,d){return c.uuid&&d.uuid?c.uuid===d.uuid:c.id===d.id?!0:(0,_.compareIgnoreCase)(c.id,d.id)===0}e.areSameExtensions=w;class P{constructor(d,g){this.version=g,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof P?w(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=P;function D(c,d){return`${c}.${d}`}e.getExtensionId=D;function k(c){return c.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function y(c,d){return k(D(c,d))}e.getGalleryExtensionId=y;function E(c,d){const g=[],b=l=>{for(const C of g)if(C.some(p=>w(d(p),d(l))))return C;return null};for(const l of c){const C=b(l);C?C.push(l):g.push([l])}return g}e.groupByExtension=E;function T(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=T;function R(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}e.getGalleryExtensionTelemetryData=R,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function h(c){const d=new Set;if(c.malicious)for(const g of c.malicious)d.add(g.id);return d}e.getMaliciousExtensionsSet=h;function v(c,d){const g=[],b=d.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const l=b.shift();if(l&&g.every(C=>!w(C.identifier,{id:l}))){const C=c.filter(p=>w(p.identifier,{id:l}));C.length===1&&(g.push(C[0]),b.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}e.getExtensionDependencies=v}),define(ve[34],we([0,1,8,156,33,6]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const D=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function k(s){const a=D.exec(s);return a&&a[1]?[(0,w.adoptToGalleryExtensionId)(a[1]),a[2]]:[(0,w.adoptToGalleryExtensionId)(s),void 0]}e.getIdAndVersion=k;var y;(function(s){s.WIN32_X64="win32-x64",s.WIN32_IA32="win32-ia32",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));function E(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=E;function T(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function R(s,a){switch(s){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function h(s,a){return a==="web"&&!s.includes("web")}e.isNotWebExtensionInWebTargetPlatform=h;function v(s,a,i){return h(a,i)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===i?!0:c(i).includes(s)}e.isTargetPlatformCompatible=v;function c(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function d(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=d;var g;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(g=e.SortBy||(e.SortBy={}));var b;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var l;(function(s){s.Install="install",s.Uninstall="uninstall"})(l=e.StatisticType||(e.StatisticType={}));var C;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(C=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService");var p;(function(s){s.Unsupported="Unsupported",s.UnsupportedPreRelease="UnsupportedPreRelease",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatiblePreRelease="IncompatiblePreRelease",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Internal="Internal"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(a,i){super(a);this.code=i,this.name=i}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=_.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,t.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,t.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,P.createDecorator)("IExtensionManagementCLIService")}),define(ve[99],we([0,1,21,11,61,8,57,5,157,34,33,41]),function(J,e,_,t,w,P,D,k,y,E,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=void 0;const h=g=>(0,y.localize)(0,null,g),v=(0,y.localize)(1,null,"ms-dotnettools.csharp");function c(g,b){return b?`${g.publisher}.${g.name}@${g.version}`:`${g.publisher}.${g.name}`}let d=class{constructor(b,l){this.extensionManagementService=b,this.extensionGalleryService=l}get location(){}async listExtensions(b,l,C=console){let p=await this.extensionManagementService.getInstalled(1);const u=R.EXTENSION_CATEGORIES.map(a=>a.toLowerCase());if(l&&l!==""){if(u.indexOf(l.toLowerCase())<0){C.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(a=>a.manifest.categories?a.manifest.categories.map(n=>n.toLowerCase()).indexOf(l.toLowerCase())>-1:!1)}else if(l===""){C.log("Possible Categories: "),u.forEach(a=>{C.log(a)});return}this.location&&C.log((0,y.localize)(2,null,this.location)),p=p.sort((a,i)=>a.identifier.id.localeCompare(i.identifier.id));let s;for(let a of p)s!==a.identifier.id&&(s=a.identifier.id,C.log(c(a.manifest,b)))}async installExtensions(b,l,C,p,u=console){const s=[],a=[];b.length&&u.log(this.location?(0,y.localize)(3,null,this.location):(0,y.localize)(4,null));const i=await this.extensionManagementService.getInstalled(1),n=(f,S)=>{const A=i.find(I=>(0,T.areSameExtensions)(I.identifier,{id:f}));if(A){if(!S&&!p)return u.log((0,y.localize)(5,null,f,A.manifest.version,f)),!1;if(S&&A.manifest.version===S)return u.log((0,y.localize)(6,null,`${f}@${S}`)),!1}return!0},r=[],o=[];for(const f of b)if(f instanceof k.URI)r.push(f);else{const[S,A]=(0,E.getIdAndVersion)(f);n(S,A)&&o.push({id:S,version:A,installOptions:{...C,isBuiltin:!1}})}for(const f of l){const[S,A]=(0,E.getIdAndVersion)(f);n(S,A)&&o.push({id:S,version:A,installOptions:{...C,isBuiltin:!0}})}if(r.length&&await Promise.all(r.map(async f=>{try{const S=await this.installVSIX(f,{...C,isBuiltin:!1},p,u);S&&a.push(S)}catch(S){u.error(S.message||S.stack||S),s.push(f.toString())}})),o.length){const f=await this.getGalleryExtensions(o);await Promise.all(o.map(async S=>{const A=f.get(S.id.toLowerCase());if(A)try{const I=await this.installFromGallery(S,A,i,p,u);I&&a.push(I)}catch(I){u.error(I.message||I.stack||I),s.push(S.id)}else u.error(`${h(S.version?`${S.id}@${S.version}`:S.id)}
${v}`),s.push(S.id)}))}if(s.length)throw new Error((0,y.localize)(7,null,s.join(", ")))}async installVSIX(b,l,C,p){const u=await this.extensionManagementService.getManifest(b);if(!u)throw new Error("Invalid vsix");if(await this.validateVSIX(u,C,p))try{return await this.extensionManagementService.install(b,l),p.log((0,y.localize)(8,null,(0,w.getBaseLabel)(b))),u}catch(a){if((0,t.isCancellationError)(a))return p.log((0,y.localize)(9,null,(0,w.getBaseLabel)(b))),null;throw a}return null}async getGalleryExtensions(b){const l=new Map,C=b.some(u=>u.installOptions.installPreReleaseVersion),p=await this.extensionGalleryService.getExtensions(b.map(u=>({...u,preRelease:C})),_.CancellationToken.None);for(const u of p)l.set(u.identifier.id.toLowerCase(),u);return l}async installFromGallery({id:b,version:l,installOptions:C},p,u,s,a){const i=await this.extensionGalleryService.getManifest(p,_.CancellationToken.None);if(i&&!this.validateExtensionKind(i,a))return null;const n=u.find(r=>(0,T.areSameExtensions)(r.identifier,p.identifier));if(n){if(p.version===n.manifest.version)return a.log((0,y.localize)(10,null,l?`${b}@${l}`:b)),null;a.log((0,y.localize)(11,null,b,p.version))}try{return C.isBuiltin?a.log(l?(0,y.localize)(12,null,b,l):(0,y.localize)(13,null,b)):a.log(l?(0,y.localize)(14,null,b,l):(0,y.localize)(15,null,b)),await this.extensionManagementService.installFromGallery(p,{...C,installGivenVersion:!!l}),a.log((0,y.localize)(16,null,b,p.version)),i}catch(r){if((0,t.isCancellationError)(r))return a.log((0,y.localize)(17,null,b)),null;throw r}}validateExtensionKind(b,l){return!0}async validateVSIX(b,l,C){const p={id:(0,T.getGalleryExtensionId)(b.publisher,b.name)},s=(await this.extensionManagementService.getInstalled(1)).find(a=>(0,T.areSameExtensions)(p,a.identifier)&&(0,D.gt)(a.manifest.version,b.version));return s&&!l?(C.log((0,y.localize)(18,null,s.identifier.id,s.manifest.version,b.version)),!1):this.validateExtensionKind(b,C)}async uninstallExtensions(b,l,C=console){const p=async s=>{if(s instanceof k.URI){const a=await this.extensionManagementService.getManifest(s);return c(a)}return s},u=[];for(const s of b){const a=await p(s),n=(await this.extensionManagementService.getInstalled()).filter(r=>(0,T.areSameExtensions)(r.identifier,{id:a}));if(!n.length)throw new Error(`${this.notInstalled(a)}
${v}`);if(n.some(r=>r.type===0)){C.log((0,y.localize)(19,null,a));return}if(!l&&n.some(r=>r.isBuiltin)){C.log((0,y.localize)(20,null,a));return}C.log((0,y.localize)(21,null,a));for(const r of n)await this.extensionManagementService.uninstall(r),u.push(r);this.location?C.log((0,y.localize)(22,null,a,this.location)):C.log((0,y.localize)(23,null,a))}}async locateExtension(b,l=console){const C=await this.extensionManagementService.getInstalled();b.forEach(p=>{C.forEach(u=>{if(u.identifier.id===p&&u.location.scheme===P.Schemas.file){l.log(u.location.fsPath);return}})})}notInstalled(b){return this.location?(0,y.localize)(24,null,b,this.location):(0,y.localize)(25,null,b)}};d=Te([Ne(0,E.IExtensionManagementService),Ne(1,E.IExtensionGalleryService)],d),e.ExtensionManagementCLIService=d}),define(ve[203],we([0,1,7,2,20,5,62,34]),function(J,e,_,t,w,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function y(d,g){return P.URI.revive(g?g.transformIncoming(d):d)}function E(d,g){return g?g.transformOutgoingURI(d):d}function T(d,g){g=g||D.DefaultURITransformer;const b=d.manifest;return{...(0,D.transformAndReviveIncomingURIs)({...d,manifest:void 0},g),manifest:b}}function R(d,g){return g?(0,w.cloneAndChange)(d,b=>b instanceof P.URI?g.transformOutgoingURI(b):void 0):d}class h{constructor(g,b){this.service=g,this.getUriTransformer=b,this.onInstallExtension=_.Event.buffer(g.onInstallExtension,!0),this.onDidInstallExtensions=_.Event.buffer(g.onDidInstallExtensions,!0),this.onUninstallExtension=_.Event.buffer(g.onUninstallExtension,!0),this.onDidUninstallExtension=_.Event.buffer(g.onDidUninstallExtension,!0)}listen(g,b){const l=this.getUriTransformer(g);switch(b){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return _.Event.map(this.onDidInstallExtensions,C=>C.map(p=>({...p,local:p.local?R(p.local,l):p.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(g,b,l){const C=this.getUriTransformer(g);switch(b){case"zip":return this.service.zip(T(l[0],C)).then(p=>E(p,C));case"unzip":return this.service.unzip(y(l[0],C));case"install":return this.service.install(y(l[0],C),l[1]);case"getManifest":return this.service.getManifest(y(l[0],C));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(l[0]);case"installFromGallery":return this.service.installFromGallery(l[0],l[1]);case"uninstall":return this.service.uninstall(T(l[0],C),l[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(T(l[0],C));case"getInstalled":return this.service.getInstalled(l[0]).then(p=>p.map(u=>R(u,C)));case"updateMetadata":return this.service.updateMetadata(T(l[0],C),l[1]).then(p=>R(p,C));case"updateExtensionScope":return this.service.updateExtensionScope(T(l[0],C),l[1]).then(p=>R(p,C));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=h;class v extends t.Disposable{constructor(g){super();this.channel=g,this._onInstallExtension=this._register(new _.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new _.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new _.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new _.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(b=>this._onInstallExtension.fire({identifier:b.identifier,source:this.isUriComponents(b.source)?P.URI.revive(b.source):b.source}))),this._register(this.channel.listen("onDidInstallExtensions")(b=>this._onDidInstallExtensions.fire(b.map(l=>({...l,local:l.local?T(l.local,null):l.local,source:this.isUriComponents(l.source)?P.URI.revive(l.source):l.source}))))),this._register(this.channel.listen("onUninstallExtension")(b=>this._onUninstallExtension.fire(b))),this._register(this.channel.listen("onDidUninstallExtension")(b=>this._onDidUninstallExtension.fire(b)))}isUriComponents(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(g){const b=await this.getTargetPlatform();return g.allTargetPlatforms.some(l=>(0,k.isTargetPlatformCompatible)(l,g.allTargetPlatforms,b))}zip(g){return Promise.resolve(this.channel.call("zip",[g]).then(b=>P.URI.revive(b)))}unzip(g){return Promise.resolve(this.channel.call("unzip",[g]))}install(g,b){return Promise.resolve(this.channel.call("install",[g,b])).then(l=>T(l,null))}getManifest(g){return Promise.resolve(this.channel.call("getManifest",[g]))}installFromGallery(g,b){return Promise.resolve(this.channel.call("installFromGallery",[g,b])).then(l=>T(l,null))}uninstall(g,b){return Promise.resolve(this.channel.call("uninstall",[g,b]))}reinstallFromGallery(g){return Promise.resolve(this.channel.call("reinstallFromGallery",[g]))}getInstalled(g=null){return Promise.resolve(this.channel.call("getInstalled",[g])).then(b=>b.map(l=>T(l,null)))}updateMetadata(g,b){return Promise.resolve(this.channel.call("updateMetadata",[g,b])).then(l=>T(l,null))}updateExtensionScope(g,b){return Promise.resolve(this.channel.call("updateExtensionScope",[g,b])).then(l=>T(l,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=v;class c{constructor(g){this.service=g}listen(g,b){throw new Error("Invalid listen")}call(g,b,l){switch(b){case"getConfigBasedTips":return this.service.getConfigBasedTips(P.URI.revive(l[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=c}),define(ve[204],we([0,1,13,11,2,3,22,57,5,23,19,26,34,33,16,14]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const g=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends w.Disposable{constructor(C,p,u,s){super();this.fileService=p,this.extensionGalleryService=u,this.logService=s,this.extensionsDownloadDir=y.URI.file(C.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(C,p){await this.cleanUpPromise;const u=this.getName(C),s=(0,D.joinPath)(this.extensionsDownloadDir,u);if(!await this.fileService.exists(s)){const a=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(a)||await this.extensionGalleryService.download(C,a,p);try{await this.rename(a,s,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(a)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",C.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,a.path),i}}return s}async delete(C){await this.cleanUpPromise,await this.fileService.del(C)}async rename(C,p,u){try{await T.Promises.rename(C.fsPath,p.fsPath)}catch(s){if(P.isWindows&&s&&s.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${C} to ${p} with 'EPERM' error. Trying again...`),this.rename(C,p,u);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const C=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(C.children){const p=[],u=[];for(const i of C.children){const n=this.parse(i.name);n&&u.push([n,i])}const s=(0,v.groupByExtension)(u,([i])=>i),a=[];for(const i of s)i.sort((n,r)=>k.rcompare(n[0].version,r[0].version)),p.push(...i.slice(1).map(n=>n[1].resource)),a.push(i[0][1]);a.sort((i,n)=>i.mtime-n.mtime),p.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(i=>i.resource)),await _.Promises.settled(p.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(C){this.logService.error(C)}}getName(C){return this.cache?`${new v.ExtensionIdentifierWithVersion(C.identifier,C.version).key().toLowerCase()}${C.properties.targetPlatform!=="undefined"?`-${C.properties.targetPlatform}`:""}`:(0,E.generateUuid)()}parse(C){const p=g.exec(C);return p&&p[1]&&p[2]?new v.ExtensionIdentifierWithVersion({id:p[1]},p[2]):null}};b=Te([Ne(0,R.INativeEnvironmentService),Ne(1,c.IFileService),Ne(2,h.IExtensionGalleryService),Ne(3,d.ILogService)],b),e.ExtensionsDownloader=b}),define(ve[205],we([0,1,2,4,19,41]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class D extends _.Disposable{constructor(y,E){super();this.environmentService=y,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,P.MANIFEST_CACHE_FOLDER,P.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(T=>this.onDidInstallExtensions(T))),this._register(E.onDidUninstallExtension(T=>this.onDidUnInstallExtension(T)))}onDidInstallExtensions(y){y.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(y){y.error||this.invalidate()}invalidate(){w.Promises.rm(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=D}),define(ve[100],we([0,1,70,17,13,2,8,4,19,26,34,33,69,14]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let c=class extends P.Disposable{constructor(b,l,C){super();this.extensionManagementService=b,this.logService=C,this.cache=this._register(new d(l,C)),this.extensionManagementService.registerParticipant({postInstall:async p=>this.postInstallExtension(p),postUninstall:async p=>this.postUninstallExtension(p)})}async getLanguageIds(){const b=await this.cache.getLanguagePacks(),l=["en",...Object.keys(b)];return(0,t.distinct)(l)}async postInstallExtension(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",b.identifier.id),await this.update())}async postUninstallExtension(b){const l=await this.cache.getLanguagePacks();Object.keys(l).some(C=>l[C]&&l[C].extensions.some(p=>(0,R.areSameExtensions)(p.extensionIdentifier,b.identifier)))&&(this.logService.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,l]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),C=await this.cache.update(l);return!(0,t.equals)(Object.keys(b),Object.keys(C))}};c=Te([Ne(0,T.IExtensionManagementService),Ne(1,E.INativeEnvironmentService),Ne(2,v.ILogService)],c),e.LocalizationsService=c;let d=class extends P.Disposable{constructor(b,l){super();this.logService=l,this.languagePacks={},this.languagePacksFilePath=(0,k.join)(b.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new w.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(b){return this.withLanguagePacks(l=>{Object.keys(l).forEach(C=>delete l[C]),this.createLanguagePacksFromExtensions(l,...b)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(b,...l){for(const C of l)C&&C.manifest&&C.manifest.contributes&&C.manifest.contributes.localizations&&C.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(b,C);Object.keys(b).forEach(C=>this.updateHash(b[C]))}createLanguagePacksFromExtension(b,l){const C=l.identifier,p=l.manifest.contributes&&l.manifest.contributes.localizations?l.manifest.contributes.localizations:[];for(const u of p)if(l.location.scheme===D.Schemas.file&&(0,h.isValidLocalization)(u)){let s=b[u.languageId];s||(s={hash:"",extensions:[],translations:{}},b[u.languageId]=s);let a=s.extensions.filter(i=>(0,R.areSameExtensions)(i.extensionIdentifier,C))[0];a?a.version=l.manifest.version:s.extensions.push({extensionIdentifier:C,version:l.manifest.version});for(const i of u.translations)s.translations[i.id]=(0,k.join)(l.location.fsPath,i.path)}}updateHash(b){if(b){const l=(0,_.createHash)("md5");for(const C of b.extensions)l.update(C.extensionIdentifier.uuid||C.extensionIdentifier.id).update(C.version);b.hash=l.digest("hex")}}withLanguagePacks(b=()=>null){return this.languagePacksFileLimiter.queue(()=>{let l=null;return y.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,C=>C.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(C)).then(C=>{try{return JSON.parse(C)}catch{return{}}}).then(C=>(l=b(C),C)).then(C=>{for(const u of Object.keys(C))C[u]||delete C[u];this.languagePacks=C,this.initializedCache=!0;const p=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",p),y.Promises.writeFile(this.languagePacksFilePath,p)}).then(()=>l,C=>this.logService.error(C))})}};d=Te([Ne(0,E.INativeEnvironmentService),Ne(1,v.ILogService)],d)}),define(ve[47],we([0,1,15,167,46,6,35]),function(J,e,_,t,w,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,P.createDecorator)("requestService");function k(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}e.isSuccess=k;function y(c){return c.res.statusCode===204}async function E(c){if(!k(c))throw new Error("Server returned "+c.res.statusCode);return y(c)?null:(await(0,_.streamToBuffer)(c.stream)).toString()}e.asText=E;async function T(c){if(!k(c))throw new Error("Server returned "+c.res.statusCode);if(y(c))return null;const g=(await(0,_.streamToBuffer)(c.stream)).toString();try{return JSON.parse(g)}catch(b){throw b.message+=`:
`+g,b}}e.asJson=T;function R(c){v(c)}e.updateProxyConfigurationsScope=R;let h;function v(c){const d=D.Registry.as(w.Extensions.Configuration),g=h;h={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},d.updateConfigurations({add:[h],remove:g?[g]:[]})}v(2)}),define(ve[206],we([0,1,21,8,16,47]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let D=class{constructor(y,E){this.requestService=y,this.fileService=E}async download(y,E,T=_.CancellationToken.None){if(y.scheme===t.Schemas.file||y.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(y,E);return}const R={type:"GET",url:y.toString()},h=await this.requestService.request(R,T);if(h.res.statusCode===200)await this.fileService.writeFile(E,h.stream);else{const v=await(0,P.asText)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${v}`)}}};D=Te([Ne(0,P.IRequestService),Ne(1,w.IFileService)],D),e.DownloadService=D}),define(ve[207],we([0,1,15,21]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class w{constructor(k){this.service=k}listen(k,y){throw new Error("Invalid listen")}call(k,y,E){switch(y){case"request":return this.service.request(E[0],t.CancellationToken.None).then(async({res:T,stream:R})=>{const h=await(0,_.streamToBuffer)(R);return[{statusCode:T.statusCode,headers:T.headers},h]})}throw new Error("Invalid call")}}e.RequestChannel=w;class P{constructor(k){this.channel=k}async request(k,y){return P.request(this.channel,k,y)}static async request(k,y,E){const[T,R]=await k.call("request",[y]);return{res:T,stream:(0,_.bufferToStream)(R)}}}e.RequestChannelClient=P}),define(ve[208],we([0,1,71,12]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function w(D,k){return D.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:D.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function P(D,k,y={}){const E=(0,_.parse)(D),T=y.proxyUrl||w(E,k);if(!T)return null;const R=(0,_.parse)(T);if(!/^https?:$/.test(R.protocol||""))return null;const h={host:R.hostname||"",port:R.port||(R.protocol==="https"?"443":"80"),auth:R.auth,rejectUnauthorized:(0,t.isBoolean)(y.strictSSL)?y.strictSSL:!0};return E.protocol==="http:"?new(await new Promise((v,c)=>{J(["http-proxy-agent"],v,c)}))(h):new(await new Promise((v,c)=>{J(["https-proxy-agent"],v,c)}))(h)}e.getProxyAgent=P}),define(ve[209],we([0,1,13,7,2,44,12,137,6]),function(J,e,_,t,w,P,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,y.createDecorator)("storageService");var T;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(T=e.WillSaveStateReason||(e.WillSaveStateReason={}));var R;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(R=e.StorageScope||(e.StorageScope={}));var h;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(h=e.StorageTarget||(e.StorageTarget={}));class v extends w.Disposable{constructor(b={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new _.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new w.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,_.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,w.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,P.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,l){l===E?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:l,target:this.getKeyTargets(b)[l]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,l,C){return this.getStorage(l)?.get(b,C)}getBoolean(b,l,C){return this.getStorage(l)?.getBoolean(b,C)}getNumber(b,l,C){return this.getStorage(l)?.getNumber(b,C)}store(b,l,C,p){if((0,D.isUndefinedOrNull)(l)){this.remove(b,C);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,C,p),this.getStorage(C)?.set(b,l)})}remove(b,l){this.withPausedEmitters(()=>{this.updateKeyTarget(b,l,void 0),this.getStorage(l)?.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,l){const C=[],p=this.getKeyTargets(b);for(const u of Object.keys(p))p[u]===l&&C.push(u);return C}updateKeyTarget(b,l,C){const p=this.getKeyTargets(l);typeof C=="number"?p[b]!==C&&(p[b]=C,this.getStorage(l)?.set(E,JSON.stringify(p))):typeof p[b]=="number"&&(delete p[b],this.getStorage(l)?.set(E,JSON.stringify(p)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const l=this.get(E,b);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=T.NONE){this._onWillSaveState.fire({reason:b});const l=this.getStorage(0),C=this.getStorage(1);switch(b){case T.NONE:await _.Promises.settled([l?.whenFlushed()??Promise.resolve(),C?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await _.Promises.settled([l?.flush(0)??Promise.resolve(),C?.flush(0)??Promise.resolve()]);break}}async logStorage(){const b=this.getStorage(0)?.items??new Map,l=this.getStorage(1)?.items??new Map;return d(b,l,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=v,v.DEFAULT_FLUSH_INTERVAL=60*1e3;class c extends v{constructor(){super();this.globalStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}e.InMemoryStorageService=c;async function d(g,b,l,C){const p=o=>{try{return JSON.parse(o)}catch{return o}},u=new Map,s=new Map;g.forEach((o,f)=>{u.set(f,o),s.set(f,p(o))});const a=new Map,i=new Map;b.forEach((o,f)=>{a.set(f,o),i.set(f,p(o))}),console.group(`Storage: Global (path: ${l})`);let n=[];u.forEach((o,f)=>{n.push({key:f,value:o})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${C})`);let r=[];a.forEach((o,f)=>{r.push({key:f,value:o})}),console.table(r),console.groupEnd(),console.log(i)}e.logStorage=d}),define(ve[210],we([0,1,3,24,5,23]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(E){if(_.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function k(E,T,R,h,v,c,d,g,b,l){const C=Object.create(null);C["common.machineId"]=d,C.sessionID=(0,P.generateUuid)()+Date.now(),C.commitHash=v,C.version=c,C["common.platformVersion"]=(T||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),C["common.platform"]=(0,_.PlatformToString)(_.platform),C["common.nodePlatform"]=t.platform,C["common.nodeArch"]=h,C["common.product"]=l||"desktop";const p=y(g||[]);p&&(C["common.msftInternal"]=p);let u=0;const s=Date.now();Object.defineProperties(C,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),_.isLinuxSnap&&(C["common.snap"]="true");const a=D(R);a&&(C["common.platformDetail"]=a);try{const i=await E.readFile(w.URI.file(b));C["common.source"]=i.value.toString().slice(0,30)}catch{}return C}e.resolveCommonProperties=k;function y(E){const T=t.env.USERDNSDOMAIN;if(!T)return!1;const R=T.toLowerCase();return E.some(h=>R===h)}e.verifyMicrosoftInternalDomain=y}),define(ve[211],we([0,1,17,11,2,20]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var D;(function(y){function E(T,R){return T.callstack<R.callstack?-1:T.callstack>R.callstack?1:0}y.compare=E})(D=e.ErrorEvent||(e.ErrorEvent={}));class k{constructor(E,T=k.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new w.DisposableStore,this._telemetryService=E,this._flushDelay=T;const R=t.errorHandler.addListener(h=>this._onErrorEvent(h));this._disposables.add((0,w.toDisposable)(R)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(E){if(!E)return;E.detail&&E.detail.stack&&(E=E.detail);let T=Array.isArray(E.stack)?E.stack.join(`
`):E.stack,R=E.message?E.message:(0,P.safeStringify)(E);!T||this._enqueue({msg:R,callstack:T})}_enqueue(E){const T=(0,_.binarySearch)(this._buffer,E,D.compare);T<0?(E.count=1,this._buffer.splice(~T,0,E)):(this._buffer[T].count||(this._buffer[T].count=0),this._buffer[T].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let E of this._buffer)this._telemetryService.publicLogError2("UnhandledError",E);this._buffer.length=0}}e.default=k,k.ERROR_FLUSH_TIMEOUT=5*1e3}),define(ve[29],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,_.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,_.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var w;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(w=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ve[212],we([0,1,25,51,13,38,8,4,3,5,81,19,84,186,16,32,29]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function b(s,a){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],n=new Map,r=new Map,o=2e4;function f(I,F,U,W){const m=F.substring(I.length+1);return w.Promises.withAsyncBody(async L=>{let M;try{M=await R.Promises.readdir(F,{withFileTypes:!0})}catch{L();return}if(W.count>=o){W.count+=M.length,W.maxReached=!0,L();return}let Y=M.length;if(Y===0){L();return}let $=M;W.count+M.length>o&&(W.maxReached=!0,Y=o-W.count,$=M.slice(0,Y)),W.count+=M.length;for(const G of $)if(G.isDirectory()){if(U.includes(G.name)||await f(I,(0,k.join)(F,G.name),U,W),--Y==0){L();return}}else{const ie=G.name.lastIndexOf(".");if(ie>=0){const B=G.name.substring(ie+1);B&&n.set(B,(n.get(B)??0)+1)}for(const B of i)B.relativePathPattern?.test(m)!==!1&&B.filePattern.test(G.name)&&r.set(B.tag,(r.get(B.tag)??0)+1);if(--Y==0){L();return}}})}const S={count:0,maxReached:!1};await f(s,s,a,S);const A=await p(s);return{configFiles:l(r),fileTypes:l(n),fileCount:S.count,maxFilesReached:S.maxReached,launchConfigFiles:A}}e.collectWorkspaceStats=b;function l(s){return[...t.Iterable.map(s.entries(),([a,i])=>({name:a,count:i}))].sort((a,i)=>i.count-a.count)}function C(){const s={os:`${_.type()} ${_.arch()} ${_.release()}`,memory:`${(_.totalmem()/c.ByteSize.GB).toFixed(2)}GB (${(_.freemem()/c.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(T.virtualMachineHint.value()*100)}%`},a=_.cpus();return a&&a.length>0&&(s.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),s}e.getMachineInfo=C;async function p(s){try{const a=new Map,i=(0,k.join)(s,".vscode","launch.json"),n=await R.Promises.readFile(i),r=[],o=(0,P.parse)(n.toString(),r);if(r.length)return console.log(`Unable to parse ${i}`),[];if((0,P.getNodeType)(o)==="object"&&o.configurations)for(const f of o.configurations){const S=f.type;S&&(a.has(S)?a.set(S,a.get(S)+1):a.set(S,1))}return l(a)}catch{return[]}}e.collectLaunchConfigs=p;let u=class{constructor(a,i){this.telemetryService=a,this.productService=i}formatMachineInfo(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}formatEnvironment(a){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${_.type()} ${_.arch()} ${_.release()}`);const n=_.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(_.totalmem()/c.ByteSize.GB).toFixed(2)}GB (${(_.freemem()/c.ByteSize.GB).toFixed(2)}GB free)`),y.isWindows||i.push(`Load (avg):       ${_.loadavg().map(r=>Math.round(r)).join(", ")}`),i.push(`VM:               ${Math.round(T.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,h.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async n=>{let[r,o]=n,f=this.formatProcessList(a,r);return i.forEach(S=>{if((0,v.isRemoteDiagnosticError)(S))f+=`
${S.errorMessage}`,o+=`
${S.errorMessage}`;else if(f+=`

Remote: ${S.hostName}`,S.processes&&(f+=`
${this.formatProcessList(a,S.processes)}`),S.workspaceMetadata){o+=`
|  Remote: ${S.hostName}`;for(const A of Object.keys(S.workspaceMetadata)){const I=S.workspaceMetadata[A];let F=`${I.fileCount} files`;I.maxFilesReached&&(F=`more than ${F}`),o+=`|    Folder (${A}): ${F}`,o+=this.formatWorkspaceStats(I)}}}),{processInfo:f,workspaceInfo:o}})}async getSystemInfo(a,i){const{memory:n,vmHint:r,os:o,cpus:f}=C(),S={os:o,memory:n,cpus:f,vmHint:r,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return y.isWindows||(S.load=`${_.loadavg().map(A=>Math.round(A)).join(", ")}`),y.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(a,i){const n=[];return(0,h.listProcesses)(a.mainPID).then(async r=>(n.push(""),n.push(this.formatEnvironment(a)),n.push(""),n.push(this.formatProcessList(a,r)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(a))),i.forEach(o=>{if((0,v.isRemoteDiagnosticError)(o))n.push(`
${o.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${o.hostName}`),n.push(this.formatMachineInfo(o.machineInfo)),o.processes&&n.push(this.formatProcessList(a,o.processes)),o.workspaceMetadata)for(const f of Object.keys(o.workspaceMetadata)){const S=o.workspaceMetadata[f];let A=`${S.fileCount} files`;S.maxFilesReached&&(A=`more than ${A}`),n.push(`Folder (${f}): ${A}`),n.push(this.formatWorkspaceStats(S))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(a){const i=[],n=60;let r=0;const o=(I,F)=>{const U=` ${I}(${F})`;r+U.length>n?(i.push(f),f="|                 ",r=f.length):r+=U.length,f+=U};let f="|      File types:";const S=10;let A=a.fileTypes.length>S?S:a.fileTypes.length;for(let I=0;I<A;I++){const F=a.fileTypes[I];o(F.name,F.count)}if(i.push(f),a.configFiles.length>=0&&(f="|      Conf files:",r=0,a.configFiles.forEach(I=>{o(I.name,I.count)}),i.push(f)),a.launchConfigFiles.length>0){let I="|      Launch Configs:";a.launchConfigFiles.forEach(F=>{I+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),i.push(I)}return i.join(`
`)}expandGPUFeatures(a){const i=Math.max(...Object.keys(a).map(n=>n.length));return Object.keys(a).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${a[n]}`).join(`
                  `)}formatWorkspaceMetadata(a){const i=[],n=[];return a.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(i.push(`|  Window (${r.title})`),r.folderURIs.forEach(o=>{const f=E.URI.revive(o);if(f.scheme===D.Schemas.file){const S=f.fsPath;n.push(b(S,["node_modules",".git"]).then(A=>{let I=`${A.fileCount} files`;A.maxFilesReached&&(I=`more than ${I}`),i.push(`|    Folder (${(0,k.basename)(S)}): ${I}`),i.push(this.formatWorkspaceStats(A))}).catch(A=>{i.push(`|      Error: Unable to collect workspace stats for folder ${S} (${A.toString()})`)}))}else i.push(`|    Folder (${f.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(r=>i.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(a,i){const n=new Map;a.windows.forEach(o=>n.set(o.pid,o.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(a.mainPID,n,r,i,0),r.join(`
`)}formatProcessItem(a,i,n,r,o){const f=o===0;let S;f?S=r.pid===a?`${this.productService.applicationName} main`:"remote agent":(S=`${"  ".repeat(o)} ${r.name}`,r.name==="window"&&(S=`${S} (${i.get(r.pid)})`));const A=process.platform==="win32"?r.mem:_.totalmem()*(r.mem/100);n.push(`${r.load.toFixed(0).padStart(5," ")}	${(A/c.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(r.children)&&r.children.forEach(I=>this.formatProcessItem(a,i,n,I,o+1))}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const n=E.URI.revive(i);if(n.scheme!==D.Schemas.file)continue;const r=n.fsPath;try{const o=await b(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:f.name,count:f.count})}),o.launchConfigFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:f.name,count:f.count})}),o.configFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:f.name,count:f.count})})}catch{}}}};u=Te([Ne(0,g.ITelemetryService),Ne(1,d.IProductService)],u),e.DiagnosticsService=u}),define(ve[213],we([0,1,17,13,21,11,7,2,3,12,5,155,34,33,14,32,29]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let b=class extends k.Disposable{constructor(a,i,n,r){super();this.galleryService=a,this.telemetryService=i,this.logService=n,this.productService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,k.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const i=await this.getTargetPlatform();return a.allTargetPlatforms.some(n=>(0,h.isTargetPlatformCompatible)(n,a.allTargetPlatforms,i))}async installFromGallery(a,i={}){try{if(!this.galleryService.isEnabled())throw new h.ExtensionManagementError(R.localize(0,null),h.ExtensionManagementErrorCode.Internal);const n=await this.checkAndGetCompatibleVersion(a,!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(n.manifest,n.extension,i)}catch(n){throw p(this.telemetryService,"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(a),void 0,n),this.logService.error("Failed to install extension.",a.identifier.id),this.logService.error(n),C(n)}}async uninstall(a,i={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,i)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(R.localize(1,null));const i=await this.getTargetPlatform(),[n]=await this.galleryService.getExtensions([{...a.identifier,preRelease:a.preRelease}],{targetPlatform:i,compatible:!0},w.CancellationToken.None);if(!n)throw new Error(R.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const a=new Date().getTime();return(!this.extensionsControlManifest||a-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=a),this.extensionsControlManifest}registerParticipant(a){this.participants.push(a)}async installExtension(a,i,n){if(!T.URI.isUri(i)){let A=this.installingExtensions.get(new v.ExtensionIdentifierWithVersion(i.identifier,i.version).key());if(A)return this.logService.info("Extensions is already requested to install",i.identifier.id),A.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],o=[],f=this.createInstallExtensionTask(a,i,n);T.URI.isUri(i)||this.installingExtensions.set(new v.ExtensionIdentifierWithVersion(f.identifier,a.version).key(),f),this._onInstallExtension.fire({identifier:f.identifier,source:i}),this.logService.info("Installing extension:",f.identifier.id),r.push({task:f,manifest:a});let S=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",f.identifier.id);else try{const I=await this.getAllDepsAndPackExtensionsToInstall(f.identifier,a,!!n.installOnlyNewlyAddedFromExtensionPack,!!n.installPreReleaseVersion);for(const{gallery:F,manifest:U}of I)if(S=S||!!U.extensionDependencies?.some(W=>(0,v.areSameExtensions)({id:W},f.identifier)),this.installingExtensions.has(new v.ExtensionIdentifierWithVersion(F.identifier,F.version).key()))this.logService.info("Extension is already requested to install",F.identifier.id);else{const W=this.createInstallExtensionTask(U,F,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new v.ExtensionIdentifierWithVersion(W.identifier,U.version).key(),W),this._onInstallExtension.fire({identifier:W.identifier,source:F}),this.logService.info("Installing extension:",W.identifier.id),r.push({task:W,manifest:U})}}catch(I){if(T.URI.isUri(f.source))(0,_.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",f.identifier.id,I.message),(0,_.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",f.identifier.id,I.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",f.identifier.id),I}const A=r.reduce((I,{task:F,manifest:U})=>(I.set(F.identifier.id.toLowerCase(),{task:F,manifest:U}),I),new Map);for(;A.size;){let I;const F=[...A.values()].filter(({manifest:U})=>!U.extensionDependencies?.some(W=>A.has(W.toLowerCase())));F.length?I=A.size===1?F:F.filter(({task:U})=>!(U===f&&!S)):(this.logService.info("Found extensions with circular dependencies",F.map(({task:U})=>U.identifier.id)),I=[...A.values()]),await this.joinAllSettled(I.map(async({task:U})=>{const W=new Date().getTime(),m=(0,E.isUndefined)(n.operation)?U.operation:n.operation;try{const L=await U.run();if(await this.joinAllSettled(this.participants.map(M=>M.postInstall(L,U.source,n,w.CancellationToken.None))),!T.URI.isUri(U.source)&&(p(this.telemetryService,m===3?"extensionGallery:update":"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(U.source),new Date().getTime()-W,void 0),y.isWeb&&m!==3))try{await this.galleryService.reportStatistic(L.manifest.publisher,L.manifest.name,L.manifest.version,"install")}catch{}o.push({local:L,identifier:U.identifier,operation:m,source:U.source})}catch(L){throw T.URI.isUri(U.source)||p(this.telemetryService,m===3?"extensionGallery:update":"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(U.source),new Date().getTime()-W,L),this.logService.error("Error while installing the extension:",U.identifier.id),L}finally{A.delete(U.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:I})=>this.logService.info("Extension installed successfully:",I.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:I})=>(0,v.areSameExtensions)(I,f.identifier))[0].local}catch(A){if(r.forEach(({task:I})=>I.cancel()),o.length)try{const I=await Promise.allSettled(o.map(({local:F})=>this.createUninstallExtensionTask(F,{versionOnly:!0}).run()));for(let F=0;F<I.length;F++){const U=I[F],{identifier:W}=o[F];U.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",W.id):this.logService.warn("Rollback: Error while uninstalling extension",W.id,(0,P.getErrorMessage)(U.reason))}}catch(I){this.logService.warn("Error while rolling back extensions",(0,P.getErrorMessage)(I),o.map(({identifier:F})=>F.id))}throw this._onDidInstallExtensions.fire(r.map(({task:I})=>({identifier:I.identifier,operation:2,source:I.source}))),A}finally{for(const{task:A,manifest:I}of r)if(!T.URI.isUri(A.source)){const F=new v.ExtensionIdentifierWithVersion(A.identifier,I.version).key();this.installingExtensions.delete(F)||this.logService.warn("Installation task is not found in the cache",F)}}}async joinAllSettled(a){const i=[],n=[],r=await Promise.allSettled(a);for(const o of r)o.status==="fulfilled"?i.push(o.value):n.push(o.reason);if(n.length)throw l(n);return i}async getAllDepsAndPackExtensionsToInstall(a,i,n,r){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const f=[a,...o.map(I=>I.identifier)],S=[],A=async(I,F)=>{const U=F.extensionDependencies||[],W=[...U];if(F.extensionPack){const m=n?o.find(L=>(0,v.areSameExtensions)(L.identifier,I)):void 0;for(const L of F.extensionPack)m&&m.manifest.extensionPack&&m.manifest.extensionPack.some(M=>(0,v.areSameExtensions)({id:M},{id:L}))||W.every(M=>!(0,v.areSameExtensions)({id:M},{id:L}))&&W.push(L)}if(W.length){const m=[...f,...S.map(M=>M.gallery.identifier)],L=W.filter(M=>m.every(Y=>!(0,v.areSameExtensions)(Y,{id:M})));if(L.length){const M=await this.galleryService.getExtensions(L.map(Y=>({id:Y,preRelease:r})),w.CancellationToken.None);for(const Y of M){if(m.find(ie=>(0,v.areSameExtensions)(ie,Y.identifier)))continue;const $=U.some(ie=>(0,v.areSameExtensions)({id:ie},Y.identifier));let G;try{G=await this.checkAndGetCompatibleVersion(Y,!0,r)}catch(ie){if(ie instanceof h.ExtensionManagementError&&ie.code===h.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!$){this.logService.info("Skipping the packed extension as it cannot be installed",Y.identifier.id);continue}else throw ie}S.push({gallery:G.extension,manifest:G.manifest}),await A(G.extension.identifier,G.manifest)}}}};return await A(a,i),o=await this.getInstalled(),S.filter(I=>!o.some(F=>(0,v.areSameExtensions)(F.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(a,i,n){const r=await this.getExtensionsControlManifest();if((0,v.getMaliciousExtensionsSet)(r).has(a.identifier.id))throw new h.ExtensionManagementError(R.localize(3,null,a.identifier.id),h.ExtensionManagementErrorCode.Malicious);if(!!r.unsupportedPreReleaseExtensions&&!!r.unsupportedPreReleaseExtensions[a.identifier.id])throw new h.ExtensionManagementError(R.localize(4,null,a.identifier.id,r.unsupportedPreReleaseExtensions[a.identifier.id].displayName),h.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(a)){const S=await this.getTargetPlatform();throw new h.ExtensionManagementError(R.localize(5,null,a.identifier.id,this.productService.nameLong,(0,h.TargetPlatformToString)(S)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(a,i,n);if(o){if(n&&i&&a.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new h.ExtensionManagementError(R.localize(6,null,a.identifier.id,this.productService.nameLong,this.productService.version),h.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!n&&a.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([a.identifier],w.CancellationToken.None))[0]?new h.ExtensionManagementError(R.localize(7,null,a.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.ExtensionManagementError(R.localize(8,null,a.identifier.id,this.productService.nameLong,this.productService.version),h.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",o.identifier.id);const f=await this.galleryService.getManifest(o,w.CancellationToken.None);if(f===null)throw new h.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(f.version!==o.version)throw new h.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:f}}async getCompatibleVersion(a,i,n){const r=await this.getTargetPlatform();let o=null;return i&&a.hasPreReleaseVersion&&a.properties.isPreReleaseVersion!==n&&(o=(await this.galleryService.getExtensions([{...a.identifier,preRelease:n}],{targetPlatform:r,compatible:!0},w.CancellationToken.None))[0]||null),!o&&await this.galleryService.isExtensionCompatible(a,n,r)&&(o=a),!o&&i&&(o=await this.galleryService.getCompatibleExtension(a,n,r)),o}async unininstallExtension(a,i){const n=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),n.waitUntilTaskIsFinished();const r=(A,I)=>{const F=this.createUninstallExtensionTask(A,I);return this.uninstallingExtensions.set(F.extension.identifier.id.toLowerCase(),F),this.logService.info("Uninstalling extension:",A.identifier.id),this._onUninstallExtension.fire(A.identifier),F},o=(A,I)=>{I?this.logService.error("Failed to uninstall extension:",A.identifier.id,I.message):this.logService.info("Successfully uninstalled extension:",A.identifier.id),p(this.telemetryService,"extensionGallery:uninstall",(0,v.getLocalExtensionTelemetryData)(A),void 0,I),this._onDidUninstallExtension.fire({identifier:A.identifier,error:I?.code})},f=[],S=[];try{f.push(r(a,{}));const A=await this.getInstalled(1);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const I=this.getAllPackExtensionsToUninstall(a,A);for(const F of I)this.uninstallingExtensions.has(F.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",F.identifier.id):f.push(r(F,{}))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(f.map(I=>I.extension),A,a),await this.joinAllSettled(f.map(async I=>{try{if(await I.run(),await this.joinAllSettled(this.participants.map(F=>F.postUninstall(I.extension,i,w.CancellationToken.None))),I.extension.identifier.uuid)try{await this.galleryService.reportStatistic(I.extension.manifest.publisher,I.extension.manifest.name,I.extension.manifest.version,"uninstall")}catch{}o(I.extension)}catch(F){const U=F instanceof h.ExtensionManagementError?F:new h.ExtensionManagementError((0,P.getErrorMessage)(F),h.ExtensionManagementErrorCode.Internal);throw o(I.extension,U),U}finally{S.push(I)}}))}catch(A){const I=A instanceof h.ExtensionManagementError?A:new h.ExtensionManagementError((0,P.getErrorMessage)(A),h.ExtensionManagementErrorCode.Internal);for(const F of f){try{F.cancel()}catch{}S.includes(F)||o(F.extension,I)}throw I}finally{for(const A of f)this.uninstallingExtensions.delete(A.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",A.extension.identifier.id)}}checkForDependents(a,i,n){for(const r of a){const o=this.getDependents(r,i);if(o.length){const f=o.filter(S=>!a.some(A=>(0,v.areSameExtensions)(A.identifier,S.identifier)));if(f.length)throw new Error(this.getDependentsErrorMessage(r,f,n))}}}getDependentsErrorMessage(a,i,n){return n===a?i.length===1?R.localize(9,null,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?R.localize(10,null,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):R.localize(11,null,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?R.localize(12,null,n.manifest.displayName||n.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?R.localize(13,null,n.manifest.displayName||n.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):R.localize(14,null,n.manifest.displayName||n.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(a,i,n=[]){if(n.indexOf(a)!==-1)return[];n.push(a);const r=a.manifest.extensionPack?a.manifest.extensionPack:[];if(r.length){const o=i.filter(S=>!S.isBuiltin&&r.some(A=>(0,v.areSameExtensions)({id:A},S.identifier))),f=[];for(const S of o)f.push(...this.getAllPackExtensionsToUninstall(S,i,n));return[...o,...f]}return[]}getDependents(a,i){return i.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(r=>(0,v.areSameExtensions)({id:r},a.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",a),a}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};b=Te([Ne(0,h.IExtensionGalleryService),Ne(1,g.ITelemetryService),Ne(2,c.ILogService),Ne(3,d.IProductService)],b),e.AbstractExtensionManagementService=b;function l(s){const a=Array.isArray(s)?s:[s];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((i,n)=>new Error(`${i.message}${i.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}e.joinErrors=l;function C(s){if(s instanceof h.ExtensionManagementError)return s;const a=new h.ExtensionManagementError(s.message,h.ExtensionManagementErrorCode.Internal);return a.stack=s.stack,a}function p(s,a,i,n,r){const o=r?r instanceof h.ExtensionManagementError?r.code:h.ExtensionManagementErrorCode.Internal:void 0;s.publicLogError(a,{...i,success:!r,duration:n,errorcode:o})}e.reportTelemetry=p;class u{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(a=>new Promise((i,n)=>{const r=a.onCancellationRequested(()=>{r.dispose(),n((0,P.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=u}),define(ve[42],we([0,1,20,12,28,29]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class D{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(b,l){return Promise.resolve(void 0)}publicLog2(b,l){return this.publicLog(b,l)}publicLogError(b,l){return Promise.resolve(void 0)}publicLogError2(b,l){return this.publicLogError(b,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=D,e.NullTelemetryService=new D;class k{async publicLog(b,l,C){}async publicLogError(b,l,C){}}e.NullEndpointTelemetryService=k,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(g,b){return b.onDidChangeConfiguration(l=>{l.source!==6&&g.publicLog2("updateConfiguration",{configurationSource:(0,w.ConfigurationTargetToString)(l.source),configurationKeys:c(l.sourceConfig)})})}e.configurationTelemetry=y;function E(g,b){return!(b.disableTelemetry||!g.enableTelemetry||b.extensionTestsLocationURI)}e.supportsTelemetry=E;function T(g){const b=g.getValue(P.TELEMETRY_SETTING_ID),l=g.getValue("telemetry.enableCrashReporter");if(g.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=T;function R(g){const b=Object.create(null),l=Object.create(null),C=Object.create(null);v(g,C);for(let p in C){p=p.length>150?p.substr(p.length-149):p;const u=C[p];typeof u=="number"?l[p]=u:typeof u=="boolean"?l[p]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${u.length}`),b[p]=u.substring(0,8191)):typeof u!="undefined"&&u!==null&&(b[p]=u)}return{properties:b,measurements:l}}e.validateTelemetryData=R;function h(g){if(!g)return"none";let b="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(C=>{g.indexOf(`${C}+`)===0&&(b=C)}),b}e.cleanRemoteAuthority=h;function v(g,b,l=0,C){if(!!g)for(let p of Object.getOwnPropertyNames(g)){const u=g[p],s=C?C+p:p;Array.isArray(u)?b[s]=(0,_.safeStringify)(u):u instanceof Date?b[s]=u.toISOString():(0,t.isObject)(u)?l<2?v(u,b,l+1,s+"."):b[s]=(0,_.safeStringify)(u):b[s]=u}}function c(g){if(!g)return[];const b=[];return d(b,"",g),b}function d(g,b,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(C=>d(g,b?`${b}.${C}`:C,l[C])):g.push(b)}}),define(ve[214],we([0,1,183,42]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function w(P,D,k,y,E,T){const R={"X-Market-Client-Id":`VSCode ${P}`,"User-Agent":`VSCode ${P} (${D.nameShort})`},h=await(0,_.getServiceMachineId)(k,E,T);return(0,t.supportsTelemetry)(D,k)&&(0,t.getTelemetryLevel)(y)===3&&(R["X-Market-User-Id"]=h),R}e.resolveMarketplaceHeaders=w}),define(ve[101],we([0,1,17,21,11,20,3,24,12,5,28,26,34,33,65,16,14,32,47,214,209,29]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c,d,g,b,l,C,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const s=D.isWeb?"web":(0,h.getTargetPlatform)(D.platform,k.arch);var a;(function(j){j[j.None=0]="None",j[j.IncludeVersions=1]="IncludeVersions",j[j.IncludeFiles=2]="IncludeFiles",j[j.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",j[j.IncludeSharedAccounts=8]="IncludeSharedAccounts",j[j.IncludeVersionProperties=16]="IncludeVersionProperties",j[j.ExcludeNonValidated=32]="ExcludeNonValidated",j[j.IncludeInstallationTargets=64]="IncludeInstallationTargets",j[j.IncludeAssetUri=128]="IncludeAssetUri",j[j.IncludeStatistics=256]="IncludeStatistics",j[j.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",j[j.Unpublished=4096]="Unpublished",j[j.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(a||(a={}));function i(...j){return String(j.reduce((V,ne)=>V|ne,0))}var n;(function(j){j[j.Tag=1]="Tag",j[j.ExtensionId=4]="ExtensionId",j[j.Category=5]="Category",j[j.ExtensionName=7]="ExtensionName",j[j.Target=8]="Target",j[j.Featured=9]="Featured",j[j.SearchText=10]="SearchText",j[j.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},S={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class A{constructor(V=S){this.state=V}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(V,ne=this.state.pageSize){return new A({...this.state,pageNumber:V,pageSize:ne})}withFilter(V,...ne){const me=[...this.state.criteria,...ne.length?ne.map(De=>({filterType:V,value:De})):[{filterType:V}]];return new A({...this.state,criteria:me})}withSortBy(V){return new A({...this.state,sortBy:V})}withSortOrder(V){return new A({...this.state,sortOrder:V})}withFlags(...V){return new A({...this.state,flags:V.reduce((ne,me)=>ne|me,0)})}withAssetTypes(...V){return new A({...this.state,assetTypes:V})}get raw(){const{criteria:V,pageNumber:ne,pageSize:me,sortBy:De,sortOrder:ae,flags:fe,assetTypes:pe}=this.state;return{filters:[{criteria:V,pageNumber:ne,pageSize:me,sortBy:De,sortOrder:ae}],assetTypes:pe,flags:fe}}get searchText(){const V=this.state.criteria.filter(ne=>ne.filterType===n.SearchText)[0];return V&&V.value?V.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(V=>String(V.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function I(j,V){const ne=(j||[]).filter(me=>me.statisticName===V)[0];return ne?ne.value:0}function F(j){const V="Microsoft.VisualStudio.Code.Translation.";return j.files.filter(me=>me.assetType.indexOf(V)===0).reduce((me,De)=>{const ae=L(j,De.assetType);return ae&&me.push([De.assetType.substring(V.length),ae]),me},[])}function U(j){if(j.properties){const V=j.properties.filter(De=>De.key===r.Repository),ne=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),me=V.filter(De=>ne.test(De.value))[0];return me?{uri:me.value,fallbackUri:me.value}:null}return L(j,r.Repository)}function W(j){return{uri:`${j.fallbackAssetUri}/${r.VSIX}?redirect=true${j.targetPlatform?`&targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${r.VSIX}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}}function m(j){const V=L(j,r.Icon);if(V)return V;const ne=h.DefaultIconPath;return{uri:ne,fallbackUri:ne}}function L(j,V){return j.files.filter(me=>me.assetType===V)[0]?{uri:`${j.assetUri}/${V}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${V}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}:null}function M(j,V){const ne=j.properties?j.properties.filter(De=>De.key===V):[],me=ne.length>0&&ne[0].value;return me?me.split(",").map(De=>(0,v.adoptToGalleryExtensionId)(De)):[]}function Y(j){const V=j.properties?j.properties.filter(ne=>ne.key===o.Engine):[];return V.length>0&&V[0].value||""}function $(j){const V=j.properties?j.properties.filter(ne=>ne.key===o.PreRelease):[];return V.length>0&&V[0].value==="true"}function G(j){const V=j.properties?j.properties.filter(me=>me.key===o.LocalizedLanguages):[],ne=V.length>0&&V[0].value||"";return ne?ne.split(","):[]}function ie(j){return j.indexOf("preview")!==-1}function B(j){return j.targetPlatform?(0,h.toTargetPlatform)(j.targetPlatform):"undefined"}function q(j){const V=(0,_.distinct)(j.versions.map(B)),ne=!!j.tags?.includes(h.WEB_EXTENSION_TAG),me=V.indexOf("web");return ne?me===-1&&V.push("web"):me!==-1&&V.splice(me,1),V}function ee(j,V){const ne=(0,h.getFallbackTargetPlarforms)(V);for(let me=0;me<j.length;me++){const De=j[me];if(De.version===j[me-1]?.version){let ae=me;const fe=B(De);if(fe===V)for(;ae>0&&j[ae-1].version===De.version;)ae--;else if(ne.includes(fe))for(;ae>0&&j[ae-1].version===De.version&&B(j[ae-1])!==V;)ae--;ae!==me&&(j.splice(me,1),j.splice(ae,0,De))}}return j}e.sortExtensionVersions=ee;function oe(j,V,ne){j.telemetryData={index:V,querySource:ne}}function re(j,V,ne){const me=j.versions[0],De={manifest:L(V,r.Manifest),readme:L(V,r.Details),changelog:L(V,r.Changelog),license:L(V,r.License),repository:U(V),download:W(V),icon:m(V),coreTranslations:F(V)};return{identifier:{id:(0,v.getGalleryExtensionId)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},name:j.extensionName,version:V.version,displayName:j.displayName,publisherId:j.publisher.publisherId,publisher:j.publisher.publisherName,publisherDisplayName:j.publisher.displayName,publisherDomain:j.publisher.domain?{link:j.publisher.domain,verified:!!j.publisher.isDomainVerified}:void 0,description:j.shortDescription||"",installCount:I(j.statistics,"install"),rating:I(j.statistics,"averagerating"),ratingCount:I(j.statistics,"ratingcount"),categories:j.categories||[],tags:j.tags||[],releaseDate:Date.parse(j.releaseDate),lastUpdated:Date.parse(j.lastUpdated),allTargetPlatforms:ne,assets:De,properties:{dependencies:M(V,o.Dependency),extensionPack:M(V,o.ExtensionPack),engine:Y(V),localizedLanguages:G(V),targetPlatform:B(V),isPreReleaseVersion:$(V)},hasPreReleaseVersion:$(me),hasReleaseVersion:!0,preview:ie(j.flags)}}let de=class{constructor(V,ne,me,De,ae,fe,pe,Q){this.requestService=ne,this.logService=me,this.environmentService=De,this.telemetryService=ae,this.fileService=fe,this.productService=pe,this.configurationService=Q;const z=pe.extensionsGallery;this.extensionsGalleryUrl=z&&z.serviceUrl,this.extensionsControlUrl=z&&z.controlUrl,this.commonHeadersPromise=(0,C.resolveMarketplaceHeaders)(pe.version,pe,this.environmentService,this.configurationService,this.fileService,V)}api(V=""){return`${this.extensionsGalleryUrl}${V}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(V,ne,me){const De=t.CancellationToken.isCancellationToken(ne)?{}:ne,ae=t.CancellationToken.isCancellationToken(ne)?ne:me,fe=[],pe=[],Q=[],z=[];let x=!0;for(const ye of V){ye.uuid?pe.push(ye.uuid):fe.push(ye.id);const Pe=!!(ye.version||ye.preRelease);Q.push({id:ye.id,uuid:ye.uuid,includePreRelease:Pe}),ye.version&&z.push({id:ye.id,uuid:ye.uuid,version:ye.version}),x=x&&!!ye.hasPreRelease&&!Pe}if(!pe.length&&!fe.length)return[];let X=new A().withPage(1,V.length);pe.length&&(X=X.withFilter(n.ExtensionId,...pe)),fe.length&&(X=X.withFilter(n.ExtensionName,...fe)),(De.queryAllVersions||x)&&(X=X.withFlags(X.flags,a.IncludeVersions));const{extensions:ue}=await this.queryGalleryExtensions(X,{targetPlatform:De.targetPlatform??s,includePreRelease:Q,versions:z,compatible:!!De.compatible},ae);return De.source&&ue.forEach((ye,Pe)=>oe(ye,Pe,De.source)),ue}async getCompatibleExtension(V,ne,me){if((0,h.isNotWebExtensionInWebTargetPlatform)(V.allTargetPlatforms,me))return null;if(await this.isExtensionCompatible(V,ne,me))return V;const De=new A().withFlags(a.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,V.identifier.uuid),{extensions:ae}=await this.queryGalleryExtensions(De,{targetPlatform:me,compatible:!0,includePreRelease:ne},t.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(V,ne,me){if(!(0,h.isTargetPlatformCompatible)(V.properties.targetPlatform,V.allTargetPlatforms,me)||!ne&&V.properties.isPreReleaseVersion)return!1;let De=V.properties.engine;if(!De){const ae=await this.getManifest(V,t.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");De=ae.engines.vscode}return(0,c.isEngineValid)(De,this.productService.version,this.productService.date)}async isValidVersion(V,ne,me,De,ae){if(!(0,h.isTargetPlatformCompatible)(B(V),De,ae)||ne!=="any"&&$(V)!==(ne==="prerelease"))return!1;if(me){const fe=await this.getEngine(V);if(!(0,c.isEngineValid)(fe,this.productService.version,this.productService.date))return!1}return!0}async query(V,ne){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let me=V.text||"";const De=(0,P.getOrDefault)(V,x=>x.pageSize,50);let ae=new A().withPage(1,De);me?(me=me.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(x,X,ue)=>(ae=ae.withFilter(n.Category,ue||X),"")),me=me.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(x,X,ue)=>(ae=ae.withFilter(n.Tag,ue||X),"")),me=me.replace(/\bfeatured(\s+|\b|$)/g,()=>(ae=ae.withFilter(n.Featured),"")),me=me.trim(),me&&(me=me.length<200?me:me.substring(0,200),ae=ae.withFilter(n.SearchText,me)),ae=ae.withSortBy(0)):V.ids?ae=ae.withFilter(n.ExtensionId,...V.ids):V.names?ae=ae.withFilter(n.ExtensionName,...V.names):ae=ae.withSortBy(4),typeof V.sortBy=="number"&&(ae=ae.withSortBy(V.sortBy)),typeof V.sortOrder=="number"&&(ae=ae.withSortOrder(V.sortOrder));const fe=async(x,X)=>{const{extensions:ue,total:ye}=await this.queryGalleryExtensions(x,{targetPlatform:s,compatible:!1,includePreRelease:!!V.includePreRelease},X);return ue.forEach((Pe,Ae)=>oe(Pe,(x.pageNumber-1)*x.pageSize+Ae,V.source)),{extensions:ue,total:ye}},{extensions:pe,total:Q}=await fe(ae,ne),z=async(x,X)=>{if(X.isCancellationRequested)throw new w.CancellationError;const{extensions:ue}=await fe(ae.withPage(x+1),X);return ue};return{firstPage:pe,total:Q,pageSize:ae.pageSize,getPage:z}}async queryGalleryExtensions(V,ne,me){const De=V.flags;!!(V.flags&a.IncludeLatestVersionOnly)&&!!(V.flags&a.IncludeVersions)&&(V=V.withFlags(V.flags&~a.IncludeVersions,a.IncludeLatestVersionOnly)),!(V.flags&a.IncludeLatestVersionOnly)&&!(V.flags&a.IncludeVersions)&&(V=V.withFlags(V.flags,a.IncludeLatestVersionOnly)),ne.versions?.length&&(V=V.withFlags(V.flags&~a.IncludeLatestVersionOnly,a.IncludeVersions)),V=V.withFlags(V.flags,a.IncludeAssetUri,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeStatistics,a.IncludeVersionProperties);const{galleryExtensions:ae,total:fe}=await this.queryRawGalleryExtensions(V,me);if(!(V.flags&a.IncludeLatestVersionOnly)){const x=[];for(const X of ae){const ue=await this.toGalleryExtensionWithCriteria(X,ne,!0);ue&&x.push(ue)}return{extensions:x,total:fe}}const Q=[],z=new Map;for(let x=0;x<ae.length;x++){const X=ae[x],ue={id:(0,v.getGalleryExtensionId)(X.publisher.publisherName,X.extensionName),uuid:X.extensionId},ye=(0,y.isBoolean)(ne.includePreRelease)?ne.includePreRelease:!!ne.includePreRelease.find(Ae=>(0,v.areSameExtensions)(Ae,ue))?.includePreRelease;let Pe=await this.toGalleryExtensionWithCriteria(X,ne,!1);!Pe||Pe.properties.isPreReleaseVersion&&(!ye||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==ne.targetPlatform&&Pe.hasPreReleaseVersion?z.set(X.extensionId,x):Q.push([x,Pe])}if(z.size){const x=new Date().getTime(),X=new A().withFlags(De&~a.IncludeLatestVersionOnly,a.IncludeVersions).withPage(1,z.size).withFilter(n.ExtensionId,...z.keys()),{extensions:ue}=await this.queryGalleryExtensions(X,ne,me);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-x,count:z.size});for(const ye of ue){const Pe=z.get(ye.identifier.uuid);Q.push([Pe,ye])}}return{extensions:Q.sort((x,X)=>x[0]-X[0]).map(([,x])=>x),total:fe}}async toGalleryExtensionWithCriteria(V,ne,me){const De={id:(0,v.getGalleryExtensionId)(V.publisher.publisherName,V.extensionName),uuid:V.extensionId},ae=ne.versions?.find(z=>(0,v.areSameExtensions)(z,De))?.version,fe=(0,y.isBoolean)(ne.includePreRelease)?ne.includePreRelease:!!ne.includePreRelease.find(z=>(0,v.areSameExtensions)(z,De))?.includePreRelease,pe=q(V),Q=ee(V.versions,ne.targetPlatform);if(ne.compatible&&me&&(0,h.isNotWebExtensionInWebTargetPlatform)(pe,ne.targetPlatform))return null;for(let z=0;z<Q.length;z++){const x=Q[z];if(!(ae&&x.version!==ae)){if(await this.isValidVersion(x,fe?"any":"release",ne.compatible,pe,ne.targetPlatform))return re(V,x,pe);if(ae&&x.version===ae)return null}}return ae||ne.compatible?null:re(V,V.versions[0],pe)}async queryRawGalleryExtensions(V,ne){if(!this.isEnabled())throw new Error("No extension gallery service configured.");V=V.withFlags(V.flags,a.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(a.Unpublished));const me=await this.commonHeadersPromise,De=JSON.stringify(V.raw),ae={...me,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(De.length)},fe=new Date().getTime();let pe,Q,z=0;try{if(pe=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:De,headers:ae},ne),pe.res.statusCode&&pe.res.statusCode>=400&&pe.res.statusCode<500)return{galleryExtensions:[],total:z};const x=await(0,l.asJson)(pe);if(x){const X=x.results[0],ue=X.extensions,ye=X.resultMetadata&&X.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return z=ye&&ye.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:ue,total:z}}return{galleryExtensions:[],total:z}}catch(x){throw Q=x,x}finally{this.telemetryService.publicLog2("galleryService:query",{...V.telemetryData,requestBodySize:String(De.length),duration:new Date().getTime()-fe,success:!!pe&&(0,l.isSuccess)(pe),responseBodySize:pe?.res.headers["Content-Length"],statusCode:pe?String(pe.res.statusCode):void 0,errorCode:Q?(0,w.isCancellationError)(Q)?"canceled":(0,w.getErrorMessage)(Q).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(z)})}}async reportStatistic(V,ne,me,De){if(!this.isEnabled())return;const ae=D.isWeb?this.api(`/itemName/${V}.${ne}/version/${me}/statType/${De==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${V}/extensions/${ne}/${me}/stats?statType=${De}`),fe=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Q={...await this.commonHeadersPromise,Accept:fe};try{await this.requestService.request({type:"POST",url:ae,headers:Q},t.CancellationToken.None)}catch{}}async download(V,ne,me){this.logService.trace("ExtensionGalleryService#download",V.identifier.id);const De=(0,v.getGalleryExtensionTelemetryData)(V),ae=new Date().getTime(),fe=x=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...De,duration:x}),pe=me===2?"install":me===3?"update":"",Q=pe?{uri:`${V.assets.download.uri}${E.URI.parse(V.assets.download.uri).query?"&":"?"}${pe}=true`,fallbackUri:`${V.assets.download.fallbackUri}${E.URI.parse(V.assets.download.fallbackUri).query?"&":"?"}${pe}=true`}:V.assets.download,z=await this.getAsset(Q);await this.fileService.writeFile(ne,z.stream),fe(new Date().getTime()-ae)}async getReadme(V,ne){if(V.assets.readme){const me=await this.getAsset(V.assets.readme,{},ne);return await(0,l.asText)(me)||""}return""}async getManifest(V,ne){if(V.assets.manifest){const me=await this.getAsset(V.assets.manifest,{},ne),De=await(0,l.asText)(me);return De?JSON.parse(De):null}return null}async getManifestFromRawExtensionVersion(V,ne){const me=L(V,r.Manifest);if(!me)throw new Error("Manifest was not found");const De={"Accept-Encoding":"gzip"},ae=await this.getAsset(me,{headers:De});return await(0,l.asJson)(ae)}async getCoreTranslation(V,ne){const me=V.assets.coreTranslations.filter(De=>De[0]===ne.toUpperCase())[0];if(me){const De=await this.getAsset(me[1]),ae=await(0,l.asText)(De);return ae?JSON.parse(ae):null}return null}async getChangelog(V,ne){if(V.assets.changelog){const me=await this.getAsset(V.assets.changelog,{},ne);return await(0,l.asText)(me)||""}return""}async getAllCompatibleVersions(V,ne,me){let De=new A().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1);V.identifier.uuid?De=De.withFilter(n.ExtensionId,V.identifier.uuid):De=De.withFilter(n.ExtensionName,V.identifier.id);const{galleryExtensions:ae}=await this.queryRawGalleryExtensions(De,t.CancellationToken.None);if(!ae.length)return[];const fe=q(ae[0]);if((0,h.isNotWebExtensionInWebTargetPlatform)(fe,me))return[];const pe=[],Q=new Set;return await Promise.all(ae[0].versions.map(async z=>{try{if(Q.has(z.version))return;await this.isValidVersion(z,ne?"prerelease":"release",!0,fe,me)&&(pe.push({version:z.version,date:z.lastUpdated,isPreReleaseVersion:$(z)}),Q.add(z.version))}catch{}})),pe}async getAsset(V,ne={},me=t.CancellationToken.None){const De=await this.commonHeadersPromise,ae={type:"GET"},fe={...De,...ne.headers||{}};ne={...ne,...ae,headers:fe};const pe=V.uri,Q=V.fallbackUri,z={...ne,url:pe};try{const x=await this.requestService.request(z,me);if(x.res.statusCode===200)return x;const X=await(0,l.asText)(x);throw new Error(`Expected 200, got back ${x.res.statusCode} instead.

${X}`)}catch(x){if((0,w.isCancellationError)(x))throw x;const X=(0,w.getErrorMessage)(x);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:pe,message:X});const ue={...ne,url:Q};return this.requestService.request(ue,me)}}async getEngine(V){let ne=Y(V);if(!ne){const me=await this.getManifestFromRawExtensionVersion(V,t.CancellationToken.None);if(!me)throw new Error("Manifest was not found");ne=me.engines.vscode}return ne}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const V=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(V.res.statusCode!==200)throw new Error("Could not get extensions report.");const ne=await(0,l.asJson)(V),me=[],De={};if(ne){for(const ae of ne.malicious)me.push({id:ae});if(ne.unsupported)for(const ae of Object.keys(ne.unsupported)){const fe=ne.unsupported[ae];(0,y.isBoolean)(fe)||(De[ae.toLowerCase()]=fe.preReleaseExtension)}if(ne.migrateToPreRelease)for(const[ae,fe]of Object.entries(ne.migrateToPreRelease))(!fe.engine||(0,c.isEngineValid)(fe.engine,this.productService.version,this.productService.date))&&(De[ae.toLowerCase()]=fe)}return{malicious:me,unsupportedPreReleaseExtensions:De}}};de=Te([Ne(1,l.IRequestService),Ne(2,g.ILogService),Ne(3,R.IEnvironmentService),Ne(4,u.ITelemetryService),Ne(5,d.IFileService),Ne(6,b.IProductService),Ne(7,T.IConfigurationService)],de);let Z=class extends de{constructor(V,ne,me,De,ae,fe,pe,Q){super(V,ne,me,De,ae,fe,pe,Q)}};Z=Te([Ne(0,p.IStorageService),Ne(1,l.IRequestService),Ne(2,g.ILogService),Ne(3,R.IEnvironmentService),Ne(4,u.ITelemetryService),Ne(5,d.IFileService),Ne(6,b.IProductService),Ne(7,T.IConfigurationService)],Z),e.ExtensionGalleryService=Z;let H=class extends de{constructor(V,ne,me,De,ae,fe,pe){super(void 0,V,ne,me,De,ae,fe,pe)}};H=Te([Ne(0,l.IRequestService),Ne(1,g.ILogService),Ne(2,R.IEnvironmentService),Ne(3,u.ITelemetryService),Ne(4,d.IFileService),Ne(5,b.IProductService),Ne(6,T.IConfigurationService)],H),e.ExtensionGalleryServiceWithNoStorageService=H}),define(ve[215],we([0,1,2,20,3,18,168,28,46,45,35,29,42]),function(J,e,_,t,w,P,D,k,y,E,T,R,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let v=class{constructor(g,b){this._configurationService=b,this._experimentProperties={},this._disposables=new _.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let l of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,P.escapeRegExpCharacters)(l),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3})}setExperimentProperty(g,b){this._experimentProperties[g]=b}_updateTelemetryLevel(){this._telemetryLevel=(0,h.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const g=await this._commonProperties;let b=g.sessionID,l=g["common.machineId"],C=g["common.firstSessionDate"],p=g["common.msftInternal"];return{sessionId:b,machineId:l,firstSessionDate:C,msftInternal:p}}dispose(){this._disposables.dispose()}_log(g,b,l,C){return this.telemetryLevel<b?Promise.resolve(void 0):this._commonProperties.then(p=>{l=(0,t.mixin)(l,p),l=(0,t.mixin)(l,this._experimentProperties),l=(0,t.cloneAndChange)(l,u=>{if(typeof u=="string")return this._cleanupInfo(u,C)}),this._appenders.forEach(u=>u.log(g,l))},p=>{console.error(p)})}publicLog(g,b,l){return this._log(g,3,b,l)}publicLog2(g,b,l){return this.publicLog(g,b,l)}publicLogError(g,b){return this.sendErrorTelemetry?this._log(g,2,b,!0):Promise.resolve(void 0)}publicLogError2(g,b){return this.publicLogError(g,b)}_anonymizeFilePaths(g){let b=g;const l=[];for(let s of this._cleanupPatterns)for(;;){const a=s.exec(g);if(!a)break;l.push([a.index,s.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(b="";;){const s=p.exec(g);if(!s)break;!C.test(s[0])&&l.every(([a,i])=>s.index<a||s.index>=i)&&(b+=g.substring(u,s.index)+"<REDACTED: user-file-path>",u=p.lastIndex)}return u<g.length&&(b+=g.substr(u)),b}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const b=g.toLowerCase(),l=/@[a-zA-Z0-9-.]+/,C=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,p=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return C.test(b)?"<REDACTED: secret>":l.test(b)?"<REDACTED: email>":p.test(b)?"<REDACTED: token>":g}_cleanupInfo(g,b){let l=g;b&&(l=this._anonymizeFilePaths(l));for(let C of this._cleanupPatterns)l=l.replace(C,"");return l=this._removePropertiesWithPossibleUserInfo(l),l}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=Te([Ne(1,k.IConfigurationService)],v),e.TelemetryService=v;function c(){const d=(0,D.localize)(0,null,E.default.nameLong),g=E.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),b=w.isWeb?"":(0,D.localize)(3,null),l=(0,D.localize)(4,null),C=(0,D.localize)(5,null),p=(0,D.localize)(6,null),u=(0,D.localize)(7,null),s=`
|       | ${l} | ${C} | ${p} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,D.localize)(8,null);return`
${d} ${g} ${b}

&nbsp;

${u}
${s}

&nbsp;

${a}
`}T.Registry.as(y.Extensions.Configuration).registerConfiguration({id:R.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(9,null),properties:{[R.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:c(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),T.Registry.as(y.Extensions.Configuration).registerConfiguration({id:R.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[R.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,D.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,D.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${R.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ve[216],we([0,1,11,20,42]),function(J,e,_,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function P(k,y){const E=await new Promise((R,h)=>{J(["applicationinsights"],R,h)});let T;return E.defaultClient?(T=new E.TelemetryClient(k),T.channel.setUseDiskRetryCaching(!0)):(E.setup(k).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),T=E.defaultClient),k.indexOf("AIF-")===0&&(T.config.endpointUrl=y?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),T}class D{constructor(y,E,T,R,h){this._eventPrefix=y,this._defaultData=E,this.testCollector=R,this.mirrored=h,this._defaultData||(this._defaultData=Object.create(null)),typeof T=="function"?this._aiClient=T():this._aiClient=T,this._asyncAIClient=null}_withAIClient(y){if(!!this._aiClient){if(typeof this._aiClient!="string"){y(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=P(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(E=>{y(E)},E=>{(0,_.onUnexpectedError)(E),console.error(E)})}}log(y,E){if(!!this._aiClient){E=(0,t.mixin)(E,this._defaultData),E=(0,w.validateTelemetryData)(E),this.testCollector&&(E.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++");try{this._withAIClient(T=>T.trackEvent({name:this._eventPrefix+"/"+y,properties:E.properties,measurements:E.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(y=>{this._withAIClient(E=>{try{E.flush({callback:()=>{this._aiClient=void 0,y(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=D}),define(ve[217],we([0,1,11,211]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class w extends t.default{installErrorListeners(){(0,_.setUnexpectedErrorHandler)(k=>console.error(k));const D=[];process.on("unhandledRejection",(k,y)=>{D.push(y),setTimeout(()=>{const E=D.indexOf(y);E>=0&&y.catch(T=>{D.splice(E,1),(0,_.isCancellationError)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T.stack&&console.warn(`stack trace: ${T.stack}`),k&&(0,_.onUnexpectedError)(k))})},1e3)}),process.on("rejectionHandled",k=>{const y=D.indexOf(k);y>=0&&D.splice(y,1)}),process.on("uncaughtException",k=>{(0,_.onUnexpectedError)(k)})}}e.default=w}),define(ve[218],we([0,1,13,21,7,2,14]),function(J,e,_,t,w,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let k=class extends P.Disposable{constructor(E,T){super();this._logService=T,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new w.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((T,R)=>{const h=++this._lastRequestId;this._pendingRequests.set(h,T),this._onCreateRequest.fire({requestId:h,...E});const v=new t.CancellationTokenSource;(0,_.timeout)(this._timeout,v.token).then(()=>R(`Request ${h} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(h,[(0,P.toDisposable)(()=>v.cancel())])})}acceptReply(E,T){const R=this._pendingRequests.get(E);R?(this._pendingRequests.delete(E),(0,P.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),R(T)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};k=Te([Ne(1,D.ILogService)],k),e.RequestStore=k}),define(ve[102],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var w;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.EnableShellIntegration="terminal.integrated.enableShellIntegration"})(w=e.TerminalSettingId||(e.TerminalSettingId={}));var P;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var D;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(D=e.TitleEventSource||(e.TitleEventSource={}));var k;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Log="log",d.Heartbeat="heartbeat"})(k=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,_.createDecorator)("ptyService");var y;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions"})(y=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var T;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(T=e.TerminalLocation||(e.TerminalLocation={}));var R;(function(d){d.TerminalView="view",d.Editor="editor"})(R=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var v;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(v=e.FlowControlConstants||(e.FlowControlConstants={}));var c;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(c=e.ProfileSource||(e.ProfileSource={}))}),define(ve[219],we([0,1,25,20,4,3,24,12,19]),function(J,e,_,t,w,P,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const R=/(\d+)\.(\d+)\.(\d+)/g.exec(_.release());let h=0;return R&&R.length===4&&(h=parseInt(R[3])),h}e.getWindowsBuildNumber=E;async function T(R,h,v,c=D.env,d=y.Promises.exists){if(w.isAbsolute(R))return await d(R)?R:void 0;if(h===void 0&&(h=D.cwd()),w.dirname(R)!=="."){const C=w.join(h,R);return await d(C)?C:void 0}const b=(0,t.getCaseInsensitive)(c,"PATH");if(v===void 0&&(0,k.isString)(b)&&(v=b.split(w.delimiter)),v===void 0||v.length===0){const C=w.join(h,R);return await d(C)?C:void 0}for(let C of v){let p;if(w.isAbsolute(C)?p=w.join(C,R):p=w.join(h,C,R),await d(p))return p;if(P.isWindows){let u=p+".com";if(await d(u)||(u=p+".exe",await d(u)))return u}}const l=w.join(h,R);return await d(l)?l:void 0}e.findExecutable=T}),define(ve[220],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var _;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(_=e.ColorScheme||(e.ColorScheme={}))}),define(ve[103],we([0,1,37,7,2,6,35,220]),function(J,e,_,t,w,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var y;(function(g){function b(l){return l&&typeof l=="object"&&typeof l.id=="string"}g.isThemeColor=b})(y=e.ThemeColor||(e.ThemeColor={}));function E(g){return{id:g}}e.themeColorFromId=E;var T;(function(g){function b(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||y.isThemeColor(n.color))}g.isThemeIcon=b;const l=new RegExp(`^\\$\\((${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?)\\)$`);function C(n){const r=l.exec(n);if(!r)return;let[,o]=r;return{id:o}}g.fromString=C;function p(n){return{id:n}}g.fromId=p;function u(n,r){let o=n.id;const f=o.lastIndexOf("~");return f!==-1&&(o=o.substring(0,f)),r&&(o=`${o}~${r}`),{id:o}}g.modify=u;function s(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}g.getModifier=s;function a(n,r){return n.id===r.id&&n.color?.id===r.color?.id}g.isEqual=a;function i(n,r){return{id:n.id,color:r?E(r):void 0}}g.asThemeIcon=i,g.asClassNameArray=_.CSSIcon.asClassNameArray,g.asClassName=_.CSSIcon.asClassName,g.asCSSSelector=_.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=_.Codicon.file,e.FolderThemeIcon=_.Codicon.folder;function R(g){switch(g){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=R,e.Extensions={ThemingContribution:"base.contributions.theming"};class h{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,w.toDisposable)(()=>{const l=this.themingParticipants.indexOf(b);this.themingParticipants.splice(l,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let v=new h;D.Registry.add(e.Extensions.ThemingContribution,v);function c(g){return v.onColorThemeChange(g)}e.registerThemingParticipant=c;class d extends w.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(l=>this.onThemeChange(l)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,l){let C=this.theme.getColor(b);return C&&l&&(C=l(C,this.theme)),C?C.toString():null}}e.Themable=d}),define(ve[221],we([0,1,37,5,103]),function(J,e,_,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function P(R,h){const v=R.map(c=>({name:c.profileName,description:D(c)}));return h&&v.push(...h.map(c=>({name:c.title,description:k(c)}))),{values:v.map(c=>c.name),markdownDescriptions:v.map(c=>c.description)}}e.createProfileSchemaEnums=P;function D(R){let h=`$(${w.ThemeIcon.isThemeIcon(R.icon)?R.icon.id:R.icon?R.icon:_.Codicon.terminal.id}) ${R.profileName}
- path: ${R.path}`;return R.args&&(typeof R.args=="string"?h+=`
- args: "${R.args}"`:h+=`
- args: [${R.args.length===0?"":`'${R.args.join("','")}'`}]`),R.overrideName!==void 0&&(h+=`
- overrideName: ${R.overrideName}`),R.color&&(h+=`
- color: ${R.color}`),R.env&&(h+=`
- env: ${JSON.stringify(R.env)}`),h}function k(R){return`$(${w.ThemeIcon.isThemeIcon(R.icon)?R.icon.id:R.icon?R.icon:_.Codicon.terminal.id}) ${R.title}
- extensionIdenfifier: ${R.extensionIdentifier}`}function y(R,h){if(!R&&!h)return!0;if(typeof R=="string"&&typeof h=="string")return R===h;if(Array.isArray(R)&&Array.isArray(h)){if(R.length!==h.length)return!1;for(let v=0;v<R.length;v++)if(R[v]!==h[v])return!1;return!0}return!1}e.terminalProfileArgsMatch=y;function E(R,h){if(!R&&!h)return!0;if(!R||!h)return!1;if(w.ThemeIcon.isThemeIcon(R)&&w.ThemeIcon.isThemeIcon(h))return R.id===h.id&&R.color===h.color;if(typeof R=="object"&&R&&"light"in R&&"dark"in R&&typeof h=="object"&&h&&"light"in h&&"dark"in h){const v=R,c=h;if((t.URI.isUri(v.light)||T(v.light))&&(t.URI.isUri(v.dark)||T(v.dark))&&(t.URI.isUri(c.light)||T(c.light))&&(t.URI.isUri(c.dark)||T(c.dark)))return v.light.path===c.light.path&&v.dark.path===c.dark.path}if(t.URI.isUri(R)&&t.URI.isUri(h)||T(R)||T(h)){const v=R,c=h;return v.path===c.path&&v.scheme===c.scheme}return!1}e.terminalIconsEqual=E;function T(R){return R?typeof R.path=="string"&&typeof R.scheme=="string":!1}e.isUriComponents=T}),define(ve[222],we([0,1,37,169,46,35,221]),function(J,e,_,t,w,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const k={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),type:"string",enum:Array.from(_.Codicon.getAll(),p=>p.id),markdownEnumDescriptions:Array.from(_.Codicon.getAll(),p=>`$(${p.id})`)},color:{description:(0,t.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},y={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...k}},E={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...k}},T=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),R=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),h=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),v=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),c=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),d=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),g={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:c},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,t.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,t.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:T},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:T},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:h},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...k}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...k}},{type:"null"},y]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...k}},{type:"null"},y]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...k}},{type:"null"},y]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function b(){P.Registry.as(w.Extensions.Configuration).registerConfiguration(g),C()}e.registerTerminalPlatformConfiguration=b;let l;function C(p,u){const s=P.Registry.as(w.Extensions.Configuration);let a;p&&(a=(0,D.createProfileSchemaEnums)(p?.profiles,u));const i=l;l={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:p?.os===3?a?.values:void 0,markdownEnumDescriptions:p?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:p?.os===2?a?.values:void 0,markdownEnumDescriptions:p?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:p?.os===1?a?.values:void 0,markdownEnumDescriptions:p?.os===1?a?.markdownDescriptions:void 0}}},s.updateConfigurations({add:[l],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=C}),define(ve[223],we([0,1,39,37,4,3,19,83,219,103]),function(J,e,_,t,w,P,D,k,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let T,R=!0;function h(a,i,n,r,o=process.env,f,S,A,I){return f=f||{existsFile:D.SymlinkSupport.existsFile,readFile:D.Promises.readFile},P.isWindows?v(n,f,o,S,r.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:r.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:r.getValue("terminal.integrated.defaultProfile.windows"),I,A):p(f,S,n,a&&typeof a=="object"?{...a}:r.getValue(P.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:r.getValue(P.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),I,A,o)}e.detectAvailableProfiles=h;async function v(a,i,n,r,o,f,S,A,I){const F=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),U=`${process.env.windir}\\${F?"Sysnative":"System32"}`;let W=!1;(0,y.getWindowsBuildNumber)()>=16299&&(W=!0),await g(A);const m=new Map;a&&(m.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),m.set("Windows PowerShell",{path:`${U}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),m.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),m.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),m.set("Command Prompt",{path:`${U}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),u(f,m);const L=await c(m.entries(),S,i,n,r,I);if(a||!a&&o)try{const M=await l(`${U}\\${W?"wsl":"bash"}.exe`,S);for(const Y of M)(!f||!(Y.profileName in f))&&L.push(Y)}catch{R&&(r?.info("WSL is not installed, so could not detect WSL profiles"),R=!1)}return L}async function c(a,i,n,r=process.env,o,f){const S=[];for(const[A,I]of a){if(I===null)continue;let F,U,W;if("source"in I){const M=T?.get(I.source);if(!M)continue;F=M.paths,U=I.args||M.args,I.icon?W=d(I.icon):M.icon&&(W=M.icon)}else F=Array.isArray(I.path)?I.path:[I.path],U=P.isWindows||Array.isArray(I.args)?I.args:void 0,W=d(I.icon);const m=await f?.(F)||F.slice(),L=await s(A,i,m,n,r,U,I.env,I.overrideName,I.isAutoDetected,o);L?(L.isAutoDetected=I.isAutoDetected,L.icon=W,L.color=I.color,S.push(L)):o?.trace("profile not validated",A,F)}return S}function d(a){return typeof a=="string"?{id:a}:a}async function g(a){T&&!a||(T=new Map,T.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),T.set("PowerShell",{profileName:"PowerShell",paths:a||await b(),icon:E.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function b(){const a=[];for await(const i of(0,k.enumeratePowerShellInstallations)())a.push(i.exePath);return a}async function l(a,i){const n=[],r=await new Promise((S,A)=>{_.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(I,F)=>{if(I)return A("Problem occurred when getting wsl distros");S(F)})});if(!r)return[];const o=new RegExp(/[\r?\n]/),f=r.split(o).filter(S=>S.trim().length>0&&S!=="");for(const S of f){if(S===""||S.startsWith("docker-desktop"))continue;const A=`${S} (WSL)`,I={profileName:A,path:a,args:["-d",`${S}`],isDefault:A===i,icon:C(S),isAutoDetected:!1};n.push(I)}return n}function C(a){return a.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):a.includes("Debian")?E.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function p(a,i,n,r,o,f,S,A){const I=new Map;if(n){const F=(await a.readFile("/etc/shells")).toString(),U=f||F.split(`
`).filter(m=>m.trim().indexOf("#")!==0&&m.trim().length>0),W=new Map;for(const m of U){let L=(0,w.basename)(m),M=W.get(L)||0;M++,M>1&&(L=`${L} (${M})`),W.set(L,M),I.set(L,{path:m,isAutoDetected:!0})}}return u(r,I),await c(I.entries(),o,a,A,i,S)}function u(a,i){if(!!a)for(const[n,r]of Object.entries(a))r===null||!("path"in r)&&!("source"in r)?i.delete(n):(r.icon=r.icon||i.get(n)?.icon,i.set(n,r))}async function s(a,i,n,r,o,f,S,A,I,F){if(n.length===0)return Promise.resolve(void 0);const U=n.shift();if(U==="")return s(a,i,n,r,o,f,S,A,I);const W={profileName:a,path:U,args:f,env:S,overrideName:A,isAutoDetected:I,isDefault:a===i};if((0,w.basename)(U)===U){const L=o.PATH?o.PATH.split(w.delimiter):void 0,M=await(0,y.findExecutable)(U,void 0,L,void 0,r.existsFile);return M?(W.path=M,W.isFromPath=!0,W):s(a,i,n,r,o,f)}return await r.existsFile((0,w.normalize)(U))?W:s(a,i,n,r,o,f,S,A,I)}}),define(ve[224],we([0,1,7,2,8,3,40,87,28,26,88,67,14,94,29,218,102,222,223]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c,d,g,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var C;(function(s){s[s.MaxRestarts=5]="MaxRestarts"})(C||(C={}));let p=0,u=class extends t.Disposable{constructor(a,i,n,r,o){super();this._reconnectConstants=a,this._configurationService=i,this._environmentService=n,this._logService=r,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new _.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new _.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new _.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new _.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new _.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new _.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new _.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new _.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new _.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new _.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new _.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new _.Emitter),this.onProcessExit=this._onProcessExit.event,(0,b.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async f=>{f.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(P.isWindows)return process.env;try{return await(0,R.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:p,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},i=(0,T.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);i&&(i.break&&i.port?a.debugBrk=i.port:!i.break&&i.port&&(a.debug=i.port));const n=new k.Client(w.FileAccess.asFileUri("bootstrap-fork",J).fsPath,a);this._onPtyHostStart.fire(),D.ProxyChannel.toService(n.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(n.onDidProcessExit(S=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(S.code),this._isDisposed||(this._restartCount<=C.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${S.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${S.code}, giving up`))}));const o=n.getChannel(g.TerminalIpcChannels.Log);v.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const f=D.ProxyChannel.toService(n.getChannel(g.TerminalIpcChannels.PtyHost));return this._register(f.onProcessData(S=>this._onProcessData.fire(S))),this._register(f.onProcessReady(S=>this._onProcessReady.fire(S))),this._register(f.onProcessExit(S=>this._onProcessExit.fire(S))),this._register(f.onDidChangeProperty(S=>this._onDidChangeProperty.fire(S))),this._register(f.onProcessReplay(S=>this._onProcessReplay.fire(S))),this._register(f.onProcessOrphanQuestion(S=>this._onProcessOrphanQuestion.fire(S))),this._register(f.onDidRequestDetach(S=>this._onDidRequestDetach.fire(S))),[n,f]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,i,n,r,o,f,S,A,I,F,U){const W=setTimeout(()=>this._handleUnresponsiveCreateProcess(),g.HeartbeatConstants.CreateProcessTimeout),m=await this._proxy.createProcess(a,i,n,r,o,f,S,A,I,F,U);return clearTimeout(W),p=Math.max(p,m),m}updateTitle(a,i,n){return this._proxy.updateTitle(a,i,n)}updateIcon(a,i,n){return this._proxy.updateIcon(a,i,n)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,i){return this._proxy.shutdown(a,i)}input(a,i){return this._proxy.input(a,i)}processBinary(a,i){return this._proxy.processBinary(a,i)}resize(a,i,n){return this._proxy.resize(a,i,n)}acknowledgeDataEvent(a,i){return this._proxy.acknowledgeDataEvent(a,i)}setUnicodeVersion(a,i){return this._proxy.setUnicodeVersion(a,i)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}installAutoReply(a,i){return this._proxy.installAutoReply(a,i)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(a){return this._proxy.uninstallAutoReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,i,n,r=!1){const o=await this._shellEnv;return(0,l.detectAvailableProfiles)(i,n,r,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,i){return this._proxy.requestDetachInstance(a,i)}async acceptDetachInstanceReply(a,i){return this._proxy.acceptDetachInstanceReply(a,i)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a,i){return this._proxy.reviveTerminalProcesses(a,i)}async refreshProperty(a,i){return this._proxy.refreshProperty(a,i)}async updateProperty(a,i,n){return this._proxy.updateProperty(a,i,n)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,i){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:i})}async acceptPtyHostResolvedVariables(a,i){this._resolveVariablesRequestStore.acceptReply(a,i)}};u=Te([Ne(1,y.IConfigurationService),Ne(2,E.IEnvironmentService),Ne(3,h.ILogService),Ne(4,c.ITelemetryService)],u),e.PtyHostService=u}),define(ve[48],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,_.createDecorator)("IUriIdentityService")}),define(ve[225],we([0,1,7,2,5,26,33,16,14,48]),function(J,e,_,t,w,P,D,k,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let T=class extends t.Disposable{constructor(h,v,c,d,g){super();this.extensionsManagementService=h,this.logService=d,this.uriIdentityService=g,this._onDidChangeExtensionsByAnotherSource=this._register(new _.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(l=>{this.installedExtensions=l.map(C=>C.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(l=>this.onInstallExtension(l))),this._register(h.onDidInstallExtensions(l=>this.onDidInstallExtensions(l))),this._register(h.onDidUninstallExtension(l=>this.onDidUninstallExtension(l)));const b=w.URI.file(c.extensionsPath);this._register(v.watch(b)),this._register(_.Event.filter(v.onDidFilesChange,l=>l.rawChanges.some(C=>this.doesChangeAffects(C,b)))(()=>this.onDidChange()))}doesChangeAffects(h,v){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h.resource),v)?this.uriIdentityService.extUri.isEqual(h.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!(h.type!==1&&h.type!==2||this.uriIdentityService.extUri.basename(h.resource).startsWith(".")):!1}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const v of h)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(v=>!(0,D.areSameExtensions)(v,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,D.areSameExtensions)(v,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(1),v=h.filter(d=>[...this.installingExtensions,...this.installedExtensions].some(g=>(0,D.areSameExtensions)(g,d.identifier))?!1:d.installedTimestamp&&d.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",d.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",d.identifier.id),!1)),c=this.installedExtensions.filter(d=>this.installingExtensions.some(g=>(0,D.areSameExtensions)(g,d))?!1:h.every(g=>!(0,D.areSameExtensions)(g.identifier,d))?(this.logService.info("Detected extension removed from another source",d.id),!0):!1);this.installedExtensions=h.map(d=>d.identifier),(v.length||c.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:c})}}};T=Te([Ne(1,k.IFileService),Ne(2,P.INativeEnvironmentService),Ne(3,y.ILogService),Ne(4,E.IUriIdentityService)],T),e.ExtensionsWatcher=T}),define(ve[104],we([0,1,48,184,16,22,124,7,2]),function(J,e,_,t,w,P,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(h){this.uri=h,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let T=class{constructor(h){this._fileService=h,this._dispooables=new y.DisposableStore,this._limit=2**16;const v=new Map,c=d=>{let g=v.get(d.scheme);return g===void 0&&(g=h.hasProvider(d)&&!this._fileService.hasCapability(d,1024),v.set(d.scheme,g)),g};this._dispooables.add(k.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(d=>{v.delete(d.scheme)})),this.extUri=new P.ExtUri(c),this._canonicalUris=new D.SkipList((d,g)=>this.extUri.compare(d,g,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(h){this._fileService.hasProvider(h)&&(h=(0,P.normalizePath)(h));let v=this._canonicalUris.get(h);return v?v.touch().uri.with({fragment:h.fragment}):(this._canonicalUris.set(h,new E(h)),this._checkTrim(),h)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const h=[...this._canonicalUris.entries()].sort((c,d)=>c[1].touch<d[1].touch?1:c[1].touch>d[1].touch?-1:0);E._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let c=0;c<v;c++)this._canonicalUris.set(h[c][0],h[c][1].touch())}};T=Te([Ne(0,w.IFileService)],T),e.UriIdentityService=T,(0,t.registerSingleton)(_.IUriIdentityService,T,!0)}),define(ve[105],we([0,1,30,22,5,6]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");var D;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(D=e.WorkbenchState||(e.WorkbenchState={}));function k(h){const v=h;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.isWorkspace=k;function y(h){const v=h;return!!(v&&typeof v=="object"&&w.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.isWorkspaceFolder=y;class E{constructor(v,c,d,g,b){this._id=v,this._transient=d,this._configuration=g,this._ignorePathCasing=b,this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(v){this._id=v.id,this._configuration=v.configuration,this._transient=v.transient,this._ignorePathCasing=v._ignorePathCasing,this.folders=v.folders}get folders(){return this._folders}set folders(v){this._folders=v,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(v){this._configuration=v}getFolder(v){return v&&this._foldersMap.findSubstr(v.with({scheme:v.scheme,authority:v.authority,path:v.path}))||null}updateFoldersMap(){this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing);for(const v of this.folders)this._foldersMap.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=E;class T{constructor(v,c){this.raw=c,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,t.joinPath)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=T;function R(h){return new T({uri:h,index:0,name:(0,t.basenameOrAuthority)(h)},{uri:h.toString()})}e.toWorkspaceFolder=R}),define(ve[226],we([0,1,31,38,120,61,8,4,3,22,5,170,6,98,105]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(G){return(typeof G=="string"?(0,k.extname)(G):(0,E.extname)(G))===d}e.hasWorkspaceFileExtension=g,e.IWorkspacesService=(0,h.createDecorator)("workspacesService");function b(G){return G.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function l(G){return G.hasOwnProperty("folderUri")}e.isRecentFolder=l;function C(G){return G.hasOwnProperty("fileUri")}e.isRecentFile=C;function p(G){return G&&G.hasOwnProperty("folderUri")}e.isFolderBackupInfo=p;function u(G){return G&&G.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=u;function s(G){const ie=G;return typeof ie?.id=="string"&&T.URI.isUri(ie.uri)}e.isSingleFolderWorkspaceIdentifier=s;function a(G){if(G.configuration)return{id:G.id,configPath:G.configuration};if(G.folders.length===1)return{id:G.id,uri:G.folders[0].uri}}e.toWorkspaceIdentifier=a;function i(G){const ie=G;return typeof ie?.id=="string"&&T.URI.isUri(ie.configPath)}e.isWorkspaceIdentifier=i;function n(G){const ie=G;if(ie?.uri)return{id:ie.id,uri:T.URI.revive(ie.uri)};const B=G;if(B?.configPath)return{id:B.id,configPath:T.URI.revive(B.configPath)};if(G?.id)return{id:G.id}}e.reviveIdentifier=n;function r(G,ie){return E.extUriBiasedIgnorePathCase.isEqualOrParent(G,ie.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function o(G){return f(G)||S(G)}e.isStoredWorkspaceFolder=o;function f(G){const ie=G;return typeof ie?.path=="string"&&(!ie.name||typeof ie.name=="string")}e.isRawFileWorkspaceFolder=f;function S(G){const ie=G;return typeof ie?.uri=="string"&&(!ie.name||typeof ie.name=="string")}e.isRawUriWorkspaceFolder=S;function A(G,ie,B,q,ee=!y.isWindows,oe){if(G.scheme!==q.scheme)return{name:B,uri:G.toString(!0)};let re=ie?void 0:oe.relativePath(q,G);if(re!==void 0)re.length===0?re=".":y.isWindows&&G.scheme===D.Schemas.file&&!ee&&(re=re.replace(/\//g,"\\"));else if(G.scheme===D.Schemas.file)re=G.fsPath,y.isWindows&&(re=(0,P.normalizeDriveLetter)(re),ee&&(re=(0,_.toSlashes)(re)));else{if(!oe.isEqualAuthority(G.authority,q.authority))return{name:B,uri:G.toString(!0)};re=G.path}return{name:B,path:re}}e.getStoredWorkspaceFolder=A;function I(G,ie,B){let q=[],ee=new Set;const oe=B.dirname(ie);for(let re of G){let de;if(f(re))re.path&&(de=B.resolvePath(oe,re.path));else if(S(re))try{de=T.URI.parse(re.uri),de.path[0]!=="/"&&(de=de.with({path:"/"+de.path}))}catch(Z){console.warn(Z)}if(de){let Z=B.getComparisonKey(de);if(!ee.has(Z)){ee.add(Z);const H=re.name||B.basenameOrAuthority(de);q.push(new c.WorkspaceFolder({uri:de,name:H,index:q.length},re))}}}return q}e.toWorkspaceFolders=I;function F(G,ie,B,q,ee){let oe=U(ie,G);const re=ee.dirname(ie),de=ee.dirname(q),Z=[],H=W(oe.folders);for(const me of oe.folders){const De=f(me)?ee.resolvePath(re,me.path):T.URI.parse(me.uri);let ae;B?ae=!1:ae=!f(me)||(0,k.isAbsolute)(me.path),Z.push(A(De,ae,me.name,de,H,ee))}const j={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},V=w.setProperty(G,["folders"],Z,j);let ne=w.applyEdits(G,V);return(0,E.isEqualAuthority)(oe.remoteAuthority,(0,v.getRemoteAuthority)(q))&&(ne=w.applyEdits(ne,w.removeProperty(ne,["remoteAuthority"],j))),ne}e.rewriteWorkspaceFileForNewLocation=F;function U(G,ie){let B=t.parse(ie);if(B&&Array.isArray(B.folders))B.folders=B.folders.filter(q=>o(q));else throw new Error(`${G} looks like an invalid workspace file.`);return B}function W(G){return y.isWindows?G.some(ie=>f(ie)&&ie.path.indexOf("/")>=0):!0}e.useSlashForPath=W;function m(G){return G.workspace&&typeof G.workspace=="object"&&typeof G.workspace.id=="string"&&typeof G.workspace.configPath=="string"}function L(G){return typeof G.folderUri=="string"}function M(G){return typeof G.fileUri=="string"}function Y(G,ie){const B={workspaces:[],files:[]};if(G){const q=function(oe,re){for(let de=0;de<oe.length;de++)try{re(oe[de],de)}catch(Z){ie.warn(`Error restoring recent entry ${JSON.stringify(oe[de])}: ${Z.toString()}. Skip entry.`)}},ee=G;if(Array.isArray(ee.entries))q(ee.entries,oe=>{const re=oe.label,de=oe.remoteAuthority;m(oe)?B.workspaces.push({label:re,remoteAuthority:de,workspace:{id:oe.workspace.id,configPath:T.URI.parse(oe.workspace.configPath)}}):L(oe)?B.workspaces.push({label:re,remoteAuthority:de,folderUri:T.URI.parse(oe.folderUri)}):M(oe)&&B.files.push({label:re,remoteAuthority:de,fileUri:T.URI.parse(oe.fileUri)})});else{const oe=G;Array.isArray(oe.workspaces3)&&q(oe.workspaces3,(re,de)=>{const Z=Array.isArray(oe.workspaceLabels)&&oe.workspaceLabels[de]||void 0;typeof re=="object"&&typeof re.id=="string"&&typeof re.configURIPath=="string"?B.workspaces.push({label:Z,workspace:{id:re.id,configPath:T.URI.parse(re.configURIPath)}}):typeof re=="string"&&B.workspaces.push({label:Z,folderUri:T.URI.parse(re)})}),Array.isArray(oe.files2)&&q(oe.files2,(re,de)=>{const Z=Array.isArray(oe.fileLabels)&&oe.fileLabels[de]||void 0;typeof re=="string"&&B.files.push({label:Z,fileUri:T.URI.parse(re)})})}}return B}e.restoreRecentlyOpened=Y;function $(G){const ie={entries:[]};for(const B of G.workspaces)l(B)?ie.entries.push({folderUri:B.folderUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority}):ie.entries.push({workspace:{id:B.workspace.id,configPath:B.workspace.configPath.toString()},label:B.label,remoteAuthority:B.remoteAuthority});for(const B of G.files)ie.entries.push({fileUri:B.fileUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority});return ie}e.toStoreData=$}),define(ve[227],we([0,1,7,13]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function w(D){let k=0,y=0,E=0;D>=1e3&&(E=Math.floor(D/1e3),D-=E*1e3),E>=60&&(y=Math.floor(E/60),E-=y*60),y>=60&&(k=Math.floor(y/60),y-=k*60);const T=k?`${k}h`:"",R=y?`${y}m`:"",h=E?`${E}s`:"",v=D?`${D}ms`:"";return`${T}${R}${h}${v}`}e.printTime=w;class P{constructor(k,y,E,T){this._logService=k,this._reconnectionToken=y,this._onClose=new _.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=E,this.protocol=T,this._disposed=!1,this._disconnectRunner1=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection grace time of ${w(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${w(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${w(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(k){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${k}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${w(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const k=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),k.end(),this._onClose.fire(void 0)}acceptReconnection(k,y,E){this._remoteAddress=k,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(y,E),this.protocol.endAcceptReconnection()}}e.ManagementConnection=P}),define(ve[72],we([0,1,27,8,4,131,45]),function(J,e,_,t,w,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLocaleFromConfig=e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const k=w.join(t.FileAccess.asFileUri("",J).fsPath,"nls.metadata.json"),y=new Map;function E(c){return new Promise(d=>_.exists(c,d))}function T(c,d){return E(k).then(g=>{if(!g||!D.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let b=`${c}||${d}`,l=y.get(b);return l||(l=P.getNLSConfiguration(D.default.commit,d,k,c).then(C=>(R.is(C)&&(C._languagePackSupport=!0),C.locale!=="en"&&C.locale!=="en-us"&&Object.keys(C.availableLanguages).length===0&&y.delete(b),C)),y.set(b,l)),l})}e.getNLSConfiguration=T;var R;(function(c){function d(g){let b=g;return b&&typeof b._languagePackId=="string"}c.is=d})(R=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}));const h=async c=>{try{const d=v(await _.promises.readFile(c,"utf8"));return JSON.parse(d).locale}catch(d){return d.code!=="ENOENT"&&console.warn(d),"en"}};e.getLocaleFromConfig=h;const v=c=>{const d=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return c.replace(d,(g,b,l,C,p)=>{if(C)return"";if(p){const u=p.length;return u>2&&p[u-1]===`
`?p[u-2]==="\r"?`\r
`:`
`:""}else return g})}}),define(ve[228],we([0,1,2]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTelemetryChannel=void 0;class t extends _.Disposable{constructor(P,D){super();this.telemetryService=P,this.telemetryAppender=D}async call(P,D,k){switch(D){case"updateTelemetryLevel":{const{telemetryLevel:y}=k;return this.telemetryService.updateInjectedTelemetryLevel(y)}case"logTelemetry":{const{eventName:y,data:E}=k;return this.telemetryAppender?this.telemetryAppender.log(y,E):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve()}throw new Error(`IPC Command ${D} not found`)}listen(P,D,k){throw new Error("Not supported")}dispose(){this.telemetryService.updateInjectedTelemetryLevel(0),super.dispose()}}e.RemoteTelemetryChannel=t}),define(ve[229],we([0,1,28,6,29,215,42]),function(J,e,_,t,w,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteTelemetryService=e.RemoteNullTelemetryService=e.RemoteTelemetryService=void 0;let k=class extends P.TelemetryService{constructor(E,T,R){super(E,R);this._telemetryCache=[],this._injectedTelemetryLevel=T}publicLog(E,T,R){return this._injectedTelemetryLevel===void 0?(this._telemetryCache?.push({eventName:E,data:T,anonymizeFilePaths:R,eventType:"usage"}),Promise.resolve()):this._injectedTelemetryLevel<3?Promise.resolve(void 0):super.publicLog(E,T,R)}publicLog2(E,T,R){return this.publicLog(E,T,R)}publicLogError(E,T){return this._injectedTelemetryLevel===void 0?(this._telemetryCache?.push({eventName:E,data:T,eventType:"error"}),Promise.resolve()):this._injectedTelemetryLevel<2?Promise.resolve(void 0):super.publicLogError(E,T)}publicLogError2(E,T){return this.publicLogError(E,T)}async flushTelemetryCache(){if(this._telemetryCache?.length!==0){for(const E of this._telemetryCache)E.eventType==="usage"?await this.publicLog(E.eventName,E.data,E.anonymizeFilePaths):await this.publicLogError(E.eventName,E.data);this._telemetryCache=[]}}async updateInjectedTelemetryLevel(E){if(E===void 0)throw this._injectedTelemetryLevel=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");if(this._injectedTelemetryLevel=this._injectedTelemetryLevel?Math.min(this._injectedTelemetryLevel,E):E,this._injectedTelemetryLevel===0)this._telemetryCache=[],this.dispose();else return this.flushTelemetryCache()}};k=Te([Ne(2,_.IConfigurationService)],k),e.RemoteTelemetryService=k,e.RemoteNullTelemetryService=new class extends D.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IRemoteTelemetryService=(0,t.refineServiceDecorator)(w.ITelemetryService)}),define(ve[49],we([0,1,62,8]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createRemoteURITransformer=e.uriTransformerPath=void 0,e.uriTransformerPath=t.FileAccess.asFileUri("vs/server/node/uriTransformer.js",J).fsPath;function w(P){const k=J.__$__nodeRequire(e.uriTransformerPath)(P);return new _.URITransformer(k)}e.createRemoteURITransformer=w}),define(ve[230],we([0,1,5,49,56,4,197]),function(J,e,_,t,w,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class k extends D.AbstractDiskFileSystemProviderChannel{constructor(T,R){super(new w.DiskFileSystemProvider(T),T);this.environmentService=R,this.uriTransformerCache=new Map,this._register(this.provider)}getUriTransformer(T){let R=this.uriTransformerCache.get(T.remoteAuthority);return R||(R=(0,t.createRemoteURITransformer)(T.remoteAuthority),this.uriTransformerCache.set(T.remoteAuthority,R)),R}transformIncoming(T,R,h=!1){if(h&&R.path==="/vscode-resource"&&R.query){const v=JSON.parse(R.query).requestResourcePath;return _.URI.from({scheme:"file",path:v})}return _.URI.revive(T.transformIncoming(R))}createSessionFileWatcher(T,R){return new y(T,R,this.logService,this.environmentService)}}e.RemoteAgentFileSystemProviderChannel=k;class y extends D.AbstractSessionFileWatcher{constructor(T,R,h,v){super(T,R,h,v)}getRecursiveWatcherOptions(T){const R=T.args["file-watcher-polling"];if(R){const h=R.split(P.delimiter),v=Number(h[0]);if(v>0)return{usePolling:h.length>1?h.slice(1):!0,pollingInterval:v}}}getExtraExcludes(T){if(T.extensionsPath)return[P.posix.join(T.extensionsPath,"**")]}}}),define(ve[231],we([0,1,232,27,23,8]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const D=/^[0-9A-Za-z-]+$/;var k;(function(c){c[c.None=0]="None",c[c.Optional=1]="Optional",c[c.Mandatory=2]="Mandatory"})(k=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class y{constructor(){this.type=0}validate(d){return!0}}e.NoneServerConnectionToken=y;class E{constructor(d){this.value=d,this.type=1}validate(d){return d===this.value}}e.OptionalServerConnectionToken=E;class T{constructor(d){this.value=d,this.type=2}validate(d){return d===this.value}}e.MandatoryServerConnectionToken=T;class R{constructor(d){this.message=d}}e.ServerConnectionTokenParseError=R;function h(c){const d=c["without-connection-token"],g=c["connection-token"],b=c["connection-token-file"],l=c.compatibility==="1.63";if(d)return typeof g!="undefined"||typeof b!="undefined"?new R("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new y;if(typeof b!="undefined"){if(typeof g!="undefined")return new R("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let C;try{C=t.readFileSync(b).toString().replace(/\r?\n$/,"")}catch{return new R(`Unable to read the connection token file at '${b}'.`)}return D.test(C)?new T(C):new R(`The connection token defined in '${b} does not adhere to the characters 0-9, a-z, A-Z or -.`)}return typeof g!="undefined"?D.test(g)?l?new E(g):new T(g):new R(`The connection token '${g} does not adhere to the characters 0-9, a-z, A-Z or -.`):l?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new E((0,w.generateUuid)())):new T((0,w.generateUuid)())}e.parseServerConnectionToken=h;function v(c,d,g){if(c.validate(g.query[P.connectionTokenQueryName]))return!0;const b=_.parse(d.headers.cookie||"");return c.validate(b[P.connectionTokenCookieName])}e.requestHasValidConnectionToken=v}),define(ve[50],we([0,1,172,181,53,6,26]),function(J,e,_,t,w,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={"disable-update-check":{type:"boolean"},auth:{type:"string"},locale:{type:"string"},host:{type:"string",cat:"o",args:"ip-address",description:_.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:_.localize(1,null)},"pick-port":{type:"string",deprecationMessage:"Use the range notation in 'port' instead."},"socket-path":{type:"string",cat:"o",args:"path",description:_.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:_.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:_.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:_.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:_.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:_.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:_.localize(8,null)},"user-data-dir":w.OPTIONS["user-data-dir"],driver:w.OPTIONS.driver,"disable-telemetry":w.OPTIONS["disable-telemetry"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:w.OPTIONS.log,logsPath:w.OPTIONS.logsPath,"force-disable-user-env":w.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL."},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":w.OPTIONS["extensions-dir"],"extensions-download-dir":w.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":w.OPTIONS["builtin-extensions-dir"],"install-extension":w.OPTIONS["install-extension"],"install-builtin-extension":w.OPTIONS["install-builtin-extension"],"uninstall-extension":w.OPTIONS["uninstall-extension"],"list-extensions":w.OPTIONS["list-extensions"],"locate-extension":w.OPTIONS["locate-extension"],"show-versions":w.OPTIONS["show-versions"],category:w.OPTIONS.category,force:w.OPTIONS.force,"do-not-sync":w.OPTIONS["do-not-sync"],"pre-release":w.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:_.localize(9,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:w.OPTIONS.help,version:w.OPTIONS.version,compatibility:{type:"string"},_:w.OPTIONS._},e.IServerEnvironmentService=(0,P.refineServiceDecorator)(D.IEnvironmentService);class k extends t.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=k}),define(ve[233],we([0,1,27,71,134,232,70,31,59,3,14,50,4,8,23,32,47,21,5,15,12,72]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c,d,g,b,l,C,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOriginalUrl=e.relativePath=e.relativeRoot=e.normalizeUrlPath=e.WebClientServer=e.serveFile=e.serveError=void 0;const s={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function a(I,F,U,W){F.writeHead(U,{"Content-Type":"text/plain"}),F.end(W)}e.serveError=a;async function i(I,F,U,W,m=Object.create(null)){try{const L=await w.promisify(_.stat)(W),M=`W/"${[L.ino,L.size,L.mtime.getTime()].join("-")}"`;if(F.headers["if-none-match"]===M)return U.writeHead(304),U.end();m["Content-Type"]=s[(0,h.extname)(W)]||(0,y.getMediaMime)(W)||"text/plain",m.Etag=M,U.writeHead(200,m),_.createReadStream(W).pipe(U)}catch(L){return L.code!=="ENOENT"&&(I.error(L),console.error(L.toString())),U.writeHead(404,{"Content-Type":"text/plain"}),U.end("Not found")}}e.serveFile=i;const n=(0,h.dirname)(v.FileAccess.asFileUri("",J).fsPath);let r=class{constructor(F,U,W,m,L){this._connectionToken=F,this._environmentService=U,this._logService=W,this._requestService=m,this._productService=L,this._webExtensionResourceUrlTemplate=this._productService.extensionsGallery?.resourceUrlTemplate?l.URI.parse(this._productService.extensionsGallery.resourceUrlTemplate):void 0}async handle(F,U,W){try{const m=W.pathname;return m==="/favicon.ico"||m==="/manifest.json"||m==="/code-192.png"||m==="/code-512.png"?i(this._logService,F,U,(0,h.join)(n,"resources","server",m.substr(1))):/^\/static\//.test(m)?this._handleStatic(F,U,W):m==="/"?this._handleRoot(F,U,W):m==="/callback"?this._handleCallback(U):/^\/web-extension-resource\//.test(m)?this._handleWebExtensionResource(F,U,W):a(F,U,404,"Not found.")}catch(m){return this._logService.error(m),console.error(m.toString()),a(F,U,500,"Internal Server Error.")}}async _handleStatic(F,U,W){const m=Object.create(null),L=decodeURIComponent(W.pathname),M=(0,h.normalize)(L.substr("/static/".length)),Y=(0,h.join)(n,M);return(0,k.isEqualOrParent)(Y,n,!E.isLinux)?i(this._logService,F,U,Y,m):a(F,U,400,"Bad request.")}_getResourceURLTemplateAuthority(F){const U=F.authority.indexOf(".");return U!==-1?F.authority.substring(U+1):void 0}async _handleWebExtensionResource(F,U,W){if(!this._webExtensionResourceUrlTemplate)return a(F,U,500,"No extension gallery service configured.");const m=decodeURIComponent(W.pathname),L=(0,h.normalize)(m.substr("/web-extension-resource/".length)),M=l.URI.parse(L).with({scheme:this._webExtensionResourceUrlTemplate.scheme,authority:L.substring(0,L.indexOf("/")),path:L.substring(L.indexOf("/")+1)});if(this._getResourceURLTemplateAuthority(this._webExtensionResourceUrlTemplate)!==this._getResourceURLTemplateAuthority(M))return a(F,U,403,"Request Forbidden");const Y={},$=oe=>{const re=F.headers[oe];re&&((0,p.isString)(re)||re[0])?Y[oe]=(0,p.isString)(re)?re:re[0]:oe!==oe.toLowerCase()&&$(oe.toLowerCase())};$("X-Client-Name"),$("X-Client-Version"),$("X-Machine-Id"),$("X-Client-Commit");const G=await this._requestService.request({type:"GET",url:M.toString(!0),headers:Y},b.CancellationToken.None),ie=G.res.statusCode||500;if(ie!==200){let oe=null;try{oe=await(0,g.asText)(G)}catch{}return a(F,U,ie,oe||`Request failed with status ${ie}`)}const B=Object.create(null),q=oe=>{const re=G.res.headers[oe];re?B[oe]=re:oe!==oe.toLowerCase()&&q(oe.toLowerCase())};q("Cache-Control"),q("Content-Type"),U.writeHead(200,B);const ee=await(0,C.streamToBuffer)(G.stream);return U.end(ee.buffer)}async _handleRoot(F,U,W){if(!F.headers.host)return a(F,U,400,"Bad request.");const m=W.query[v.connectionTokenQueryName];if(typeof m=="string"){const Z=Object.create(null);Z["Set-Cookie"]=P.serialize(v.connectionTokenCookieName,m,{sameSite:"strict",maxAge:60*60*24*7});const H=Object.create(null);for(let V in W.query)V!==v.connectionTokenQueryName&&(H[V]=W.query[V]);const j=t.format({pathname:"/",query:H});return Z.Location=j,U.writeHead(302,Z),U.end()}const L="remote";function M(Z){return Z.replace(/"/g,"&quot;")}let Y;this._environmentService.driverHandle&&(Y=!1);const $=v.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",J).fsPath,G=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,c.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["read:user","user:email","repo"],["user:email"],["repo"]]}:void 0,ie=(0,e.relativeRoot)((0,e.getOriginalUrl)(F)),B=(0,e.relativePath)((0,e.getOriginalUrl)(F)),q=this._environmentService.args.locale||await(0,u.getLocaleFromConfig)(this._environmentService.argvResource.fsPath),ee=await(0,u.getNLSConfiguration)(q,this._environmentService.userDataPath),oe=(await w.promisify(_.readFile)($)).toString().replace("{{WORKBENCH_WEB_CONFIGURATION}}",M(JSON.stringify({remoteAuthority:L,webviewEndpoint:B+"/static/out/vs/workbench/contrib/webview/browser/pre",_wrapWebWorkerExtHostInIframe:Y,developmentOptions:{enableSmokeTestDriver:this._environmentService.driverHandle==="web"?!0:void 0,logLevel:this._logService.getLevel()},userDataPath:this._environmentService.userDataPath,settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0,productConfiguration:{rootEndpoint:ie,updateEndpoint:this._environmentService.args["disable-update-check"]?void 0:ie+"/update/check",logoutEndpoint:this._environmentService.args.auth?ie+"/logout":void 0,proxyEndpointTemplate:ie+"/proxy/{{port}}",serviceWorker:{scope:B+"/",path:ie+"/_static/out/browser/serviceWorker.js"},extensionsGallery:{...this._productService.extensionsGallery,resourceUrlTemplate:this._webExtensionResourceUrlTemplate?this._webExtensionResourceUrlTemplate.with({scheme:"http",authority:L,path:`web-extension-resource/${this._webExtensionResourceUrlTemplate.authority}${this._webExtensionResourceUrlTemplate.path}`}).toString(!0):void 0}}}))).replace("{{WORKBENCH_AUTH_SESSION}}",()=>G?M(JSON.stringify(G)):"").replace(/{{BASE}}/g,ie).replace(/{{VS_BASE}}/g,B).replace(/{{NLS_CONFIGURATION}}/g,()=>M(JSON.stringify(ee))),re=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this._getScriptCspHashes(oe).join(" ")} 'sha256-9CevbjD7QdrWdGrVTVJD74tTH4eAhisvCOlLtWUn+Iw=' http://${L};`,"child-src 'self';",`frame-src 'self' https://*.vscode-webview.net ${this._productService.webEndpointUrl||""} data:;`,"worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),de={"Content-Type":"text/html","Content-Security-Policy":re};return this._connectionToken.type!==0&&(de["Set-Cookie"]=P.serialize(v.connectionTokenCookieName,this._connectionToken.value,{sameSite:"strict",maxAge:60*60*24*7})),U.writeHead(200,de),U.end(oe)}_getScriptCspHashes(F){const U=/<script>([\s\S]+?)<\/script>/img,W=[];let m;for(;m=U.exec(F);){const L=D.createHash("sha256"),M=m[1].replace(/\r\n/g,`
`),Y=L.update(Buffer.from(M)).digest().toString("base64");W.push(`'sha256-${Y}'`)}return W}async _handleCallback(F){const U=v.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",J).fsPath,W=(await w.promisify(_.readFile)(U)).toString(),m=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this._getScriptCspHashes(W).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return F.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":m}),F.end(W)}};r=Te([Ne(1,R.IServerEnvironmentService),Ne(2,T.ILogService),Ne(3,g.IRequestService),Ne(4,d.IProductService)],r),e.WebClientServer=r;const o=(I,F=!1)=>I.replace(/\/\/+/g,"/").replace(/\/+$/,F?"/":"");e.normalizeUrlPath=o;const f=I=>{const F=(I.split("?",1)[0].match(/\//g)||[]).length;return(0,e.normalizeUrlPath)("./"+(F>1?"../".repeat(F-1):""))};e.relativeRoot=f;const S=I=>{const F=I.split("?",1)[0].split("/");return(0,e.normalizeUrlPath)("./"+F[F.length-1])};e.relativePath=S;const A=I=>I.originalUrl||I.url;e.getOriginalUrl=A}),define(ve[234],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,_.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t}),define(ve[106],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var _;(function(l){l[l.Upsert=0]="Upsert",l[l.RemoveChild=1]="RemoveChild",l[l.Invalidated=2]="Invalidated",l[l.SetProp=3]="SetProp",l[l.Bulk=4]="Bulk"})(_=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,w=(l,C)=>{const p={controllerId:C};return t.set(l,p),p};e.createPrivateApiFor=w;const P=l=>t.get(l);e.getPrivateApiFor=P;const D=(l,C,p,u)=>{let s=p;return{enumerable:!0,configurable:!1,get(){return s},set(a){if(!u(s,a)){const i=s;s=a,l.listener?.({op:3,key:C,value:a,previous:i})}}}},k=(l,C)=>l===C,y={range:(l,C)=>l===C?!0:!l||!C?!1:l.isEqual(C),label:k,description:k,sortText:k,busy:k,error:k,canResolveChildren:k,tags:(l,C)=>!(l.length!==C.length||l.some(p=>!C.find(u=>p.id===u.id)))},E=Object.keys(y),T=(l,C)=>({range:D(l,"range",void 0,y.range),label:D(l,"label",C,y.label),description:D(l,"description",void 0,y.description),sortText:D(l,"sortText",void 0,y.sortText),canResolveChildren:D(l,"canResolveChildren",!1,y.canResolveChildren),busy:D(l,"busy",!1,y.busy),error:D(l,"error",void 0,y.error),tags:D(l,"tags",[],y.tags)}),R=(l,C)=>{const p=new Map;for(const u of E)y[u](l[u],C[u])||p.set(u,C[u]);return p};e.diffTestItems=R;class h extends Error{constructor(C){super(`Attempted to insert a duplicate test item ID ${C}`)}}e.DuplicateTestItemError=h;class v extends Error{constructor(C){super(`TestItem with ID "${C}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=v;class c extends Error{constructor(C,p,u){super(`TestItem with ID "${C}" is from controller "${p}" and cannot be added as a child of an item from controller "${u}".`)}}e.MixedTestItemController=c;const d=l=>{const C=(0,e.getPrivateApiFor)(l);let p=new Map;return{get size(){return p.size},forEach(u,s){for(const a of p.values())u.call(s,a,this)},replace(u){const s=new Map,a=new Set(p.keys()),i={op:4,ops:[]};for(const n of u){if(!(n instanceof g))throw new v(n.id);const r=(0,e.getPrivateApiFor)(n).controllerId;if(r!==C.controllerId)throw new c(n.id,r,C.controllerId);if(s.has(n.id))throw new h(n.id);s.set(n.id,n),a.delete(n.id),i.ops.push({op:0,item:n})}for(const n of a.keys())i.ops.push({op:1,id:n});C.listener?.(i),p=s},add(u){if(!(u instanceof g))throw new v(u.id);p.set(u.id,u),C.listener?.({op:0,item:u})},delete(u){p.delete(u)&&C.listener?.({op:1,id:u})},get(u){return p.get(u)},toJSON(){return Array.from(p.values())},[Symbol.iterator](){return p.values()}}};class g{constructor(C,p,u,s){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const a=(0,e.createPrivateApiFor)(this,C);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof b?void 0:a.parent}},children:{value:d(this),enumerable:!0,writable:!1},...T(a,u)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=g;class b extends g{constructor(C,p){super(C,C,p,void 0)}}e.TestItemRootImpl=b});var Et=this&&this.__classPrivateFieldSet||function(J,e,_,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!w:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(J,_):w?w.value=_:e.set(J,_),_},tt=this&&this.__classPrivateFieldGet||function(J,e,_,t){if(_==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?t:_==="a"?t.call(J):t?t.value:e.get(J)};define(ve[107],we([0,1,17,11,77,30,59,18,12,5,23,16,97]),function(J,e,_,t,w,P,D,k,y,E,T,R,h){"use strict";var v,c,d,g,b,l,C,p,u,s,a,i,n,r,o,f,S,A,I,F;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function U(N){function O(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(O,N),Object.setPrototypeOf(O.prototype,N.prototype),O}let W=b=class{constructor(O){v.set(this,void 0),Et(this,v,O,"f")}static from(...O){let te=O;return new b(function(){if(te){for(const be of te)be&&typeof be.dispose=="function"&&be.dispose();te=void 0}})}dispose(){typeof tt(this,v,"f")=="function"&&(tt(this,v,"f").call(this),Et(this,v,void 0,"f"))}};v=new WeakMap,W=b=Te([U],W),e.Disposable=W;let m=l=class{constructor(O,te){if(O<0)throw(0,t.illegalArgument)("line must be non-negative");if(te<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=O,this._character=te}static Min(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let be=1;be<O.length;be++){const ze=O[be];ze.isBefore(te)&&(te=ze)}return te}static Max(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let be=1;be<O.length;be++){const ze=O[be];ze.isAfter(te)&&(te=ze)}return te}static isPosition(O){if(!O)return!1;if(O instanceof l)return!0;let{line:te,character:be}=O;return typeof te=="number"&&typeof be=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,te=0){if(O===null||te===null)throw(0,t.illegalArgument)();let be;return typeof O=="undefined"?be=0:typeof O=="number"?be=O:(be=typeof O.lineDelta=="number"?O.lineDelta:0,te=typeof O.characterDelta=="number"?O.characterDelta:0),be===0&&te===0?this:new l(this.line+be,this.character+te)}with(O,te=this.character){if(O===null||te===null)throw(0,t.illegalArgument)();let be;return typeof O=="undefined"?be=this.line:typeof O=="number"?be=O:(be=typeof O.line=="number"?O.line:this.line,te=typeof O.character=="number"?O.character:this.character),be===this.line&&te===this.character?this:new l(be,te)}toJSON(){return{line:this.line,character:this.character}}};m=l=Te([U],m),e.Position=m;let L=C=class{constructor(O,te,be,ze){let xe,Qe;if(typeof O=="number"&&typeof te=="number"&&typeof be=="number"&&typeof ze=="number"?(xe=new m(O,te),Qe=new m(be,ze)):O instanceof m&&te instanceof m&&(xe=O,Qe=te),!xe||!Qe)throw new Error("Invalid arguments");xe.isBefore(Qe)?(this._start=xe,this._end=Qe):(this._start=Qe,this._end=xe)}static isRange(O){return O instanceof C?!0:O?m.isPosition(O.start)&&m.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof C?this.contains(O._start)&&this.contains(O._end):O instanceof m?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const te=m.Max(O.start,this._start),be=m.Min(O.end,this._end);if(!te.isAfter(be))return new C(te,be)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const te=m.Min(O.start,this._start),be=m.Max(O.end,this.end);return new C(te,be)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,te=this.end){if(O===null||te===null)throw(0,t.illegalArgument)();let be;return O?m.isPosition(O)?be=O:(be=O.start||this.start,te=O.end||this.end):be=this.start,be.isEqual(this._start)&&te.isEqual(this.end)?this:new C(be,te)}toJSON(){return[this.start,this.end]}};L=C=Te([U],L),e.Range=L;let M=p=class extends L{constructor(O,te,be,ze){let xe,Qe;if(typeof O=="number"&&typeof te=="number"&&typeof be=="number"&&typeof ze=="number"?(xe=new m(O,te),Qe=new m(be,ze)):O instanceof m&&te instanceof m&&(xe=O,Qe=te),!xe||!Qe)throw new Error("Invalid arguments");super(xe,Qe);this._anchor=xe,this._active=Qe}static isSelection(O){return O instanceof p?!0:O?L.isRange(O)&&m.isPosition(O.anchor)&&m.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};M=p=Te([U],M),e.Selection=M;class Y{constructor(O,te,be){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,t.illegalArgument)("port");if(typeof be!="undefined"&&(typeof be!="string"||be.length===0||!/^[0-9A-Za-z\-]+$/.test(be)))throw(0,t.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(te),this.connectionToken=be}}e.ResolvedAuthority=Y;class $ extends Error{constructor(O,te=h.RemoteAuthorityResolverErrorCode.Unknown,be){super(O);this._message=O,this._code=te,this._detail=be,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,$.prototype)}static NotAvailable(O,te){return new $(O,h.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(O){return new $(O,h.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=$;var G;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(G=e.EndOfLine||(e.EndOfLine={}));var ie;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(ie=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=u=class{constructor(O,te){this._range=O,this._newText=te}static isTextEdit(O){return O instanceof u?!0:O?L.isRange(O)&&typeof O.newText=="string":!1}static replace(O,te){return new u(O,te)}static insert(O,te){return u.replace(new L(O,O),te)}static delete(O){return u.replace(O,"")}static setEndOfLine(O){const te=new u(new L(new m(0,0),new m(0,0)),"");return te.newEol=O,te}get range(){return this._range}set range(O){if(O&&!L.isRange(O))throw(0,t.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,t.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,t.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=u=Te([U],B),e.TextEdit=B;var q;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(q=e.FileEditType||(e.FileEditType={}));let ee=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,te,be,ze){this._edits.push({_type:1,from:O,to:te,options:be,metadata:ze})}createFile(O,te,be){this._edits.push({_type:1,from:void 0,to:O,options:te,metadata:be})}deleteFile(O,te,be){this._edits.push({_type:1,from:O,to:void 0,options:te,metadata:be})}replaceNotebookMetadata(O,te,be){this._edits.push({_type:3,metadata:be,uri:O,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(O,te,be,ze,xe){let Qe,Je,st=[],at;if(kt.isNotebookRange(te)&&St.isNotebookCellDataArray(be)&&!St.isNotebookCellDataArray(ze)?(Qe=te.start,Je=te.end,st=be,at=ze):typeof te=="number"&&typeof be=="number"&&St.isNotebookCellDataArray(ze)&&(Qe=te,Je=be,st=ze,at=xe),Qe===void 0||Je===void 0)throw new Error("Invalid arguments");(Qe!==Je||st.length>0)&&this._edits.push({_type:5,uri:O,index:Qe,count:Je-Qe,cells:st,metadata:at})}replaceNotebookCellMetadata(O,te,be,ze){this._edits.push({_type:3,metadata:ze,uri:O,edit:{editType:8,index:te,metadata:be}})}replace(O,te,be,ze){this._edits.push({_type:2,uri:O,edit:new B(te,be),metadata:ze})}insert(O,te,be,ze){this.replace(O,new L(te,te),be,ze)}delete(O,te,be){this.replace(O,te,"",be)}has(O){return this._edits.some(te=>te._type===2&&te.uri.toString()===O.toString())}set(O,te){if(te)for(const be of te)be&&this._edits.push({_type:2,uri:O,edit:be});else{for(let be=0;be<this._edits.length;be++){const ze=this._edits[be];ze._type===2&&ze.uri.toString()===O.toString()&&(this._edits[be]=void 0)}(0,_.coalesceInPlace)(this._edits)}}get(O){const te=[];for(let be of this._edits)be._type===2&&be.uri.toString()===O.toString()&&te.push(be.edit);return te}entries(){const O=new P.ResourceMap;for(let te of this._edits)if(te._type===2){let be=O.get(te.uri);be||(be=[te.uri,[]],O.set(te.uri,be)),be[1].push(te.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ee=Te([U],ee),e.WorkspaceEdit=ee;let oe=s=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof s?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=s._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,te=this._tabstop++){if(typeof O=="function"){const be=new s;be._tabstop=this._tabstop,O(be),this._tabstop=be._tabstop,O=be.value}else O=s._escape(O);return this.value+="${",this.value+=te,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,te=this._tabstop++){const be=O.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=be,this.value+="|}",this}appendVariable(O,te){if(typeof te=="function"){const be=new s;be._tabstop=this._tabstop,te(be),this._tabstop=be._tabstop,te=be.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,te&&(this.value+=":",this.value+=te),this.value+="}",this}};oe=s=Te([U],oe),e.SnippetString=oe;var re;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(re=e.DiagnosticTag||(e.DiagnosticTag={}));var de;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(de=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Z=a=class{constructor(O,te){if(this.uri=O,te)if(te instanceof L)this.range=te;else if(te instanceof m)this.range=new L(te,te);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof a?!0:O?L.isRange(O.range)&&E.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Z=a=Te([U],Z),e.Location=Z;let H=class{constructor(O,te){this.location=O,this.message=te}static is(O){return O?typeof O.message=="string"&&O.location&&L.isRange(O.location.range)&&E.URI.isUri(O.location.uri):!1}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.location.range.isEqual(te.location.range)&&O.location.uri.toString()===te.location.uri.toString()}};H=Te([U],H),e.DiagnosticRelatedInformation=H;let j=class{constructor(O,te,be=de.Error){if(!L.isRange(O))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=O,this.message=te,this.severity=be}toJSON(){return{severity:de[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.severity===te.severity&&O.code===te.code&&O.severity===te.severity&&O.source===te.source&&O.range.isEqual(te.range)&&(0,_.equals)(O.tags,te.tags)&&(0,_.equals)(O.relatedInformation,te.relatedInformation,H.isEqual)}};j=Te([U],j),e.Diagnostic=j;let V=class{constructor(O,te){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=te}};V=Te([U],V),e.Hover=V;var ne;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(ne=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let me=class{constructor(O,te=ne.Text){this.range=O,this.kind=te}toJSON(){return{range:this.range,kind:ne[this.kind]}}};me=Te([U],me),e.DocumentHighlight=me;var De;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(De=e.SymbolKind||(e.SymbolKind={}));var ae;(function(N){N[N.Deprecated=1]="Deprecated"})(ae=e.SymbolTag||(e.SymbolTag={}));let fe=i=class{constructor(O,te,be,ze,xe){this.name=O,this.kind=te,this.containerName=xe,typeof be=="string"&&(this.containerName=be),ze instanceof Z?this.location=ze:be instanceof L&&(this.location=new Z(ze,be)),i.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:De[this.kind],location:this.location,containerName:this.containerName}}};fe=i=Te([U],fe),e.SymbolInformation=fe;let pe=n=class{constructor(O,te,be,ze,xe){this.name=O,this.detail=te,this.kind=be,this.range=ze,this.selectionRange=xe,this.children=[],n.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(n.validate)}};pe=n=Te([U],pe),e.DocumentSymbol=pe;var Q;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(Q=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let z=class{constructor(O,te){this.title=O,this.kind=te}};z=Te([U],z),e.CodeAction=z;let x=r=class{constructor(O){this.value=O}append(O){return new r(this.value?this.value+r.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+r.sep)}};x.sep=".",x=r=Te([U],x),e.CodeActionKind=x,x.Empty=new x(""),x.QuickFix=x.Empty.append("quickfix"),x.Refactor=x.Empty.append("refactor"),x.RefactorExtract=x.Refactor.append("extract"),x.RefactorInline=x.Refactor.append("inline"),x.RefactorRewrite=x.Refactor.append("rewrite"),x.Source=x.Empty.append("source"),x.SourceOrganizeImports=x.Source.append("organizeImports"),x.SourceFixAll=x.Source.append("fixAll");let X=class{constructor(O,te){if(this.range=O,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};X=Te([U],X),e.SelectionRange=X;class ue{constructor(O,te,be,ze,xe,Qe){this.kind=O,this.name=te,this.detail=be,this.uri=ze,this.range=xe,this.selectionRange=Qe}}e.CallHierarchyItem=ue;class ye{constructor(O,te){this.fromRanges=te,this.from=O}}e.CallHierarchyIncomingCall=ye;class Pe{constructor(O,te){this.fromRanges=te,this.to=O}}e.CallHierarchyOutgoingCall=Pe;var Ae;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(Ae=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Fe=class{constructor(O,te){this.range=O,this.command=te}get isResolved(){return!!this.command}};Fe=Te([U],Fe),e.CodeLens=Fe;let Ue=o=class{constructor(O,te=!1){c.set(this,void 0),Et(this,c,new w.MarkdownString(O,{supportThemeIcons:te}),"f")}static isMarkdownString(O){return O instanceof o?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return tt(this,c,"f").value}set value(O){tt(this,c,"f").value=O}get isTrusted(){return tt(this,c,"f").isTrusted}set isTrusted(O){tt(this,c,"f").isTrusted=O}get supportThemeIcons(){return tt(this,c,"f").supportThemeIcons}set supportThemeIcons(O){tt(this,c,"f").supportThemeIcons=O}get supportHtml(){return tt(this,c,"f").supportHtml}set supportHtml(O){tt(this,c,"f").supportHtml=O}appendText(O){return tt(this,c,"f").appendText(O),this}appendMarkdown(O){return tt(this,c,"f").appendMarkdown(O),this}appendCodeblock(O,te){return tt(this,c,"f").appendCodeblock(te??"",O),this}};c=new WeakMap,Ue=o=Te([U],Ue),e.MarkdownString=Ue;let le=class{constructor(O,te){this.label=O,this.documentation=te}};le=Te([U],le),e.ParameterInformation=le;let ge=class{constructor(O,te){this.label=O,this.documentation=te,this.parameters=[]}};ge=Te([U],ge),e.SignatureInformation=ge;let he=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};he=Te([U],he),e.SignatureHelp=he;var Re;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(Re=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Me;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Me=e.InlayHintKind||(e.InlayHintKind={}));let qe=class{constructor(O){this.label=O}};qe=Te([U],qe),e.InlayHintLabelPart=qe;let Be=class{constructor(O,te,be){this.label=O,this.position=te,this.kind=be}};Be=Te([U],Be),e.InlayHint=Be;var je;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var He;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(He=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(N){N[N.Deprecated=1]="Deprecated"})(se=e.CompletionItemTag||(e.CompletionItemTag={}));let Se=class{constructor(O,te){this.label=O,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&He[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Se=Te([U],Se),e.CompletionItem=Se;let ke=class{constructor(O=[],te=!1){this.items=O,this.isIncomplete=te}};ke=Te([U],ke),e.CompletionList=ke;let Le=class{constructor(O,te,be){this.text=O,this.range=te,this.command=be}};Le=Te([U],Le),e.InlineSuggestion=Le;let Oe=class{constructor(O){this.items=O}};Oe=Te([U],Oe),e.InlineSuggestions=Oe;var Ye;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(Ye=e.ViewColumn||(e.ViewColumn={}));var $e;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})($e=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ve;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Ve=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Xe;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ge;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Ge=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ze;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var rt;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(rt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var et;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(et=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function O(te){switch(te){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=O}(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let nt=class{constructor(O,te){if(te&&!E.URI.isUri(te))throw(0,t.illegalArgument)("target");if(!L.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.target=te}};nt=Te([U],nt),e.DocumentLink=nt;let ot=class{constructor(O,te,be,ze){this.red=O,this.green=te,this.blue=be,this.alpha=ze}};ot=Te([U],ot),e.Color=ot;let vt=class{constructor(O,te){if(te&&!(te instanceof ot))throw(0,t.illegalArgument)("color");if(!L.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.color=te}};vt=Te([U],vt),e.ColorInformation=vt;let pt=class{constructor(O){if(!O||typeof O!="string")throw(0,t.illegalArgument)("label");this.label=O}};pt=Te([U],pt),e.ColorPresentation=pt;var Dt;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Dt=e.ColorFormat||(e.ColorFormat={}));var It;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(It=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Pt{constructor(O,te,be){if(this.startIndex=O,this.length=te,this.tooltip=be,typeof O!="number"||O<0)throw(0,t.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,t.illegalArgument)("length");if(be!==void 0&&typeof be!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Pt;var Ee;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(Ee=e.TerminalLocation||(e.TerminalLocation={}));class Ce{constructor(O){this.options=O,typeof O!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=Ce;var ce;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(ce=e.TaskRevealKind||(e.TaskRevealKind={}));var K;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(K=e.TaskPanelKind||(e.TaskPanelKind={}));let Ie=f=class{constructor(O,te){if(this.label=te,typeof O!="string"||typeof te!="string")throw(0,t.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}get id(){return this._id}};Ie.Clean=new f("clean","Clean"),Ie.Build=new f("build","Build"),Ie.Rebuild=new f("rebuild","Rebuild"),Ie.Test=new f("test","Test"),Ie=f=Te([U],Ie),e.TaskGroup=Ie;function _e(N){let O="";for(let te=0;te<N.length;te++)O+=N[te].replace(/,/g,",,")+",";return O}let Ke=class{constructor(O,te,be){if(typeof O!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=O,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=be):this._options=te)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,t.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let te of this._args)O.push(te);return _e(O)}};Ke=Te([U],Ke),e.ProcessExecution=Ke;let We=class{constructor(O,te,be){if(this._args=[],Array.isArray(te)){if(!O)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this._command=O,this._args=te,this._options=be}else{if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=O,this._options=te}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)O.push(typeof te=="string"?te:te.value);return _e(O)}};We=Te([U],We),e.ShellExecution=We;var it;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(it=e.ShellQuoting||(e.ShellQuoting={}));var lt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(lt=e.TaskScope||(e.TaskScope={}));class wt{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=wt;let ct=S=class{constructor(O,te,be,ze,xe,Qe){this.__deprecated=!1,this._definition=this.definition=O;let Je;typeof te=="string"?(this._name=this.name=te,this._source=this.source=be,this.execution=ze,Je=xe,this.__deprecated=!0):te===lt.Global||te===lt.Workspace?(this.target=te,this._name=this.name=be,this._source=this.source=ze,this.execution=xe,Je=Qe):(this.target=te,this._name=this.name=be,this._source=this.source=ze,this.execution=xe,Je=Qe),typeof Je=="string"?(this._problemMatchers=[Je],this._hasDefinedMatchers=!0):Array.isArray(Je)?(this._problemMatchers=Je,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ke?this._definition={type:S.ProcessType,id:this._execution.computeId()}:this._execution instanceof We?this._definition={type:S.ShellType,id:this._execution.computeId()}:this._execution instanceof wt?this._definition={type:S.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:S.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const te=this._definition.type;(S.EmptyType===te||S.ProcessType===te||S.ShellType===te||S.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};ct.ExtensionCallbackType="customExecution",ct.ProcessType="process",ct.ShellType="shell",ct.EmptyType="$empty",ct=S=Te([U],ct),e.Task=ct;var ut;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(ut=e.ProgressLocation||(e.ProgressLocation={}));let ft=class{constructor(O,te=cn.None){this.collapsibleState=te,E.URI.isUri(O)?this.resourceUri=O:this.label=O}};ft=Te([U],ft),e.TreeItem=ft;var cn;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(cn=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ft=class{constructor(O){this._value=O}async asString(){return JSON.stringify(this._value)}};Ft=Te([U],Ft),e.TreeDataTransferItem=Ft;let Ot=class{constructor(){this._items=new Map}get(O){return this._items.get(O)}set(O,te){this._items.set(O,te)}forEach(O){this._items.forEach(O)}};Ot=Te([U],Ot),e.TreeDataTransfer=Ot;let yt=class{constructor(O,te){this.id=O,this.color=te}};yt=Te([U],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let Nt=class{constructor(O){this.id=O}};Nt=Te([U],Nt),e.ThemeColor=Nt;var fn;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(fn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Mt=class{constructor(O,te){if(typeof O!="string"&&(!O||!E.URI.isUri(O)&&!E.URI.isUri(O.uri)))throw(0,t.illegalArgument)("base");if(typeof te!="string")throw(0,t.illegalArgument)("pattern");typeof O=="string"?this.baseUri=E.URI.file(O):E.URI.isUri(O)?this.baseUri=O:this.baseUri=O.uri,this.pattern=te}get base(){return this._base}set base(O){this._base=O,this._baseUri=E.URI.file(O)}get baseUri(){return this._baseUri}set baseUri(O){this._baseUri=O,this._base=O.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Mt=Te([U],Mt),e.RelativePattern=Mt;let bt=class{constructor(O,te,be,ze){this.enabled=typeof O=="boolean"?O:!0,typeof te=="string"&&(this.condition=te),typeof be=="string"&&(this.hitCondition=be),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};bt=Te([U],bt),e.Breakpoint=bt;let Ut=class extends bt{constructor(O,te,be,ze,xe){super(te,be,ze,xe);if(O===null)throw(0,t.illegalArgument)("location");this.location=O}};Ut=Te([U],Ut),e.SourceBreakpoint=Ut;let Bt=class extends bt{constructor(O,te,be,ze,xe){super(te,be,ze,xe);this.functionName=O}};Bt=Te([U],Bt),e.FunctionBreakpoint=Bt;let zt=class extends bt{constructor(O,te,be,ze,xe,Qe,Je){super(ze,xe,Qe,Je);if(!te)throw(0,t.illegalArgument)("dataId");this.label=O,this.dataId=te,this.canPersist=be}};zt=Te([U],zt),e.DataBreakpoint=zt;let $t=class{constructor(O,te,be){this.command=O,this.args=te||[],this.options=be}};$t=Te([U],$t),e.DebugAdapterExecutable=$t;let Wt=class{constructor(O,te){this.port=O,this.host=te}};Wt=Te([U],Wt),e.DebugAdapterServer=Wt;let Ht=class{constructor(O){this.path=O}};Ht=Te([U],Ht),e.DebugAdapterNamedPipeServer=Ht;let jt=class{constructor(O){this.implementation=O}};jt=Te([U],jt),e.DebugAdapterInlineImplementation=jt;let qt=class{constructor(O,te){this.range=O,this.expression=te}};qt=Te([U],qt),e.EvaluatableExpression=qt;var hn;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(hn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Vt=class{constructor(O,te){this.range=O,this.text=te}};Vt=Te([U],Vt),e.InlineValueText=Vt;let Gt=class{constructor(O,te,be=!0){this.range=O,this.variableName=te,this.caseSensitiveLookup=be}};Gt=Te([U],Gt),e.InlineValueVariableLookup=Gt;let Kt=class{constructor(O,te){this.range=O,this.expression=te}};Kt=Te([U],Kt),e.InlineValueEvaluatableExpression=Kt;let xt=class{constructor(O,te){this.frameId=O,this.stoppedLocation=te}};xt=Te([U],xt),e.InlineValueContext=xt;var dn;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(dn=e.FileChangeType||(e.FileChangeType={}));let Yt=A=class extends Error{constructor(O,te=R.FileSystemProviderErrorCode.Unknown,be){super(E.URI.isUri(O)?O.toString(!0):O);this.code=be?.name??"Unknown",(0,R.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype),typeof Error.captureStackTrace=="function"&&typeof be=="function"&&Error.captureStackTrace(this,be)}static FileExists(O){return new A(O,R.FileSystemProviderErrorCode.FileExists,A.FileExists)}static FileNotFound(O){return new A(O,R.FileSystemProviderErrorCode.FileNotFound,A.FileNotFound)}static FileNotADirectory(O){return new A(O,R.FileSystemProviderErrorCode.FileNotADirectory,A.FileNotADirectory)}static FileIsADirectory(O){return new A(O,R.FileSystemProviderErrorCode.FileIsADirectory,A.FileIsADirectory)}static NoPermissions(O){return new A(O,R.FileSystemProviderErrorCode.NoPermissions,A.NoPermissions)}static Unavailable(O){return new A(O,R.FileSystemProviderErrorCode.Unavailable,A.Unavailable)}};Yt=A=Te([U],Yt),e.FileSystemError=Yt;let Xt=class{constructor(O,te,be){this.start=O,this.end=te,this.kind=be}};Xt=Te([U],Xt),e.FoldingRange=Xt;var mn;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(mn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var gn;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(gn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var vn;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(vn=e.CommentMode||(e.CommentMode={}));class pn{constructor(O,te=[]){this.tokenTypes=O,this.tokenModifiers=te}}e.SemanticTokensLegend=pn;function wn(N){return typeof N=="undefined"||(0,y.isStringArray)(N)}class Qt{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let te=0,be=O.tokenTypes.length;te<be;te++)this._tokenTypeStrToInt.set(O.tokenTypes[te],te);for(let te=0,be=O.tokenModifiers.length;te<be;te++)this._tokenModifierStrToInt.set(O.tokenModifiers[te],te)}}push(O,te,be,ze,xe){if(typeof O=="number"&&typeof te=="number"&&typeof be=="number"&&typeof ze=="number"&&(typeof xe=="number"||typeof xe=="undefined"))return typeof xe=="undefined"&&(xe=0),this._pushEncoded(O,te,be,ze,xe);if(L.isRange(O)&&typeof te=="string"&&wn(be))return this._push(O,te,be);throw(0,t.illegalArgument)()}_push(O,te,be){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const ze=O.start.line,xe=O.start.character,Qe=O.end.character-O.start.character,Je=this._tokenTypeStrToInt.get(te);let st=0;if(be)for(const at of be){if(!this._tokenModifierStrToInt.has(at))throw new Error("`tokenModifier` is not in the provided legend");const dt=this._tokenModifierStrToInt.get(at);st|=1<<dt>>>0}this._pushEncoded(ze,xe,Qe,Je,st)}_pushEncoded(O,te,be,ze,xe){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const st=this._data.length/5|0;let at=0,dt=0;for(let mt=0;mt<st;mt++){let gt=this._data[5*mt],_t=this._data[5*mt+1];gt===0?(gt=at,_t+=dt):gt+=at,this._data[5*mt]=gt,this._data[5*mt+1]=_t,at=gt,dt=_t}}let Qe=O,Je=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Qe-=this._prevLine,Qe===0&&(Je-=this._prevChar)),this._data[this._dataLen++]=Qe,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=be,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=xe,this._prevLine=O,this._prevChar=te}static _sortAndDeltaEncode(O){let te=[];const be=O.length/5|0;for(let Je=0;Je<be;Je++)te[Je]=Je;te.sort((Je,st)=>{const at=O[5*Je],dt=O[5*st];if(at===dt){const mt=O[5*Je+1],gt=O[5*st+1];return mt-gt}return at-dt});const ze=new Uint32Array(O.length);let xe=0,Qe=0;for(let Je=0;Je<be;Je++){const st=5*te[Je],at=O[st+0],dt=O[st+1],mt=O[st+2],gt=O[st+3],_t=O[st+4],un=at-xe,Gn=un===0?dt-Qe:dt,Rt=5*Je;ze[Rt+0]=un,ze[Rt+1]=Gn,ze[Rt+2]=mt,ze[Rt+3]=gt,ze[Rt+4]=_t,xe=at,Qe=dt}return ze}build(O){return this._dataIsSortedAndDeltaEncoded?new Jt(new Uint32Array(this._data),O):new Jt(Qt._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=Qt;class Jt{constructor(O,te){this.resultId=te,this.data=O}}e.SemanticTokens=Jt;class yn{constructor(O,te,be){this.start=O,this.deleteCount=te,this.data=be}}e.SemanticTokensEdit=yn;class En{constructor(O,te){this.resultId=te,this.edits=O}}e.SemanticTokensEdits=En;var Sn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Sn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var bn;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(bn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let At=class{constructor(){}};At.Back={iconPath:new yt("arrow-left")},At=Te([U],At),e.QuickInputButtons=At;var Cn;(function(N){N[N.Separator=-1]="Separator",N[N.Default=0]="Default"})(Cn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Dn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class In{constructor(O,te,be){this.badge=O,this.tooltip=te,this.color=be}static validate(O){if(O.badge){let te=(0,k.nextCharLength)(O.badge,0);if(te<O.badge.length&&(te+=(0,k.nextCharLength)(O.badge,te)),O.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=In;let Zt=class{constructor(O){this.kind=O}};Zt=Te([U],Zt),e.ColorTheme=Zt;var Pn;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(Pn=e.ColorThemeKind||(e.ColorThemeKind={}));class kt{constructor(O,te){if(O<0)throw(0,t.illegalArgument)("start must be positive");if(te<0)throw(0,t.illegalArgument)("end must be positive");O<=te?(this._start=O,this._end=te):(this._start=te,this._end=O)}static isNotebookRange(O){return O instanceof kt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let te=this._start,be=this._end;return O.start!==void 0&&(te=O.start),O.end!==void 0&&(be=O.end),te===this._start&&be===this._end?this:new kt(te,be)}}e.NotebookRange=kt;class St{constructor(O,te,be,ze,xe,Qe,Je){this.kind=O,this.value=te,this.languageId=be,this.mime=ze,this.outputs=xe??[],this.metadata=Qe,this.executionSummary=Je,St.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(te=>St.isNotebookCellData(te))}static isNotebookCellData(O){return!0}}e.NotebookCellData=St;class kn{constructor(O){this.cells=O}}e.NotebookData=kn;class ht{constructor(O,te){this.data=O,this.mime=te;const be=(0,D.normalizeMimeType)(te,!0);if(!be)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=be}static isNotebookCellOutputItem(O){return O instanceof ht?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const te={name:O.name,message:O.message,stack:O.stack};return ht.json(te,"application/vnd.code.notebook.error")}static stdout(O){return ht.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return ht.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,te="application/octet-stream"){return new ht(O,te)}static text(O,te=D.Mimes.text){const be=tt(ht,d,"f",g).encode(String(O));return new ht(be,te)}static json(O,te="application/json"){const be=JSON.stringify(O,void 0,"	");return ht.text(be,te)}}e.NotebookCellOutputItem=ht,d=ht,g={value:new TextEncoder};class Tt{constructor(O,te,be){this.items=Tt.ensureUniqueMimeTypes(O,!0),typeof te=="string"?(this.id=te,this.metadata=be):(this.id=(0,T.generateUuid)(),this.metadata=te??be)}static isNotebookCellOutput(O){return O instanceof Tt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,y.isArray)(O.items)}static ensureUniqueMimeTypes(O,te=!1){const be=new Set,ze=new Set;for(let xe=0;xe<O.length;xe++){const Qe=O[xe],Je=(0,D.normalizeMimeType)(Qe.mime);if(!be.has(Je)){be.add(Je);continue}ze.add(xe),te&&console.warn(`DUPLICATED mime type '${Qe.mime}' will be dropped`)}return ze.size===0?O:O.filter((xe,Qe)=>!ze.has(Qe))}}e.NotebookCellOutput=Tt;var _n;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(_n=e.NotebookCellKind||(e.NotebookCellKind={}));var Rn;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Rn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var An;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(An=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Tn;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Tn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ln{constructor(O,te){this.text=O,this.alignment=te}}e.NotebookCellStatusBarItem=Ln;var Fn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Fn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class On{constructor(O,te=[]){this.uri=O,this.provides=(0,_.asArray)(te)}}e.NotebookRendererScript=On;let en=class{constructor(O,te){this.label=O,this.timestamp=te}};en=Te([U],en),e.TimelineItem=en;var Nn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Nn=e.ExtensionMode||(e.ExtensionMode={}));var Mn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Mn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Un;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=3]="RegEx"})(Un=e.StandardTokenType||(e.StandardTokenType={}));class Bn{constructor(O,te){this.ranges=O,this.wordPattern=te}}e.LinkedEditingRanges=Bn;class zn{constructor(O,te){this._port=O,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=zn;var $n;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})($n=e.TestResultState||(e.TestResultState={}));var Wn;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Wn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let tn=class{constructor(O=void 0,te=void 0,be=void 0){this.include=O,this.exclude=te,this.profile=be}};tn=Te([U],tn),e.TestRunRequest=tn;let nn=I=class{constructor(O){this.message=O}static diff(O,te,be){const ze=new I(O);return ze.expectedOutput=te,ze.actualOutput=be,ze}};nn=I=Te([U],nn),e.TestMessage=nn;let rn=class{constructor(O){this.id=O}};rn=Te([U],rn),e.TestTag=rn;let Ct=class{constructor(O,te){this.covered=O,this.total=te}};Ct=Te([U],Ct),e.CoveredCount=Ct;let sn=F=class{constructor(O,te,be,ze){this.uri=O,this.statementCoverage=te,this.branchCoverage=be,this.functionCoverage=ze}static fromDetails(O,te){const be=new Ct(0,0),ze=new Ct(0,0),xe=new Ct(0,0);for(const Je of te)if("branches"in Je){be.total+=1,be.covered+=Je.executionCount>0?1:0;for(const st of Je.branches)ze.total+=1,ze.covered+=st.executionCount>0?1:0}else xe.total+=1,xe.covered+=Je.executionCount>0?1:0;const Qe=new F(O,be,ze.total>0?ze:void 0,xe.total>0?xe:void 0);return Qe.detailedCoverage=te,Qe}};sn=F=Te([U],sn),e.FileCoverage=sn;let on=class{constructor(O,te,be=[]){this.executionCount=O,this.location=te,this.branches=be}};on=Te([U],on),e.StatementCoverage=on;let an=class{constructor(O,te){this.executionCount=O,this.location=te}};an=Te([U],an),e.BranchCoverage=an;let ln=class{constructor(O,te){this.executionCount=O,this.location=te}};ln=Te([U],ln),e.FunctionCoverage=ln;var Hn;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var jn;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(jn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var qn;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(qn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Vn{constructor(O,te,be,ze,xe,Qe){this.kind=O,this.name=te,this.detail=be,this.uri=ze,this.range=xe,this.selectionRange=Qe}}e.TypeHierarchyItem=Vn}),define(ve[108],we([0,1,173,12,5,2,6,35,16,17,8]),function(J,e,_,t,w,P,D,k,y,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,_.localize)(0,null),providerDisplayName:(0,_.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function R(m,L,M){for(const Y of M.visibleEditorPanes)if(Y.group.id===L&&m.matches(Y.input))return Y.getViewState()}e.findViewStateForEditor=R;function h(m){if(p(m))return!1;const L=m;return w.URI.isUri(L?.resource)}e.isResourceEditorInput=h;function v(m){if(p(m))return!1;const L=m;return L?.original!==void 0&&L.modified!==void 0}e.isResourceDiffEditorInput=v;function c(m){if(p(m)||v(m))return!1;const L=m;return L?.primary!==void 0&&L.secondary!==void 0}e.isResourceSideBySideEditorInput=c;function d(m){if(p(m))return!1;const L=m;return L?L.resource===void 0||L.resource.scheme===T.Schemas.untitled||L.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=d;var g;(function(m){m[m.SHORT=0]="SHORT",m[m.MEDIUM=1]="MEDIUM",m[m.LONG=2]="LONG"})(g=e.Verbosity||(e.Verbosity={}));var b;(function(m){m[m.EXPLICIT=1]="EXPLICIT",m[m.AUTO=2]="AUTO",m[m.FOCUS_CHANGE=3]="FOCUS_CHANGE",m[m.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var l;(function(m){m[m.None=0]="None",m[m.Readonly=2]="Readonly",m[m.Untitled=4]="Untitled",m[m.Singleton=8]="Singleton",m[m.RequiresTrust=16]="RequiresTrust",m[m.CanSplitInGroup=32]="CanSplitInGroup",m[m.ForceDescription=64]="ForceDescription"})(l=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class C extends P.Disposable{}e.AbstractEditorInput=C;function p(m){return m instanceof C}e.isEditorInput=p;function u(m){const L=m;return w.URI.isUri(L?.preferredResource)}function s(m){const L=m;return p(L?.primary)&&p(L?.secondary)}e.isSideBySideEditorInput=s;function a(m){const L=m;return p(L?.modified)&&p(L?.original)}e.isDiffEditorInput=a;function i(m){return p(m?.editor)}e.isEditorInputWithOptions=i;function n(m){const L=m;return i(m)&&L?.group!==void 0}e.isEditorInputWithOptionsAndGroup=n;function r(m){const L=m;return typeof L?.groupId=="number"&&p(L.editor)}e.isEditorIdentifier=r;var o;(function(m){m[m.UNKNOWN=0]="UNKNOWN",m[m.REPLACE=1]="REPLACE",m[m.MOVE=2]="MOVE",m[m.UNPIN=3]="UNPIN"})(o=e.EditorCloseContext||(e.EditorCloseContext={}));var f;(function(m){m[m.GROUP_ACTIVE=0]="GROUP_ACTIVE",m[m.GROUP_INDEX=1]="GROUP_INDEX",m[m.GROUP_LOCKED=2]="GROUP_LOCKED",m[m.EDITOR_OPEN=3]="EDITOR_OPEN",m[m.EDITOR_CLOSE=4]="EDITOR_CLOSE",m[m.EDITOR_MOVE=5]="EDITOR_MOVE",m[m.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",m[m.EDITOR_LABEL=7]="EDITOR_LABEL",m[m.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",m[m.EDITOR_PIN=9]="EDITOR_PIN",m[m.EDITOR_STICKY=10]="EDITOR_STICKY",m[m.EDITOR_DIRTY=11]="EDITOR_DIRTY",m[m.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(f=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var S;(function(m){m[m.PRIMARY=1]="PRIMARY",m[m.SECONDARY=2]="SECONDARY",m[m.BOTH=3]="BOTH",m[m.ANY=4]="ANY"})(S=e.SideBySideEditor||(e.SideBySideEditor={}));class A{getOriginalUri(L,M){if(!L)return;if(M?.supportSideBySide){const{primary:$,secondary:G}=this.getSideEditors(L);if($&&G){if(M?.supportSideBySide===S.BOTH)return{primary:this.getOriginalUri($,{filterByScheme:M.filterByScheme}),secondary:this.getOriginalUri(G,{filterByScheme:M.filterByScheme})};if(M?.supportSideBySide===S.ANY)return this.getOriginalUri($,{filterByScheme:M.filterByScheme})??this.getOriginalUri(G,{filterByScheme:M.filterByScheme});L=M.supportSideBySide===S.PRIMARY?$:G}}if(v(L)||c(L))return;const Y=u(L)?L.preferredResource:L.resource;return!Y||!M||!M.filterByScheme?Y:this.filterUri(Y,M.filterByScheme)}getSideEditors(L){return s(L)||c(L)?{primary:L.primary,secondary:L.secondary}:a(L)||v(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,M){if(!L)return;if(M?.supportSideBySide){const{primary:$,secondary:G}=this.getSideEditors(L);if($&&G){if(M?.supportSideBySide===S.BOTH)return{primary:this.getCanonicalUri($,{filterByScheme:M.filterByScheme}),secondary:this.getCanonicalUri(G,{filterByScheme:M.filterByScheme})};if(M?.supportSideBySide===S.ANY)return this.getCanonicalUri($,{filterByScheme:M.filterByScheme})??this.getCanonicalUri(G,{filterByScheme:M.filterByScheme});L=M.supportSideBySide===S.PRIMARY?$:G}}if(v(L)||c(L))return;const Y=L.resource;return!Y||!M||!M.filterByScheme?Y:this.filterUri(Y,M.filterByScheme)}filterUri(L,M){if(Array.isArray(M)){if(M.some(Y=>L.scheme===Y))return L}else if(M===L.scheme)return L}}e.EditorResourceAccessor=new A;var I;(function(m){m[m.LEFT=0]="LEFT",m[m.RIGHT=1]="RIGHT"})(I=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(L){const M=this.instantiationService=L.get(D.IInstantiationService);for(const[Y,$]of this.editorSerializerConstructors)this.createEditorSerializer(Y,$,M);this.editorSerializerConstructors.clear()}createEditorSerializer(L,M,Y){const $=Y.createInstance(M);this.editorSerializerInstances.set(L,$)}registerFileEditorFactory(L){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=L}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(L,M){if(this.editorSerializerConstructors.has(L)||this.editorSerializerInstances.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.instantiationService?this.createEditorSerializer(L,M,this.instantiationService):this.editorSerializerConstructors.set(L,M),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(L),this.editorSerializerInstances.delete(L)})}getEditorSerializer(L){return this.editorSerializerInstances.get(typeof L=="string"?L:L.typeId)}}k.Registry.add(e.EditorExtensions.EditorFactory,new F);async function U(m,L){if(!m||!m.length)return[];const M=await Promise.all(m.map(async Y=>{const $=w.URI.revive(Y.fileUri);if(!$||!await L.canHandleResource($))return;let ie=Y.exists,B=Y.type;if(typeof ie!="boolean"||typeof B!="number")try{B=(await L.resolve($)).isDirectory?y.FileType.Directory:y.FileType.Unknown,ie=!0}catch{ie=!1}if(!ie&&Y.openOnlyIfExists||B===y.FileType.Directory)return;const q={selection:ie?Y.selection:void 0,pinned:!0,override:Y.editorOverrideId};let ee;return ie?ee={resource:$,options:q}:ee={resource:$,options:q,forceUntitled:!0},ee}));return(0,E.coalesce)(M)}e.pathsToEditors=U;var W;(function(m){m[m.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",m[m.SEQUENTIAL=1]="SEQUENTIAL"})(W=e.EditorsOrder||(e.EditorsOrder={}))}),define(ve[235],we([0,1,60,51,59,8,4,3,89]),function(J,e,_,t,w,P,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var E;(function(I){I[I.Markup=1]="Markup",I[I.Code=2]="Code"})(E=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",w.Mimes.latex,w.Mimes.markdown,"image/png","image/jpeg",w.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[w.Mimes.latex,w.Mimes.markdown,"application/json",w.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(I){I[I.Running=1]="Running",I[I.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var R;(function(I){I[I.Pending=2]="Pending",I[I.Executing=3]="Executing"})(R=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var h;(function(I){I[I.WithHardKernelDependency=0]="WithHardKernelDependency",I[I.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",I[I.Pure=2]="Pure",I[I.Never=3]="Never"})(h=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var v;(function(I){I.Always="always",I.Never="never",I.Optional="optional"})(v=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var c;(function(I){I[I.ModelChange=1]="ModelChange",I[I.Move=2]="Move",I[I.ChangeLanguage=5]="ChangeLanguage",I[I.Initialize=6]="Initialize",I[I.ChangeCellMetadata=7]="ChangeCellMetadata",I[I.Output=8]="Output",I[I.OutputItem=9]="OutputItem",I[I.ChangeCellContent=10]="ChangeCellContent",I[I.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",I[I.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",I[I.ChangeCellMime=13]="ChangeCellMime",I[I.Unknown=100]="Unknown"})(c=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(I){I[I.Handle=0]="Handle",I[I.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(I){I[I.Replace=1]="Replace",I[I.Output=2]="Output",I[I.Metadata=3]="Metadata",I[I.CellLanguage=4]="CellLanguage",I[I.DocumentMetadata=5]="DocumentMetadata",I[I.Move=6]="Move",I[I.OutputItems=7]="OutputItems",I[I.PartialMetadata=8]="PartialMetadata",I[I.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));var b;(function(I){I.scheme=P.Schemas.vscodeNotebookCell;const F=/^ch(\d{7,})/;function U($,G){return $.with({scheme:I.scheme,fragment:`ch${G.toString().padStart(7,"0")}${$.scheme!==P.Schemas.file?$.scheme:""}`})}I.generate=U;function W($){if($.scheme!==I.scheme)return;const G=F.exec($.fragment);return G?{handle:Number(G[1]),notebook:$.with({scheme:$.fragment.substring(G[0].length)||P.Schemas.file,fragment:null})}:void 0}I.parse=W;function m($,G,ie){return $.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`ch${G.toString().padStart(7,"0")},${ie??""},${$.scheme!==P.Schemas.file?$.scheme:""}`})}I.generateCellOutputUri=m;function L($){if($.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const G=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($.fragment);if(!G)return;const ie=Number(G[1]),B=G[2]&&G[2]!==""?G[2]:void 0,q=G[3];return{handle:ie,outputId:B,notebook:$.with({scheme:q||P.Schemas.file,fragment:null})}}I.parseCellOutputUri=L;function M($,G,ie){return $.with({scheme:ie,fragment:`ch${G.toString().padStart(7,"0")}${$.scheme!==P.Schemas.file?$.scheme:""}`})}I.generateCellUri=M;function Y($,G){if($.scheme!==G)return;const ie=F.exec($.fragment);return ie?{handle:Number(ie[1]),notebook:$.with({scheme:$.fragment.substring(ie[0].length)||P.Schemas.file,fragment:null})}:void 0}I.parseCellUri=Y})(b=e.CellUri||(e.CellUri={}));const l=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function C(I){return l.get(I)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=C;function p(I){return l.get(I)?.supportedByCore??!1}e.mimeTypeSupportedByCore=p;function u(I){return l.get(I)?.mergeable??!1}e.mimeTypeIsMergeable=u;const s=I=>k.isWindows?I.replace(/\//g,"\\"):I;class a{constructor(F=[],U=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=U,this.order=[...new Set(F)].map(W=>({pattern:W,matches:_.parse(s(W))}))}sort(F){const U=new Map(t.Iterable.map(F,m=>[m,s(m)]));let W=[];for(const{matches:m}of this.order)for(const[L,M]of U)if(m(M)){W.push(L),U.delete(L);break}return U.size&&(W=W.concat([...U.keys()].sort((m,L)=>this.defaultOrder.indexOf(m)-this.defaultOrder.indexOf(L)))),W}prioritize(F,U){const W=this.findIndex(F);if(W===-1){this.order.unshift({pattern:F,matches:_.parse(s(F))});return}const m=new Set(U.map(M=>this.findIndex(M,W)));m.delete(-1);const L=Array.from(m).sort();this.order.splice(W+1,0,...L.map(M=>this.order[M]));for(let M=L.length-1;M>=0;M--)this.order.splice(L[M],1)}toArray(){return this.order.map(F=>F.pattern)}findIndex(F,U=this.order.length){const W=s(F);for(let m=0;m<U;m++)if(this.order[m].matches(W))return m;return-1}}e.MimeTypeDisplayOrder=a;function i(I,F,U,W=(m,L)=>m===L){const m=[];function L($,G,ie){if(G===0&&ie.length===0)return;const B=m[m.length-1];B&&B.start+B.deleteCount===$?(B.deleteCount+=G,B.toInsert.push(...ie)):m.push({start:$,deleteCount:G,toInsert:ie})}let M=0,Y=0;for(;;){if(M===I.length){L(M,0,F.slice(Y));break}if(Y===F.length){L(M,I.length-M,[]);break}const $=I[M],G=F[Y];if(W($,G)){M+=1,Y+=1;continue}U(G)?(L(M,1,[]),M+=1):(L(M,0,[G]),Y+=1)}return m}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(I){I.default="default",I.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(I){const F=I;return!!((typeof F.include=="string"||_.isRelativePattern(F.include))&&(typeof F.exclude=="string"||_.isRelativePattern(F.exclude)))}e.isDocumentExcludePattern=r;function o(I,F,U){if(Array.isArray(I.viewType)&&I.viewType.indexOf(F)>=0||I.viewType===F)return!0;if(I.filenamePattern){const W=r(I.filenamePattern)?I.filenamePattern.include:I.filenamePattern,m=r(I.filenamePattern)?I.filenamePattern.exclude:void 0;if(_.match(W,(0,D.basename)(U.fsPath).toLowerCase()))return!(m&&_.match(m,(0,D.basename)(U.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class f{constructor(F){this.textModel=F}getElements(){const F=new Int32Array(this.textModel.cells.length);for(let U=0;U<this.textModel.cells.length;U++)F[U]=this.textModel.cells[U].getHashValue();return F}}e.CellSequence=f,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var S;(function(I){I[I.Left=1]="Left",I[I.Right=2]="Right"})(S=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class A{static create(F){return`${A._prefix}${F}`}static parse(F){if(F.startsWith(A._prefix))return F.substring(A._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=A,A._prefix="notebook/"}),define(ve[109],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,_.createDecorator)("environmentVariableService");var t;(function(w){w[w.Replace=1]="Replace",w[w.Append=2]="Append",w[w.Prepend=3]="Prepend"})(t=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(ve[236],we([0,1,3,109]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class w{constructor(y){this.map=new Map,y.forEach((E,T)=>{const R=E.map.entries();let h=R.next();for(;!h.done;){const v=h.value[0];let c=this.map.get(v);if(c||(c=[],this.map.set(v,c)),c.length>0&&c[0].type===t.EnvironmentVariableMutatorType.Replace){h=R.next();continue}const d=h.value[1];c.unshift({extensionIdentifier:T,value:d.value,type:d.type}),h=R.next()}})}applyToProcessEnvironment(y,E){let T;_.isWindows&&(T={},Object.keys(y).forEach(R=>T[R.toLowerCase()]=R)),this.map.forEach((R,h)=>{const v=_.isWindows&&T[h.toLowerCase()]||h;R.forEach(c=>{const d=E?E(c.value):c.value;switch(c.type){case t.EnvironmentVariableMutatorType.Append:y[v]=(y[v]||"")+d;break;case t.EnvironmentVariableMutatorType.Prepend:y[v]=d+(y[v]||"");break;case t.EnvironmentVariableMutatorType.Replace:y[v]=d;break}})})}diff(y){const E=new Map,T=new Map,R=new Map;if(y.map.forEach((h,v)=>{const c=this.map.get(v),d=P(h,c);d&&E.set(v,d)}),this.map.forEach((h,v)=>{const c=y.map.get(v),d=P(h,c);d&&R.set(v,d)}),this.map.forEach((h,v)=>{const c=y.map.get(v),d=D(h,c);d&&T.set(v,d)}),!(E.size===0&&T.size===0&&R.size===0))return{added:E,changed:T,removed:R}}}e.MergedEnvironmentVariableCollection=w;function P(k,y){if(!y)return k;const E=new Set;y.forEach(R=>E.add(R.extensionIdentifier));const T=[];return k.forEach(R=>{E.has(R.extensionIdentifier)||T.push(R)}),T.length===0?void 0:T}function D(k,y){if(!y)return;const E=new Map;y.forEach(R=>E.set(R.extensionIdentifier,R));const T=[];return k.forEach(R=>{const h=E.get(R.extensionIdentifier);h&&(R.type!==h.type||R.value!==h.value)&&T.push(h)}),T.length===0?void 0:T}}),define(ve[110],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function _(w){return[...w.entries()]}e.serializeEnvironmentVariableCollection=_;function t(w){return new Map(w)}e.deserializeEnvironmentVariableCollection=t}),define(ve[237],we([0,1,4,76,3]),function(J,e,_,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.injectShellIntegrationArgs=e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function P(o,f){if(!!f)if(w.isWindows)for(const S in f){let A=S;for(const F in o)if(S.toLowerCase()===F.toLowerCase()){A=F;break}const I=f[S];I!==void 0&&D(o,A,I)}else Object.keys(f).forEach(S=>{const A=f[S];A!==void 0&&D(o,S,A)})}e.mergeEnvironments=P;function D(o,f,S){typeof S=="string"?o[f]=S:delete o[f]}function k(o,f,S,A){o.TERM_PROGRAM="vscode",f&&(o.TERM_PROGRAM_VERSION=f),T(o,A)&&(o.LANG=R(S)),o.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=k;function y(o,f){if(!!f)for(const S of Object.keys(f)){const A=f[S];A&&(o[S]=A)}}function E(o,f){return Object.keys(f).forEach(S=>{const A=f[S];if(typeof A=="string")try{f[S]=o(A)}catch{f[S]=A}}),f}function T(o,f){if(f==="on")return!0;if(f==="auto"){const S=o.LANG;return!S||S.search(/\.UTF\-8$/)===-1&&S.search(/\.utf8$/)===-1&&S.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=T;function R(o){const f=o?o.split("-"):[],S=f.length;if(S===0)return"en_US.UTF-8";if(S===1){const A={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};f[0]in A&&f.push(A[f[0]])}else f[1]=f[1].toUpperCase();return f.join("_")+".UTF-8"}e.getLangEnvVariable=R;function h(o,f,S,A,I,F){if(o.cwd){const W=typeof o.cwd=="object"?o.cwd.fsPath:o.cwd,m=v(W,S);return c(m||W)}let U;return!o.ignoreConfigurationCwd&&I&&(S&&(I=v(I,S,F)),I&&(_.isAbsolute(I)?U=I:A&&(U=_.join(A.fsPath,I)))),U||(U=A?A.fsPath:f||""),c(U)}e.getCwd=h;function v(o,f,S){if(f)try{return f(o)}catch(A){S?.error("Could not resolve terminal cwd",A);return}return o}function c(o){return w.OS===1&&o&&o[1]===":"?o[0].toUpperCase()+o.substr(1):o}function d(o,f,S){if(!!S)return A=>S.resolveWithEnvironment(f,o,A)}e.createVariableResolver=d;function g(o,f,S,A,I,F,U,W=w.platform){let m;U&&(m=l(o,"automationShell",W)),m||(m=l(o,"shell",W));let L=m||f;if(W===3&&!S&&A){const M=_.join(A,"Sysnative").replace(/\//g,"\\").toLowerCase();L&&L.toLowerCase().indexOf(M)===0&&(L=_.join(A,"System32",L.substr(M.length+1)))}if(L&&W===3&&(L=L.replace(/\//g,"\\")),I)try{L=I(L)}catch(M){F.error("Could not resolve shell",M)}return L}e.getDefaultShell=g;function b(o,f,S,A,I=w.platform){if(f&&l(o,"automationShell",I))return[];const F=I===3?"windows":I===1?"osx":"linux";let U=o(`terminal.integrated.shellArgs.${F}`);if(!U)return[];if(typeof U=="string"&&I===3)return S?S(U):U;if(S){const W=[];for(const m of U)try{W.push(S(m))}catch(L){A.error(`Could not resolve terminal.integrated.shellArgs.${F}`,L),W.push(m)}U=W}return U}e.getDefaultShellArgs=b;function l(o,f,S=w.platform){return o(`terminal.integrated.${f}.${S===3?"windows":S===1?"osx":"linux"}`)}function C(o,f,S,A,I,F){const U={};if(o.strictEnv)y(U,o.env);else{y(U,F);const W={...f};S&&(W&&E(S,W),o.env&&E(S,o.env)),(0,t.sanitizeProcessEnvironment)(U,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),P(U,W),P(U,o.env),k(U,A,w.locale,I)}return U}e.createTerminalEnvironment=C;var p;(function(o){o.WindowsPwsh="windows-pwsh",o.WindowsPwshLogin="windows-pwsh-login",o.Pwsh="pwsh",o.PwshLogin="pwsh-login",o.Zsh="zsh",o.ZshLogin="zsh-login",o.Bash="bash"})(p=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(p.WindowsPwsh,["-noexit"," -command",'. "${execInstallFolder}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"']),e.shellIntegrationArgs.set(p.WindowsPwshLogin,["-l","-noexit"," -command",'. "${execInstallFolder}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"']),e.shellIntegrationArgs.set(p.Pwsh,["-noexit","-command",'. "${execInstallFolder}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(p.PwshLogin,["-l","-noexit","-command",'. "${execInstallFolder}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(p.Zsh,["-c",'"${execInstallFolder}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-zsh.sh"; zsh -i']),e.shellIntegrationArgs.set(p.ZshLogin,["-c",'"${execInstallFolder}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-zsh.sh"; zsh -il']),e.shellIntegrationArgs.set(p.Bash,["--init-file","${execInstallFolder}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const u=["-login","-l"],s=["-nol","-nologo"];function a(o,f,S,A,I){if(!S||!A.executable||A.isFeatureTerminal)return{args:A.args,enableShellIntegration:!1};const F=A.args,U=_.basename(A.executable).toLowerCase();let W;if(I===1)U==="pwsh.exe"&&(!F||n(F)?W=e.shellIntegrationArgs.get(p.WindowsPwsh):i(F)?W=e.shellIntegrationArgs.get(p.WindowsPwshLogin):o.warn(`Shell integration cannot be enabled when custom args ${F} are provided for ${U} on Windows.`));else{switch(U){case"bash":!F||F.length===0?W=e.shellIntegrationArgs.get(p.Bash):r(F)&&(f.VSCODE_SHELL_LOGIN="1",W=e.shellIntegrationArgs.get(p.Bash));break;case"pwsh":!F||n(F)?W=e.shellIntegrationArgs.get(p.Pwsh):i(F)&&(W=e.shellIntegrationArgs.get(p.PwshLogin));break;case"zsh":!F||F.length===0?W=e.shellIntegrationArgs.get(p.Zsh):r(F)&&(W=e.shellIntegrationArgs.get(p.ZshLogin));break}W||o.warn(`Shell integration cannot be enabled when custom args ${F} are provided for ${U}.`)}return{args:W||F,enableShellIntegration:W!==void 0}}e.injectShellIntegrationArgs=a;function i(o){return typeof o=="string"?u.includes(o.toLowerCase()):o.length===1&&u.includes(o[0].toLowerCase())||o.length===2&&(u.includes(o[0].toLowerCase())||u.includes(o[1].toLowerCase()))&&(s.includes(o[0].toLowerCase())||s.includes(o[1].toLowerCase()))}function n(o){return typeof o=="string"?s.includes(o.toLowerCase()):o.length===0||o?.length===1&&s.includes(o[0].toLowerCase())}function r(o){return o==="string"&&u.includes(o.toLowerCase())||typeof o!="string"&&o.length===1&&u.includes(o[0].toLowerCase())}}),define(ve[238],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var _;(function(P){P.Delimiter="\0"})(_=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class w{constructor(D,k=D.length){if(this.path=D,this.viewEnd=k,D.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(D,k,y=D.parent){if(D.id===k)return new w([k]);let E=[D.id];for(let T=y;T&&T.id!==k;T=T.parent)E.push(T.id);return E.push(k),new w(E.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const k=D.indexOf("\0");return k===-1?D:D.slice(0,k)}static fromString(D){return new w(D.split("\0"))}static join(D,k){return new w([...D.path,k])}static joinToString(D,k){return D.toString()+"\0"+k}static compare(D,k){return D===k?0:k.startsWith(D+"\0")?2:D.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let D=1;D<=this.viewEnd;D++)yield new w(this.path,D)}compare(D){if(typeof D=="string")return w.compare(this.toString(),D);for(let k=0;k<D.viewEnd&&k<this.viewEnd;k++)if(D.path[k]!==this.path[k])return 1;return D.viewEnd>this.viewEnd?2:D.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let D=1;D<this.viewEnd;D++)this.stringifed+="\0",this.stringifed+=this.path[D]}return this.stringifed}}e.TestId=w}),define(ve[239],we([0,1,28,6]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,t.refineServiceDecorator)(_.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(ve[240],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,_.createDecorator)("configurationResolverService")}),define(ve[241],we([0,1,4,24,12,20,3,61,174]),function(J,e,_,t,w,P,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class E{constructor(R,h,v){this._contributedVariables=new Map,this._context=R,this._labelService=h,v&&(this._envVariablesPromise=v.then(c=>this.prepareEnv(c)))}prepareEnv(R){if(D.isWindows){const h=Object.create(null);return Object.keys(R).forEach(v=>{h[v.toLowerCase()]=R[v]}),h}return R}resolveWithEnvironment(R,h,v){return this.recursiveResolve(this.prepareEnv(R),h?h.uri:void 0,v)}async resolveAsync(R,h){return this.recursiveResolve(await this._envVariablesPromise,R?R.uri:void 0,h)}async resolveAnyBase(R,h,v,c){const d=P.deepClone(h);return D.isWindows&&d.windows?Object.keys(d.windows).forEach(g=>d[g]=d.windows[g]):D.isMacintosh&&d.osx?Object.keys(d.osx).forEach(g=>d[g]=d.osx[g]):D.isLinux&&d.linux&&Object.keys(d.linux).forEach(g=>d[g]=d.linux[g]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(await this._envVariablesPromise,R?R.uri:void 0,d,v,c)}async resolveAnyAsync(R,h,v){return this.resolveAnyBase(R,h,v)}async resolveAnyMap(R,h,v){const c=new Map;return{newConfig:await this.resolveAnyBase(R,h,v,c),resolvedVariables:c}}resolveWithInteractionReplace(R,h,v,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(R,h,v,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(R,h){if(this._contributedVariables.has(R))throw new Error("Variable "+R+" is contributed twice.");this._contributedVariables.set(R,h)}recursiveResolve(R,h,v,c,d){if(w.isString(v))return this.resolveString(R,h,v,c,d);if(w.isArray(v))return v.map(g=>this.recursiveResolve(R,h,g,c,d));if(w.isObject(v)){let g=Object.create(null);return Object.keys(v).forEach(b=>{const l=this.resolveString(R,h,b,c,d);g[l]=this.recursiveResolve(R,h,v[b],c,d)}),g}return v}resolveString(R,h,v,c,d){return v.replace(E.VARIABLE_REGEXP,(b,l)=>{if(l.includes(E.VARIABLE_LHS))return b;let C=this.evaluateSingleVariable(R,b,l,h,c);return d&&d.set(l,C),C!==b&&w.isString(C)&&C.match(E.VARIABLE_REGEXP)&&(C=this.resolveString(R,h,C,c,d)),C})}fsPath(R){return this._labelService?this._labelService.getUriLabel(R,{noPrefix:!0}):R.fsPath}evaluateSingleVariable(R,h,v,c,d){let g;const b=v.split(":");b.length>1&&(v=b[0],g=b[1]);const l=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error((0,y.localize)(0,null,h))},C=()=>{const u=l();if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return s}throw new Error((0,y.localize)(1,null,h,_.basename(u)))},p=()=>{if(g){const u=this._context.getFolderUri(g);if(u)return u;throw new Error((0,y.localize)(2,null,h,g))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,h)):new Error((0,y.localize)(4,null,h))};switch(v){case"env":if(g){if(R){const u=R[D.isWindows?g.toLowerCase():g];if(w.isString(u))return u}return""}throw new Error((0,y.localize)(5,null,h));case"config":if(g){const u=this._context.getConfigurationValue(c,g);if(w.isUndefinedOrNull(u))throw new Error((0,y.localize)(6,null,h,g));if(w.isObject(u))throw new Error((0,y.localize)(7,null,h,g));return u}throw new Error((0,y.localize)(8,null,h));case"command":return this.resolveFromMap(h,g,d,"command");case"input":return this.resolveFromMap(h,g,d,"input");default:switch(v){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(p()));case"cwd":return c||g?(0,k.normalizeDriveLetter)(this.fsPath(p())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return _.basename(this.fsPath(p()));case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new Error((0,y.localize)(9,null,h))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new Error((0,y.localize)(10,null,h))}case"file":return l();case"fileWorkspaceFolder":return C();case"relativeFile":return c||g?_.relative(this.fsPath(p()),l()):l();case"relativeFileDirname":{const u=_.dirname(l());if(c||g){const s=_.relative(this.fsPath(p()),u);return s.length===0?".":s}return u}case"fileDirname":return _.dirname(l());case"fileExtname":return _.extname(l());case"fileBasename":return _.basename(l());case"fileBasenameNoExtension":{const u=_.basename(l());return u.slice(0,u.length-_.extname(u).length)}case"fileDirnameBasename":return _.basename(_.dirname(l()));case"execPath":{const u=this._context.getExecPath();return u||h}case"execInstallFolder":{const u=this._context.getAppRoot();return u||h}case"pathSeparator":return _.sep;default:try{const u=g?`${v}:${g}`:v;return this.resolveFromMap(h,u,d,void 0)}catch{return h}}}}resolveFromMap(R,h,v,c){if(h&&v){const d=c===void 0?v[h]:v[c+":"+h];if(typeof d=="string")return d;throw new Error((0,y.localize)(11,null,R))}return R}}e.AbstractVariableResolverService=E,E.VARIABLE_LHS="${",E.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[242],we([0,1,6,108]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,_.createDecorator)("editorGroupsService");var w;(function(c){c[c.UP=0]="UP",c[c.DOWN=1]="DOWN",c[c.LEFT=2]="LEFT",c[c.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var P;(function(c){c[c.HORIZONTAL=0]="HORIZONTAL",c[c.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(c){c[c.FIRST=0]="FIRST",c[c.LAST=1]="LAST",c[c.NEXT=2]="NEXT",c[c.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var k;(function(c){c[c.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",c[c.EVEN=1]="EVEN",c[c.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(c){c[c.COPY_EDITORS=0]="COPY_EDITORS",c[c.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function E(c){const d=c;return(0,t.isEditorInput)(d?.editor)&&(0,t.isEditorInput)(d?.replacement)}e.isEditorReplacement=E;var T;(function(c){c[c.CREATION_TIME=0]="CREATION_TIME",c[c.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",c[c.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T=e.GroupsOrder||(e.GroupsOrder={}));var R;(function(c){c[c.NEW_EDITOR=1]="NEW_EDITOR",c[c.MOVE_EDITOR=2]="MOVE_EDITOR",c[c.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function h(c){const d=c;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=h;function v(c){return c.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=v}),define(ve[111],we([0,1,6,242]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,_.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(P){const D=P;return typeof P=="number"||(0,t.isEditorGroup)(D)}e.isPreferredGroup=w}),define(ve[243],we([0,1,17,15,77,123,52,20,12,5,63,142,178,198,106,235,238,111,107]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c,d,g,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var C;(function(Ee){function Ce(K){const{selectionStartLineNumber:Ie,selectionStartColumn:_e,positionLineNumber:Ke,positionColumn:We}=K,it=new l.Position(Ie-1,_e-1),lt=new l.Position(Ke-1,We-1);return new l.Selection(it,lt)}Ee.to=Ce;function ce(K){const{anchor:Ie,active:_e}=K;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:_e.line+1,positionColumn:_e.character+1}}Ee.from=ce})(C=e.Selection||(e.Selection={}));var p;(function(Ee){function Ce(K){if(!K)return;const{start:Ie,end:_e}=K;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:_e.line+1,endColumn:_e.character+1}}Ee.from=Ce;function ce(K){if(!K)return;const{startLineNumber:Ie,startColumn:_e,endLineNumber:Ke,endColumn:We}=K;return new l.Range(Ie-1,_e-1,Ke-1,We-1)}Ee.to=ce})(p=e.Range||(e.Range={}));var u;(function(Ee){function Ce(ce){switch(ce){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Ee.to=Ce})(u=e.TokenType||(e.TokenType={}));var s;(function(Ee){function Ce(K){return new l.Position(K.lineNumber-1,K.column-1)}Ee.to=Ce;function ce(K){return{lineNumber:K.line+1,column:K.character+1}}Ee.from=ce})(s=e.Position||(e.Position={}));var a;(function(Ee){function Ce(Ie,_e){return(0,_.coalesce)((0,_.asArray)(Ie).map(Ke=>ce(Ke,_e)))}Ee.from=Ce;function ce(Ie,_e){if(typeof Ie=="string")return{$serialized:!0,language:Ie};if(Ie)return{$serialized:!0,language:Ie.language,scheme:K(Ie.scheme,_e),pattern:He.from(Ie.pattern)??void 0,exclusive:Ie.exclusive}}function K(Ie,_e){return _e&&typeof Ie=="string"?_e.transformOutgoingScheme(Ie):Ie}})(a=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(Ee){function Ce(K){switch(K){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Ee.from=Ce;function ce(K){switch(K){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Ee.to=ce})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(Ee){function Ce(K){let Ie;return K.code&&((0,y.isString)(K.code)||(0,y.isNumber)(K.code)?Ie=String(K.code):Ie={value:String(K.code.value),target:K.code.target}),{...p.from(K.range),message:K.message,source:K.source,code:Ie,severity:o.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(r.from),tags:Array.isArray(K.tags)?(0,_.coalesce)(K.tags.map(i.from)):void 0}}Ee.from=Ce;function ce(K){const Ie=new l.Diagnostic(p.to(K),K.message,o.to(K.severity));return Ie.source=K.source,Ie.code=(0,y.isString)(K.code)?K.code:K.code?.value,Ie.relatedInformation=K.relatedInformation&&K.relatedInformation.map(r.to),Ie.tags=K.tags&&(0,_.coalesce)(K.tags.map(i.to)),Ie}Ee.to=ce})(n=e.Diagnostic||(e.Diagnostic={}));var r;(function(Ee){function Ce(K){return{...p.from(K.location.range),message:K.message,resource:K.location.uri}}Ee.from=Ce;function ce(K){return new l.DiagnosticRelatedInformation(new l.Location(K.resource,p.to(K)),K.message)}Ee.to=ce})(r=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var o;(function(Ee){function Ce(K){switch(K){case l.DiagnosticSeverity.Error:return v.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return v.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return v.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return v.MarkerSeverity.Hint}return v.MarkerSeverity.Error}Ee.from=Ce;function ce(K){switch(K){case v.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case v.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case v.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case v.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Ee.to=ce})(o=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var f;(function(Ee){function Ce(K){return typeof K=="number"&&K>=l.ViewColumn.One?K-1:K===l.ViewColumn.Beside?b.SIDE_GROUP:b.ACTIVE_GROUP}Ee.from=Ce;function ce(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=ce})(f=e.ViewColumn||(e.ViewColumn={}));function S(Ee){return typeof Ee.range!="undefined"}function A(Ee){return Ee.length===0?!0:!!S(Ee[0])}e.isDecorationOptionsArr=A;var I;(function(Ee){function Ce(We){return We.map(Ee.from)}Ee.fromMany=Ce;function ce(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function K(We){let it;if(ce(We)){const{language:ut,value:ft}=We;it={value:"```"+ut+`
`+ft+"\n```\n"}}else l.MarkdownString.isMarkdownString(We)?it={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml}:typeof We=="string"?it={value:We}:it={value:""};const lt=Object.create(null);it.uris=lt;const wt=ut=>{try{let ft=E.URI.parse(ut,!0);ft=ft.with({query:Ie(ft.query,lt)}),lt[ut]=ft}catch{}return""},ct=new P.marked.Renderer;return ct.link=wt,ct.image=ut=>typeof ut=="string"?wt(w.parseHrefAndDimensions(ut).href):"",(0,P.marked)(it.value,{renderer:ct}),it}Ee.from=K;function Ie(We,it){if(!We)return We;let lt;try{lt=(0,D.parse)(We)}catch{}if(!lt)return We;let wt=!1;return lt=(0,k.cloneAndChange)(lt,ct=>{if(E.URI.isUri(ct)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ut]=ct,wt=!0,ut}else return}),wt?JSON.stringify(lt):We}function _e(We){const it=new l.MarkdownString(We.value,We.supportThemeIcons);return it.isTrusted=We.isTrusted,it.supportHtml=We.supportHtml,it}Ee.to=_e;function Ke(We){if(!!We)return typeof We=="string"?We:Ee.from(We)}Ee.fromStrict=Ke})(I=e.MarkdownString||(e.MarkdownString={}));function F(Ee){return A(Ee)?Ee.map(Ce=>({range:p.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?I.fromMany(Ce.hoverMessage):Ce.hoverMessage?I.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):Ee.map(Ce=>({range:p.from(Ce)}))}e.fromRangeOrRangeWithMessage=F;function U(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?E.URI.file(Ee):Ee}e.pathOrURIToURI=U;var W;(function(Ee){function Ce(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?U(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}Ee.from=Ce})(W=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var m;(function(Ee){function Ce(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?U(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?W.from(ce.before):void 0,after:ce.after?W.from(ce.after):void 0}}Ee.from=Ce})(m=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var L;(function(Ee){function Ce(ce){if(typeof ce=="undefined")return ce;switch(ce){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Ce})(L=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var M;(function(Ee){function Ce(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?L.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?m.from(ce.light):void 0,dark:ce.dark?m.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?U(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?W.from(ce.before):void 0,after:ce.after?W.from(ce.after):void 0}}Ee.from=Ce})(M=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Y;(function(Ee){function Ce(K){return{text:K.newText,eol:K.newEol&&Re.from(K.newEol),range:p.from(K.range)}}Ee.from=Ce;function ce(K){const Ie=new l.TextEdit(p.to(K.range),K.text);return Ie.newEol=typeof K.eol=="undefined"?void 0:Re.to(K.eol),Ie}Ee.to=ce})(Y=e.TextEdit||(e.TextEdit={}));var $;(function(Ee){function Ce(K,Ie,_e){const Ke={edits:[]};if(K instanceof l.WorkspaceEdit)for(let We of K._allEntries())if(We._type===1)Ke.edits.push({_type:1,oldUri:We.from,newUri:We.to,options:We.options,metadata:We.metadata});else if(We._type===2){const it=Ie?.getDocument(We.uri);Ke.edits.push({_type:2,resource:We.uri,edit:Y.from(We.edit),modelVersionId:it?.version,metadata:We.metadata})}else We._type===3?Ke.edits.push({_type:3,metadata:We.metadata,resource:We.uri,edit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:_e?.getNotebookDocument(We.uri,!0)?.apiNotebook.version}):We._type===5&&Ke.edits.push({_type:3,metadata:We.metadata,resource:We.uri,notebookVersionId:_e?.getNotebookDocument(We.uri,!0)?.apiNotebook.version,edit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(Ye.from)}});return Ke}Ee.from=Ce;function ce(K){const Ie=new l.WorkspaceEdit;for(const _e of K.edits)_e.edit?Ie.replace(E.URI.revive(_e.resource),p.to(_e.edit.range),_e.edit.text):Ie.renameFile(E.URI.revive(_e.oldUri),E.URI.revive(_e.newUri),_e.options);return Ie}Ee.to=ce})($=e.WorkspaceEdit||(e.WorkspaceEdit={}));var G;(function(Ee){const Ce=Object.create(null);Ce[l.SymbolKind.File]=0,Ce[l.SymbolKind.Module]=1,Ce[l.SymbolKind.Namespace]=2,Ce[l.SymbolKind.Package]=3,Ce[l.SymbolKind.Class]=4,Ce[l.SymbolKind.Method]=5,Ce[l.SymbolKind.Property]=6,Ce[l.SymbolKind.Field]=7,Ce[l.SymbolKind.Constructor]=8,Ce[l.SymbolKind.Enum]=9,Ce[l.SymbolKind.Interface]=10,Ce[l.SymbolKind.Function]=11,Ce[l.SymbolKind.Variable]=12,Ce[l.SymbolKind.Constant]=13,Ce[l.SymbolKind.String]=14,Ce[l.SymbolKind.Number]=15,Ce[l.SymbolKind.Boolean]=16,Ce[l.SymbolKind.Array]=17,Ce[l.SymbolKind.Object]=18,Ce[l.SymbolKind.Key]=19,Ce[l.SymbolKind.Null]=20,Ce[l.SymbolKind.EnumMember]=21,Ce[l.SymbolKind.Struct]=22,Ce[l.SymbolKind.Event]=23,Ce[l.SymbolKind.Operator]=24,Ce[l.SymbolKind.TypeParameter]=25;function ce(Ie){return typeof Ce[Ie]=="number"?Ce[Ie]:6}Ee.from=ce;function K(Ie){for(const _e in Ce)if(Ce[_e]===Ie)return Number(_e);return l.SymbolKind.Property}Ee.to=K})(G=e.SymbolKind||(e.SymbolKind={}));var ie;(function(Ee){function Ce(K){switch(K){case l.SymbolTag.Deprecated:return 1}}Ee.from=Ce;function ce(K){switch(K){case 1:return l.SymbolTag.Deprecated}}Ee.to=ce})(ie=e.SymbolTag||(e.SymbolTag={}));var B;(function(Ee){function Ce(K){return{name:K.name,kind:G.from(K.kind),tags:K.tags&&K.tags.map(ie.from),containerName:K.containerName,location:de.from(K.location)}}Ee.from=Ce;function ce(K){const Ie=new l.SymbolInformation(K.name,G.to(K.kind),K.containerName,de.to(K.location));return Ie.tags=K.tags&&K.tags.map(ie.to),Ie}Ee.to=ce})(B=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var q;(function(Ee){function Ce(K){const Ie={name:K.name||"!!MISSING: name!!",detail:K.detail,range:p.from(K.range),selectionRange:p.from(K.selectionRange),kind:G.from(K.kind),tags:K.tags?.map(ie.from)??[]};return K.children&&(Ie.children=K.children.map(Ce)),Ie}Ee.from=Ce;function ce(K){const Ie=new l.DocumentSymbol(K.name,K.detail,G.to(K.kind),p.to(K.range),p.to(K.selectionRange));return(0,_.isNonEmptyArray)(K.tags)&&(Ie.tags=K.tags.map(ie.to)),K.children&&(Ie.children=K.children.map(ce)),Ie}Ee.to=ce})(q=e.DocumentSymbol||(e.DocumentSymbol={}));var ee;(function(Ee){function Ce(K){const Ie=new l.CallHierarchyItem(G.to(K.kind),K.name,K.detail||"",E.URI.revive(K.uri),p.to(K.range),p.to(K.selectionRange));return Ie._sessionId=K._sessionId,Ie._itemId=K._itemId,Ie}Ee.to=Ce;function ce(K,Ie,_e){if(Ie=Ie??K._sessionId,_e=_e??K._itemId,Ie===void 0||_e===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:_e,name:K.name,detail:K.detail,kind:G.from(K.kind),uri:K.uri,range:p.from(K.range),selectionRange:p.from(K.selectionRange),tags:K.tags?.map(ie.from)}}Ee.from=ce})(ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var oe;(function(Ee){function Ce(ce){return new l.CallHierarchyIncomingCall(ee.to(ce.from),ce.fromRanges.map(K=>p.to(K)))}Ee.to=Ce})(oe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var re;(function(Ee){function Ce(ce){return new l.CallHierarchyOutgoingCall(ee.to(ce.to),ce.fromRanges.map(K=>p.to(K)))}Ee.to=Ce})(re=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var de;(function(Ee){function Ce(K){return{range:K.range&&p.from(K.range),uri:K.uri}}Ee.from=Ce;function ce(K){return new l.Location(E.URI.revive(K.uri),p.to(K.range))}Ee.to=ce})(de=e.location||(e.location={}));var Z;(function(Ee){function Ce(K){const Ie=K,_e=K;return{originSelectionRange:Ie.originSelectionRange?p.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:_e.uri,range:p.from(Ie.targetRange?Ie.targetRange:_e.range),targetSelectionRange:Ie.targetSelectionRange?p.from(Ie.targetSelectionRange):void 0}}Ee.from=Ce;function ce(K){return{targetUri:E.URI.revive(K.uri),targetRange:p.to(K.range),targetSelectionRange:K.targetSelectionRange?p.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?p.to(K.originSelectionRange):void 0}}Ee.to=ce})(Z=e.DefinitionLink||(e.DefinitionLink={}));var H;(function(Ee){function Ce(K){return{range:p.from(K.range),contents:I.fromMany(K.contents)}}Ee.from=Ce;function ce(K){return new l.Hover(K.contents.map(I.to),p.to(K.range))}Ee.to=ce})(H=e.Hover||(e.Hover={}));var j;(function(Ee){function Ce(K){return{range:p.from(K.range),expression:K.expression}}Ee.from=Ce;function ce(K){return new l.EvaluatableExpression(p.to(K.range),K.expression)}Ee.to=ce})(j=e.EvaluatableExpression||(e.EvaluatableExpression={}));var V;(function(Ee){function Ce(K){if(K instanceof l.InlineValueText)return{type:"text",range:p.from(K.range),text:K.text};if(K instanceof l.InlineValueVariableLookup)return{type:"variable",range:p.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:p.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Ce;function ce(K){switch(K.type){case"text":return{range:p.to(K.range),text:K.text};case"variable":return{range:p.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:p.to(K.range),expression:K.expression}}}Ee.to=ce})(V=e.InlineValue||(e.InlineValue={}));var ne;(function(Ee){function Ce(K){return{frameId:K.frameId,stoppedLocation:p.from(K.stoppedLocation)}}Ee.from=Ce;function ce(K){return new l.InlineValueContext(K.frameId,p.to(K.stoppedLocation))}Ee.to=ce})(ne=e.InlineValueContext||(e.InlineValueContext={}));var me;(function(Ee){function Ce(K){return{range:p.from(K.range),kind:K.kind}}Ee.from=Ce;function ce(K){return new l.DocumentHighlight(p.to(K.range),K.kind)}Ee.to=ce})(me=e.DocumentHighlight||(e.DocumentHighlight={}));var De;(function(Ee){function Ce(ce){switch(ce){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Ee.to=Ce})(De=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(Ee){function Ce(ce){return{triggerKind:De.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}Ee.to=Ce})(ae=e.CompletionContext||(e.CompletionContext={}));var fe;(function(Ee){function Ce(K){switch(K){case l.CompletionItemTag.Deprecated:return 1}}Ee.from=Ce;function ce(K){switch(K){case 1:return l.CompletionItemTag.Deprecated}}Ee.to=ce})(fe=e.CompletionItemTag||(e.CompletionItemTag={}));var pe;(function(Ee){const Ce=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function ce(_e){return Ce.get(_e)??9}Ee.from=ce;const K=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Ie(_e){return K.get(_e)??l.CompletionItemKind.Property}Ee.to=Ie})(pe=e.CompletionItemKind||(e.CompletionItemKind={}));var Q;(function(Ee){function Ce(ce,K){const Ie=new l.CompletionItem(ce.label);return Ie.insertText=ce.insertText,Ie.kind=pe.to(ce.kind),Ie.tags=ce.tags?.map(fe.to),Ie.detail=ce.detail,Ie.documentation=w.isMarkdownString(ce.documentation)?I.to(ce.documentation):ce.documentation,Ie.sortText=ce.sortText,Ie.filterText=ce.filterText,Ie.preselect=ce.preselect,Ie.commitCharacters=ce.commitCharacters,T.Range.isIRange(ce.range)?Ie.range=p.to(ce.range):typeof ce.range=="object"&&(Ie.range={inserting:p.to(ce.range.insert),replacing:p.to(ce.range.replace)}),Ie.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Ie.insertText=new l.SnippetString(ce.insertText):(Ie.insertText=ce.insertText,Ie.textEdit=Ie.range instanceof l.Range?new l.TextEdit(Ie.range,Ie.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Ie.additionalTextEdits=ce.additionalTextEdits.map(_e=>Y.to(_e))),Ie.command=K&&ce.command?K.fromInternal(ce.command):void 0,Ie}Ee.to=Ce})(Q=e.CompletionItem||(e.CompletionItem={}));var z;(function(Ee){function Ce(K){return{label:K.label,documentation:K.documentation?I.fromStrict(K.documentation):void 0}}Ee.from=Ce;function ce(K){return{label:K.label,documentation:w.isMarkdownString(K.documentation)?I.to(K.documentation):K.documentation}}Ee.to=ce})(z=e.ParameterInformation||(e.ParameterInformation={}));var x;(function(Ee){function Ce(K){return{label:K.label,documentation:K.documentation?I.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(z.from):[],activeParameter:K.activeParameter}}Ee.from=Ce;function ce(K){return{label:K.label,documentation:w.isMarkdownString(K.documentation)?I.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(z.to):[],activeParameter:K.activeParameter}}Ee.to=ce})(x=e.SignatureInformation||(e.SignatureInformation={}));var X;(function(Ee){function Ce(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(x.from):[]}}Ee.from=Ce;function ce(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(x.to):[]}}Ee.to=ce})(X=e.SignatureHelp||(e.SignatureHelp={}));var ue;(function(Ee){function Ce(ce,K){const Ie=new l.InlayHint(typeof K.label=="string"?K.label:K.label.map(ye.to.bind(void 0,ce)),s.to(K.position),Pe.to(K.kind));return Ie.tooltip=w.isMarkdownString(K.tooltip)?I.to(K.tooltip):K.tooltip,Ie.paddingLeft=K.paddingLeft,Ie.paddingRight=K.paddingRight,Ie}Ee.to=Ce})(ue=e.InlayHint||(e.InlayHint={}));var ye;(function(Ee){function Ce(ce,K){const Ie=new l.InlayHintLabelPart(K.label);return Ie.tooltip=w.isMarkdownString(K.tooltip)?I.to(K.tooltip):K.tooltip,R.Command.is(K.command)&&(Ie.command=ce.fromInternal(K.command)),K.location&&(Ie.location=de.to(K.location)),Ie}Ee.to=Ce})(ye=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Pe;(function(Ee){function Ce(K){return K}Ee.from=Ce;function ce(K){return K}Ee.to=ce})(Pe=e.InlayHintKind||(e.InlayHintKind={}));var Ae;(function(Ee){function Ce(K){return{range:p.from(K.range),url:K.target,tooltip:K.tooltip}}Ee.from=Ce;function ce(K){let Ie;if(K.url)try{Ie=typeof K.url=="string"?E.URI.parse(K.url,!0):E.URI.revive(K.url)}catch{}return new l.DocumentLink(p.to(K.range),Ie)}Ee.to=ce})(Ae=e.DocumentLink||(e.DocumentLink={}));var Fe;(function(Ee){function Ce(K){const Ie=new l.ColorPresentation(K.label);return K.textEdit&&(Ie.textEdit=Y.to(K.textEdit)),K.additionalTextEdits&&(Ie.additionalTextEdits=K.additionalTextEdits.map(_e=>Y.to(_e))),Ie}Ee.to=Ce;function ce(K){return{label:K.label,textEdit:K.textEdit?Y.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Ie=>Y.from(Ie)):void 0}}Ee.from=ce})(Fe=e.ColorPresentation||(e.ColorPresentation={}));var Ue;(function(Ee){function Ce(K){return new l.Color(K[0],K[1],K[2],K[3])}Ee.to=Ce;function ce(K){return[K.red,K.green,K.blue,K.alpha]}Ee.from=ce})(Ue=e.Color||(e.Color={}));var le;(function(Ee){function Ce(K){return{range:p.from(K.range)}}Ee.from=Ce;function ce(K){return new l.SelectionRange(p.to(K.range))}Ee.to=ce})(le=e.SelectionRange||(e.SelectionRange={}));var ge;(function(Ee){function Ce(ce){switch(ce){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Ee.to=Ce})(ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var he;(function(Ee){function Ce(K){switch(K){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Ce;function ce(K){switch(K){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Ee.to=ce})(he=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Re;(function(Ee){function Ce(K){if(K===l.EndOfLine.CRLF)return 1;if(K===l.EndOfLine.LF)return 0}Ee.from=Ce;function ce(K){if(K===1)return l.EndOfLine.CRLF;if(K===0)return l.EndOfLine.LF}Ee.to=ce})(Re=e.EndOfLine||(e.EndOfLine={}));var Me;(function(Ee){function Ce(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Ce})(Me=e.ProgressLocation||(e.ProgressLocation={}));var qe;(function(Ee){function Ce(ce){const K={start:ce.start+1,end:ce.end+1};return ce.kind&&(K.kind=Be.from(ce.kind)),K}Ee.from=Ce})(qe=e.FoldingRange||(e.FoldingRange={}));var Be;(function(Ee){function Ce(ce){if(ce)switch(ce){case l.FoldingRangeKind.Comment:return R.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return R.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return R.FoldingRangeKind.Region}}Ee.from=Ce})(Be=e.FoldingRangeKind||(e.FoldingRangeKind={}));var je;(function(Ee){function Ce(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?p.from(ce.selection):void 0,override:typeof ce.override=="boolean"?h.EditorResolution.DISABLED:void 0}}Ee.from=Ce})(je=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var He;(function(Ee){function Ce(_e){return _e instanceof l.RelativePattern?_e.toJSON():typeof _e=="string"?_e:ce(_e)||K(_e)?new l.RelativePattern(_e.baseUri??_e.base,_e.pattern).toJSON():_e}Ee.from=Ce;function ce(_e){const Ke=_e;return Ke?E.URI.isUri(Ke.baseUri)&&typeof Ke.pattern=="string":!1}function K(_e){const Ke=_e;return Ke?typeof Ke.base=="string"&&typeof Ke.pattern=="string":!1}function Ie(_e){return typeof _e=="string"?_e:new l.RelativePattern(E.URI.revive(_e.baseUri),_e.pattern)}Ee.to=Ie})(He=e.GlobPattern||(e.GlobPattern={}));var se;(function(Ee){function Ce(ce){if(ce){if(Array.isArray(ce))return ce.map(Ce);if(typeof ce=="string")return ce;{const K=ce;return{language:K.language,scheme:K.scheme,pattern:He.from(K.pattern),exclusive:K.exclusive}}}else return}Ee.from=Ce})(se=e.LanguageSelector||(e.LanguageSelector={}));var Se;(function(Ee){function Ce(K){return{start:K.start,end:K.end}}Ee.from=Ce;function ce(K){return new l.NotebookRange(K.start,K.end)}Ee.to=ce})(Se=e.NotebookRange||(e.NotebookRange={}));var ke;(function(Ee){function Ce(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Ee.to=Ce;function ce(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Ee.from=ce})(ke=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Le;(function(Ee){function Ce(K){switch(K){case l.NotebookCellKind.Markup:return d.CellKind.Markup;case l.NotebookCellKind.Code:default:return d.CellKind.Code}}Ee.from=Ce;function ce(K){switch(K){case d.CellKind.Markup:return l.NotebookCellKind.Markup;case d.CellKind.Code:default:return l.NotebookCellKind.Code}}Ee.to=ce})(Le=e.NotebookCellKind||(e.NotebookCellKind={}));var Oe;(function(Ee){function Ce(K){const Ie={metadata:K.metadata??Object.create(null),cells:[]};for(let _e of K.cells)l.NotebookCellData.validate(_e),Ie.cells.push(Ye.from(_e));return Ie}Ee.from=Ce;function ce(K){const Ie=new l.NotebookData(K.cells.map(Ye.to));return(0,y.isEmptyObject)(K.metadata)||(Ie.metadata=K.metadata),Ie}Ee.to=ce})(Oe=e.NotebookData||(e.NotebookData={}));var Ye;(function(Ee){function Ce(K){return{cellKind:Le.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:ke.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Ve.from):[]}}Ee.from=Ce;function ce(K){return new l.NotebookCellData(Le.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Ve.to):void 0,K.metadata,K.internalMetadata?ke.to(K.internalMetadata):void 0)}Ee.to=ce})(Ye=e.NotebookCellData||(e.NotebookCellData={}));var $e;(function(Ee){function Ce(K){return{mime:K.mime,valueBytes:t.VSBuffer.wrap(K.data)}}Ee.from=Ce;function ce(K){return new l.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}Ee.to=ce})($e=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ve;(function(Ee){function Ce(K){return{outputId:K.id,items:K.items.map($e.from),metadata:K.metadata}}Ee.from=Ce;function ce(K){const Ie=K.items.map($e.to);return new l.NotebookCellOutput(Ie,K.outputId,K.metadata)}Ee.to=ce})(Ve=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Xe;(function(Ee){function Ce(Ie){return K(Ie)?{include:(0,y.withNullAsUndefined)(He.from(Ie.include)),exclude:(0,y.withNullAsUndefined)(He.from(Ie.exclude))}:(0,y.withNullAsUndefined)(He.from(Ie))}Ee.from=Ce;function ce(Ie){return K(Ie)?{include:He.to(Ie.include),exclude:He.to(Ie.exclude)}:He.to(Ie)}Ee.to=ce;function K(Ie){const _e=Ie;return _e?!!_e.include&&!!_e.exclude:!1}})(Xe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ge;(function(Ee){function Ce(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?W.from(ce.top):void 0}}Ee.from=Ce})(Ge=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ze;(function(Ee){function Ce(ce,K,Ie){const _e=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(_e,Ie),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}Ee.from=Ce})(Ze=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var rt;(function(Ee){function Ce(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}Ee.from=Ce})(rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var et;(function(Ee){function Ce(K){return{uri:K.uri,provides:K.provides}}Ee.from=Ce;function ce(K){return new l.NotebookRendererScript(E.URI.revive(K.uri),K.provides)}Ee.to=ce})(et=e.NotebookRendererScript||(e.NotebookRendererScript={}));var nt;(function(Ee){function Ce(K){return{message:I.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location?de.from(K.location):void 0}}Ee.from=Ce;function ce(K){const Ie=new l.TestMessage(typeof K.message=="string"?K.message:I.to(K.message));return Ie.actualOutput=K.actual,Ie.expectedOutput=K.expected,Ie.location=K.location?de.to(K.location):void 0,Ie}Ee.to=ce})(nt=e.TestMessage||(e.TestMessage={}));var ot;(function(Ee){let Ce;(function(ce){ce.Delimiter="\0"})(Ce||(Ce={})),Ee.namespace=(ce,K)=>ce+"\0"+K,Ee.denamespace=ce=>{const K=ce.indexOf("\0");return{ctrlId:ce.slice(0,K),tagId:ce.slice(K+1)}}})(ot=e.TestTag||(e.TestTag={}));var vt;(function(Ee){function Ce(_e){const Ke=(0,c.getPrivateApiFor)(_e).controllerId;return{extId:g.TestId.fromExtHostTestItem(_e,Ke).toString(),label:_e.label,uri:_e.uri,tags:_e.tags.map(We=>ot.namespace(Ke,We.id)),range:p.from(_e.range)||null,description:_e.description||null,sortText:_e.sortText||null,error:_e.error&&I.fromStrict(_e.error)||null}}Ee.from=Ce;function ce(_e){return{parent:void 0,error:void 0,id:g.TestId.fromString(_e.extId).localId,label:_e.label,uri:E.URI.revive(_e.uri),tags:(_e.tags||[]).map(Ke=>{const{tagId:We}=ot.denamespace(Ke);return new l.TestTag(We)}),range:p.to(_e.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:_e.description||void 0,sortText:_e.sortText||void 0}}Ee.toPlain=ce;function K(_e){const Ke=g.TestId.fromString(_e.extId),We=new c.TestItemImpl(Ke.controllerId,Ke.localId,_e.label,E.URI.revive(_e.uri));return We.range=p.to(_e.range||void 0),We.description=_e.description||void 0,We.sortText=_e.sortText||void 0,We}function Ie(_e){let Ke;for(const We of _e.tests){const it=K(We.item);(0,c.getPrivateApiFor)(it).parent=Ke,Ke=it}return Ke}Ee.toItemFromContext=Ie})(vt=e.TestItem||(e.TestItem={})),function(Ee){function Ce(K){return{id:K.id}}Ee.from=Ce;function ce(K){return new l.TestTag(K.id)}Ee.to=ce}(ot=e.TestTag||(e.TestTag={}));var pt;(function(Ee){const Ce=(K,Ie)=>{const _e={...vt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(We=>We.type===0).map(nt.to)})),children:K.children.map(Ke=>Ie.get(Ke)).filter(y.isDefined).map(Ke=>Ce(Ke,Ie))};for(const Ke of _e.children)Ke.parent=_e;return _e};function ce(K){const Ie=[],_e=new Map;for(const Ke of K.items)_e.set(Ke.item.extId,Ke),K.request.targets.some(We=>We.controllerId===Ke.controllerId&&We.testIds.includes(Ke.item.extId))&&Ie.push(Ke);return{completedAt:K.completedAt,results:Ie.map(Ke=>Ce(Ke,_e))}}Ee.to=ce})(pt=e.TestResults||(e.TestResults={}));var Dt;(function(Ee){function Ce(_e){return{covered:_e.covered,total:_e.covered}}function ce(_e){return"line"in _e?s.from(_e):p.from(_e)}function K(_e){return"branches"in _e?{count:_e.executionCount,location:ce(_e.location),type:1,branches:_e.branches.length?_e.branches.map(Ke=>({count:Ke.executionCount,location:Ke.location&&ce(Ke.location)})):void 0}:{type:0,count:_e.executionCount,location:ce(_e.location)}}Ee.fromDetailed=K;function Ie(_e){return{uri:_e.uri,statement:Ce(_e.statementCoverage),branch:_e.branchCoverage&&Ce(_e.branchCoverage),function:_e.functionCoverage&&Ce(_e.functionCoverage),details:_e.detailedCoverage?.map(K)}}Ee.fromFile=Ie})(Dt=e.TestCoverage||(e.TestCoverage={}));var It;(function(Ee){function Ce(ce){switch(ce){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Ee.to=Ce})(It=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Pt;(function(Ee){function Ce(K){const Ie=new l.TypeHierarchyItem(G.to(K.kind),K.name,K.detail||"",E.URI.revive(K.uri),p.to(K.range),p.to(K.selectionRange));return Ie._sessionId=K._sessionId,Ie._itemId=K._itemId,Ie}Ee.to=Ce;function ce(K,Ie,_e){if(Ie=Ie??K._sessionId,_e=_e??K._itemId,Ie===void 0||_e===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:_e,kind:G.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:p.from(K.range),selectionRange:p.from(K.selectionRange),tags:K.tags?.map(ie.from)}}Ee.from=ce})(Pt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ve[244],we([0,1,12,239,14,97,105,110,240,108,111,8,194,109]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let c=class{constructor(g,b,l,C,p,u,s,a,i,n){this._remoteAuthority=g,this._channel=b,this._configurationService=l,this._workspaceContextService=C,this._resolverService=p,this._environmentVariableService=u,this._remoteAuthorityResolverService=s,this._logService=a,this._editorService=i,this._labelService=n}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this._channel.listen("$onDidChangeProperty")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(g,b,l,C,p,u,s){await this._configurationService.whenRemoteConfigurationLoaded();const a=Object.create(null),i=l?(0,_.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(l)):void 0;let n;try{n=(await this._resolverService.resolveAnyMap(i,{shellLaunchConfig:g,configuration:b})).resolvedVariables}catch(W){this._logService.error(W)}if(n)for(const[W,m]of n.entries())(/^config:/.test(W)||W==="selectedText"||W==="lineNumber")&&(a[W]=m);const r=[];for(const[W,m]of this._environmentVariableService.collections.entries())r.push([W,(0,k.serializeEnvironmentVariableCollection)(m.map)]);const o=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),f=o.options&&o.options.extensionHostEnv,S=this._workspaceContextService.getWorkspace(),A=S.folders,I=l?this._workspaceContextService.getWorkspaceFolder(l):null,F=E.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:E.SideBySideEditor.PRIMARY,filterByScheme:[R.Schemas.file,R.Schemas.userData,R.Schemas.vscodeRemote]}),U={configuration:b,resolvedVariables:a,envVariableCollections:r,shellLaunchConfig:g,workspaceId:S.id,workspaceName:this._labelService.getWorkspaceLabel(S),workspaceFolders:A,activeWorkspaceFolder:I,activeFileResource:F,shouldPersistTerminal:C,cols:p,rows:u,unicodeVersion:s,resolverEnv:f};return await this._channel.call("$createProcess",U)}requestDetachInstance(g,b){return this._channel.call("$requestDetachInstance",[g,b])}acceptDetachInstanceReply(g,b){return this._channel.call("$acceptDetachInstanceReply",[g,b])}attachToProcess(g){return this._channel.call("$attachToProcess",[g])}detachFromProcess(g){return this._channel.call("$detachFromProcess",[g])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(g,b){return this._channel.call("$processBinary",[g,b])}start(g){return this._channel.call("$start",[g])}input(g,b){return this._channel.call("$input",[g,b])}acknowledgeDataEvent(g,b){return this._channel.call("$acknowledgeDataEvent",[g,b])}setUnicodeVersion(g,b){return this._channel.call("$setUnicodeVersion",[g,b])}shutdown(g,b){return this._channel.call("$shutdown",[g,b])}resize(g,b,l){return this._channel.call("$resize",[g,b,l])}getInitialCwd(g){return this._channel.call("$getInitialCwd",[g])}getCwd(g){return this._channel.call("$getCwd",[g])}orphanQuestionReply(g){return this._channel.call("$orphanQuestionReply",[g])}sendCommandResult(g,b,l){return this._channel.call("$sendCommandResult",[g,b,l])}installAutoReply(g,b){return this._channel.call("$installAutoReply",[g,b])}uninstallAllAutoReplies(){return this._channel.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(g){return this._channel.call("$getDefaultSystemShell",[g])}getProfiles(g,b,l){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,g,b,l])}acceptPtyHostResolvedVariables(g,b){return this._channel.call("$acceptPtyHostResolvedVariables",[g,b])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(g){return this._channel.call("$getWslPath",[g])}setTerminalLayoutInfo(g){const l={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:g?g.tabs:[]};return this._channel.call("$setTerminalLayoutInfo",l)}updateTitle(g,b,l){return this._channel.call("$updateTitle",[g,b,l])}updateIcon(g,b,l){return this._channel.call("$updateIcon",[g,b,l])}refreshProperty(g,b){return this._channel.call("$refreshProperty",[g,b])}updateProperty(g,b,l){return this._channel.call("$updateProperty",[g,b,l])}getTerminalLayoutInfo(){const b={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",b)}reviveTerminalProcesses(g,b){return this._channel.call("$reviveTerminalProcesses",[g,b])}serializeTerminalState(g){return this._channel.call("$serializeTerminalState",[g])}};c=Te([Ne(2,t.IWorkbenchConfigurationService),Ne(3,D.IWorkspaceContextService),Ne(4,y.IConfigurationResolverService),Ne(5,v.IEnvironmentVariableService),Ne(6,P.IRemoteAuthorityResolverService),Ne(7,w.ILogService),Ne(8,T.IEditorService),Ne(9,h.ILabelService)],c),e.RemoteTerminalChannelClient=c}),define(ve[245],we([0,1,199]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Logger=e.Translations=void 0;var t;(function(P){function D(k,y){if(k===y)return!0;let E=Object.keys(k),T=new Set;for(let R of Object.keys(y))T.add(R);if(E.length!==T.size)return!1;for(let R of E){if(k[R]!==y[R])return!1;T.delete(R)}return T.size===0}P.equals=D})(t=e.Translations||(e.Translations={}));class w{constructor(D){this._messageHandler=D}error(D,k){this._messageHandler(_.Severity.Error,D,k)}warn(D,k){this._messageHandler(_.Severity.Warning,D,k)}info(D,k){this._messageHandler(_.Severity.Info,D,k)}}e.Logger=w}),define(ve[112],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class _{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++_.count}}e.ProxyIdentifier=_,_.count=0;const t=[];function w(k){const y=new _(k);return t[y.nid]=y,y}e.createProxyIdentifier=w;function P(k){return t[k].sid}e.getStringIdentifierForProxy=P;class D{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=D}),define(ve[246],we([0,1,52,5,112]),function(J,e,_,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var D;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var E;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(E=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class h{static mixin(C){return C._id=h._n++,C}}e.IdObject=h,h._n=0;var v;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var c;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(c=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var d;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(d=e.WorkspaceEditType||(e.WorkspaceEditType={}));function g(l){if(l&&l.edits)for(const C of l.edits)typeof C.resource=="object"?C.resource=t.URI.revive(C.resource):(C.newUri=t.URI.revive(C.newUri),C.oldUri=t.URI.revive(C.oldUri)),C.metadata&&C.metadata.iconPath&&(C.metadata=(0,_.revive)(C.metadata));return l}e.reviveWorkspaceEditDto=g;var b;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,w.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,w.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,w.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,w.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,w.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,w.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,w.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,w.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,w.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createProxyIdentifier)("ExtHostTelemetry")}});var Et=this&&this.__classPrivateFieldSet||function(J,e,_,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!w:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(J,_):w?w.value=_:e.set(J,_),_},tt=this&&this.__classPrivateFieldGet||function(J,e,_,t){if(_==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?t:_==="a"?t.call(J):t?t.value:e.get(J)};define(ve[247],we([0,1,12,107,243,20,246,17,14,52,63,86,5,2,6,234,106,15,112,36]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c,d,g,b,l,C){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let u=class{constructor(o,f){p.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Et(this,p,o.getProxy(D.MainContext.MainThreadCommands),"f"),this._logService=f,this.converter=new s(this,S=>{const A=this._apiCommands.get(S);return A?.result===i.Void?A:void 0},f),this._argumentProcessors=[{processArgument(S){return(0,E.revive)(S)}},{processArgument(S){return(0,P.cloneAndChange)(S,function(A){if(T.Range.isIRange(A))return w.Range.to(A);if(R.Position.isIPosition(A))return w.Position.to(A);if(T.Range.isIRange(A.range)&&h.URI.isUri(A.uri))return w.location.to(A);if(A instanceof b.VSBuffer)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const f=this.registerCommand(!1,o.id,async(...S)=>{const A=o.args.map((F,U)=>{if(!F.validate(S[U]))throw new Error(`Invalid argument '${F.name}' when running '${o.id}', received: ${S[U]}`);return F.convert(S[U])}),I=await this.executeCommand(o.internalId,...A);return o.result.convert(I,S,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new t.Disposable(()=>{f.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,f,S,A,I,F){if(this._logService.trace("ExtHostCommands#registerCommand",f),!f.trim().length)throw new Error("invalid id");if(this._commands.has(f))throw new Error(`command '${f}' already exists`);return this._commands.set(f,{callback:S,thisArg:A,description:I,extension:F}),o&&tt(this,p,"f").$registerCommand(f),new t.Disposable(()=>{this._commands.delete(f)&&o&&tt(this,p,"f").$unregisterCommand(f)})}executeCommand(o,...f){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,f,!0)}async _doExecuteCommand(o,f,S){if(this._commands.has(o))return this._executeContributedCommand(o,f,!1);{let A=!1;const I=(0,P.cloneAndChange)(f,function(F){if(F instanceof t.Position)return w.Position.from(F);if(F instanceof t.Range)return w.Range.from(F);if(F instanceof t.Location)return w.location.from(F);if(t.NotebookRange.isNotebookRange(F))return w.NotebookRange.from(F);if(F instanceof ArrayBuffer)return A=!0,b.VSBuffer.wrap(new Uint8Array(F));if(F instanceof Uint8Array)return A=!0,b.VSBuffer.wrap(F);if(!Array.isArray(F))return F});try{const F=await tt(this,p,"f").$executeCommand(o,A?new l.SerializableObjectWithBuffers(I):I,S);return(0,E.revive)(F)}catch(F){if(F instanceof Error&&F.message==="$executeCommand:retry")return this._doExecuteCommand(o,f,!1);throw F}}}async _executeContributedCommand(o,f,S){const A=this._commands.get(o);if(!A)throw new Error("Unknown command");let{callback:I,thisArg:F,description:U}=A;if(U)for(let W=0;W<U.args.length;W++)try{(0,_.validateConstraint)(f[W],U.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${U.args[W].name}' - ${U.args[W].description}`)}try{return await I.apply(F,f)}catch(W){if(o===this.converter.delegatingCommandId){const m=this.converter.getActualCommand(...f);m&&(o=m.command)}throw this._logService.error(W,o,A.extension?.identifier),S?new class extends Error{constructor(){super((0,C.toErrorMessage)(W));this.id=o,this.source=A.extension?.displayName??A.extension?.name}}:W}}$executeContributedCommand(o,...f){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(f=f.map(S=>this._argumentProcessors.reduce((A,I)=>I.processArgument(A),S)),this._executeContributedCommand(o,f,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),tt(this,p,"f").$getCommands().then(f=>(o&&(f=f.filter(S=>S[0]!=="_")),f))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(let[f,S]of this._commands){let{description:A}=S;A&&(o[f]=A)}return Promise.resolve(o)}};p=new WeakMap,u=Te([Ne(0,d.IExtHostRpcService),Ne(1,y.ILogService)],u),e.ExtHostCommands=u,e.IExtHostCommands=(0,c.createDecorator)("IExtHostCommands");class s{constructor(o,f,S){this._commands=o,this._lookupApiCommand=f,this._logService=S,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,f){if(!o)return;const S={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return S;const A=this._lookupApiCommand(o.command);if(A)S.id=A.internalId,S.arguments=A.args.map((I,F)=>I.convert(o.arguments&&o.arguments[F]));else if((0,k.isNonEmptyArray)(o.arguments)){const I=++this._cachIdPool;this._cache.set(I,o),f.add((0,v.toDisposable)(()=>{this._cache.delete(I),this._logService.trace("CommandsConverter#DISPOSE",I)})),S.$ident=I,S.id=this.delegatingCommandId,S.arguments=[I],this._logService.trace("CommandsConverter#CREATE",o.command,I)}return S}fromInternal(o){return typeof o.$ident=="number"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const f=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],f?f.command:"MISSING"),f?this._commands.executeCommand(f.command,...f.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=s;class a{constructor(o,f,S,A){this.name=o,this.description=f,this.validate=S,this.convert=A}optional(){return new a(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,f){return new a(o??this.name,f??this.description,this.validate,this.convert)}}e.ApiCommandArgument=a,a.Uri=new a("uri","Uri of a text document",r=>h.URI.isUri(r),r=>r),a.Position=new a("position","A position in a text document",r=>t.Position.isPosition(r),w.Position.from),a.Range=new a("range","A range in a text document",r=>t.Range.isRange(r),w.Range.from),a.Selection=new a("selection","A selection in a text document",r=>t.Selection.isSelection(r),w.Selection.from),a.Number=new a("number","",r=>typeof r=="number",r=>r),a.String=new a("string","",r=>typeof r=="string",r=>r),a.CallHierarchyItem=new a("item","A call hierarchy item",r=>r instanceof t.CallHierarchyItem,w.CallHierarchyItem.from),a.TypeHierarchyItem=new a("item","A type hierarchy item",r=>r instanceof t.TypeHierarchyItem,w.TypeHierarchyItem.from),a.TestItem=new a("testItem","A VS Code TestItem",r=>r instanceof g.TestItemImpl,w.TestItem.from);class i{constructor(o,f){this.description=o,this.convert=f}}e.ApiCommandResult=i,i.Void=new i("no result",r=>r);class n{constructor(o,f,S,A,I){this.id=o,this.internalId=f,this.description=S,this.args=A,this.result=I}}e.ApiCommand=n}),define(ve[248],we([0,1,80]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logRemoteEntryIfError=e.logRemoteEntry=void 0;function t(P,D,k=null){const y=(0,_.parse)(D).args;let E=y.shift();if(typeof E=="string")switch(D.severity||(D.severity="info"),k&&(/^\[/.test(k)||(k=`[${k}]`),/ $/.test(k)||(k=`${k} `),E=k+E),D.severity){case"log":case"info":P.info(E,...y);break;case"warn":P.warn(E,...y);break;case"error":P.error(E,...y);break}}e.logRemoteEntry=t;function w(P,D,k){const y=(0,_.parse)(D).args,E=y.shift();typeof E!="string"||D.severity!=="error"||(/^\[/.test(k)||(k=`[${k}]`),/ $/.test(k)||(k=`${k} `),P.error(k+E,...y))}e.logRemoteEntryIfError=w}),define(ve[249],we([0,1,175,4,57,38,17,147,12,5,19,33,65,41,245]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionScanner=e.ExtensionScannerInput=void 0;const d="package.json";class g{constructor(i,n,r,o,f,S){this._ourVersion=i,this._ourProductDate=n,this._log=r,this._absoluteFolderPath=o,this._isBuiltin=f,this._isUnderDevelopment=S,this._absoluteManifestPath=t.join(o,d)}}class b extends g{static _fastParseJSON(i,n){try{return JSON.parse(i)}catch{return P.parse(i,n)}}parse(){return T.Promises.readFile(this._absoluteManifestPath).then(i=>{const n=[],r=b._fastParseJSON(i.toString(),n);if(P.getNodeType(r)!=="object")this._log.error(this._absoluteFolderPath,_.localize(0,null,this._absoluteManifestPath));else{if(n.length===0)return r.__metadata&&(r.uuid=r.__metadata.id),r.isUserBuiltin=!!r.__metadata?.isBuiltin,delete r.__metadata,r;n.forEach(o=>{this._log.error(this._absoluteFolderPath,_.localize(1,null,this._absoluteManifestPath,o.offset,o.length,(0,k.getParseErrorMessage)(o.error)))})}return null},i=>(i.code==="ENOENT"||this._log.error(this._absoluteFolderPath,_.localize(2,null,this._absoluteManifestPath,i.message)),null))}}class l extends g{constructor(i,n,r,o,f,S,A){super(i,n,r,o,f,S);this._nlsConfig=A}replaceNLS(i){const n=(F,U)=>{U.forEach(W=>{this._log.error(this._absoluteFolderPath,_.localize(3,null,F,(0,k.getParseErrorMessage)(W.error)))})},r=F=>{this._log.error(this._absoluteFolderPath,_.localize(4,null,F))};let o=t.extname(this._absoluteManifestPath),f=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-o.length);const S=`${i.publisher}.${i.name}`;let A=this._nlsConfig.translations[S],I;return A?I=T.Promises.readFile(A,"utf8").then(F=>{let U=[],W=P.parse(F,U);return U.length>0?(n(A,U),{values:void 0,default:`${f}.nls.json`}):P.getNodeType(W)!=="object"?(r(A),{values:void 0,default:`${f}.nls.json`}):{values:W.contents?W.contents.package:void 0,default:`${f}.nls.json`}},F=>({values:void 0,default:`${f}.nls.json`})):I=T.SymlinkSupport.existsFile(f+".nls"+o).then(F=>{if(!!F)return l.findMessageBundles(this._nlsConfig,f).then(U=>U.localized?T.Promises.readFile(U.localized,"utf8").then(W=>{let m=[],L=P.parse(W,m);return m.length>0?(n(U.localized,m),{values:void 0,default:U.original}):P.getNodeType(L)!=="object"?(r(U.localized),{values:void 0,default:U.original}):{values:L,default:U.original}},W=>({values:void 0,default:U.original})):{values:void 0,default:U.original},U=>{})}),I.then(F=>{if(F===void 0)return i;let U=[];return l.resolveOriginalMessageBundle(F.default,U).then(W=>{if(U.length>0)return n(F.default,U),i;if(P.getNodeType(F)!=="object")return r(F.default),i;const m=F.values||Object.create(null);return l._replaceNLStrings(this._nlsConfig,i,m,W,this._log,this._absoluteFolderPath),i})},F=>i)}static resolveOriginalMessageBundle(i,n){return new Promise((r,o)=>{i?T.Promises.readFile(i).then(f=>{r(P.parse(f.toString(),n))},f=>{r(null)}):r(null)})}static findMessageBundles(i,n){return new Promise((r,o)=>{function f(S,A){let I=`${S}.nls.${A}.json`;T.SymlinkSupport.existsFile(I).then(F=>{F&&r({localized:I,original:`${S}.nls.json`});let U=A.lastIndexOf("-");U===-1?r({localized:`${S}.nls.json`,original:null}):(A=A.substring(0,U),f(S,A))})}if(i.devMode||i.pseudo||!i.locale)return r({localized:n+".nls.json",original:null});f(n,i.locale)})}static _replaceNLStrings(i,n,r,o,f,S){function A(I,F,U){const W=I[F];if(y.isString(W)){const m=W,L=m.length;if(L>1&&m[0]==="%"&&m[L-1]==="%"){const M=m.substr(1,L-2);let Y=r[M];Y===void 0&&o&&(Y=o[M]);let $=typeof Y=="string"?Y:typeof Y?.message=="string"?Y.message:void 0;$!==void 0?(i.pseudo&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),I[F]=U&&(F==="title"||F==="category")&&o?{value:$,original:o[M]}:$):f.warn(S,_.localize(5,null,M))}}else if(y.isObject(W))for(let m in W)W.hasOwnProperty(m)&&(m==="commands"?A(W,m,!0):A(W,m,U));else if(y.isArray(W))for(let m=0;m<W.length;m++)A(W,m,U)}for(let I in n)n.hasOwnProperty(I)&&A(n,I)}}class C extends g{validate(i){let n=i;n.isBuiltin=this._isBuiltin,n.isUserBuiltin=!this._isBuiltin&&!!n.isUserBuiltin,n.isUnderDevelopment=this._isUnderDevelopment;let r=[];return C.isValidExtensionDescription(this._ourVersion,this._ourProductDate,this._absoluteFolderPath,n,r)?(r.forEach(o=>{this._log.warn(this._absoluteFolderPath,o)}),n.publisher||(n.publisher=v.UNDEFINED_PUBLISHER),n.id=(0,R.getExtensionId)(n.publisher,n.name),n.identifier=new v.ExtensionIdentifier(n.id),n.extensionLocation=E.URI.file(this._absoluteFolderPath),n):(r.forEach(o=>{this._log.error(this._absoluteFolderPath,o)}),null)}static isValidExtensionDescription(i,n,r,o,f){return C.baseIsValidExtensionDescription(r,o,f)?w.valid(o.version)?(0,h.isValidExtensionVersion)(i,n,o,f):(f.push(_.localize(6,null)),!1):!1}static baseIsValidExtensionDescription(i,n,r){if(!n)return r.push(_.localize(7,null)),!1;if(typeof n.publisher!="undefined"&&typeof n.publisher!="string")return r.push(_.localize(8,null)),!1;if(typeof n.name!="string")return r.push(_.localize(9,null,"name")),!1;if(typeof n.version!="string")return r.push(_.localize(10,null,"version")),!1;if(!n.engines)return r.push(_.localize(11,null,"engines")),!1;if(typeof n.engines.vscode!="string")return r.push(_.localize(12,null,"engines.vscode")),!1;if(typeof n.extensionDependencies!="undefined"&&!C._isStringArray(n.extensionDependencies))return r.push(_.localize(13,null,"extensionDependencies")),!1;if(typeof n.activationEvents!="undefined"){if(!C._isStringArray(n.activationEvents))return r.push(_.localize(14,null,"activationEvents")),!1;if(typeof n.main=="undefined"&&typeof n.browser=="undefined")return r.push(_.localize(15,null,"activationEvents","main")),!1}if(typeof n.main!="undefined"){if(typeof n.main!="string")return r.push(_.localize(16,null,"main")),!1;{const o=t.join(i,n.main);o.startsWith(i)||r.push(_.localize(17,null,o,i))}if(typeof n.activationEvents=="undefined")return r.push(_.localize(18,null,"activationEvents","main")),!1}if(typeof n.browser!="undefined"){if(typeof n.browser!="string")return r.push(_.localize(19,null,"browser")),!1;{const o=t.join(i,n.browser);o.startsWith(i)||r.push(_.localize(20,null,o,i))}if(typeof n.activationEvents=="undefined")return r.push(_.localize(21,null,"activationEvents","browser")),!1}return!0}static _isStringArray(i){if(!Array.isArray(i))return!1;for(let n=0,r=i.length;n<r;n++)if(typeof i[n]!="string")return!1;return!0}}class p{constructor(i,n,r,o,f,S,A,I,F){this.ourVersion=i,this.ourProductDate=n,this.commit=r,this.locale=o,this.devMode=f,this.absoluteFolderPath=S,this.isBuiltin=A,this.isUnderDevelopment=I,this.translations=F}static createNLSConfig(i){return{devMode:i.devMode,locale:i.locale,pseudo:i.locale==="pseudo",translations:i.translations}}static equals(i,n){return i.ourVersion===n.ourVersion&&i.ourProductDate===n.ourProductDate&&i.commit===n.commit&&i.locale===n.locale&&i.devMode===n.devMode&&i.absoluteFolderPath===n.absoluteFolderPath&&i.isBuiltin===n.isBuiltin&&i.isUnderDevelopment===n.isUnderDevelopment&&i.mtime===n.mtime&&c.Translations.equals(i.translations,n.translations)}}e.ExtensionScannerInput=p;class u{constructor(i){this.root=i}resolveExtensions(){return T.Promises.readDirsInDir(this.root).then(i=>i.map(n=>({name:n,path:t.join(this.root,n)})))}}class s{static scanExtension(i,n,r,o,f,S,A){return o=t.normalize(o),new b(i,n,r,o,f,S).parse().then(F=>F===null?null:new l(i,n,r,o,f,S,A).replaceNLS(F)).then(F=>F===null?null:new C(i,n,r,o,f,S).validate(F))}static async scanExtensions(i,n,r=null){const o=i.absoluteFolderPath,f=i.isBuiltin,S=i.isUnderDevelopment;r||(r=new u(o));try{let A={};if(!f)try{const m=await T.Promises.readFile(t.join(o,".obsolete"),"utf8");A=JSON.parse(m)}catch{}let I=await r.resolveExtensions();I.sort((m,L)=>m.name<L.name?-1:1),f||(I=I.filter(m=>m.name.indexOf(".")!==0));const F=p.createNLSConfig(i);let U=await Promise.all(I.map(m=>this.scanExtension(i.ourVersion,i.ourProductDate,n,m.path,f,S,F))),W=D.coalesce(U);return W=W.filter(m=>m!==null&&!A[new R.ExtensionIdentifierWithVersion({id:(0,R.getGalleryExtensionId)(m.publisher,m.name)},m.version).key()]),f||(W=(0,R.groupByExtension)(W,L=>({id:L.identifier.value,uuid:L.uuid})).map(L=>L.sort((M,Y)=>w.rcompare(M.version,Y.version))[0])),W.sort((m,L)=>m.extensionLocation.fsPath<L.extensionLocation.fsPath?-1:1),W}catch(A){return n.error(o,A),[]}}static scanOneOrMultipleExtensions(i,n){const r=i.absoluteFolderPath,o=i.isBuiltin,f=i.isUnderDevelopment;return T.SymlinkSupport.existsFile(t.join(r,d)).then(S=>{if(S){const A=p.createNLSConfig(i);return this.scanExtension(i.ourVersion,i.ourProductDate,n,r,o,f,A).then(I=>I===null?[]:[I])}return this.scanExtensions(i,n)},S=>(n.error(r,S),[]))}static scanSingleExtension(i,n){const r=i.absoluteFolderPath,o=i.isBuiltin,f=i.isUnderDevelopment,S=p.createNLSConfig(i);return this.scanExtension(i.ourVersion,i.ourProductDate,n,r,o,f,S)}static mergeBuiltinExtensions(i,n){return Promise.all([i,n]).then(([r,o])=>{let f=Object.create(null);for(let A=0,I=r.length;A<I;A++)f[v.ExtensionIdentifier.toKey(r[A].identifier)]=r[A];for(let A=0,I=o.length;A<I;A++)f[v.ExtensionIdentifier.toKey(o[A].identifier)]=o[A];let S=Object.keys(f).map(A=>f[A]);return S.sort((A,I)=>{const F=t.basename(A.extensionLocation.fsPath),U=t.basename(I.extensionLocation.fsPath);return F<U?-1:F>U?1:0}),S})}}e.ExtensionScanner=s}),define(ve[250],we([0,1,3,44,5,49,171,8,249,41,62,72,89,84,212,4,24,19]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c,d,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;let l=null;function C(){return l||(l=(0,d.normalize)((0,d.join)(k.FileAccess.asFileUri("",J).fsPath,"..","extensions"))),l}let p=null;function u(){return p||(p=(0,d.normalize)((0,d.join)(k.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),p}class s{constructor(i,n,r,o,f){if(this._connectionToken=i,this.environmentService=n,this.logService=o,this.productService=f,this._logger=new class{error(A,I){o.error(A,I)}warn(A,I){o.warn(A,I)}info(A,I){o.info(A,I)}},n.args["install-builtin-extension"]){const A={isMachineScoped:!!n.args["do-not-sync"],installPreReleaseVersion:!!n.args["pre-release"]};this.whenExtensionsReady=r.installExtensions([],n.args["install-builtin-extension"],A,!!n.args.force).then(null,I=>{o.error(I)})}else this.whenExtensionsReady=Promise.resolve();const S=n.args["install-extension"];if(S){const A=S.map(I=>/\.vsix$/i.test(I)?w.URI.file((0,d.isAbsolute)(I)?I:(0,d.join)((0,g.cwd)(),I)):I);this.whenExtensionsReady.then(()=>r.installExtensions(A,[],{isMachineScoped:!!n.args["do-not-sync"],installPreReleaseVersion:!!n.args["pre-release"]},!!n.args.force)).then(null,I=>{o.error(I)})}}async call(i,n,r){switch(n){case"getEnvironmentData":{const o=r,f=(0,P.createRemoteURITransformer)(o.remoteAuthority);let S=await this._getEnvironmentData();return S=(0,T.transformOutgoingURIs)(S,f),S}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const o=r,f=o.language;this.logService.trace(`Scanning extensions using UI language: ${f}`);const S=(0,P.createRemoteURITransformer)(o.remoteAuthority),A=o.extensionDevelopmentPath&&o.extensionDevelopmentPath.map(U=>w.URI.revive(S.transformIncoming(U))),I=A?A.filter(U=>U.scheme===k.Schemas.file).map(U=>U.fsPath):void 0;let F=await this._scanExtensions(f,I);return F=(0,T.transformOutgoingURIs)(F,S),this.logService.trace("Scanned Extensions",F),s._massageWhenConditions(F),F}case"scanSingleExtension":{await this.whenExtensionsReady;const o=r,f=o.language,S=o.isBuiltin,A=(0,P.createRemoteURITransformer)(o.remoteAuthority),I=w.URI.revive(A.transformIncoming(o.extensionLocation)),F=I.scheme===k.Schemas.file?I.fsPath:null;if(!F)return null;const U=await this._getTranslations(f);let W=await this._scanSingleExtension(F,S,f,U);return W?(W=(0,T.transformOutgoingURIs)(W,A),s._massageWhenConditions([W]),W):null}case"getDiagnosticInfo":{const o=r,f={machineInfo:(0,c.getMachineInfo)()},S=o.includeProcesses?(0,v.listProcesses)(process.pid):Promise.resolve();let A=[];const I={};if(o.folders){const F=(0,P.createRemoteURITransformer)("");A=o.folders.map(W=>w.URI.revive(F.transformIncoming(W))).filter(W=>W.scheme==="file").map(W=>(0,c.collectWorkspaceStats)(W.fsPath,["node_modules",".git"]).then(m=>{I[(0,d.basename)(W.fsPath)]=m}))}return Promise.all([S,...A]).then(([F,U])=>(f.processes=F||void 0,f.workspaceMetadata=o.folders?I:void 0,f))}}throw new Error(`IPC Command ${n} not found`)}listen(i,n,r){throw new Error("Not supported")}static _massageWhenConditions(i){const n=(I,F)=>I.replace(/file/g,"vscode-remote"),r=I=>{let F="";return F+=I.global?"g":"",F+=I.ignoreCase?"i":"",F+=I.multiline?"m":"",new RegExp(n(I.source,!0),F)},o=new class{mapDefined(I){return h.ContextKeyDefinedExpr.create(I)}mapNot(I){return h.ContextKeyNotExpr.create(I)}mapEquals(I,F){return I==="resourceScheme"&&typeof F=="string"?h.ContextKeyEqualsExpr.create(I,n(F,!1)):h.ContextKeyEqualsExpr.create(I,F)}mapNotEquals(I,F){return I==="resourceScheme"&&typeof F=="string"?h.ContextKeyNotEqualsExpr.create(I,n(F,!1)):h.ContextKeyNotEqualsExpr.create(I,F)}mapGreater(I,F){return h.ContextKeyGreaterExpr.create(I,F)}mapGreaterEquals(I,F){return h.ContextKeyGreaterEqualsExpr.create(I,F)}mapSmaller(I,F){return h.ContextKeySmallerExpr.create(I,F)}mapSmallerEquals(I,F){return h.ContextKeySmallerEqualsExpr.create(I,F)}mapRegex(I,F){return I==="resourceScheme"&&F?h.ContextKeyRegexExpr.create(I,r(F)):h.ContextKeyRegexExpr.create(I,F)}mapIn(I,F){return h.ContextKeyInExpr.create(I,F)}},f=I=>{if(!I||!I.when||!/resourceScheme/.test(I.when))return;const F=h.ContextKeyExpr.deserialize(I.when);if(!F)return;const U=F.map(o);I.when=U.serialize()},S=I=>{if(Array.isArray(I))for(let F of I)f(F);else f(I)},A=I=>{for(let F in I)S(I[F])};i.forEach(I=>{I.contributes&&(I.contributes.menus&&A(I.contributes.menus),I.contributes.keybindings&&S(I.contributes.keybindings),I.contributes.views&&A(I.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken.type!==0?this._connectionToken.value:"",appRoot:w.URI.file(this.environmentService.appRoot),settingsPath:this.environmentService.machineSettingsResource,logsPath:w.URI.file(this.environmentService.logsPath),extensionsPath:w.URI.file(this.environmentService.extensionsPath),extensionHostLogsPath:w.URI.file((0,d.join)(this.environmentService.logsPath,`exthost${s._namePool++}`)),globalStorageHome:this.environmentService.globalStorageHome,workspaceStorageHome:this.environmentService.workspaceStorageHome,userHome:this.environmentService.userHome,os:_.OS,arch:process.arch,marks:t.getMarks(),useHostProxy:!!this.environmentService.args["use-host-proxy"]}}async _getTranslations(i){const n=await(0,R.getNLSConfiguration)(i,this.environmentService.userDataPath);if(R.InternalNLSConfiguration.is(n))try{const r=await b.Promises.readFile(n._translationsConfigFile,"utf8");return JSON.parse(r)}catch{return Object.create(null)}else return Object.create(null)}async _scanExtensions(i,n){const r=await this._getTranslations(i),[o,f,S]=await Promise.all([this._scanBuiltinExtensions(i,r),this._scanInstalledExtensions(i,r),this._scanDevelopedExtensions(i,r,n)]);let A=new Map;o.forEach(F=>{!F||A.set(E.ExtensionIdentifier.toKey(F.identifier),F)}),f.forEach(F=>{!F||(A.has(E.ExtensionIdentifier.toKey(F.identifier))&&console.warn(D.localize(0,null,A.get(E.ExtensionIdentifier.toKey(F.identifier)).extensionLocation.fsPath,F.extensionLocation.fsPath)),A.set(E.ExtensionIdentifier.toKey(F.identifier),F))}),S.forEach(F=>{!F||A.set(E.ExtensionIdentifier.toKey(F.identifier),F)});const I=[];return A.forEach(F=>I.push(F)),I}_scanDevelopedExtensions(i,n,r){if(r){const o=r.map(f=>y.ExtensionScanner.scanOneOrMultipleExtensions(new y.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,i,!0,f,!1,!0,n),this._logger));return Promise.all(o).then(f=>{let S=[];for(let A of f)S=S.concat(A);return S})}return Promise.resolve([])}_scanBuiltinExtensions(i,n){const r=this.productService.version,o=this.productService.commit,f=this.productService.date,S=!!process.env.VSCODE_DEV,A=new y.ExtensionScannerInput(r,f,o,i,S,C(),!0,!1,n),I=y.ExtensionScanner.scanExtensions(A,this._logger);let F=I;if(S){class U{constructor(Y){this.builtInExtensions=Y}resolveExtensions(){return Promise.resolve(this.builtInExtensions.map(Y=>({name:Y.name,path:(0,d.join)(u(),Y.name)})))}}const W=Promise.resolve(this.productService.builtInExtensions||[]),m=new y.ExtensionScannerInput(r,f,o,i,S,u(),!0,!1,{}),L=W.then(M=>new U(M)).then(M=>y.ExtensionScanner.scanExtensions(m,this._logger,M));F=y.ExtensionScanner.mergeBuiltinExtensions(I,L)}return F}_scanInstalledExtensions(i,n){const r=!!process.env.VSCODE_DEV,o=new y.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,i,r,this.environmentService.extensionsPath,!1,!1,n);return y.ExtensionScanner.scanExtensions(o,this._logger)}_scanSingleExtension(i,n,r,o){const f=!!process.env.VSCODE_DEV,S=new y.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,r,f,i,n,!1,o);return y.ExtensionScanner.scanSingleExtension(S,this._logger)}}e.RemoteAgentEnvironmentChannel=s,s._namePool=1}),define(ve[113],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,_.createDecorator)("remoteAgentService")}),define(ve[251],we([0,1,11,2,8,189]),function(J,e,_,t,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class D extends P.DiskFileSystemProviderClient{static register(y,E,T){const R=y.getConnection();if(!R)return t.Disposable.None;const h=new t.DisposableStore,v=(async()=>{try{const c=await y.getRawEnvironment();c?E.registerProvider(w.Schemas.vscodeRemote,h.add(new D(c,R))):T.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(c){T.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,_.getErrorMessage)(c))}})();return h.add(E.onWillActivateFileSystemProvider(c=>{c.scheme===w.Schemas.vscodeRemote&&c.join(v)})),h}constructor(y,E){super(E.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:y.os===3})}}e.RemoteFileSystemProviderClient=D}),define(ve[73],we([0,1,27,13,4,12,19,150,265,266]),function(J,e,_,t,w,P,D,k,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class T extends Error{constructor(s,a){let i=a.message;switch(s){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=s,this.cause=a}}e.ExtractError=T;function R(u){const s=u.externalFileAttributes>>16||33188;return[448,56,7].map(a=>s&a).reduce((a,i)=>a+i,s&61440)}function h(u){if(u instanceof T)return u;let s;return/end of central directory record signature not found/.test(u.message)&&(s="CorruptZip"),new T(s,u)}function v(u,s,a,i,n,r){const o=w.dirname(s),f=w.join(i,o);if(!f.startsWith(i))return Promise.reject(new Error(k.localize(0,null,s)));const S=w.join(i,s);let A;return r.onCancellationRequested(()=>{A&&A.destroy()}),Promise.resolve(D.Promises.mkdir(f,{recursive:!0})).then(()=>new Promise((I,F)=>{if(!r.isCancellationRequested)try{A=(0,_.createWriteStream)(S,{mode:a}),A.once("close",()=>I()),A.once("error",F),u.once("error",F),u.pipe(A)}catch(U){F(U)}}))}function c(u,s,a,i){let n=(0,t.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{n.cancel(),u.close()}),new Promise((o,f)=>{const S=new t.Sequencer,A=I=>{I.isCancellationRequested||(r++,u.readEntry())};u.once("error",f),u.once("close",()=>n.then(()=>{i.isCancellationRequested||u.entryCount===r?o():f(new T("Incomplete",new Error(k.localize(1,null,r,u.entryCount))))},f)),u.readEntry(),u.on("entry",I=>{if(i.isCancellationRequested)return;if(!a.sourcePathRegex.test(I.fileName)){A(i);return}const F=I.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(F)){const m=w.join(s,F);n=(0,t.createCancelablePromise)(L=>D.Promises.mkdir(m,{recursive:!0}).then(()=>A(L)).then(void 0,f));return}const U=g(u,I),W=R(I);n=(0,t.createCancelablePromise)(m=>S.queue(()=>U.then(L=>v(L,F,W,s,a,m).then(()=>A(m)))).then(null,f))})})}function d(u,s=!1){return new Promise((a,i)=>{(0,y.open)(u,s?{lazyEntries:!0}:void 0,(n,r)=>{n?i(h(n)):a((0,P.assertIsDefined)(r))})})}function g(u,s){return new Promise((a,i)=>{u.openReadStream(s,(n,r)=>{n?i(h(n)):a((0,P.assertIsDefined)(r))})})}function b(u,s){return new Promise((a,i)=>{const n=new E.ZipFile;s.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const r=(0,_.createWriteStream)(u);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>a(u))})}e.zip=b;function l(u,s,a={},i){const n=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let r=d(u,!0);return a.overwrite&&(r=r.then(o=>D.Promises.rm(s).then(()=>o))),r.then(o=>c(o,s,{sourcePathRegex:n},i))}e.extract=l;function C(u,s){return d(u).then(a=>new Promise((i,n)=>{a.on("entry",r=>{r.fileName===s&&g(a,r).then(o=>i(o),o=>n(o))}),a.once("close",()=>n(new Error(k.localize(2,null,s))))}))}function p(u,s){return C(u,s).then(a=>new Promise((i,n)=>{const r=[];a.once("error",n),a.on("data",o=>r.push(o)),a.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=p}),define(ve[252],we([0,1,73,159]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function w(P){return(0,_.buffer)(P,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=w}),define(ve[253],we([0,1,17,13,11,2,8,4,3,22,57,5,23,19,73,160,26,34,33,182,41,16,14,32]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c,d,g,b,l,C,p,u,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let i=class extends P.Disposable{constructor(r,o,f,S,A){super();this.beforeRemovingExtension=r,this.fileService=o,this.logService=f,this.environmentService=S,this.productService=A,this._devSystemExtensionsPath=null,this.systemExtensionsPath=S.builtinExtensionsPath,this.extensionsPath=S.extensionsPath,this.uninstalledPath=k.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new t.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(r){const o=[];(r===null||r===0)&&o.push(this.scanSystemExtensions().then(null,f=>Promise.reject(new b.ExtensionManagementError(this.joinErrors(f).message,b.ExtensionManagementErrorCode.Internal)))),(r===null||r===1)&&o.push(this.scanUserExtensions(!0).then(null,f=>Promise.reject(new b.ExtensionManagementError(this.joinErrors(f).message,b.ExtensionManagementErrorCode.Internal))));try{const f=await Promise.all(o);return(0,_.flatten)(f)}catch(f){throw this.joinErrors(f)}}async scanUserExtensions(r){this.logService.trace("Started scanning user extensions");let[o,f]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return f=f.filter(S=>!o[new l.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).key()]),r&&(f=(0,l.groupByExtension)(f,A=>A.identifier).map(A=>A.sort((I,F)=>T.rcompare(I.manifest.version,F.manifest.version))[0])),this.logService.trace("Scanned user extensions:",f.length),f}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(r,o,f,S){const A=r.key(),I=k.join(this.extensionsPath,`.${(0,h.generateUuid)()}`),F=k.join(this.extensionsPath,A);try{await v.Promises.rm(F)}catch{try{await v.Promises.rm(F)}catch{}throw new b.ExtensionManagementError((0,d.localize)(0,null,F,r.id),b.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(r,o,I,S);let U=await this.scanExtension(R.URI.file(I),1);if(!U)throw new Error((0,d.localize)(1,null,I));await this.storeMetadata(U,{...f,installedTimestamp:Date.now()});try{await this.rename(r,I,F,Date.now()+2*60*1e3),this.logService.info("Renamed to",F)}catch(W){try{await v.Promises.rm(I)}catch{}if(W.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",r.id);else throw this.logService.info(`Rename failed because of ${(0,w.getErrorMessage)(W)}. Deleted from extracted location`,I),W}try{U=await this.scanExtension(R.URI.file(F),1)}catch{}if(U)return U;throw new Error((0,d.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(r,o){return this.setMetadata(r,o),await this.storeMetadata(r,{...o,installedTimestamp:r.installedTimestamp}),r}async storeMetadata(r,o){o.isMachineScoped=o.isMachineScoped||void 0,o.isBuiltin=o.isBuiltin||void 0,o.installedTimestamp=o.installedTimestamp||void 0;const f=k.join(r.location.fsPath,"package.json"),S=await v.Promises.readFile(f,"utf8"),{manifest:A}=await this.parseManifest(S);return A.__metadata=o,await v.Promises.writeFile(f,JSON.stringify(A,null,"	")),r}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...r){const o=r.map(f=>new l.ExtensionIdentifierWithVersion(f.identifier,f.manifest.version));await this.withUninstalledExtensions(f=>{o.forEach(S=>f[S.key()]=!0)})}async setInstalled(r){await this.withUninstalledExtensions(S=>delete S[r.key()]);const f=(await this.scanExtensions(1)).find(S=>new l.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).equals(r))||null;return f?(await this.storeMetadata(f,{installedTimestamp:Date.now()}),this.scanExtension(f.location,1)):null}async withUninstalledExtensions(r){return this.uninstalledFileLimiter.queue(async()=>{let o;try{o=await v.Promises.readFile(this.uninstalledPath,"utf8")}catch(S){if(S.code!=="ENOENT")throw S}let f={};if(o)try{f=JSON.parse(o)}catch{}return r&&(r(f),Object.keys(f).length?await v.Promises.writeFile(this.uninstalledPath,JSON.stringify(f)):await v.Promises.rm(this.uninstalledPath)),f})}async removeExtension(r,o){this.logService.trace(`Deleting ${o} extension from disk`,r.identifier.id,r.location.fsPath),await v.Promises.rm(r.location.fsPath),this.logService.info("Deleted from disk",r.identifier.id,r.location.fsPath)}async removeUninstalledExtension(r){await this.removeExtension(r,"uninstalled"),await this.withUninstalledExtensions(o=>delete o[new l.ExtensionIdentifierWithVersion(r.identifier,r.manifest.version).key()])}async extractAtLocation(r,o,f,S){this.logService.trace(`Started extracting the extension from ${o} to ${f}`);try{await v.Promises.rm(f)}catch(A){throw new b.ExtensionManagementError(this.joinErrors(A).message,b.ExtensionManagementErrorCode.Delete)}try{await(0,c.extract)(o,f,{sourcePath:"extension",overwrite:!0},S),this.logService.info(`Extracted extension to ${f}:`,r.id)}catch(A){try{await v.Promises.rm(f)}catch{}let I=b.ExtensionManagementErrorCode.Extract;throw A instanceof c.ExtractError&&(A.type==="CorruptZip"?I=b.ExtensionManagementErrorCode.CorruptZip:A.type==="Incomplete"&&(I=b.ExtensionManagementErrorCode.IncompleteZip)),new b.ExtensionManagementError(A.message,I)}}async rename(r,o,f,S){try{await v.Promises.rename(o,f)}catch(A){if(y.isWindows&&A&&A.code==="EPERM"&&Date.now()<S)return this.logService.info(`Failed renaming ${o} to ${f} with 'EPERM' error. Trying again...`,r.id),this.rename(r,o,f,S);throw new b.ExtensionManagementError(A.message||(0,d.localize)(3,null,o,f),A.code||b.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const r=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return r;const o=this.scanDevSystemExtensions(),[f,S]=await Promise.all([r,o]);return[...f,...S]}async scanExtensionsInDir(r,o){const f=new t.Limiter(10),S=await this.fileService.resolve(R.URI.file(r));return S.children?(await Promise.all(S.children.filter(I=>I.isDirectory).map(I=>f.queue(async()=>o===1&&(0,E.basename)(I.resource).indexOf(".")===0?null:this.scanExtension(I.resource,o))))).filter(I=>I&&I.identifier):[]}async scanExtension(r,o){try{const f=await this.fileService.resolve(r);if(f.children){const{manifest:S,metadata:A}=await this.readManifest(r.fsPath),I=f.children.find(({name:m})=>/^readme(\.txt|\.md|)$/i.test(m))?.resource,F=f.children.find(({name:m})=>/^changelog(\.txt|\.md|)$/i.test(m))?.resource,U={id:(0,l.getGalleryExtensionId)(S.publisher,S.name)},W={type:o,identifier:U,manifest:S,location:r,readmeUrl:I,changelogUrl:F,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:o===0};return this.setMetadata(W,A),W}}catch(f){o!==0&&this.logService.trace(f)}return null}async scanDefaultSystemExtensions(){const r=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",r.length),r}async scanDevSystemExtensions(){const r=this.getDevSystemExtensionsList();if(r.length){const o=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",o.length),o.filter(f=>r.some(S=>(0,l.areSameExtensions)(f.identifier,{id:S})))}else return[]}setMetadata(r,o){r.publisherDisplayName=o?.publisherDisplayName||null,r.publisherId=o?.publisherId||null,r.identifier.uuid=o?.id,r.isMachineScoped=!!o?.isMachineScoped,r.isPreReleaseVersion=!!o?.isPreReleaseVersion,r.preRelease=!!o?.preRelease,r.isBuiltin=r.type===0||!!o?.isBuiltin,r.installedTimestamp=o?.installedTimestamp}async removeUninstalledExtensions(){const r=await this.getUninstalledExtensions(),o=await this.scanAllUserExtensions(),f=new Set;for(const I of o)r[new l.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]||f.add(I.identifier.id.toLowerCase());const S=(0,l.groupByExtension)(o,I=>I.identifier);await t.Promises.settled(S.map(async I=>{const F=I.sort((U,W)=>T.rcompare(U.manifest.version,W.manifest.version))[0];f.has(F.identifier.id.toLowerCase())||await this.beforeRemovingExtension(F)}));const A=o.filter(I=>r[new l.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]);await t.Promises.settled(A.map(I=>this.removeUninstalledExtension(I)))}async removeOutdatedExtensions(){const r=await this.scanAllUserExtensions(),o=[],f=(0,l.groupByExtension)(r,S=>S.identifier);o.push(...(0,_.flatten)(f.map(S=>S.sort((A,I)=>T.rcompare(A.manifest.version,I.manifest.version)).slice(1)))),await t.Promises.settled(o.map(S=>this.removeExtension(S,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(r=>r.name)}joinErrors(r){const o=Array.isArray(r)?r:[r];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((f,S)=>new Error(`${f.message}${f.message?",":""}${S instanceof Error?S.message:S}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=k.normalize(k.join(D.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(r){const o=[v.Promises.readFile(k.join(r,"package.json"),"utf8").then(I=>this.parseManifest(I)),v.Promises.readFile(k.join(r,"package.nls.json"),"utf8").then(void 0,I=>I.code!=="ENOENT"?Promise.reject(I):"{}").then(I=>JSON.parse(I))],[{manifest:f,metadata:S},A]=await Promise.all(o);return{manifest:(0,C.localizeManifest)(f,A),metadata:S}}parseManifest(r){return new Promise((o,f)=>{try{const S=JSON.parse(r);S.publisher||(S.publisher=p.UNDEFINED_PUBLISHER);const A=S.__metadata||null;o({manifest:S,metadata:A})}catch{f(new Error((0,d.localize)(4,null)))}})}};i=Te([Ne(1,u.IFileService),Ne(2,s.ILogService),Ne(3,g.INativeEnvironmentService),Ne(4,a.IProductService)],i),e.ExtensionsScanner=i}),define(ve[114],we([0,1,36,11,8,4,3,24,22,57,5,23,19,73,158,66,26,213,34,33,204,195,252,205,253,225,65,16,6,14,32,29,48]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c,d,g,b,l,C,p,u,s,a,i,n,r,o,f,S,A,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let U=class extends b.AbstractExtensionManagementService{constructor($,G,ie,B,q,ee,oe,re,de){super($,G,ie,re);this.environmentService=B,this.downloadService=q,this.fileService=oe;const Z=this._register(ee.createInstance(u.ExtensionsLifecycle));this.extensionsScanner=this._register(ee.createInstance(i.ExtensionsScanner,j=>Z.postUninstall(j))),this.manifestCache=this._register(new a.ExtensionsManifestCache(B,this)),this.extensionsDownloader=this._register(ee.createInstance(p.ExtensionsDownloader));const H=this._register(new n.ExtensionsWatcher(this,oe,B,ie,de));this._register(H.onDidChangeExtensionsByAnotherSource(({added:j,removed:V})=>{j.length&&this._onDidInstallExtensions.fire(j.map(ne=>({identifier:ne.identifier,operation:1,local:ne}))),V.forEach(ne=>this._onDidUninstallExtension.fire({identifier:ne}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const $=await this.isAlpineLinux(),G=(0,l.getTargetPlatform)($?"alpine":D.platform,k.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",G),G})()),this._targetPlatformPromise}async isAlpineLinux(){if(!D.isLinux)return!1;let $;try{$=(await this.fileService.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await this.fileService.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(ie){this.logService.debug("Error while getting the os-release file.",(0,t.getErrorMessage)(ie))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip($){this.logService.trace("ExtensionManagementService#zip",$.identifier.id);const G=await this.collectFiles($),ie=await(0,v.zip)((0,y.joinPath)(this.environmentService.tmpDir,(0,R.generateUuid)()).fsPath,G);return T.URI.file(ie)}async unzip($){return this.logService.trace("ExtensionManagementService#unzip",$.toString()),(await this.install($)).identifier}async getManifest($){const G=await this.downloadVsix($),ie=P.resolve(G.fsPath);return(0,s.getManifest)(ie)}getInstalled($=null){return this.extensionsScanner.scanExtensions($)}async install($,G={}){this.logService.trace("ExtensionManagementService#install",$.toString());const ie=await this.downloadVsix($),B=await(0,s.getManifest)(P.resolve(ie.fsPath));if(B.engines&&B.engines.vscode&&!(0,r.isEngineValid)(B.engines.vscode,this.productService.version,this.productService.date))throw new Error(c.localize(0,null,(0,C.getGalleryExtensionId)(B.publisher,B.name),this.productService.version));return this.installExtension(B,ie,G)}async updateMetadata($,G){this.logService.trace("ExtensionManagementService#updateMetadata",$.identifier.id);const ie={...$.manifest.__metadata||{},...G};return G.isPreReleaseVersion&&(ie.preRelease=!0),$=await this.extensionsScanner.saveMetadataForLocalExtension($,ie),this.manifestCache.invalidate(),$}async updateExtensionScope($,G){return this.logService.trace("ExtensionManagementService#updateExtensionScope",$.identifier.id),$=await this.extensionsScanner.saveMetadataForLocalExtension($,{...$.manifest.__metadata||{},isMachineScoped:G}),this.manifestCache.invalidate(),$}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix($){if($.scheme===w.Schemas.file)return $;const G=(0,y.joinPath)(this.environmentService.tmpDir,(0,R.generateUuid)());return await this.downloadService.download($,G),G}createInstallExtensionTask($,G,ie){return T.URI.isUri(G)?new L($,G,ie,this.galleryService,this.extensionsScanner,this.logService):new m(G,ie,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask($,G){return new M($,G,this.extensionsScanner)}async collectFiles($){const G=async B=>{let q=await h.Promises.readdir(B);q=q.map(re=>P.join(B,re));const ee=await Promise.all(q.map(re=>h.Promises.stat(re)));let oe=Promise.resolve([]);return ee.forEach((re,de)=>{const Z=q[de];re.isFile()&&(oe=oe.then(H=>[...H,Z])),re.isDirectory()&&(oe=oe.then(H=>G(Z).then(j=>[...H,...j])))}),oe};return(await G($.location.fsPath)).map(B=>({path:`extension/${P.relative($.location.fsPath,B)}`,localPath:B}))}};U=Te([Ne(0,l.IExtensionGalleryService),Ne(1,I.ITelemetryService),Ne(2,S.ILogService),Ne(3,g.INativeEnvironmentService),Ne(4,d.IDownloadService),Ne(5,f.IInstantiationService),Ne(6,o.IFileService),Ne(7,A.IProductService),Ne(8,F.IUriIdentityService)],U),e.ExtensionManagementService=U;class W extends b.AbstractExtensionTask{constructor($,G,ie,B){super();this.identifier=$,this.source=G,this.extensionsScanner=ie,this.logService=B,this._operation=2}get operation(){return this._operation}async installExtension($,G){try{const ie=await this.unsetUninstalledAndGetLocal($.identifierWithVersion);if(ie)return $.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ie,{...ie.manifest.__metadata||{},...$.metadata}):ie}catch{throw D.isMacintosh?new l.ExtensionManagementError(c.localize(1,null),l.ExtensionManagementErrorCode.Internal):new l.ExtensionManagementError(c.localize(2,null),l.ExtensionManagementErrorCode.Internal)}return this.extract($,G)}async unsetUninstalledAndGetLocal($){if(!await this.isUninstalled($))return null;this.logService.trace("Removing the extension from uninstalled list:",$.id);const ie=await this.extensionsScanner.setInstalled($);return this.logService.info("Removed the extension from uninstalled list:",$.id),ie}async isUninstalled($){return!!(await this.extensionsScanner.getUninstalledExtensions())[$.key()]}async extract({zipPath:$,identifierWithVersion:G,metadata:ie},B){let q=await this.extensionsScanner.extractUserExtension(G,$,ie,B);return this.logService.info("Extracting completed.",G.id),q}}class m extends W{constructor($,G,ie,B,q){super($.identifier,$,B,q);this.gallery=$,this.options=G,this.extensionsDownloader=ie}async doRun($){const ie=(await this.extensionsScanner.scanExtensions(null)).find(q=>(0,C.areSameExtensions)(q.identifier,this.gallery.identifier));ie&&(this._operation=3);const B=await this.downloadInstallableExtension(this.gallery,this._operation);B.metadata.isMachineScoped=this.options.isMachineScoped||ie?.isMachineScoped,B.metadata.isBuiltin=this.options.isBuiltin||ie?.isBuiltin,B.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,B.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:ie?.preRelease||this.options.installPreReleaseVersion;try{const q=await this.installExtension(B,$);return ie&&E.neq(ie.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(ie),q}catch(q){throw await this.deleteDownloadedVSIX(B.zipPath),q}}async deleteDownloadedVSIX($){try{await this.extensionsDownloader.delete(T.URI.file($))}catch(G){this.logService.warn("Error while deleting the downloaded vsix",$.toString(),(0,t.getErrorMessage)(G))}}async downloadInstallableExtension($,G){const ie={id:$.identifier.uuid,publisherId:$.publisherId,publisherDisplayName:$.publisherDisplayName};let B;try{this.logService.trace("Started downloading extension:",$.identifier.id),B=(await this.extensionsDownloader.downloadExtension($,G)).fsPath,this.logService.info("Downloaded extension:",$.identifier.id,B)}catch(q){throw new l.ExtensionManagementError((0,b.joinErrors)(q).message,l.ExtensionManagementErrorCode.Download)}try{const q=await(0,s.getManifest)(B);return{zipPath:B,identifierWithVersion:new C.ExtensionIdentifierWithVersion($.identifier,q.version),metadata:ie}}catch(q){throw await this.deleteDownloadedVSIX(B),new l.ExtensionManagementError((0,b.joinErrors)(q).message,l.ExtensionManagementErrorCode.Invalid)}}}class L extends W{constructor($,G,ie,B,q,ee){super({id:(0,C.getGalleryExtensionId)($.publisher,$.name)},G,q,ee);this.manifest=$,this.location=G,this.options=ie,this.galleryService=B}async doRun($){const G=new C.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),B=(await this.extensionsScanner.scanExtensions(1)).find(ee=>(0,C.areSameExtensions)(this.identifier,ee.identifier)),q=await this.getMetadata(this.identifier.id,this.manifest.version,$);if(q.isMachineScoped=this.options.isMachineScoped||B?.isMachineScoped,q.isBuiltin=this.options.isBuiltin||B?.isBuiltin,B)if(this._operation=3,G.equals(new C.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version)))try{await this.extensionsScanner.removeExtension(B,"existing")}catch{throw new Error(c.localize(3,null,this.manifest.displayName||this.manifest.name))}else E.gt(B.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(B);else{const ee=await this.unsetUninstalledAndGetLocal(G);if(ee)try{await this.extensionsScanner.removeExtension(ee,"existing")}catch{throw new Error(c.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:P.resolve(this.location.fsPath),identifierWithVersion:G,metadata:q},$)}async getMetadata($,G,ie){try{let[B]=await this.galleryService.getExtensions([{id:$,version:G}],ie);if(B||([B]=await this.galleryService.getExtensions([{id:$}],ie)),B)return{id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId,isPreReleaseVersion:B.properties.isPreReleaseVersion,preRelease:B.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class M extends b.AbstractExtensionTask{constructor($,G,ie){super();this.extension=$,this.options=G,this.extensionsScanner=ie}async doRun($){const G=[],ie=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const B=new C.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);G.push(...ie.filter(q=>B.equals(new C.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version))))}else G.push(...ie.filter(B=>(0,C.areSameExtensions)(B.identifier,this.extension.identifier)));if(!G.length)throw new Error(c.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...G),this.options.remove)for(const B of G)try{$.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(B)}catch(q){throw new Error(c.localize(6,null,(0,_.toErrorMessage)(q)))}}}}),define(ve[58],we([0,1,70,82,25,15,11,7,2,4,3,23,40,85,254]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(I,F=""){this.debugLabel=F,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=U=>{if(this.traceSocketEvent("error",{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,D.onUnexpectedError)(U)}},this.socket.on("error",this._errorListener)}traceSocketEvent(I,F){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,F)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(I){const F=U=>{this.traceSocketEvent("read",U),I(P.VSBuffer.wrap(U))};return this.socket.on("data",F),{dispose:()=>this.socket.off("data",F)}}onClose(I){const F=U=>{this.traceSocketEvent("close",{hadError:U}),I({type:0,hadError:U,error:void 0})};return this.socket.on("close",F),{dispose:()=>this.socket.off("close",F)}}onEnd(I){const F=()=>{this.traceSocketEvent("nodeEndReceived"),I()};return this.socket.on("end",F),{dispose:()=>this.socket.off("end",F)}}write(I){if(!this.socket.destroyed)try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,F=>{if(F){if(F.code==="EPIPE")return;(0,D.onUnexpectedError)(F)}})}catch(F){if(F.code==="EPIPE")return;(0,D.onUnexpectedError)(F)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,F)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const U=()=>{this.socket.off("close",U),this.socket.off("end",U),this.socket.off("error",U),this.socket.off("timeout",U),this.socket.off("drain",U),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",U),this.socket.on("end",U),this.socket.on("error",U),this.socket.on("timeout",U),this.socket.on("drain",U)})}}e.NodeSocket=d;var g;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var b;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(b||(b={}));class l extends y.Disposable{constructor(I,F,U,W){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:F,inflateBytesLength:U?.byteLength||0,recordInflateBytes:W}),this._flowManager=this._register(new C(this,F,U,W,this._onData,(m,L)=>this._write(m,L))),this._register(this._flowManager.onError(m=>{console.error(m),(0,D.onUnexpectedError)(m),this._onClose.fire({type:0,hadError:!0,error:m})})),this._incomingData=new v.ChunkStream,this._register(this.socket.onData(m=>this._acceptChunk(m))),this._register(this.socket.onClose(m=>this._onClose.fire(m)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(I,F){this.socket.traceSocketEvent(I,F)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._flowManager.writeMessage(I)}_write(I,F){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let U=2;I.byteLength<126?U+=0:I.byteLength<2**16?U+=2:U+=8;const W=P.VSBuffer.alloc(U);if(F?W.writeUInt8(194,0):W.writeUInt8(130,0),I.byteLength<126)W.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){W.writeUInt8(126,1);let m=1;W.writeUInt8(I.byteLength>>>8&255,++m),W.writeUInt8(I.byteLength>>>0&255,++m)}else{W.writeUInt8(127,1);let m=1;W.writeUInt8(0,++m),W.writeUInt8(0,++m),W.writeUInt8(0,++m),W.writeUInt8(0,++m),W.writeUInt8(I.byteLength>>>24&255,++m),W.writeUInt8(I.byteLength>>>16&255,++m),W.writeUInt8(I.byteLength>>>8&255,++m),W.writeUInt8(I.byteLength>>>0&255,++m)}this.socket.write(P.VSBuffer.concat([W,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const F=this._incomingData.peek(this._state.readLen),U=F.readUInt8(0),W=(U&128)>>>7,m=(U&64)>>>6,L=F.readUInt8(1),M=(L&128)>>>7,Y=L&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(Y===126?2:0)+(Y===127?8:0),this._state.fin=W,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(m)),this._state.firstFrameOfMessage=Boolean(W),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const F=this._incomingData.read(this._state.readLen),U=F.readUInt8(1),W=(U&128)>>>7;let m=U&127,L=1;m===126?m=F.readUInt8(++L)*2**8+F.readUInt8(++L):m===127&&(m=F.readUInt8(++L)*0+F.readUInt8(++L)*0+F.readUInt8(++L)*0+F.readUInt8(++L)*0+F.readUInt8(++L)*2**24+F.readUInt8(++L)*2**16+F.readUInt8(++L)*2**8+F.readUInt8(++L));let M=0;W&&(M=F.readUInt8(++L)*2**24+F.readUInt8(++L)*2**16+F.readUInt8(++L)*2**8+F.readUInt8(++L)),this._state.state=3,this._state.readLen=m,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const F=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",F),s(F,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",F),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(F,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=l;class C extends y.Disposable{constructor(I,F,U,W,m,L){super();this._tracer=I,this._onData=m,this._writeFn=L,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,F?(this._zlibInflateStream=this._register(new p(this._tracer,W,U,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:P.VSBuffer.alloc(0)}writeMessage(I){this._writeQueue.push(I),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const I=this._writeQueue.shift();if(this._zlibDeflateStream){const F=await this._deflateMessage(this._zlibDeflateStream,I);this._writeFn(F,!0)}else this._writeFn(I,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(I,F){return new Promise((U,W)=>{I.write(F),I.flush(m=>U(m))})}acceptFrame(I,F,U){this._readQueue.push({data:I,isCompressed:F,isLastFrameOfMessage:U}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const I=this._readQueue.shift();if(this._zlibInflateStream&&I.isCompressed){const F=await this._inflateFrame(this._zlibInflateStream,I.data,I.isLastFrameOfMessage);this._onData.fire(F)}else this._onData.fire(I.data)}this._isProcessingReadQueue=!1}}_inflateFrame(I,F,U){return new Promise((W,m)=>{I.write(F),U&&I.write(P.VSBuffer.fromByteArray([0,0,255,255])),I.flush(L=>W(L))})}}class p extends y.Disposable{constructor(I,F,U,W){super();this._tracer=I,this._recordInflateBytes=F,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=c.createInflateRaw(W),this._zlibInflate.on("error",m=>{this._tracer.traceSocketEvent("zlibInflateError",{message:m?.message,code:m?.code}),this._onError.fire(m)}),this._zlibInflate.on("data",m=>{this._tracer.traceSocketEvent("zlibInflateData",m),this._pendingInflateData.push(P.VSBuffer.wrap(m))}),U&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",U.buffer),this._zlibInflate.write(U.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?P.VSBuffer.concat(this._recordedInflateBytes):P.VSBuffer.alloc(0)}write(I){this._recordInflateBytes&&this._recordedInflateBytes.push(I.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",I),this._zlibInflate.write(I.buffer)}flush(I){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const F=P.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,I(F)})}}class u extends y.Disposable{constructor(I,F){super();this._tracer=I,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=c.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",U=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibDeflate.on("data",U=>{this._tracer.traceSocketEvent("zlibDeflateData",U),this._pendingDeflateData.push(P.VSBuffer.wrap(U))})}write(I){this._tracer.traceSocketEvent("zlibDeflateWrite",I.buffer),this._zlibDeflate.write(I.buffer)}flush(I){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let F=P.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,F=F.slice(0,F.byteLength-4),I(F)})}}function s(A,I){if(I===0)return;let F=A.byteLength>>>2;for(let Y=0;Y<F;Y++){const $=A.readUInt32BE(Y*4);A.writeUInt32BE($^I,Y*4)}let U=F*4,W=A.byteLength-U;const m=I>>>24&255,L=I>>>16&255,M=I>>>8&255;W>=1&&A.writeUInt8(A.readUInt8(U)^m,U),W>=2&&A.writeUInt8(A.readUInt8(U+1)^L,U+1),W>=3&&A.writeUInt8(A.readUInt8(U+2)^M,U+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function i(){const A=(0,R.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;let I;return e.XDG_RUNTIME_DIR?I=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${A}.sock`):I=(0,E.join)((0,w.tmpdir)(),`vscode-ipc-${A}.sock`),r(I),I}e.createRandomIPCHandle=i;function n(A,I,F){const U=(0,_.createHash)("md5").update(A).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${F}-${I}-sock`;let W;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?W=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-${U.substr(0,8)}-${F}-${I}.sock`):W=(0,E.join)(A,`${F}-${I}.sock`),r(W),W}e.createStaticIPCHandle=n;function r(A){const I=a[T.platform];typeof I=="number"&&A.length>=I&&console.warn(`WARNING: IPC handle "${A}" is longer than ${I} chars, try a shorter --user-data-dir`)}class o extends h.IPCServer{constructor(I){super(o.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const F=k.Event.fromNodeEventEmitter(I,"connection");return k.Event.map(F,U=>({protocol:new v.Protocol(new d(U,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(U,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function f(A){return new Promise((I,F)=>{const U=(0,t.createServer)();U.on("error",F),U.listen(A,()=>{U.removeListener("error",F),I(new o(U))})})}e.serve=f;function S(A,I){return new Promise((F,U)=>{const W=(0,t.createConnection)(A,()=>{W.removeListener("error",U),F(v.Client.fromSocket(new d(W,`ipc-client${I}`),I))});W.once("error",U)})}e.connect=S}),define(ve[115],we([0,1,71,13,15,11,2,12,28,26,67,14,208,254]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let c=class extends D.Disposable{constructor(g,b,l){super();this.environmentService=b,this.logService=l,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,b){this.logService.trace("RequestService#request",g.url);const{proxyUrl:l,strictSSL:C}=this;let p;try{p=await(0,T.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(a){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",a))}const u={...process.env,...p},s=g.agent?g.agent:await(0,h.getProxyAgent)(g.url||"",u,{proxyUrl:l,strictSSL:C});return g.agent=s,g.strictSSL=C,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,b)}async getNodeRequest(g){return((0,_.parse)(g.url).protocol==="https:"?await new Promise((C,p)=>{J(["https"],C,p)}):await new Promise((C,p)=>{J(["http"],C,p)})).request}_request(g,b){return t.Promises.withAsyncBody(async(l,C)=>{let p;const u=(0,_.parse)(g.url),s=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),a={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,k.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(a.auth=g.user+":"+g.password),p=s(a,i=>{const n=(0,k.isNumber)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...g,url:i.headers.location,followRedirects:n-1},b).then(l,C);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,v.createGunzip)())),l({res:i,stream:(0,w.streamToBufferReadableStream)(r)})}}),p.on("error",C),g.timeout&&p.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&p.write(g.data),p.end(),b.onCancellationRequested(()=>{p.abort(),C((0,P.canceled)())})})}async resolveProxy(g){}};c=Te([Ne(0,y.IConfigurationService),Ne(1,E.INativeEnvironmentService),Ne(2,R.ILogService)],c),e.RequestService=c}),define(ve[116],we([0,1,39,72,49,8,4,15,7,58,67,3,248,64]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function c(C={},p,u,s,a){const i=await(0,t.getNLSConfiguration)(p,s.userDataPath);let n;try{n=await(0,T.getResolvedShellEnv)(a,s.args,process.env)}catch(I){a.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",I),n={}}const r=s.isBuilt?(0,D.join)(s.appRoot,"bin"):(0,D.join)(s.appRoot,"resources","server","bin-dev"),o=(0,D.join)(r,"remote-cli"),f=process.env;let S=C.PATH||(n?n.PATH:void 0)||f.PATH;S?S=o+D.delimiter+S:S=o;const A={...f,...n,VSCODE_LOG_NATIVE:String(u),VSCODE_AMD_ENTRYPOINT:"vs/workbench/services/extensions/node/extensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(i,void 0,0),...C};return s.args["without-browser-env-var"]||(A.BROWSER=(0,D.join)(r,"helpers",R.isWindows?"browser.cmd":"browser.sh")),b(A,"PATH",S),l(A),A}e.buildUserEnvironment=c;class d{constructor(p,u,s,a,i,n){this.socket=p,this.socketDrain=u,this.initialDataChunk=s,this.skipWebSocketFrames=a,this.permessageDeflate=i,this.inflateBytes=n}toIExtHostSocketMessage(){return{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:this.skipWebSocketFrames,permessageDeflate:this.permessageDeflate,inflateBytes:this.inflateBytes.buffer.toString("base64")}}}class g{constructor(p,u,s,a,i,n){this._environmentService=p,this._logService=u,this._reconnectionToken=s,this._onClose=new y.Emitter,this.onClose=this._onClose.event,this._disposed=!1,this._remoteAddress=a,this._extensionHostProcess=null,this._connectionData=g._toConnectionData(i,n),this._log("New connection established.")}get _logPrefix(){return`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] `}_log(p){this._logService.info(`${this._logPrefix}${p}`)}_logError(p){this._logService.error(`${this._logPrefix}${p}`)}static _toConnectionData(p,u){return p instanceof E.NodeSocket?new d(p.socket,p.drain(),u,!0,!1,k.VSBuffer.alloc(0)):new d(p.socket.socket,p.drain(),u,!1,p.permessageDeflate,p.recordedInflateBytes)}async _sendSocketToExtensionHost(p,u){await u.socketDrain;const s=u.toIExtHostSocketMessage();p.send(s,u.socket)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const p={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(p)}acceptReconnection(p,u,s){this._remoteAddress=p,this._log("The client has reconnected.");const a=g._toConnectionData(u,s);if(!this._extensionHostProcess){this._connectionData=a;return}this._sendSocketToExtensionHost(this._extensionHostProcess,a)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(p){try{let u=[];p.port&&!process.pkg&&(u=[`--inspect${p.break?"-brk":""}=0.0.0.0:${p.port}`]);const s=await c(p.env,p.language,!!p.debugId,this._environmentService,this._logService);(0,v.removeDangerousEnvVariables)(s);const a={env:s,execArgv:u,silent:!0},i=["--type=extensionHost",`--uriTransformerPath=${w.uriTransformerPath}`],n=this._environmentService.args["use-host-proxy"];i.push(`--useHostProxy=${n?"true":"false"}`),this._extensionHostProcess=_.fork(P.FileAccess.asFileUri("bootstrap-fork",J).fsPath,i,a);const r=this._extensionHostProcess.pid;this._log(`<${r}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const o=y.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),f=y.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");o(A=>this._log(`<${r}> ${A}`)),f(A=>this._log(`<${r}><stderr> ${A}`)),this._extensionHostProcess.on("message",A=>{A&&A.type==="__$console"&&(0,h.logRemoteEntry)(this._logService,A,`${this._logPrefix}<${r}>`)}),this._extensionHostProcess.on("error",A=>{this._logError(`<${r}> Extension Host Process had an error`),this._logService.error(A),this._cleanResources()}),this._extensionHostProcess.on("exit",(A,I)=>{this._log(`<${r}> Extension Host Process exited with code: ${A}, signal: ${I}.`),this._cleanResources()});const S=A=>{A.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",S),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",S)}catch(u){console.error("ExtensionHostConnection errored"),u&&console.error(u)}}}e.ExtensionHostConnection=g;function b(C,p,u){const s=Object.keys(C).filter(i=>i.toLowerCase()===p.toLowerCase()),a=s.length>0?s[0]:p;C[a]=u}function l(C){for(let p of Object.keys(C))C[p]===null&&delete C[p]}}),define(ve[255],we([0,1,68,14,54,96,28,47,115,42,29,34,101,114,92,45,2,93,56,8,16,32,95,113,50,99,69,100,11,5,4,24,206,66,48,104,53,3]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c,d,g,b,l,C,p,u,s,a,i,n,r,o,f,S,A,I,F,U,W,m,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class Y extends g.Disposable{constructor(B,q){super();this.args=B,this.remoteDataFolder=q,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async q=>{const ee=q.get(t.ILogService),oe=q.get(R.IExtensionManagementCLIService);try{await this.doRun(oe)}catch(re){throw ee.error(re),console.error((0,f.getErrorMessage)(re)),re}})}async initServices(){const B=new _.ServiceCollection,q={_serviceBrand:void 0,...d.default};B.set(u.IProductService,q);const ee=new i.ServerEnvironmentService(this.args,q);B.set(i.IServerEnvironmentService,ee);const oe=new t.LogService(new s.SpdLogLogger(a.RemoteExtensionLogFileName,(0,A.join)(ee.logsPath,`${a.RemoteExtensionLogFileName}.log`),!0,!1,(0,t.getLogLevel)(ee)));B.set(t.ILogService,oe),oe.trace(`Remote configuration data at ${this.remoteDataFolder}`),oe.trace("process arguments:",this.args);const re=this._register(new b.FileService(oe));B.set(p.IFileService,re),re.registerProvider(C.Schemas.file,this._register(new l.DiskFileSystemProvider(oe)));const de=this._register(new P.ConfigurationService(ee.settingsResource,re));return await de.initialize(),B.set(D.IConfigurationService,de),B.set(W.IUriIdentityService,new m.UriIdentityService(re)),B.set(k.IRequestService,new w.SyncDescriptor(y.RequestService)),B.set(U.IDownloadService,new w.SyncDescriptor(F.DownloadService)),B.set(T.ITelemetryService,E.NullTelemetryService),B.set(R.IExtensionGalleryService,new w.SyncDescriptor(h.ExtensionGalleryServiceWithNoStorageService)),B.set(R.IExtensionManagementService,new w.SyncDescriptor(v.ExtensionManagementService)),B.set(R.IExtensionManagementCLIService,new w.SyncDescriptor(n.ExtensionManagementCLIService)),B.set(r.ILocalizationsService,new w.SyncDescriptor(o.LocalizationsService)),new c.InstantiationService(B)}async doRun(B){if(this.args["list-extensions"])return B.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"]){const q={isMachineScoped:!!this.args["do-not-sync"],installPreReleaseVersion:!!this.args["pre-release"]};return B.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],q,!!this.args.force)}else{if(this.args["uninstall-extension"])return B.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return B.locateExtension(this.args["locate-extension"])}}asExtensionIdOrVSIX(B){return B.map(q=>/\.vsix$/i.test(q)?S.URI.file((0,A.isAbsolute)(q)?q:(0,A.join)((0,I.cwd)(),q)):q)}}function $(ie){setTimeout(()=>process.exit(ie),0)}async function G(ie,B,q){if(ie.help){const oe=d.default.serverApplicationName+(M.isWindows?".cmd":"");console.log((0,L.buildHelpMessage)(d.default.nameLong,oe,d.default.version,q,{noInputFiles:!0,noPipe:!0}));return}if(ie.version){console.log((0,L.buildVersionMessage)(d.default.version,d.default.commit));return}const ee=new Y(ie,B);try{await ee.run(),$(0)}catch{$(1)}finally{ee.dispose()}}e.run=G}),define(ve[256],we([0,1,58,267,27,247,5,226,14]),function(J,e,_,t,w,P,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class E{constructor(h,v,c){this._commands=h,this.logService=v,this._ipcHandlePath=c,this._server=t.createServer((d,g)=>this.onRequest(d,g)),this.setup().catch(d=>(v.error(d),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",h=>this.logService.error(h))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(h,v){const c=[];h.setEncoding("utf8"),h.on("data",d=>c.push(d)),h.on("end",()=>{const d=JSON.parse(c.join(""));switch(d.type){case"open":this.open(d,v);break;case"openExternal":this.openExternal(d,v);break;case"status":this.getStatus(d,v);break;case"extensionManagement":this.manageExtensions(d,v).catch(this.logService.error);break;default:v.writeHead(404),v.write(`Unknown message type: ${d.type}`,g=>{g&&this.logService.error(g)}),v.end();break}})}open(h,v){const{fileURIs:c,folderURIs:d,forceNewWindow:g,diffMode:b,addMode:l,forceReuseWindow:C,gotoLineMode:p,waitMarkerFilePath:u,remoteAuthority:s}=h,a=[];if(Array.isArray(d))for(const o of d)try{a.push({folderUri:D.URI.parse(o)})}catch{}if(Array.isArray(c))for(const o of c)try{(0,k.hasWorkspaceFileExtension)(o)?a.push({workspaceUri:D.URI.parse(o)}):a.push({fileUri:D.URI.parse(o)})}catch{}const i=u?D.URI.file(u):void 0,r={forceNewWindow:g,diffMode:b,addMode:l,gotoLineMode:p,forceReuseWindow:C,preferNewWindow:!C&&!i&&!l,waitMarkerFileURI:i,remoteAuthority:s};this._commands.executeCommand("_remoteCLI.windowOpen",a,r),v.writeHead(200),v.end()}async openExternal(h,v){for(const c of h.uris){const d=D.URI.parse(c),g=d.scheme==="file"?d:c;await this._commands.executeCommand("_remoteCLI.openExternal",g)}v.writeHead(200),v.end()}async manageExtensions(h,v){try{const c=b=>b?.map(l=>/\.vsix$/i.test(l)?D.URI.parse(l):l),d={list:h.list,install:c(h.install),uninstall:c(h.uninstall),force:h.force},g=await this._commands.executeCommand("_remoteCLI.manageExtensions",d);v.writeHead(200),v.write(g)}catch(c){v.writeHead(500),v.write(String(c),d=>{d&&this.logService.error(d)})}v.end()}async getStatus(h,v){try{const c=await this._commands.executeCommand("_remoteCLI.getSystemStatus");v.writeHead(200),v.write(c),v.end()}catch(c){v.writeHead(500),v.write(String(c),d=>{d&&this.logService.error(d)}),v.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&w.existsSync(this._ipcHandlePath)&&w.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=E;let T=class extends E{constructor(h,v){super(h,v,(0,_.createRandomIPCHandle)())}};T=Te([Ne(0,P.IExtHostCommands),Ne(1,y.ILogService)],T),e.CLIServer=T}),define(ve[257],we([0,1,25,7,20,2,4,3,5,58,49,256,236,110,237,241,116]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class b extends d.AbstractVariableResolverService{constructor(p,u,s,a){super({getFolderUri:i=>{const n=u.filter(r=>r.name===i);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>u.length,getConfigurationValue:(i,n)=>a[`config:${n}`],getExecPath:()=>p.VSCODE_EXEC_PATH,getAppRoot:()=>p.VSCODE_CWD,getFilePath:()=>{if(s)return D.normalize(s.fsPath)},getSelectedText:()=>a.selectedText,getLineNumber:()=>a.lineNumber},void 0,Promise.resolve(p))}}class l extends P.Disposable{constructor(p,u,s,a){super();this._environmentService=p,this._logService=u,this._ptyService=s,this._productService=a,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new t.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(p,u,s){switch(u){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,s);case"$createProcess":{const a=(0,T.createRemoteURITransformer)(p.remoteAuthority);return this._createProcess(a,s)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,s);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,s);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,s);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,s);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,s);case"$start":return this._ptyService.start.apply(this._ptyService,s);case"$input":return this._ptyService.input.apply(this._ptyService,s);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,s);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,s);case"$resize":return this._ptyService.resize.apply(this._ptyService,s);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,s);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,s);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,s);case"$sendCommandResult":return this._sendCommandResult(s[0],s[1],s[2]);case"$installAutoReply":return this._ptyService.installAutoReply.apply(this._ptyService,s);case"$uninstallAllAutoReplies":return this._ptyService.uninstallAllAutoReplies.apply(this._ptyService,s);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,s);case"$getProfiles":return this._getProfiles.apply(this,s);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(s[0]);case"$getTerminalLayoutInfo":return this._ptyService.getTerminalLayoutInfo(s);case"$setTerminalLayoutInfo":return this._ptyService.setTerminalLayoutInfo(s);case"$serializeTerminalState":return this._ptyService.serializeTerminalState.apply(this._ptyService,s);case"$reviveTerminalProcesses":return this._ptyService.reviveTerminalProcesses.apply(this._ptyService,s);case"$setUnicodeVersion":return this._ptyService.setUnicodeVersion.apply(this._ptyService,s);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,s);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,s);case"$updateProperty":return this._ptyService.updateProperty.apply(this._ptyService,s);case"$refreshProperty":return this._ptyService.refreshProperty.apply(this._ptyService,s);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(s[0],s[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(s[0],s[1])}throw new Error(`IPC Command ${u} not found`)}listen(p,u,s){switch(u){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||t.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||t.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||t.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||t.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||t.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||t.Event.None;case"$onDidChangeProperty":return this._ptyService.onDidChangeProperty;default:break}throw new Error("Not supported")}async _createProcess(p,u){const s={name:u.shellLaunchConfig.name,executable:u.shellLaunchConfig.executable,args:u.shellLaunchConfig.args,cwd:typeof u.shellLaunchConfig.cwd=="string"||typeof u.shellLaunchConfig.cwd=="undefined"?u.shellLaunchConfig.cwd:y.URI.revive(p.transformIncoming(u.shellLaunchConfig.cwd)),env:u.shellLaunchConfig.env,useShellEnvironment:u.shellLaunchConfig.useShellEnvironment};let a;u.shellLaunchConfig.useShellEnvironment?(this._logService.trace("*"),a=await(0,g.buildUserEnvironment)(u.resolverEnv,k.language,!1,this._environmentService,this._logService)):a=this._getEnvironment(),this._logService.trace("baseEnv",a);const i=Y=>({uri:y.URI.revive(p.transformIncoming(Y.uri)),name:Y.name,index:Y.index,toResource:()=>{throw new Error("Not implemented")}}),n=u.workspaceFolders.map(i),r=u.activeWorkspaceFolder?i(u.activeWorkspaceFolder):void 0,o=u.activeFileResource?y.URI.revive(p.transformIncoming(u.activeFileResource)):void 0,f=new b(a,n,o,u.resolvedVariables),S=c.createVariableResolver(r,process.env,f),A=c.getCwd(s,_.homedir(),S,r?.uri,u.configuration["terminal.integrated.cwd"],this._logService);s.cwd=A;const I=k.isWindows?"terminal.integrated.env.windows":k.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",F=u.configuration[I],U=c.createTerminalEnvironment(s,F,S,this._productService.version,u.configuration["terminal.integrated.detectLocale"],a);if(!s.strictEnv){const Y=[];for(const[ie,B]of u.envVariableCollections)Y.push([ie,{map:(0,v.deserializeEnvironmentVariableCollection)(B)}]);const $=new Map(Y);new h.MergedEnvironmentVariableCollection($).applyToProcessEnvironment(U)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:s,initialCwd:A,cols:u.cols,rows:u.rows,env:U});const W=(0,E.createRandomIPCHandle)();U.VSCODE_IPC_HOOK_CLI=W;const m={executeCommand:(Y,...$)=>this._executeCommand(Y,$,p)},L=new R.CLIServerBase(m,this._logService,W),M=await this._ptyService.createProcess(s,A,u.cols,u.rows,u.unicodeVersion,U,a,!1,u.shouldPersistTerminal,u.workspaceId,u.workspaceName);return this._ptyService.onProcessExit(Y=>Y.id===M&&L.dispose()),{persistentTerminalId:M,resolvedShellLaunchConfig:s}}_executeCommand(p,u,s){let a,i;const n=new Promise((f,S)=>{a=f,i=S}),r=++this._lastReqId;this._pendingCommands.set(r,{resolve:a,reject:i,uriTransformer:s});const o=(0,w.cloneAndChange)(u,f=>{if(f&&f.$mid===1)return s.transformOutgoing(f);if(f&&f instanceof y.URI)return s.transformOutgoingURI(f)});return this._onExecuteCommand.fire({reqId:r,commandId:p,commandArgs:o}),n}_sendCommandResult(p,u,s){const a=this._pendingCommands.get(p);if(!a)return;this._pendingCommands.delete(p);const i=(0,w.cloneAndChange)(s,n=>{if(n&&n.$mid===1)return a.uriTransformer.transformIncoming(n)});u?a.reject(i):a.resolve(i)}_getDefaultSystemShell(p){return this._ptyService.getDefaultSystemShell(p)}async _getProfiles(p,u,s,a){return this._ptyService.getProfiles?.(p,u,s,a)||[]}_getEnvironment(){return{...process.env}}_getWslPath(p){return this._ptyService.getWslPath(p)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=l}),define(ve[258],we([0,1,25,7,2,8,4,81,19,40,28,96,90,200,176,66,177,187,179,26,101,34,99,203,114,16,93,56,54,92,68,69,100,14,94,95,45,32,47,207,115,210,29,42,216,217,102,224,48,104,250,230,228,229,257,49,50,244,113,251]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c,d,g,b,l,C,p,u,s,a,i,n,r,o,f,S,A,I,F,U,W,m,L,M,Y,$,G,ie,B,q,ee,oe,re,de,Z,H,j,V,ne,me,De,ae,fe,pe,Q,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const x="monacoworkbench",X=Object.create(null);function ue(ge){return X[ge]||(X[ge]=(0,ae.createRemoteURITransformer)(ge)),X[ge]}async function ye(ge,he,Re,Me){const qe=new A.ServiceCollection,Be=new Pe,je={_serviceBrand:void 0,...L.default};qe.set(M.IProductService,je);const He=new fe.ServerEnvironmentService(he,je);qe.set(C.IEnvironmentService,He),qe.set(C.INativeEnvironmentService,He);const se=new U.LogService(new m.SpdLogLogger(Q.RemoteExtensionLogFileName,D.join(He.logsPath,`${Q.RemoteExtensionLogFileName}.log`),!0,!1,(0,U.getLogLevel)(He))),Se=new U.MultiplexLogService([new Ae((0,U.getLogLevel)(He)),se]);qe.set(U.ILogService,Se),setTimeout(()=>le(He.logsPath).then(null,et=>Se.error(et)),1e4),Se.trace(`Remote configuration data at ${Re}`),Se.trace("process arguments:",He.args);const ke=je.serverGreeting.join(`
`);ke&&se.info(`

${ke}

`),Be.registerChannel(c.ExtensionHostDebugBroadcastChannel.ChannelName,new c.ExtensionHostDebugBroadcastChannel);const Le=new E.StaticRouter(et=>et.clientId==="renderer");Be.registerChannel("logger",new W.LogLevelChannel(Se));const Oe=Me.add(new r.FileService(Se));qe.set(n.IFileService,Oe),Oe.registerProvider(P.Schemas.file,Me.add(new o.DiskFileSystemProvider(Se)));const Ye=new R.ConfigurationService(He.machineSettingsResource,Oe);qe.set(T.IConfigurationService,Ye),qe.set(Z.IUriIdentityService,new H.UriIdentityService(Oe)),qe.set(Y.IRequestService,new f.SyncDescriptor(G.RequestService));let $e=q.NullAppender;const Ve=await(0,k.getMachineId)();if((0,q.supportsTelemetry)(je,He)){je.aiConfig&&je.aiConfig.asimovKey&&($e=new ee.AppInsightsAppender(x,null,je.aiConfig.asimovKey),Me.add((0,w.toDisposable)(()=>$e.flush())));const et={appenders:[$e],commonProperties:(0,ie.resolveCommonProperties)(Oe,(0,_.release)(),(0,_.hostname)(),process.arch,je.commit,je.version+"-remote",Ve,je.msftInternalDomains,He.installSourcePath,"remoteAgent"),piiPaths:[He.appRoot]},nt=He.args["telemetry-level"];let ot;nt==="all"?ot=3:nt==="error"?ot=2:nt==="crash"?ot=1:nt!==void 0&&(ot=0),qe.set(me.IRemoteTelemetryService,new f.SyncDescriptor(me.RemoteTelemetryService,[et,ot]))}else qe.set(me.IRemoteTelemetryService,me.RemoteNullTelemetryService);qe.set(u.IExtensionGalleryService,new f.SyncDescriptor(p.ExtensionGalleryServiceWithNoStorageService));const Xe=Be.getChannel("download",Le);qe.set(d.IDownloadService,new g.DownloadServiceChannelClient(Xe,()=>ue("renderer"))),qe.set(u.IExtensionManagementService,new f.SyncDescriptor(i.ExtensionManagementService));const Ge=new S.InstantiationService(qe);qe.set(I.ILocalizationsService,Ge.createInstance(F.LocalizationsService));const Ze=Ge.createInstance(s.ExtensionManagementCLIService);qe.set(u.IExtensionManagementCLIService,Ze);const rt=Ge.createInstance(de.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:Ye.getValue("terminal.integrated.persistentSessionScrollback")??100});return qe.set(re.IPtyService,rt),qe.set(b.IEncryptionMainService,new f.SyncDescriptor(l.EncryptionMainService,[Ve])),qe.set(h.ICredentialsMainService,new f.SyncDescriptor(v.CredentialsMainService,[!0])),Ge.invokeFunction(et=>{const nt=new j.RemoteAgentEnvironmentChannel(ge,He,Ze,Se,je);Be.registerChannel("remoteextensionsenvironment",nt);const ot=new ne.RemoteTelemetryChannel(et.get(me.IRemoteTelemetryService),$e);Be.registerChannel("telemetry",ot),Be.registerChannel(pe.REMOTE_TERMINAL_CHANNEL_NAME,new De.RemoteTerminalChannel(He,Se,rt,je));const vt=new V.RemoteAgentFileSystemProviderChannel(Se,He);Be.registerChannel(z.REMOTE_FILE_SYSTEM_CHANNEL_NAME,vt),Be.registerChannel("request",new $.RequestChannel(et.get(Y.IRequestService)));const pt=et.get(u.IExtensionManagementService),Dt=new a.ExtensionManagementChannel(pt,Ce=>ue(Ce.remoteAuthority));Be.registerChannel("extensions",Dt);const It=E.ProxyChannel.fromService(et.get(I.ILocalizationsService));Be.registerChannel("localizations",It);const Pt=E.ProxyChannel.fromService(et.get(b.IEncryptionMainService));Be.registerChannel("encryption",Pt);const Ee=E.ProxyChannel.fromService(et.get(h.ICredentialsMainService));return Be.registerChannel("credentials",Ee),pt.removeDeprecatedExtensions(),Me.add(new oe.default(et.get(B.ITelemetryService))),{telemetryService:et.get(B.ITelemetryService)}}),{socketServer:Be,instantiationService:Ge}}e.setupServerServices=ye;class Pe extends E.IPCServer{constructor(){const he=new t.Emitter;super(he.event);this._onDidConnectEmitter=he}acceptConnection(he,Re){this._onDidConnectEmitter.fire({protocol:he,onDidClientDisconnect:Re})}}e.SocketServer=Pe;class Ae extends U.AbstractLogger{constructor(he=U.DEFAULT_LOG_LEVEL){super();this.setLevel(he),this.useColors=Boolean(process.stdout.isTTY)}trace(he,...Re){this.getLevel()<=U.LogLevel.Trace&&(this.useColors?console.log(`[90m[${Fe()}][0m`,he,...Re):console.log(`[${Fe()}]`,he,...Re))}debug(he,...Re){this.getLevel()<=U.LogLevel.Debug&&(this.useColors?console.log(`[90m[${Fe()}][0m`,he,...Re):console.log(`[${Fe()}]`,he,...Re))}info(he,...Re){this.getLevel()<=U.LogLevel.Info&&(this.useColors?console.log(`[90m[${Fe()}][0m`,he,...Re):console.log(`[${Fe()}]`,he,...Re))}warn(he,...Re){this.getLevel()<=U.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${Fe()}][0m`,he,...Re):console.warn(`[${Fe()}]`,he,...Re))}error(he,...Re){this.getLevel()<=U.LogLevel.Error&&(this.useColors?console.error(`[91m[${Fe()}][0m`,he,...Re):console.error(`[${Fe()}]`,he,...Re))}critical(he,...Re){this.getLevel()<=U.LogLevel.Critical&&(this.useColors?console.error(`[90m[${Fe()}][0m`,he,...Re):console.error(`[${Fe()}]`,he,...Re))}dispose(){}flush(){}}function Fe(){const ge=new Date;return`${Ue(ge.getHours())}:${Ue(ge.getMinutes())}:${Ue(ge.getSeconds())}`}function Ue(ge){return ge<10?`0${ge}`:String(ge)}async function le(ge){const he=D.basename(ge),Re=D.dirname(ge),Be=(await y.Promises.readdir(Re)).filter(He=>/^\d{8}T\d{6}$/.test(He)).sort().filter(He=>He!==he),je=Be.slice(0,Math.max(0,Be.length-9));await Promise.all(je.map(He=>y.Promises.rm(D.join(Re,He))))}}),define(ve[259],we([0,1,70,27,82,260,71,117,15,31,2,8,4,44,3,5,23,136,85,58,6,14,32,29,116,227,231,50,258,233]),function(J,e,_,t,w,P,D,k,y,E,T,R,h,v,c,d,g,b,l,C,p,u,s,a,i,n,r,o,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const A=5*60*1e3;let I=class extends T.Disposable{constructor(W,m,L,M,Y,$,G){super();this._socketServer=W,this._connectionToken=m,this._environmentService=M,this._productService=Y,this._logService=$,this._instantiationService=G,this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),this._allReconnectionTokens=new Set,this._webClientServer=L?this._instantiationService.createInstance(S.WebClientServer,this._connectionToken):null,this._logService.info("Extension host agent started.")}async handleRequest(W,m){if(W.method!=="GET")return(0,S.serveError)(W,m,405,`Unsupported method ${W.method}`);if(!W.url)return(0,S.serveError)(W,m,400,"Bad request.");const L=D.parse(W.url,!0),M=L.pathname;if(!M)return(0,S.serveError)(W,m,400,"Bad request.");if(M==="/version")return m.writeHead(200,{"Content-Type":"text/plain"}),m.end(this._productService.commit||"");if(M==="/delay-shutdown")return this._delayShutdown(),m.writeHead(200),m.end("OK");if(!(0,r.requestHasValidConnectionToken)(this._connectionToken,W,L))return(0,S.serveError)(W,m,403,"Forbidden.");if(M==="/vscode-remote-resource"){const Y=L.query.path;if(typeof Y!="string")return(0,S.serveError)(W,m,400,"Bad request.");let $;try{$=d.URI.from({scheme:R.Schemas.file,path:Y}).fsPath}catch{return(0,S.serveError)(W,m,400,"Bad request.")}const G=Object.create(null);return this._environmentService.isBuilt&&((0,E.isEqualOrParent)($,this._environmentService.builtinExtensionsPath,!c.isLinux)||(0,E.isEqualOrParent)($,this._environmentService.extensionsPath,!c.isLinux))&&(G["Cache-Control"]="public, max-age=31536000"),(0,S.serveFile)(this._logService,W,m,$,G)}if(this._webClientServer){this._webClientServer.handle(W,m,L);return}return m.writeHead(404,{"Content-Type":"text/plain"}),m.end("Not found")}handleUpgrade(W,m){let L=(0,g.generateUuid)(),M=!1,Y=!1;if(W.url){const ee=D.parse(W.url,!0).query;typeof ee.reconnectionToken=="string"&&(L=ee.reconnectionToken),ee.reconnection==="true"&&(M=!0),ee.skipWebSocketFrames==="true"&&(Y=!0)}if(W.headers.upgrade!=="websocket"){m.end("HTTP/1.1 400 Bad Request");return}const $=W.headers["sec-websocket-key"],G=_.createHash("sha1");G.update($+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const ie=G.digest("base64"),B=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ie}`];let q=!1;if(!Y&&!this._environmentService.args["disable-websocket-compression"]&&W.headers["sec-websocket-extensions"]){const ee=Array.isArray(W.headers["sec-websocket-extensions"])?W.headers["sec-websocket-extensions"]:[W.headers["sec-websocket-extensions"]];for(const oe of ee)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(oe)){if(/\b(permessage-deflate)\b/.test(oe)){q=!0,B.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(oe)){q=!0,B.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}m.write(B.join(`\r
`)+`\r
\r
`),m.setTimeout(0),m.setNoDelay(!0),Y?this._handleWebSocketConnection(new C.NodeSocket(m,`server-connection-${L}`),M,L):this._handleWebSocketConnection(new C.WebSocketNodeSocket(new C.NodeSocket(m,`server-connection-${L}`),q,null,!0),M,L)}handleServerError(W){this._logService.error("Error occurred in server"),this._logService.error(W)}_getRemoteAddress(W){let m;return W instanceof C.NodeSocket?m=W.socket:m=W.socket.socket,m.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(W,m,L){const M=m.getSocket();this._logService.error(`${W} ${L}.`);const Y={type:"error",reason:L};m.sendControl(y.VSBuffer.fromString(JSON.stringify(Y))),m.dispose(),await M.drain(),M.dispose()}_handleWebSocketConnection(W,m,L){const M=this._getRemoteAddress(W),Y=`[${M}][${L.substr(0,8)}]`,$=new l.PersistentProtocol(W);let G,ie;try{const re=J.__$__nodeRequire("vsda");G=new re.validator,ie=new re.signer}catch{}let B;(function(re){re[re.WaitingForAuth=0]="WaitingForAuth",re[re.WaitingForConnectionType=1]="WaitingForConnectionType",re[re.Done=2]="Done",re[re.Error=3]="Error"})(B||(B={}));let q=0;const ee=re=>{q=3,oe.dispose(),this._rejectWebSocketConnection(Y,$,re)},oe=$.onControlMessage(re=>{if(q===0){let de;try{de=JSON.parse(re.toString())}catch{return ee("Malformed first message")}if(de.type!=="auth")return ee("Invalid first message");if(this._connectionToken.type===2&&!this._connectionToken.validate(de.auth))return ee("Unauthorized client refused: auth mismatch");let Z=(0,g.generateUuid)();if(ie)try{Z=ie.sign(de.data)}catch{}let H=(0,g.generateUuid)();if(G)try{H=G.createNewMessage(H)}catch{}const j={type:"sign",data:H,signedData:Z};$.sendControl(y.VSBuffer.fromString(JSON.stringify(j))),q=1}else if(q===1){let de;try{de=JSON.parse(re.toString())}catch{return ee("Malformed second message")}if(de.type!=="connectionType")return ee("Invalid second message");if(typeof de.signedData!="string")return ee("Invalid second message field type");const Z=de.commit,H=this._productService.commit;if(Z&&H&&Z!==H)return ee("Client refused: version mismatch");let j=!1;if(!G)j=!0;else if(this._connectionToken.validate(de.signedData))j=!0;else try{j=G.validate(de.signedData)==="ok"}catch{}if(!j){if(this._environmentService.isBuilt)return ee("Unauthorized client refused");this._logService.error(`${Y} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let V in this._managementConnections)this._managementConnections[V].shortenReconnectionGraceTimeIfNecessary();for(let V in this._extHostConnections)this._extHostConnections[V].shortenReconnectionGraceTimeIfNecessary();q=2,oe.dispose(),this._handleConnectionType(M,Y,$,W,m,L,de)}})}async _handleConnectionType(W,m,L,M,Y,$,G){const ie=G.desiredConnectionType===1?`${m}[ManagementConnection]`:G.desiredConnectionType===2?`${m}[ExtensionHostConnection]`:m;if(G.desiredConnectionType===1)if(Y){if(!this._managementConnections[$])return this._allReconnectionTokens.has($)?this._rejectWebSocketConnection(ie,L,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ie,L,"Unknown reconnection token (never seen)");L.sendControl(y.VSBuffer.fromString(JSON.stringify({type:"ok"})));const B=L.readEntireBuffer();L.dispose(),this._managementConnections[$].acceptReconnection(W,M,B)}else{if(this._managementConnections[$])return this._rejectWebSocketConnection(ie,L,"Duplicate reconnection token");L.sendControl(y.VSBuffer.fromString(JSON.stringify({type:"ok"})));const B=new n.ManagementConnection(this._logService,$,W,L);this._socketServer.acceptConnection(B.protocol,B.onClose),this._managementConnections[$]=B,this._allReconnectionTokens.add($),B.onClose(()=>{delete this._managementConnections[$]})}else if(G.desiredConnectionType===2){const B=G.args||{language:"en"},q=await this._updateWithFreeDebugPort(B);if(q.port&&this._logService.trace(`${ie} - startParams debug port ${q.port}`),this._logService.trace(`${ie} - startParams language: ${q.language}`),this._logService.trace(`${ie} - startParams env: ${JSON.stringify(q.env)}`),Y){if(!this._extHostConnections[$])return this._allReconnectionTokens.has($)?this._rejectWebSocketConnection(ie,L,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ie,L,"Unknown reconnection token (never seen)");L.sendPause(),L.sendControl(y.VSBuffer.fromString(JSON.stringify(q.port?{debugPort:q.port}:{})));const ee=L.readEntireBuffer();L.dispose(),this._extHostConnections[$].acceptReconnection(W,M,ee)}else{if(this._extHostConnections[$])return this._rejectWebSocketConnection(ie,L,"Duplicate reconnection token");L.sendPause(),L.sendControl(y.VSBuffer.fromString(JSON.stringify(q.port?{debugPort:q.port}:{})));const ee=L.readEntireBuffer();L.dispose();const oe=new i.ExtensionHostConnection(this._environmentService,this._logService,$,W,M,ee);this._extHostConnections[$]=oe,this._allReconnectionTokens.add($),oe.onClose(()=>{delete this._extHostConnections[$],this._onDidCloseExtHostConnection()}),oe.start(q)}}else if(G.desiredConnectionType===3){const B=G.args;this._createTunnel(L,B)}else return this._rejectWebSocketConnection(ie,L,"Unknown initial data received")}async _createTunnel(W,m){const L=W.getSocket().socket,M=W.readEntireBuffer();W.dispose(),L.pause();const Y=await this._connectTunnelSocket(m.host,m.port);M.byteLength>0&&Y.write(M.buffer),Y.on("end",()=>L.end()),Y.on("close",()=>L.end()),Y.on("error",()=>L.destroy()),L.on("end",()=>Y.end()),L.on("close",()=>Y.end()),L.on("error",()=>Y.destroy()),Y.pipe(L),L.pipe(Y)}_connectTunnelSocket(W,m){return new Promise((L,M)=>{const Y=w.createConnection({host:W,port:m},()=>{Y.removeListener("error",M),Y.pause(),L(Y)});Y.once("error",M)})}_updateWithFreeDebugPort(W){return typeof W.port=="number"?(0,b.findFreePort)(W.port,10,5e3).then(m=>(W.port=m,W)):(W.debugId=void 0,W.port=void 0,W.break=void 0,Promise.resolve(W))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},A))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}};I=Te([Ne(3,o.IServerEnvironmentService),Ne(4,s.IProductService),Ne(5,u.ILogService),Ne(6,p.IInstantiationService)],I),e.RemoteExtensionHostAgentServer=I;async function F(U,W,m){const L=(0,r.parseServerConnectionToken)(W);L instanceof r.ServerConnectionTokenParseError&&(console.warn(L.message),process.exit(1));const M=new T.DisposableStore,{socketServer:Y,instantiationService:$}=await(0,f.setupServerServices)(L,W,m,M);$.invokeFunction(re=>{const de=re.get(u.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const Z=(0,h.join)(process.env.HOMEDRIVE,"node_modules"),H=(0,h.dirname)((0,h.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),j=(0,h.join)(H,"node_modules");if(t.existsSync(Z)||t.existsSync(j)){const V=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${Z}
* ${j}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;de.warn(V),console.warn(V),process.exit(0)}}});const G=t.existsSync(R.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",J).fsPath);if(G&&U&&typeof U!="string"){const re=L.type!==0?`?${R.connectionTokenQueryName}=${L.value}`:"";console.log(`Web UI available at http://localhost${U.port===80?"":`:${U.port}`}/${re}`)}const ie=$.createInstance(I,Y,L,G);v.mark("code/server/ready");const B=P.performance.now(),q=global.vscodeServerStartTime,ee=global.vscodeServerListenTime,oe=global.vscodeServerCodeLoadedTime;if($.invokeFunction(re=>{re.get(a.ITelemetryService).publicLog2("serverStart",{startTime:q,startedTime:ee,codeLoadedTime:oe,readyTime:B})}),W["print-startup-performance"]){const re=k.LoaderStats.get();let de="";de+=`

### Load AMD-module
`,de+=k.LoaderStats.toMarkdownTable(["Module","Duration"],re.amdLoad),de+=`

### Load commonjs-module
`,de+=k.LoaderStats.toMarkdownTable(["Module","Duration"],re.nodeRequire),de+=`

### Invoke AMD-module factory
`,de+=k.LoaderStats.toMarkdownTable(["Module","Duration"],re.amdInvoke),de+=`

### Invoke commonjs-module
`,de+=k.LoaderStats.toMarkdownTable(["Module","Duration"],re.nodeEval),de+=`Start-up time: ${ee-q}
`,de+=`Code loading time: ${oe-q}
`,de+=`Initialized time: ${B-q}
`,de+=`
`,console.log(de)}return ie}e.createServer=F}),define(ve[268],we([0,1,25,27,8,255,259,53,4,260,50,45,44]),function(J,e,_,t,w,P,D,k,y,E,T,R,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,h.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=E.performance.now();const v={onMultipleValues:(l,C)=>{console.error(`Option ${l} can only be defined once. Using value ${C}.`)},onUnknownOption:l=>{console.error(`Ignoring option ${l}: not supported for server.`)},onDeprecatedOption:(l,C)=>{console.warn(`Option '${l}' is deprecated: ${C}`)}};function c(){return(0,k.parseArgs)(process.argv.slice(2),T.serverOptions,v)}function d(l){const C=l["server-data-dir"]||l["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,y.join)(_.homedir(),R.default.serverDataFolderName||".vscode-remote"),p=l["user-data-dir"]||(0,y.join)(C,"data"),u=(0,y.join)(p,"User"),s=(0,y.join)(u,"globalStorage"),a=(0,y.join)(p,"Machine");l["user-data-dir"]=p;const i=(0,y.dirname)(w.FileAccess.asFileUri("",J).fsPath),n=l["builtin-extensions-dir"]||(0,y.join)(i,"extensions");return l["builtin-extensions-dir"]=n,l["extensions-dir"]=l["extensions-dir"]||(0,y.join)(C,"extensions"),[C,l["extensions-dir"],p,u,a,s].forEach(r=>{try{t.existsSync(r)||t.mkdirSync(r,{mode:448})}catch(o){console.error(o)}}),C}function g(l=c()){return(0,P.run)(l,d(l),T.serverOptions)}e.spawnCli=g;function b(l,C=c()){return(0,D.createServer)(l,C,d(C))}e.createServer=b})}).call(this);

//# sourceMappingURL=server.main.js.map
